/******************************通用方法对象************************************/

var commonJs = (function() {
    var isTouchable, EVENT_START, EVENT_MOVE, EVENT_END;
    
    /**
     * ajax统一请求
     * @param {Object} url
     * @param {Object} _data
     * @param {Object} callback
     * @param {Object} errorFn
     */
    var _ajax = function(url, _data, callback, errorFn) {
        //由于ajax存在阻塞IO, 所以LOADING显示放到defer方法里面执行
        if (!!window.isShowLoading) {
            _showLoading();
        }
        if (typeof(_data) != "string") {
             _data = JSON.stringify(_data);
        }
        //_.defer(function(){
        //console.log("deferred");
        $.ajax({
            type: "POST",
            data: _data,
            url: url,
            async: true,
            contentType: "application/json;charset=utf-8",
            dataType: "json", //指定服务器返回的数据类型
            success: function(res) {
                if(res.result === "0") {
                    callback(res);
                } else {
                    errorFn(e);
                }
            },
            error: errorFn(e),
            complete: function(xhr, status) {
                if (!!window.isShowLoading) {
                    _closeLoading();
                }
            }
        });
        //});
    }
    
    var _appcanRequestAjax = function(url, _data, callback, errorFn) {
        //appcan.request.ajax({ //些方法不好使，有些电脑无法获取到数据
        if (!!window.isShowLoading) {
            _showLoading();
        }
        if (typeof(_data) != "string") {
            _data = JSON.stringify(_data);
        }
        //由于ajax存在阻塞IO, 所以LOADING显示放到defer方法里面执行
        //_.defer(function(){
        //console.log("deferred");
        $.ajax({
            url : url,
            type : "POST",
            async: true,
            data : _data,//this.pretreatment(data, option),
            dataType: "json",
            contentType: "application/json;charset=utf-8",
            success : function(data) {
                callback(data);
            },
            error : function(e, err) {
                errorFn(e, err);
            },
            complete: function(xhr, status) {
                if (!!window.isShowLoading) {
                    _closeLoading();
                }
            }
        });
        //});
    }
    
    //获取URL参数
    var _getUrlParam = function(url) {
        var para = new Object();
        if(url.indexOf("?") != -1) {
            //分割成字符串
            var getval = url.split('?')[1];
            var keyValue = getval.split('&');
            for(var i=0; i< keyValue.length; i++){
                para[keyValue[i].split("=")[0]] = unescape(keyValue[i].split("=")[1]);
            }
        }
        return para;
    }
    
    /**
     * 通过value获取codelist数据集中的text
     */
    var _compareText = function(dc, value) {
        var text = null ;
        for(var i in dc) {
            var d = dc[i];
            if(d.value == value) {
                text = d.text;
                break;
            } 
        }
        return text || value;
    }
    
    var _getCodelistData = function(_data, value) {
        var data = {value: value, text: null};
        for(var i in _data) {
            var d = _data[i];
            if(d.value == value) {
                data.text = d.text;
                break;
            } 
        }
        return data;
    }
    
    /**
     *获取登陆患者信息，用户为患者时写入患者数据到 localPatient
     */
    var _getPatient = function() {
        //写入医生登陆信息,登陆开发完成后，该行需注释
        //appcan.locStorage.setVal("localPatient", JSON.stringify(patientInfoTestData));
        
        var localPatient = appcan.locStorage.getVal("localPatient"); //医生登陆信息
        if (!!!localPatient) {
            return null;
        }
        return JSON.parse(localPatient);
    }
    
    /**
     *获取登陆医生信息，用户为医生时写入医生数据到 localDoctor
     */
    var _getDoctor = function() {
        //写入医生登陆信息,登陆开发完成后，该行需注释
        //appcan.locStorage.setVal("localDoctor", JSON.stringify(doctorInfo));
        
        var doctor = appcan.locStorage.getVal("localDoctor"); //医生登陆信息
        if (!!!doctor) {
            return null;
        }
        return JSON.parse(doctor);
    }
    
    /**
     *获取登陆药师信息，用户为医生时写入医生数据到 localApothecary
     */
    var _getApothecary = function(type) {
        //写入药师登陆信息,登陆开发完成后，该行需注释
        // if (type === "YS") {
           // appcan.locStorage.setVal("localApothecary", JSON.stringify(apothecaryInfo));
        // } else if (type === "TJS") {
            // appcan.locStorage.setVal("localApothecary", JSON.stringify(apothecaryInfoAdjust));
        // }
        
        var localApothecary = appcan.locStorage.getVal("localApothecary"); //药师登陆信息
        if (!!!localApothecary) {
            return null;
        }
        return JSON.parse(localApothecary);
    }
    
    /**
     *获取登陆机构信息，用户为机构时写入医生数据到 localOranization
     */
    var _getOrganization = function() {
        //写入机构登陆信息,登陆开发完成后，该行需注释
        var localOranization = appcan.locStorage.getVal("localOrganization");
        if (!!!localOranization) {
            return null;
        }
        return JSON.parse(localOranization);
    }
    
    var _getLogingUser = function() {
        var loginUser = appcan.locStorage.getVal("loginUser"); //医生登陆信息
        if (!!!loginUser) {
            return null;
        }
        return JSON.parse(loginUser);
    }
    
    //json日期格式转换为正常格式 年月日形式
    
    
    var _jsonDateFormat = function(jsonDate) {
        if(jsonDate!=null){
            var year = jsonDate.year + 1900;
            var month = jsonDate.month + 1;
            var day = jsonDate.date;
            month = (month > 9) ? ("" + month) : ("0" + month);
            //如果得到的数字小于9要在前面加'0'
            day = (day > 9) ? ("" + day) : ("0" + day);
            return year + "-" + month + "-" + day;
        }else{
            return "";
        }
        
    }

    
    
    //json日期格式转换为正常格式 年月日时分秒形式
    var _jsonTimeFormat = function(jsonTime) {
        if(jsonTime!=null){
            var year = jsonTime.year + 1900;
            var month = jsonTime.month + 1;
            var day = jsonTime.date;
            month = (month > 9) ? ("" + month) : ("0" + month);
            //如果得到的数字小于9要在前面加'0'
            day = (day > 9) ? ("" + day) : ("0" + day);
            var hour = jsonTime.hours;
            var minute = jsonTime.minutes;
            var seconds = jsonTime.seconds;
            hour = (hour > 9) ? ("" + hour) : ("0" + hour);
            minute = (minute > 9) ? ("" + minute) : ("0" + minute);
            seconds = (seconds > 9) ? ("" + seconds) : ("0" + seconds);
        
            return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
        }else{
            return "";
        }
    }
    
    //日期格式 转换成 日期String 例：2018-09-01
    var _dateToString = function(date) {
        if (!!!date) return null;
        var _date;
        try {
            _date = new Date(date);
        } catch(e) {
            return null;
        }
        var year = _date.getFullYear();
        var month = _date.getMonth() +1;
        var day = _date.getDate();
        return year + "-" + (month > 9 ? month : "0" + month) + "-" + (day > 9 ? day : "0" + day); 
    }
    
    //日期格式 转换成 时间String 例：12：00：00
    var _timeToString = function(time) {
        if (!!!time) return null;
        var _date;
        try {
            _date = new Date(time);
        } catch(e) {
            return null;
        }
        var hours = _date.getHours() > 9 ? _date.getHours() : "0" + _date.getHours();
        var minute = _date.getMinutes() > 9 ? _date.getMinutes() : "0" + _date.getMinutes();
        var second = _date.getSeconds() > 9 ? _date.getSeconds() : "0" + _date.getSeconds();
        return hours + ":" + minute + ":" + second; 
    }
    
    //日期格式 转换成 日期带时间String 例：2018-09-01  12：00：00
    var _dateTimeToString = function(time) {
        if (!!!time) return null;
        return _dateToString(time) + " " + _timeToString(time);
    }
        
    //金额转换成财务显示格式，3位一撇 ###,###
    var _moneyFormat = function(amount) {
        if (!!!amount) return null;
        var _amount = amount.toString();
        var _amountInt = (_amount.indexOf(".") < 0 ? _amount : _amount.substr(0,  _amount.indexOf("."))).toString();
        var _amountPoint = _amount.indexOf(".") < 0 ? "" : _amount.substr(_amount.indexOf("."), 15);
        _amount = "";
        for(var i = 0; i <= _amountInt.length; i++) {
            _amount = _amountInt.substr(_amountInt.length - i, 1) + _amount;
            if (i > 0 && i  % 3 === 0 && i != _amountInt.length) {
                _amount = "," + _amount;
            }
        }
        return _amount + _amountPoint;
    }
    
    /**
     * URL参数转换成JSON数据格式 
     */
    var _urlQueryToJSON = function(urlQuery) {
        if (!!!urlQuery) return null;
        var urlParam = {};
        for(var obj in urlQuery.split("&")) {
            urlParam[urlQuery.split("&")[obj].split("=")[0]] = urlQuery.split("&")[obj].split("=")[1];
        }
        return urlParam;
    }
    
    /**
     * 窗口列表上、下拉加载数据函数  0:下拉 1:上拖
     * @Param  loadDataFun：松手时触发事件，些处主要写数据加载函数
     *         bounceType：类型：0:下拉 1:上拖  空值则默认2种类型
     *         startPullCall：开始下拉、上拖时处理事件
     *         downEndCall: 超过临界点执行事件
     */
    var _listWindowBounce = function(loadDataFun, bounceType, startPullCall, downEndCall) {
        _.defer(function(){
            appcan.frame.setBounce({
                bounceType: bounceType || [0,1], 
                startPullCall :function(type) {
                    console.log(!type ? "开始下拉" : "开始上拖");
                    //$("#pullstatus"+type).html(!type?"开始下拉":"开始上拖");
                }, 
                downEndCall: function(type) {
                    console.log(!type ? "下拉超过临界点,产生事件了！" : "上拖超过临界点,产生事件了！");
                    //$("#pullstatus"+type).html(!type?"下拉超过临界点,产生事件了！":"超过临界点,产生事件了！");
                }, 
                upEndCall: function(type) {
                    console.log("松手了,产生事件了,开始更新数据！type:" + type );
                    setTimeout(function() {
                        console.log("数据加载后，隐藏加载图标信息！type:" + type );
                        appcan.frame.resetBounce(type);
                        
                    }, 100);
                    loadDataFun();
                },
                color: "#f7f7f7"
            });
        });
    }
    
    /**
     * collection类插入MODELS数据前检查方法 
     */
    var _onBeforeAdd = function(collection, models, options) {
        if (collection.length === 0) {
            if (!!!models[models.length -1]) {
                models.firstRow = true;
            } else {
                models[0].firstRow = true;
            }
        } else {
             collection.models[collection.length -1].set("lastRow", false);  
        }
        if (!!!models[models.length -1]) {
            models.lastRow = true;
        } else {
            models[models.length -1].lastRow = true;
        }
        return models;
    }
    
    /**
     * WINDOW打开公用方法 
     */
    var _openWindow = function(pageName, url) {
        appcan.window.open({
            name: pageName,
            dataType: 0,
            aniId: 2,
            data: url
        });
    }
    
    /**
     *  关闭已打开的窗口 
     */
    var _closeWindow = function(framePageName) {
        if (!!framePageName) {
            var frame = appcan.require("frame");
            frame.close(framePageName);
        }
        appcan.window.close(-1);      
    }
    
    /**
     * 检查医生是否已登陆系统 
     */
    var _checkDoctorLogin = function() {
        var doctorInfo = _getDoctor();
        if (!!!doctorInfo || !!!doctorInfo.id) {
            _openWindow("doctorLoginPage", "../../login/login.html");
            return false;
        } else {
            return true;
        }
    }
    
    /**
     * 检查医生是否已登陆系统 
     */
    var _checkPharmacistLogin = function() {
        var apothecaryInfo = _getApothecary();
        if (!!!apothecaryInfo || !!!apothecaryInfo.id) {
            _openWindow("apothecaryLoginPage", "../login/login.html");
            return false;
        } else {
            return true;
        }
    }
    
    /**
     * 检查机构是否已登陆系统 
     */
    var _checkMechanismLogin = function() {
        var organization = _getOrganization();
        if (!!!organization || !!!organization.id) {
            _openWindow("loginPage", "../login/login.html");
            return false;
        } else {
            return true;
        }
    }
    
    //根据身份证号计算年龄

    var _getAgeByIdentityCard = function(identityCard) {
        var len = (identityCard + "").length;
        if (len == 0) {
            return 0;
        } else {
            if ((len != 15) && (len != 18))//身份证号码只能为15位或18位其它不合法
            {
                return 0;
            }
        }
        var strBirthday = "";
        if (len == 18)//处理18位的身份证号码从号码中得到生日和性别代码
        {
            strBirthday = identityCard.substr(6, 4) + "/" + identityCard.substr(10, 2) + "/" + identityCard.substr(12, 2);
        }
        if (len == 15) {
            strBirthday = "19" + identityCard.substr(6, 2) + "/" + identityCard.substr(8, 2) + "/" + identityCard.substr(10, 2);
        }
        //时间字符串里，必须是“/”
        var birthDate = new Date(strBirthday);
        var nowDateTime = new Date();
        var age = nowDateTime.getFullYear() - birthDate.getFullYear();
        //再考虑月、天的因素;.getMonth()获取的是从0开始的，这里进行比较，不需要加1
        if (nowDateTime.getMonth() < birthDate.getMonth() || (nowDateTime.getMonth() == birthDate.getMonth() && nowDateTime.getDate() < birthDate.getDate())) {
            age--;
        }
        return age;
    }
    
    /**
     * 加密函数 
     */ 
    var _compile = function(code) {    
       //var c = String.fromCharCode(code.charCodeAt(0) + code.length);
       var c = "", str = String.fromCharCode(Math.trunc(Math.random() * 127));
       for(var i = 0; i < code.length; i++){  
           c += String.fromCharCode(code.charCodeAt(i) + str.charCodeAt(0));  
       }  
       return escape(str + c);
    }
     
    /**
     * 解密函数
     */
    var _uncompile = function(code) {
       code = unescape(code);  
       //var c = String.fromCharCode(code.charCodeAt(0) - code.length);
       var c = "", str = String.fromCharCode(code.charCodeAt(0));
       for(var i = 1; i< code.length; i++){  
           c += String.fromCharCode(code.charCodeAt(i) - str.charCodeAt(0));
       }  
       return c;  
    }
    
    /**
     *img的base64转码
     * img对象
     * callback回调，返回data
     */
    var getBase64Image = function(img, callback){
    	  var canvas = document.createElement("canvas");
          var ctx = canvas.getContext("2d");
          img.onload = function(){
	        // var width = img.width;
	        // var height = img.height;
	        // var maxLen = 1024;
	         // var rate = 1;
	         // if (width >= height) {
	             // if (width > maxLen) {
	                 // rate = maxLen / width;
	             // }
	         // } else {
	             // if (height > maxLen) {
	                 // rate = maxLen / height;
	             // }
	         // };
	          // rate = rate*0.5;
	         // img.width = width * rate;
	         // img.height = height * rate;
	        // canvas.width = width*rate; 
	        // canvas.height = height*rate;
        
	          canvas.width = img.width;
	          canvas.height = img.height;
	          ctx.drawImage(img, 0, 0, img.width, img.height);
	          var ext = img.src.substring(img.src.lastIndexOf(".")+1).toLowerCase();
              var dataURL = canvas.toDataURL("image/"+ext);
              callback(dataURL);
              canvas = null;
          }
    }
    
    /**
     *base64码转成file
     * dataurl-base64码
     * filename
     */
    var dataURLtoFile = function(dataurl, filename){
	    var arr = dataurl.split(',');
    	var mime = arr[0].match(/:(.*?);/)[1];
        var bstr = atob(arr[1]);
        var n = bstr.length;
        var u8arr = new Uint8Array(n);
        while(n--){
         u8arr[n] = bstr.charCodeAt(n);
        }
        return new File([u8arr], filename, {type:mime});
    }
    
    /**
     *  显示Loading加载样式 
     */
    var _createLoading = function() {
        try{
            if ('ontouchstart' in window) {
                isTouchable = true;
                EVENT_START = 'touchstart';
                EVENT_MOVE = 'touchmove';
                EVENT_END = 'touchend';
            } else {
                isTouchable = false;
                EVENT_START = 'mousedown';
                EVENT_MOVE = 'mousemove';
                EVENT_END = 'mouseup';
            }
            var loadingPanel = '<div class="loading-mask ub ub-ac ub-pc">';
            loadingPanel += '     <div class="loader duration-500ms-before">';
            loadingPanel += '         <span class="ub ub-ac ub-pc"><font style="font-size: .825em">Loading</font></span>';
            loadingPanel += '     </div>';
            loadingPanel += '</div>';
            if ($("body").find(".loading-mask").length <= 0) {
                //$("body").append(loadingPanel);
                var mask = document.createElement("div");
                mask.innerHTML = loadingPanel;
                var child = [].slice.call(mask.childNodes)[0];
                document.body.appendChild(child);
                //增加滚动条防穿透样式
                this.mask = {};
                //this.mask.scrollTop = document.scrollingElement.scrollTop;
                //document.body.classList.add("mask-show");
                //document.body.style.top = -this.mask.scrollTop + 'px';
                //console.log("mask  create");
                $("body").find(".loading-mask").toggleClass("loading-mask-show", true);
            } else {
                //console.log("mask  show");
                $("body").find(".loading-mask").toggleClass("loading-mask-show", true);
            }
            
            
            //window.loadingConfig.y = Math.trunc(height/2) - 20;
            //window.loadingConfig.x = Math.trunc(width/2) - 225;
            //uexLoadingView.open(JSON.stringify(window.loadingConfig));
        } catch(e) {
            console.log(e)
        }
    }
    
    var _showLoading = function() {
        try{
            if ($("body").find(".loading-mask").length <= 0) {
                _createLoading();
            } else {
                //console.log("mask  show");
                $("body").find(".loading-mask").toggleClass("loading-mask-show", true);
                //console.log($("body").find(".loading-mask")[0].classList);
            }
            //window.loadingConfig.y = Math.trunc(height/2) - 20;
            //window.loadingConfig.x = Math.trunc(width/2) - 225;
            //uexLoadingView.open(JSON.stringify(window.loadingConfig));
            //uexLoadingView.openCircleLoading();
        } catch(e) {
            console.log(e)
        }
    }
    
    /**
     *  关闭Loading加载样式 
     */
    var _closeLoading = function() {
        try{
            if ($("body").find(".loading-mask").length > 0) {
                //console.log("mask  close");
                $("body").find(".loading-mask").toggleClass("loading-mask-show", false);
            }
            //uexLoadingView.close();
        } catch(e) {
            console.log(e)
        }
    }
    
    /**
     * 物理回退键捕捉处理事件 
     */
    var _setBackKeyProc = function(callback) {
        //监听物理退出键按钮
        uexWindow.setReportKey(0, 1);
        var _fn = function(keyCode) {
            if (keyCode === 0) {
                callback();
            }
        }
        uexWindow.onKeyPressed = _fn;
    }
    
    /*
     * 获取极光推送APP推送ID
     */
    var _getJpushRegistrationId = function(id, type) {
        var jpushRegistrationId = uexJPush.getRegistrationID();
        if(!!id) {
            var url = window.ServerURL + "/updateRegeristerId";
            var param = {"id": id,"type": type, "regeristerId": jpushRegistrationId, "appType": 'XF'};
            _appcanRequestAjax(url, param, function() {
                console.log("提交服务器更新极光推送ID:" + jpushRegistrationId);
            });
        }
    }
    
    /**
     * 调用网易云信网络聊天与视频
     */
    var _doNeteaseNim = function(accountREQ, accountRCV) {
        //网易云信聊天
        var param = {
            accountREQ: accountREQ,  //请求者账号
            tokenREQ: window.neteaseNim.patientPwd, //请求者密码
            accountRCV: accountRCV,   //接收者账号
            tokenRCV: window.neteaseNim.doctorPwd  //接收者密码
        };
        bethuneDoctor.startNeteaseNimActivity(param, function (error, data) {
            alert(error);
            if (!!!error){
                alert("返回结果是:"+data.result);
            }
        });
    }
    
     /*
     * 验证是否为11位有效手机号码
     * by sushu 2018-12-28
     */
    var isPoneAvailable = function(str){
    	var myreg=/^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
    	if (!myreg.test(str)) {
    	  	return false;
        } else {
            return true;
        }
    }

    var _onReceiveNotificationOpen = function (data) {
        var infoObj = {}
        if(typeof data === "string") {
            infoObj = JSON.parse(data)
        } else {
            infoObj = data;
        }
        // alert("onReceiveNotificationOpen\n" + JSON.stringify(infoObj));
        if (infoObj.extras.jumpType === "1" || infoObj.extras.jumpType === "4") {
            //推送消息到医生-医生诊疗跳转到详细页
            var param = "orderId=" + infoObj.extras.id;
            commonJs.openWindow("diagnosisDetailPage", "views/doctor/diagnosis/diagnosis_detail.html?" + param);
            appcan.window.evaluateScript("diagnosisDetailPage", "diagnosisDetail.init()");
        }else if(infoObj.extras.jumpType === "3"){
        	//推送消息到患者-医生开诊费后-缴费单详细页
        	var param = "id=" + infoObj.extras.id;
            commonJs.openWindow("diagnosisfeeConfirmPage", "views/patient/diagnosis/diagnosisfeeConfirm.html?" + param);
            appcan.window.evaluatePopoverScript("diagnosisfeeConfirmPage", "diagnosisFeeConfirmContentPage", "diagnosisFeeConfirm.initModel('"+infoObj.extras.id+"')");
        }else if(infoObj.extras.jumpType === "7"){
        	//推送消息到患者-平台药师审方后-患者处方单详细页
        	var param = "id=" + infoObj.extras.id;
            commonJs.openWindow("recipeInfoPatientPage", "views/patient/diagnosistreat/recipe_info_patient.html?" + param);
            appcan.window.evaluateScript("recipeInfoPatientPage", "recipeInfo.init()");
        }else if(infoObj.extras.jumpType === "8"){
        	//推送消息到患者-药房药师选药后-购药缴费单详细页
        	//查询缴费单据
        	var url = window.ServerURL + "/getPayXf";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	            var param = "id=" + res[0].orderId;
	            param += "&payId=" + res[0].id;
	            commonJs.openWindow("drugFeePaymentPage", "views/patient/diagnosis/drugFeePayment.html?" + param);
	            appcan.window.evaluatePopoverScript("drugFeePaymentPage", "drugFeePaymentContentPage", "drugFeePayment.init()");
            });
        }else if(infoObj.extras.jumpType === "9"){
        	//推送消息到药房调剂师-患者缴药费后-调剂师历史处方单详细页
        	var param = "id=" + infoObj.extras.id;
            commonJs.openWindow("adjustPrescribePage", "views/pharmacist/chomedicine/adjust_prescribe.html?" + param);
            appcan.window.evaluatePopoverScript("adjustPrescribePage", "adjustPrescribeContentPage", "adjustPrescribe.init()");
        }else if(infoObj.extras.jumpType === "10"){
        	//推送消息到患者-医生开预约单后-患者预约单明细
        	var url = window.ServerURL + "/getTForwardInfo";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	        	var param = "forwardId=" + infoObj.extras.id;
	        	param += "&forwardType=" + res[0].forwardType;
	            commonJs.openWindow("assayOrgSelectPage", "views/patient/assay/assay_org_select.html?" + param);
	            appcan.window.evaluatePopoverScript("assayOrgSelectPage", "assayOrgSelectContentPage", "assayOrgSelectContent.init()");
            });
        }else if(infoObj.extras.jumpType === "11"){
        	//推送消息到机构-患者选机构及化验方式并缴费-机构预约单明细
        	var url = window.ServerURL + "/getTForwardInfo";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	        	var param = "forwardId=" + infoObj.extras.id;
	        	param += "&forwardType=" + res[0].forwardType;
	            commonJs.openWindow("assayOrgAppointmentPage", "views/organization/assay/assay_org_appointment.html?" + param);
	            appcan.window.evaluatePopoverScript("assayOrgAppointmentPage", "assayOrgAppointmentContentPage", "assayOrgAppointmentContent.init()");
            });
        }else if(infoObj.extras.jumpType === "12"){
        	//推送消息到患者-机构录入预约时间确认后-患者预约单明细
        	var url = window.ServerURL + "/getTForwardInfo";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	        	var param = "forwardId=" + infoObj.extras.id;
	        	param += "&forwardType=" + res[0].forwardType;
	            commonJs.openWindow("assayBillViewPage", "views/patient/assay/assay_bill_view.html?" + param);
	            appcan.window.evaluatePopoverScript("assayBillViewPage", "assayBillViewContentPage", "assayBillViewContent.init()");
            });
        }else if(infoObj.extras.jumpType === "13"){
        	//推送消息到患者-机构确认已检验完-患者预约单明细
        	var url = window.ServerURL + "/getTForwardInfo";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	        	var param = "forwardId=" + infoObj.extras.id;
	        	param += "&forwardType=" + res[0].forwardType;
	            commonJs.openWindow("assayBillViewPage", "views/patient/assay/assay_bill_view.html?" + param);
	            appcan.window.evaluatePopoverScript("assayBillViewPage", "assayBillViewContentPage", "assayBillViewContent.init()");
            });
        }else if(infoObj.extras.jumpType === "14"){
        	//推送消息到患者-机构上传报告-患者预约单明细
        	var url = window.ServerURL + "/getTForwardInfo";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	        	var param = "forwardId=" + infoObj.extras.id;
	        	param += "&forwardType=" + res[0].forwardType;
	            commonJs.openWindow("assayBillViewPage", "views/patient/assay/assay_bill_view.html?" + param);
	            appcan.window.evaluatePopoverScript("assayBillViewPage", "assayBillViewContentPage", "assayBillViewContent.init()");
            });
        }else if(infoObj.extras.jumpType === "15"){
        	//推送消息到机构-患者新增上门单-机构上门单明细
        	var param = "serviceId=" + infoObj.extras.id;
            commonJs.openWindow("orgConfirmPage", "views/patient/roomService/org_confirm.html?" + param);
            appcan.window.evaluatePopoverScript("orgConfirmPage", "orgConfirmContentPage", "orgConfirmContentJs.init()");
        }else if(infoObj.extras.jumpType === "16"){
        	//推送消息到患者-机构确认上门服务单后-患者缴费单明细
        	var url = window.ServerURL + "/getPayXf";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	            var url = window.ServerURL + "/getTUpdoorInfo";
	            var param = {"id": res[0].orderId};
	            _appcanRequestAjax(url, param, function(res) {
		        	var param = "serviceId=" + res[0].id;
		        	param += "&sourceType=" + res[0].forwardType;
		            commonJs.openWindow("patientPaymentPage", "views/patient/roomService/patient_payment.html?" + param);
		            appcan.window.evaluatePopoverScript("patientPaymentPage", "patientPaymentContentPage", "patientPaymentContentJs.init()");
	            });
            });
        }else if(infoObj.extras.jumpType === "17"){
        	//推送消息到机构-上门服务单患者缴费后-机构上门服务单明细
        	var param = "serviceId=" + infoObj.extras.id;
            commonJs.openWindow("serviceCompletePage", "views/patient/roomService/service_complete.html?" + param);
            appcan.window.evaluatePopoverScript("serviceCompletePage", "serviceCompleteContentPage", "serviceCompleteContentJs.init()");
        }else if(infoObj.extras.jumpType === "18"){
        	//推送消息到患者-机构服务完成-患者上门服务单明细
        	var url = window.ServerURL + "/getTUpdoorInfo";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
	        	var param = "serviceId=" + infoObj.extras.id;
	        	param += "&sourceType=" + res[0].forwardType;
	            commonJs.openWindow("patientServiceDetailPage", "views/patient/roomService/patient_service_detail.html?" + param);
	            appcan.window.evaluatePopoverScript("patientServiceDetailPage", "patientServiceDetailContentPage", "patientServiceDetailContentJs.init()");
            });
        }else if(infoObj.extras.jumpType === "19"){
        	//推送消息到医生-药师处方驳回-医生处方单详细页
        	var url = window.ServerURL + "/getTRecipeInfoXf";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
                var param = "taskId=" + res.tRecipeInfoVOList[0].tRecipeInfo.taskId;
                param += "&recipeId=" + infoObj.extras.id;
	            commonJs.openWindow("prescriptionOrderPage", "views/doctor/diagnosis/prescription_order_header.html?" + param);
	            appcan.window.evaluatePopoverScript("prescriptionOrderPage", "prescriptionOrderContentPage", "prescriptionOrder.init()");
            });
        }else if(infoObj.extras.jumpType === "20"){
        	//推送消息到患者-医生修改后的处方单-处方单详细页
        	var param = "id=" + infoObj.extras.id;
            commonJs.openWindow("recipeInfoPatientPage", "views/patient/diagnosistreat/recipe_info_patient.html?" + param);
            appcan.window.evaluateScript("recipeInfoPatientPage", "recipeInfo.init()");
        }else if(infoObj.extras.jumpType === "21"){
        	//推送消息到患者-医生退诊费后-缴费单详细页
        	//查询缴费单据
        	var url = window.ServerURL + "/getPayXf";
            var param = {"id": infoObj.extras.id};
            _appcanRequestAjax(url, param, function(res) {
            	if(res[0].payOrderType === "GY"){
	            	var param = "id=" + res[0].orderId;
		            param += "&payId=" + res[0].id;
		            commonJs.openWindow("drugFeePaymentPage", "views/patient/diagnosis/drugFeePayment.html?" + param);
		            appcan.window.evaluatePopoverScript("drugFeePaymentPage", "drugFeePaymentContentPage", "drugFeePayment.init()");
            	}else if(res[0].payOrderType === "ZL"){
		            var param = "id=" + infoObj.extras.id;
		            commonJs.openWindow("diagnosisfeeConfirmPage", "views/patient/diagnosis/diagnosisfeeConfirm.html?" + param);
		            appcan.window.evaluatePopoverScript("diagnosisfeeConfirmPage", "diagnosisFeeConfirmContentPage", "diagnosisFeeConfirm.initModel('"+infoObj.extras.id+"')");
            	}else if(res[0].payOrderType === "SM"){
	            	var url = window.ServerURL + "/getTUpdoorInfo";
		            var param = {"id": res[0].orderId};
		            _appcanRequestAjax(url, param, function(res) {
			        	var param = "serviceId=" + res[0].id;
			        	param += "&sourceType=" + res[0].forwardType;
			            commonJs.openWindow("patientPaymentPage", "views/patient/roomService/patient_payment.html?" + param);
			            appcan.window.evaluatePopoverScript("patientPaymentPage", "patientPaymentContentPage", "patientPaymentContentJs.init()");
		            });
            	}else if(res[0].payOrderType === "JY"){
		            var url = window.ServerURL + "/getTForwardInfo";
		            var param = {"id": res[0].orderId};
		            _appcanRequestAjax(url, param, function(res) {
			        	var param = "forwardId=" + res[0].id;
			        	param += "&forwardType=" + res[0].forwardType;
			            commonJs.openWindow("assayOrgSelectPage", "views/patient/assay/assay_org_select.html?" + param);
			            appcan.window.evaluatePopoverScript("assayOrgSelectPage", "assayOrgSelectContentPage", "assayOrgSelectContent.init()");
		            });
            	}
            });
        }
    }

    var _onReceiveNotification = function (data) {
            alert("onReceiveNotification\n" + data);
        }
    
    return {
        _ajax: _ajax,
        requestAjax: _appcanRequestAjax,
        getUrlParam: _getUrlParam,
        compareText: _compareText,
        getCodelistData: _getCodelistData,
        getPatient: _getPatient, //当前登陆患者信息
        getDoctor: _getDoctor,   //医生登陆信息
        getApothecary: _getApothecary, //药师登陆信息
        getOrganization: _getOrganization, //机构登陆信息
        getLoginUser: _getLogingUser,  //当前用户信息
        jsonDateFormat:_jsonDateFormat,
        jsonTimeFormat:_jsonTimeFormat,
        dateToString: _dateToString,
        dateTimeToString: _dateTimeToString,
        timeToString: _timeToString,
        moneyFormat: _moneyFormat,   //格式化金额数据
        urlQueryToJSON: _urlQueryToJSON, //html头参数JSON格式化
        listWindowBounce: _listWindowBounce,  //LIST窗口下拉、上拖事件
        onBeforeAdd: _onBeforeAdd,
        openWindow: _openWindow,  //打开window窗口
        closeWindow: _closeWindow,  //关闭已打开的窗口
        checkDoctorLogin: _checkDoctorLogin, //检查医生是否已登陆
        checkPharmacistLogin: _checkPharmacistLogin,  //检查药师、调剂师是否已登陆
        checkMechanismLogin: _checkMechanismLogin, //检查机构是否已登陆
        getAgeByIdentityCard: _getAgeByIdentityCard, //根据身份证号计算年龄
        compile: _compile,  //字符串加密
        uncompile: _uncompile,  //字符串解密
        getBase64Image: getBase64Image, //img的base64编码
        dataURLtoFile: dataURLtoFile, //base64码转file
        createLoading: _createLoading,  //创建Loading
        showLoading: _showLoading,  //显示Loading
        closeLoading: _closeLoading,  //关闭Loading
        setBackKeyProc: _setBackKeyProc,  //物理退回键按钮功能
        getJpushRegistrationId: _getJpushRegistrationId,  //获取极光推送APP推送ID
        doNeteaseNim: _doNeteaseNim,   //网易云信聊天
        isPoneAvailable: isPoneAvailable, //验证是否为11位有效手机号码
        onReceiveNotificationOpen: _onReceiveNotificationOpen,  //极光推送点击信息
        onReceiveNotification: _onReceiveNotification  //极光推送收到信息后弹出提示
    }
})();

/******************************通用方法对象************************************/