if(!window.assayReportView){
    window.assayReportView = {};
}

var assayReportView = function() {
    var pageCount = 0, inParam, checkCount = 0, insassReports = [];
    
    var setInsassReportImg = function(data) {
        $(".insassReport").css("background-image", "url(" + window.PicURL + data.reportPictureUrl + ")");
        $("[data-bind='text:index']").text(data.index);
    }
    
    var getForwardInfo = function(){
        var param = _.clone(window.pagingParam);
        param.id = inParam.forwardId;
        commonService.request(param, {
            url: window.ServerURL + "/getTForwardDetailInfo",
            success: function(res) {
                var insassReport;
                for (var i = 0; i < res.tInsassReportList.length; i++) {
                    insassReport = res.tInsassReportList[i];
                    insassReport.index = i;
                    insassReports.push(insassReport);
                }
                setInsassReportImg(insassReports[0]);
            }
        });
    }
    
    appcan.button("#btnPrior", "btn-act", function() {
        var index = $("[data-bind='text:index']").text();
        if (!!index) {
            index = index.trim();
        }
        if (Number(index) === 0) {
            appcan.window.openToast("已是第一张报告", 2000, 5, 0);
            return;
        }
        var data = insassReports[Number(index) - 1];
        setInsassReportImg(data);
    });
    
    appcan.button("#btnNext", "btn-act", function() {
        var index = $("[data-bind='text:index']").text();
        if (!!index) {
            index = index.trim();
        }
        if (Number(index) + 1 === insassReports.length) {
            appcan.window.openToast("已是最后一张报告", 2000, 5, 0);
            return;
        }
        var data = insassReports[Number(index) + 1];
        setInsassReportImg(data);
    });
    
    //绑定鼠标左键按住事件
    $(".mask-layer-imgbox div").on("touchstart", function(event) {
        //alert("event:" + JSON.stringify(event.changedTouches[0]));
        event.preventDefault && event.preventDefault(); //去掉图片拖动响应
        
        //获取需要拖动节点的坐标
        var offset_x = $(this)[0].offsetLeft;//x坐标
        var offset_y = $(this)[0].offsetTop;//y坐标
        
        //获取当前鼠标的坐标
        var mouse_x = event.changedTouches[0].pageX;
        var mouse_y = event.changedTouches[0].pageY;
        //alert("mouse_x:" + mouse_x);
        //绑定拖动事件
        //由于拖动时，可能鼠标会移出元素，所以应该使用全局（document）元素
        $(".mask-layer-imgbox").on("touchmove", function (ev) {
            // 计算鼠标移动了的位置
            var _x = ev.changedTouches[0].pageX - mouse_x;
            var _y = ev.changedTouches[0].pageY - mouse_y;
            //alert("mouse_x:" + mouse_x + "ev.changedTouches[0].pageX:" + ev.changedTouches[0].pageX);
            //设置移动后的元素坐标
            var now_x = (offset_x + _x ) + "px";
            var now_y = (offset_y + _y ) + "px";
            //改变目标元素的位置
            $(".mask-layer-imgbox div").css({
                top: now_y,
                left: now_x
            });
        });
    });
    
    //当鼠标左键松开，接触事件绑定
    $(".mask-layer-imgbox").on("touchend", function () {
        $(".mask-layer-imgbox").off("touchmove");
    });
    
    //缩放
    var zoom_n = 1;
    appcan.button("#btnMagnify", "btn-act", function() {
        zoom_n += 0.1;
        $(".mask-layer-imgbox div").css({
            "transform": "scale(" + zoom_n + ")",
            "-moz-transform": "scale(" + zoom_n + ")",
            "-ms-transform": "scale(" + zoom_n + ")",
            "-o-transform": "scale(" + zoom_n + ")",
            "-webkit-": "scale(" + zoom_n + ")"
        });
    });
    
    //缩小
    appcan.button("#btnShrink", "btn-act", function() {
        zoom_n -= 0.1;
        if (zoom_n <= 0.1) {
            zoom_n = 0.1;
            $(".mask-layer-imgbox div").css({
                "transform":"scale(.1)",
                "-moz-transform":"scale(.1)",
                "-ms-transform":"scale(.1)",
                "-o-transform":"scale(.1)",
                "-webkit-transform":"scale(.1)"
            });
        } else {
            $(".mask-layer-imgbox div").css({
                "transform": "scale(" + zoom_n + ")",
                "-moz-transform": "scale(" + zoom_n + ")",
                "-ms-transform": "scale(" + zoom_n + ")",
                "-o-transform": "scale(" + zoom_n + ")",
                "-webkit-transform": "scale(" + zoom_n + ")"
            });
        }
    });
    
    //正常
    appcan.button("#btnNomal", "btn-act", function() {
        zoom_n = 1;
        $(".mask-layer-imgbox div").css({
            "transform": "scale(" + zoom_n + ")",
            "-moz-transform": "scale(" + zoom_n + ")",
            "-ms-transform": "scale(" + zoom_n + ")",
            "-o-transform": "scale(" + zoom_n + ")",
            "-webkit-": "scale(" + zoom_n + ")"
        });
        //改变目标元素的位置
        $(".mask-layer-imgbox div").css({
            top: 0,
            left: 0
        });
    });
        
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        getForwardInfo();
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    assayReportView.init();
});
