if(!window.editValue) {
    window.editValue = null;
}

var editValue = function() {
    var pubEditParam = new PubEditParam({});
    var pubEditValue = {}, inParam;
    
    var EditValueModel = MVVM.Model.extend({
        //defaults,散列（或函数）用于为模型指定默认属性。
        defaults: {"value": "", "text": "", "checked": false, "first": false, "last": false},
        idAttribute: "value"
    });
    
    //声名病类列表模型
    var EditValueCollection = MVVM.Collection.extend({
        initialize: function() {
            return;
        },
        parse: function(data) {
            console.log("editValueCollection.parse");
            return data;
        },
        model: EditValueModel
    });
    
    var checkItemViewModel = new(MVVM.ViewModel.extend({
        el: "#showRadiobox",
        collection: new EditValueCollection()
    }));

    
    
    var inputChange = function(event) {
        //返回JSNO字串
        var fieldValue = {};
        fieldValue[pubEditParam.fieldCode] = $("#inputValue", "[data-component='editValue']").val();
        //pubEditParam.setFieldValue(fieldValue);
        pubEditValue.fieldValue = fieldValue;
        if(!!inParam.parentPageName) {
            appcan.window.evaluatePopoverScript(inParam.parentPageName, inParam.parentFrameName, inParam.js +"(" + JSON.stringify(pubEditValue) + ")");
        } else {
            uexWindow.publishChannelNotification("getPubEditValue", JSON.stringify(pubEditValue));
        }
    }
    
    var checkItemClick = function(event) {
        var selectValue = $($(event.currentTarget).find("#codeValue")).text().trim();
        if (!!!selectValue) {
            return;
        }
        var editValueModel = new EditValueModel();
        editValueModel = checkItemViewModel.collection.where({checked: true});
        if (editValueModel.length > 0) {
                editValueModel[0].set("checked", false);
        }
        editValueModel= checkItemViewModel.collection.where({value: selectValue});
        if (editValueModel.length > 0) {
            editValueModel[0].set("checked", true);
        }
        var fieldValue = {};
        fieldValue[pubEditParam.fieldCode] = selectValue; //editValueModel[0].get("value");
        pubEditValue.fieldValue = fieldValue;
        pubEditValue.selectData = editValueModel[0];
        //向内容窗口发送值
        if(!!inParam.parentPageName) {
            appcan.window.evaluatePopoverScript(inParam.parentPageName, inParam.parentFrameName, inParam.js +"(" + JSON.stringify(pubEditValue) + ")");
        } else {
            uexWindow.publishChannelNotification("getPubEditValue", JSON.stringify(pubEditValue));
        }
    }
    
    var initInput = function() {
        $("#divInputEdit", "[data-component='editValue']").css("display", "inline");
        //修改录入属性
        $("#inputValue", "[data-component='editValue']").attr("type", pubEditParam.dataType);
      
        //fieldValue值为JSON字串，转JSON对象后取值
        $("#inputValue", "[data-component='editValue']").val(pubEditParam.fieldValue[pubEditParam.fieldCode] || "");
        $("#inputLabel", "[data-component='editValue']").text(pubEditParam.fieldName);
        
        //录入框CHANGE事件
        $("#inputValue", "[data-component='editValue']").change(inputChange);
    }
    
    var initCheckItem = function() {
        $("#divRadioboxEdit", "[data-component='editValue']").css("display", "inline");
        $("#radioboxLabel", "[data-component='editValue']").text(pubEditParam.fieldName);        
        checkItemViewModel.collection.add(pubEditParam.codelistType);
        checkItemViewModel.collection.first().set("first", true);
        checkItemViewModel.collection.last().set("last", true);
        var editValueModel = new EditValueModel();
        editValueModel = checkItemViewModel.collection.where({value: pubEditParam.fieldValue[pubEditParam.fieldCode]});
        if (editValueModel.length > 0) {
            editValueModel[0].set("checked", true);
        }
        appcan.button("li[data-control-scope='radioboxView_scope']", "", checkItemClick);
    }
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        var frame = {frameName: pubEditParam.fieldCode};
        uexWindow.publishChannelNotification("setCloseFrame", JSON.stringify(frame));
        pubEditValue = {fieldCode: pubEditParam.fieldCode, 
                    fieldName: pubEditParam.fieldName,
                    dataType: pubEditParam.dataType, 
                    editorType: pubEditParam.editorType, 
                    fieldValue: {}};
        if (pubEditParam.editorType === "input") {
            initInput();
        } else if (pubEditParam.editorType === "checkItem") {
            initCheckItem();
        }
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    editValue.init();
});
