/**
 * @author Nicro.Li
 * @description 公用值修改父页面与子页面参数传递类
 * @param  options: 参数项
 * @param: operationType 操作类型 只接受：set, get2个值，不传时默认为get操作
 */

var PubEditParam = function(options, operationType) {
    if (operationType === "set") {
        this.fieldCode = options.fieldCode; //字段编码
        this.fieldName = options.fieldName; //字段名称 用于LABEL显示
        this.dataType = options.dataType; //数据类型<input>控件的type类型
        this.editorType = options.editorType; //编辑器类型
        this.fieldValue = options.fieldValue; //字段当前值
        var codelistValue = [];
        if (!!options.codelistType) {
            codelistValue = window.codeList[options.codelistType];
        }
        this.codelistType = codelistValue; //codelist
        
        //写入本地缓存
        this.saveLocStorage(options);
    } else {
        this.getLocStorageValue();
        //为保证数据准确性,取出数据后,把本地缓存清除
        this.removeLocStorage();
    }
    /*
    appcan.locStorage.setVal("changeObjectName", "");
    appcan.locStorage.setVal("changeObjectLabel", "");
    appcan.locStorage.setVal("changeObjectDataType", ""); 
    appcan.locStorage.setVal("changeObjectEditorType", ""); //录入数据对像信息
    appcan.locStorage.setVal("changeObjectValue", null);
    appcan.locStorage.setVal("codelistType", null);
    */
}

PubEditParam.prototype = {
    saveLocStorage: function(options) {
        this.fieldCode = options.fieldCode; //字段编码
        this.fieldName = options.fieldName; //字段名称 用于LABEL显示
        this.dataType = options.dataType; //数据类型<input>控件的type类型
        this.editorType = options.editorType; //编辑器类型
        this.fieldValue = options.fieldValue; //字段当前值
        var codelistValue = [];
        if (!!options.codelistType) {
            codelistValue = window.codeList[options.codelistType];
        }
        this.codelistType = codelistValue; //codelist
    
        appcan.locStorage.setVal("fieldCode", options.fieldCode || "");
        appcan.locStorage.setVal("fieldName", options.fieldName || "");
        appcan.locStorage.setVal("dataType", options.dataType || "text"); 
        appcan.locStorage.setVal("editorType", options.editorType || ""); //录入数据对像信息
        appcan.locStorage.setVal("fieldValue", options.fieldValue || null);
        appcan.locStorage.setVal("codelistType", codelistValue);
    },    
    getLocStorageValue: function() {
        this.fieldCode = appcan.locStorage.getVal("fieldCode"); //字段编码
        this.fieldName = appcan.locStorage.getVal("fieldName"); //字段名称 用于LABEL显示
        this.dataType = appcan.locStorage.getVal("dataType"); //数据类型<input>控件的type类型
        this.editorType = appcan.locStorage.getVal("editorType"); //编辑器类型
        this.fieldValue = JSON.parse(appcan.locStorage.getVal("fieldValue")); //字段当前值
        var codelistValue = JSON.parse(appcan.locStorage.getVal("codelistType")); //转JSON对象
        this.codelistType = codelistValue; //codelist
    },
    removeLocStorage: function() {
        //移除值域信息
        appcan.locStorage.remove("fieldCode");
        appcan.locStorage.remove("fieldName");
        appcan.locStorage.remove("dataType"); 
        appcan.locStorage.remove("editorType"); //录入数据对像信息
        appcan.locStorage.remove("fieldValue");
        appcan.locStorage.remove("codelistType");
    },
    setFieldValue: function(value) {
       this.fieldValue = value;
       appcan.locStorage.setVal("fieldValue", value || null); 
    },
}
