appcan.define("selectview", function($, exports, module) {
var model_thinLine =  '<li class="selectviewItem" data-index="<%=index%>">\
                <div class="data-row-pd-left-1em">\
                    <div class="ub ub-f1 ub-ver data-row">\
                        <div class="ub ub-f1 data-line-height-min">\
                            <div class="ub ub-f1 view-label">\
                                <span class="font-32"><%=data.text%></span>\
                            </div>\
                            <div class="ub ub-f1 ub-pe ub-ac check-color right">\
                                <div class="check-icon-size-1x"></div>\
                            </div>\
                        </div>\
                    </div>\
                    <div class="one-px-h-line"></div>\
                </div>\
            </li>';

    var thinLineTmp = appcan.view.template(model_thinLine);
    var viewid = 1;
    function isWindows() {
        if(window.navigator.platform == "Win32") return true;
        if (!('ontouchstart' in window))
            return true;
    }

    function Selectview(option) {
        appcan.extend(this, appcan.eventEmitter);
        var self = this;
        self.option = $.extend({
            selector : "body",
            type : "thinLine",
            align : 'left',
            name: "",
            multiLine : false,
            id : viewid++
        }, option, true);
        self.ele = $(self.option.selector);
        if (self.option.data) {
            self.set(data);
        }

    };

    Selectview.prototype = {
        buildSelectview : function(data, group) {
            var container = $("<ul></ul>")
            var self = this;
            var html = thinLineTmp;
            for (var i in data) {
                var ele = $(html({
                    data : data[i],
                    option : self.option,
                    index: i
                }));
                ele[0]["item-data"] = data[i];
                //初始化选中项
                if (!!data[i].checked) {
                    ele[0].find(".check-icon-size-1x").addClass("check-blue");
                }
                ele.on('tap', function(evt) {
                    self.itemClick(evt);
                });
                ele.on(isWindows() ? 'mousedown' : 'touchstart', function(evt) {
                    self.touchItem(evt)
                });
                ele.on('longTap', function(evt) {
                    self.longTapItem(evt)
                });
                ele.on('cancleTap', function(evt) {
                    self.longTapItem(evt)
                });
                container.append(ele);
            }
            //var twoLine = $("<div class='two-px-h-line'></div>");
            var result = $("<div></div>");
            result.append( $("<div class='two-px-h-line top'></div>"));
            result.append(container);
            result.append( $("<div class='two-px-h-line bottom'></div>"));
            return result; //container;
        },
        add : function(data, dir) {
            var self = this;
            var container = self.buildSelectview(data);
            if (dir || dir == 1)
                self.ele.children().append(container.children());
            else {
                var first = self.ele.children().first();
                first.prepend(container.children());
            };
            $.each(self.ele.children().children(),function(i, li){  
                $(li).attr("data-index", i);
            });  
            return self;
        },
        set : function(data) {
            var self = this;
            var container;
            container = self.buildSelectview(data);
            self.ele.html(container);
            return self;
        },
        itemClick : function(evt) {
            var self = this;
            var obj = $(evt.currentTarget);
            obj.removeClass(this.option.touchClass);
            var returnData = [];
            if (!!self.multiLine) {
                for (var i = 0; i < $(event.currentTarget.parentElement).find("li").length; i++) {
                    returnData[i] = $(event.currentTarget.parentElement).find("li")[0]["item-data"];
                    returnData[i].checked = true;
                }
            } else {
                //单选时，选清除已选中项
               $(event.currentTarget.parentElement).find(".check-icon-size-1x").removeClass("check-blue");
               obj.find(".check-icon-size-1x").addClass("check-blue");
               returnData[0] = obj[0]["item-data"];
               returnData[0].checked = true;
            }
            self.trigger("select:click", self, obj, returnData);
        },
        touchItem : function(evt) {
            if (this.option.hasTouchEffect) {
                var self = this;
                var obj = $(evt.currentTarget);
                if (obj[0]["item_data"].switchBtn && self.option.hasControl)
                    return;
                obj.addClass(self.option.touchClass);
                setTimeout(function() {
                    obj.removeClass(self.option.touchClass);
                }, 300);
            }
        },
        longTapItem : function(evt) {
            if (this.option.hasTouchEffect) {
                var obj = $(evt.currentTarget);
                obj.removeClass(this.option.touchClass);
            }
        },
        updateItem : function(item, name, value) {
            switch(name) {
            case "title":
                $(".lv_title", item).html(value);
                break;
            case "subTitle":
                $(".lv_subTitle", item).html(value);
                break;
            }
        }
    }
    module.exports = function(option) {
        return new Selectview(option);
    };
});
