var DoctorLocationModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : doctorLocationTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，
    //那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
    	//头像
        getHeadPicture : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["HEAD_PICTURE"],
            get : function(HEAD_PICTURE) {
                return !!HEAD_PICTURE ? window.PicURL + HEAD_PICTURE : "";
            }
        },
        //距离
        getDistance: {
        	deps : ["DISTANCE"],
        	get : function(DISTANCE) {
        		if(DISTANCE > 1){
        			return DISTANCE.toFixed(2) + "公里";
        		}else{
        			return (DISTANCE*1000).toFixed(2) + "米";
        		}
        	}
        },
        //医生ID
        getDoctorId: {
        	deps : ["DOCTOR_ID"],
        	get : function(DOCTOR_ID) {
        		return DOCTOR_ID;
        	}
        },
        //医生手机号
        getDoctorPhone: {
        	deps : ["DOCTOR_PHONE"],
        	get : function(DOCTOR_PHONE) {
        		return DOCTOR_PHONE;
        	}
        }
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});