var DoctorTeamInfoModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : doctorTeamInfoTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        //头像
        getHeadPicture: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["headPicture"],
            get: function(headPicture) {
                if(!!headPicture && headPicture.indexOf("blob:file") != '-1'){
                    return headPicture;
                } else if(!!headPicture && headPicture.indexOf("data:image") != '-1'){
                    return headPicture;
                }
                return !!headPicture ? window.PicURL + headPicture : "";
            }
        },
        //头像
        getByHeadPicture: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["byHeadPicture"],
            get: function(byHeadPicture) {
                if(!!byHeadPicture && byHeadPicture.indexOf("blob:file") != '-1'){
                    return byHeadPicture;
                } else if(!!byHeadPicture && byHeadPicture.indexOf("data:image") != '-1'){
                    return byHeadPicture;
                }
                return !!byHeadPicture ? window.PicURL + byHeadPicture : "";
            }
        },
        getOnlineFlag: {
            deps: ["onlineStatus"],
            get: function(onlineStatus) {
                return onlineStatus === "Y" ? true : false;
            }
        },
        getOfflineFlag: {
            deps: ["onlineStatus"],
            get: function(onlineStatus) {
                return onlineStatus === "N" ? true : false;
            }
        },
        getOnlineStatus: {
            deps: ["onlineStatus"],
            get: function(onlineStatus) {
                return onlineStatus === "Y" ? "在线" : "离线";
            }
        },
        getSelectFlag: {
            deps: ["selectFlag"],
            get: function(selectFlag) {
                return selectFlag === "Y" ? true : false;
            }
        }
        //单据状态
        /*
        getStatus : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["status"],
            get : function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.recipeStatus, status);
                return codelist.text || status;
            }
        }
        */
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});