var ForwardInfoModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : forwardInfoTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        //类型
        getForwardType: {
            deps:["forwardType"],
            get: function(forwardType) {
                var text = "";
                if (forwardType === "HY") {
                    text = "化验";
                } else if (forwardType === "JC") {
                    text = "预约";
                }
                return text;
            }
        },
        //是否检查单
        getAppointmentFlag: {
            deps:["forwardType"],
            get: function(forwardType) {
                if (forwardType === "JC") {
                    return true;
                } else {
                    return false;
                }
            }
        },
        //检验总价
        getForwardFee: {
            deps:["forwardFee"],
            get: function(forwardFee) {
                return commonJs.moneyFormat(forwardFee);
            }
        },
        //检查优惠总价
        getForwardSaleFee: {
            deps:["forwardSaleFee"],
            get: function(forwardSaleFee) {
                return commonJs.moneyFormat(forwardSaleFee);
            }
        },
        //合计
        getSumFee: {
            deps:["sumFee"],
            get: function(sumFee) {
                return commonJs.moneyFormat(sumFee);
            }
        },
        //缴费金额
        getTaskSumfee: {
            deps:["taskSumfee"],
            get: function(taskSumfee) {
                return commonJs.moneyFormat(taskSumfee);
            }
        },
        //性别
        getSex : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["sex"],
            get : function(sex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, sex);
                return codelist.text || sex;
            }
        },
        //单据状态
        getStatus : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.forwardStatus, status);
                return codelist.text || status;
            }
        },
        getStatusColor: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                /*
                {id: "114", value: "YKD", text: "已开单"},
                {id: "115", value: "YJF", text: "已缴费"},
                {id: "116", value: "YYY", text: "已预约"},
                {id: "117", value: "YJY", text: "已检验"},
                {id: "118", value: "YWC", text: "已完成"},
                {id: "119", value: "YGB", text: "已关闭"}
                */
                
                var color = "";
                if (status === "YKD") {
                    //已开单
                   color = "#09b1d2";
                } else if(status === "DJF") {
                    //待缴费
                    color = "#fa7070"; 
                } else if (status === "YJF") {
                    //已缴费
                    color = "#32d8b1"; 
                } else if (status === "YYY") {
                    //已预约
                    color = "#fda007"; 
                } else if (status === "YJY") {
                    //已检验
                    color = "#8b90f9"; 
                } else if (status === "YWC") {
                    //已完成
                    color = "#86cd69"; 
                } else if (status === "YGB") {
                    //已关闭
                    color = "#999999"; 
                }
                return color;
            }
        },
        getTastWay: {
            deps: ["tastWay"],
            get: function(tastWay) {
                var text;
                if (tastWay == 0) {
                    text = "检验中心";
                } else if (tastWay == 1){
                    text = "护士上门";
                } else {
                    text = tastWay;
                }
                return text;
            }
        },
        getDoTime: {
            deps: ["doTime"],
            get: function(doTime) {
                if (typeof(doTime) === "object" && _.allKeys(doTime).length === 0) {
                     return null;
                } else if(!!!doTime) {
                    return null;
                }
                return  commonJs.dateTimeToString(doTime);
            }
        },
        //头像
        getTastDoctorPic : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["tastDoctorPic"],
            get : function(tastDoctorPic) {
                if(!!tastDoctorPic && tastDoctorPic.indexOf("blob:file") != '-1'){
                    return tastDoctorPic;
                } else if(!!tastDoctorPic && tastDoctorPic.indexOf("data:image") != '-1'){
                    return tastDoctorPic;
                }
                return !!tastDoctorPic ? window.PicURL + tastDoctorPic : "";
            }
        },
        getTastWayFlag: {
            deps: ["tastWay"], 
            get: function(tastWay) {
                if (tastWay == 1) {
                    return true;
                } else {
                    return false;
                }
            }
        },
        //评份标志
        getScoreOneFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 1;
            }
        },
        //评份标志
        getScoreTwoFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 2;
            }
        },
        //评份标志
        getScoreThreeFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 3;
            }
        },
        //评份标志
        getScoreFourFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 4;
            }
        },
        //评份标志
        getScoreFiveFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 5;
            }
        },
        //缴费按钮是否显示
        getJznones: {
            deps: ["status"],
            get: function(status) {
                jzflags=false;
                if(this.get("status") === "YJF"){
                    jzflags=true;
                }
                return jzflags;
            }
        }
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});