var MechanismModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : mechanismTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        //单据状态
        getStatus : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.forwardStatus, status);
                return codelist.text || status;
            }
        },
        getMechanismPicture: {
            deps: ["mechanismPicture1"],
            get: function(mechanismPicture1) {
                if(!!mechanismPicture1 && mechanismPicture1.indexOf("blob:file") != '-1'){
                    return mechanismPicture1;
                } else if(!!mechanismPicture1 && mechanismPicture1.indexOf("data:image") != '-1'){
                    return mechanismPicture1;
                }
                return !!mechanismPicture1 ? window.PicURL + mechanismPicture1 : "";
            }
        },
        //机构是否登陆,有ID值则表示已登陆
        getIsLogin: {
            deps: ["id"],
            get: function(id) {
                return !!id;
            }
        },
        getMechanismType: {
            deps: ["mechanismType"],
            get: function(mechanismType) {
                var codelist = commonJs.getCodelistData(window.codeList.mechanismType, mechanismType);
                return codelist.text || mechanismType;
            }
        },
        getBusinessLicenseTime:{
            deps: ["businessLicenseTime"],
            get: function(businessLicenseTime){
                if (typeof(businessLicenseTime) === "object" && _.allKeys(businessLicenseTime).length === 0) {
                     return null;
                } else if(!!!businessLicenseTime) {
                    return null;
                }
                return  commonJs.dateToString(businessLicenseTime);
            }
        }
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});