
//recipeDetailInfoTable.styleDisplay = "-webkit-box !important";
var PatientRelativModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : patientRelativTable,
    //在model创建后执行的方法
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，
    //那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        //亲属性别
        getRelativSex : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["relativSex"],
            get: function(relativSex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, relativSex);
                return codelist.text || relativSex;
            }
        },
        getNameLength: {
            deps: ["relativName"],
            get: function(relativName) {
                var chrLength = 0, pLength = 0;
                for (var i = 0; i < relativName.length; i++) {
                    var str = relativName[i];
                    if (/([A-Za-z0-9])/g.test(str)) {
                        chrLength++;
                    } else {
                        pLength++;
                    }
                }
                return !!relativName ? pLength + chrLength*0.45 + 0.3 : 0.3;
            }
        }
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});