payStatementVTable.isMonthFeeSum = false; //该行数据是否为月金额统计行
payStatementVTable.monthFeeSum = 0; //月汇总金额
payStatementVTable.payMonthStr = "";
var PayStatementModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : payStatementVTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        //医师类别 
        getTastDoctorType : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["tastDoctorType"],
            get : function(tastDoctorType) {
                var codelist = commonJs.getCodelistData(window.codeList.doctorType, tastDoctorType);
                return codelist.text || tastDoctorType;
            },
        },
        //单据状态
        getStatus : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["status"],
            get : function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.payStatus, status);
                return codelist.text || status;
            }
        },
        getAwaitPayStatus: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["status"],
            get : function(status) {
                return !!status ? status === "0" : false;
            }
        },
        //状态值标签显示信息
        getPayOrderTypeLabel: {
            deps : ["payOrderType"],
            get : function(payOrderType) {
                var text;
                if (payOrderType === "GY") {
                    text = "购药费："; 
                } else if (payOrderType === "ZL") {
                    text = "诊疗费：";
                }
                return text || payOrderType;
            }
        },
        //性别
        getSex : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["sex"],
            get : function(sex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, sex);
                return codelist.text || sex;
            }
        },
        //付款日期
        getPayTime: {
            deps: ["payTime"],
            get: function(payTime) {
                if (typeof(payTime) === "object" && _.allKeys(payTime).length === 0) {
                     return null;
                } else if(!!!payTime) {
                    return null;
                }
                return !!!payTime ? null : commonJs.dateToString(payTime).substr(5, 5);
            }
        },
        getMonthFeeSum: {
            deps: ["isMonthFeeSum"],
            get: function(isMonthFeeSum) {
                if (!!isMonthFeeSum) {
                    var _self = this, param = {
                        yearMonth: this.get("payMonth"),
                        tastDoctorId: this.get("tastDoctorId")
                    };
                    commonService.request(param, {
                        url: window.ServerURL + "/getTaskPaySumFeeXf",
                        success: function(data) {
                            _self.set("monthFeeSum", data);
                        }
                    })
                }
            }
        }
        
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            console.log("patch");
            break;
        case "delete":
            console.log("delete");
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});