
recipeDrugDetailTable.styleDisplay = "-webkit-box !important";
var RecipeDrugDetailModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : recipeDrugDetailTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，
    //那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        getDrugAmount: {
            deps: ["retailPrice, usageTotal"],
            get: function() {
                var drugAmount;
                try {
                    //金额取2位小数
                    drugAmount = Math.round((this.get("sale") || 1) * this.get("retailPrice") * this.get("usageTotal") * 100) / 100;
                } catch(e) {
                    return null;
                }
                return commonJs.moneyFormat(drugAmount) || null;
            }
        },
        getLast: {
            get: function() {
                return this.get("lastRow") === null ||  typeof(this.get("lastRow")) === "undefined" || this.get("lastRow") === false ? false : true
            }
        }
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});

