taskInfoTable.extend1 = "N";
//是否修改登陆用户与患者关系标志  Y:
taskInfoTable.doctorTaskPrice = "";
//正常诊疗费职称（从医生表取数据）
taskInfoTable.platformPrice = "";
//平台价（从医生表取数据）
taskInfoTable.customerPrice = "";
//签约客户价（从医生表取数据）
var TaskInfoModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults: taskInfoTable, //诊疗记录表
    //在model创建后执行的方法
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds: {
        getTastDoctorType: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["tastDoctorType"],
            get: function(tastDoctorType) {
                for (var i = 0; i < window.codeList.doctorType.length; i++) {
                    if (tastDoctorType === window.codeList.doctorType[i].value) {
                        return window.codeList.doctorType[i].text;
                    }
                }
                return tastDoctorType;
            }
        },
        getSex: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["sex"],
            get: function(sex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, sex);
                return codelist.text || sex;
            }
        },
        //诊疗单据状态
        getStatus: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.taskStatus, status);
                return codelist.text || status;
            }
        },
        //患者性别
        getRelativSex: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["relativSex"],
            get: function(relativSex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, relativSex);
                return codelist.text || relativSex;
            }
        },
        //患者性别 医生查询
        getPatientSex: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["patientSex"],
            get: function(patientSex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, patientSex);
                return codelist.text || patientSex;
            }
        },
        getStatusNone: {
            deps: ["status"],
            get: function(status) {
                if(this.get("status") === "YWC"||this.get("status") === "YGB" ){
                    flag=true;
                }else{
                    flag=false;
                }
                return flag;
                
            }
        },
         //患者签约日期
        getSignTimeStr: {
            deps: ["signTime"],
            get: function(signTime) {
                if (typeof(signTime) === "object" && _.allKeys(signTime).length === 0) {
                     return null;
                } else if(!!!signTime) {
                    return null;
                }
                return  commonJs.dateTimeToString(signTime);
            }
        },
        getCreateDateStr: {
            deps: ["createDate"],
            get: function(createDate) {
                if (typeof(createDate) === "object" && _.allKeys(createDate).length === 0) {
                     return null;
                } else if(!!!createDate) {
                    return null;
                }
                return  commonJs.dateTimeToString(createDate);
            }
        },
        getJznone: {
            deps: ["status"],
            get: function(status) {
                
                jzflag=true;
                if(this.get("status") === "YZX"){
                    jzflag=false;
                }
                return jzflag;
                
            }
        },
        getJznones: {
            deps: ["status"],
            get: function(status) {
                
                jzflags=true;
                if(this.get("status") === "YJF"||this.get("status") === "YJZ"||this.get("status") === "DJF"||this.get("status") === "YTF"){
                    jzflags=false;
                }
                return jzflags;
            }
        },
        //患者年龄
        getAge: {
            deps: ["patientBirthDate"],
            get: function(patientBirthDate) {
                if (typeof(patientBirthDate) === "object" && _.allKeys(patientBirthDate).length === 0) {
                     return '';
                } else if(!!!patientBirthDate) {
                    return '';
                }
                return new Date().getFullYear() - commonJs.dateToString(patientBirthDate).substr(0,4);
            }
        }
    },
    parse: function(data) {
        //console.log(data);
        return data;
    },
    sync: function(method, model, options) {
        switch (method) {
        case "create":
            console.log("create");
            break;
        case "update":
            console.log("update");
            /*
            var param = {
                "payOrderType": "ZL",
                "orderId": model.get("id"),
                "taskPrice": model.get("doctorTaskPrice"), //正常价格
                "customerPrice": model.get("customerPrice"), //签约客户价格
                "platformPrice": model.get("platformPrice"), //平台价格
                //存在新属关系时，患者信息传入新属数据
                "patientAge": model.get("relativAge") || model.get("patientAge"),
                "sex": model.get("relativSex") || model.get("sex"),
                "patientName": model.get("relativName") || model.get("patientName"),
                "illnessCode": model.get("illnessCode"),
                "illnessName": model.get("illnessName"),
                "sumfee": model.get("taskPrice"),
                "relativRelCode": model.get("relativRelCode") || "BR",
                "relativRelName": model.get("relativRelName") || "本人",
                "extend1": model.get("extend1") || "N"
            };

            var diagnosisCostService = new DiagnosisCostService(param, options);
            diagnosisCostService.addPay();
            */
            break;
        case "patch":
            console.log("patch");
            break;
        case "delete":
            console.log("delete");
            break;
        case "read":
            
            //diagnosisCostPostService.request(param, options);
            break;
        default:
            break;
        }
    }
});

