var UpdoorInfoModel = CommonBase.Model.extend({
    defaults: updoorInfoTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds: {
    	//提交时间
        getCreateDateStr: {
            deps: ["createDate"],
            get: function(createDate) {
            	if(createDate == undefined){
            		return null;
            	}
                return commonJs.dateTimeToString(createDate);
            }
        },
        //状态
        getStatus: {
            deps: ["status"],
            get: function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.updoorStatus, status);
                return codelist.text || status;
            }
        },
        //性别
        getSex: {
            deps : ["sex"],
            get : function(sex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, sex);
                return codelist.text || sex;
            }
        },
        //缴费时间
        getTaskPayTimeStr: {
            deps: ["taskPayTime"],
            get: function(taskPayTime) {
            	if(taskPayTime == undefined){
            		return null;
            	}
                return commonJs.dateTimeToString(taskPayTime);
            }
        },
        //服务完成时间
        getTaskPayTimeStr: {
            deps: ["overTime"],
            get: function(overTime) {
            	if(overTime == undefined){
            		return null;
            	}
                return commonJs.dateTimeToString(overTime);
            }
        },
        //收费标准
        getServerItemPrice : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["serverItemPrice"],
            get : function(serverItemPrice) {
                return "￥"+serverItemPrice+"/次";
            },
        },
        //服务次数
        getTastCount : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["tastCount"],
            get : function(tastCount) {
                return tastCount+"次";
            },
        },
       //合计金额
        getSumFee : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["sumFee"],
            get : function(sumFee) {
                return "￥"+sumFee;
            },
        },
        //评份标志
        getScoreOneFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 1;
            }
        },
        //评份标志
        getScoreTwoFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 2;
            }
        },
        //评份标志
        getScoreThreeFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 3;
            }
        },
        //评份标志
        getScoreFourFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 4;
            }
        },
        //评份标志
        getScoreFiveFlag: {
            deps:["evaluateScore"],
            get: function(evaluateScore) {
                return evaluateScore >= 5;
            }
        },
        //地址
        getAddress: {
        	deps : ["regionDesc, address"],
        	get : function() {
        		patientAddress = "";
        		patientAddress += !!this.get("regionDesc")?this.get("regionDesc"):"";
        		patientAddress += !!this.get("address")?this.get("address"):"";
        		return  patientAddress;
        	}
        },
        //缴费按钮是否显示
        getJznones: {
            deps: ["status"],
            get: function(status) {
                jzflags=true;
                if(this.get("status") === "YQR"){
                    jzflags=false;
                }
                return jzflags;
            }
        }
    },
    parse : function(data) {
        return data;
    },
    sync: function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});
