if(!window.assayBillCreateContent){
    window.assayBillCreateContent = {};
}

var assayBillCreateContent = function() {
    var pageCount = 0, inParam, doctorInfo = {}, checkCount = 0, assayItemData = [];
    var forwardType = ["HY", "JC"];
    
    var forwardInfoModel = new ForwardInfoModel();
    var forwardInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".forwardInfo",
        model: forwardInfoModel
    }))();
    
    var assayItemInfoViewModel = {};
    
    var setSumFee = function() {
        var sumFee = 0;
        for (var i =0; i < assayItemInfoViewModel.collection.models.length; i++) {
            var data = assayItemInfoViewModel.collection.models[i];
            sumFee += Number(data.get("price"));
        }
        forwardInfoModel.set("forwardFee", sumFee);
        forwardInfoModel.set("forwardSaleFee", sumFee);
        var forwardInfo = JSON.stringify(forwardInfoModel.attributes);
        uexWindow.evaluateScript("", "0", "setSumFee(" + forwardInfo + ")");
    }
    
    var addAssayItem = function(res) {
        var items = [];
        if (res.length > 0) {
            if (typeof(items) === "string") {
                res = JSON.parse(res);
            }
            for (var i in res) {
                var assayItemInfos = assayItemInfoViewModel.collection.where({"itemId": res[i].assayItem.id});
                if (assayItemInfos.length > 0) {
                    continue;
                }
                var item = {};
                item.itemId = res[i].assayItem.id;
                item.itemCode = res[i].assayItem.itemCode;
                item.itemName = res[i].assayItem.itemName;
                item.price = res[i].assayItem.price;
                items.push(item);
            }
            assayItemInfoViewModel.collection.add(items);
            setSumFee();
        }
        //res[0].assayItem
        //alert("生成化验单成功\n" + JSON.stringify(items));
    }
    
    appcan.button("#btnAddAssayItem", "btn-act", function() {
        var outParam = "forwardType=" + inParam.forwardType;
        commonJs.openWindow("selectAssayItemPage", "select_assay_item.html?" + outParam);
    });
    
    var getTaskInfo = function() {
        var param = _.clone(window.pagingParam);
        param.id = inParam.taskId || "_";
        param.doctoryId = doctorInfo.id;
        commonService.request(param, {
            url: window.ServerURL + "/getTaskInfoXf",
            success: function(res) {
                if (res.length > 0) {
                    var forwardInfo = _.clone(forwardInfoTable);
                    forwardInfo.forwardType = inParam.forwardType;
                    forwardInfo.taskId = res[0].id; //诊疗记录ID
                    forwardInfo.status = "YKD"; //已开单
                    forwardInfo["patientId"] = res[0].patientId; //患者ID
                    forwardInfo["patientCode"] = res[0].patientCode; //患者编号
                    forwardInfo["patientPhone"] = res[0].patientPhone; //患者手机号
                    forwardInfo["patientName"] = res[0].relativName; //患者姓名
                    forwardInfo["cardId"] = res[0].cardId; //患者身份证号
                    forwardInfo["sex"] = res[0].relativSex; //患者性别
                    forwardInfo["patientBirthDate"] = res[0].patientBirthDate; //出生年月日
                    forwardInfo["patientAge"] = res[0].relativAge; //患者年龄
                    forwardInfo["tastDoctorId"] = res[0].tastDoctorId; //接诊医师ID
                    forwardInfo["tastDoctorCode"] = res[0].tastDoctorCode; //接诊医师编号
                    forwardInfo["tastDoctorName"] = res[0].tastDoctorName; //接诊医师姓名
                    forwardInfo["tastDoctorType"] = res[0].tastDoctorType; //接诊医师类别（Q全科 Z专科）
                    forwardInfo["tastDoctorMechanismId"] = res[0].tastDoctorMechanismId; //接诊医师单位ID（对应机构）
                    forwardInfo["tastDoctorMechanismName"] = res[0].tastDoctorMechanismName; //接诊医师机构名称
                    forwardInfo["tastDoctorMechanismType"] = res[0].tastDoctorMechanismType; //接诊医师单位类别(药房、检验中心、康复中心、门诊、一级医院、二级医院、三级医院、药械租赁公司)
                    forwardInfo["tastDoctorTitleCode"] = res[0].tastDoctorTitleCode; //接诊医师职称编码
                    forwardInfo["tastDoctorTitleName"] = res[0].tastDoctorTitleName; //接诊医师职称名称（主任医师、副主任医师、主治医师、医师）  
                    forwardInfoViewModel.model.set(forwardInfo);
                }             
            }
        });
    }
    
    var doSaveForwardInfo = function() {
        var forwardInfo = {"tForwardInfo": {}, "tAssayItemInfoList": [], "tInspectionInfoList": []};
        forwardInfo.tForwardInfo.forwardType = forwardInfoViewModel.model.get("forwardType");
        forwardInfo.tForwardInfo.taskId = forwardInfoViewModel.model.get("taskId");
        forwardInfo.tForwardInfo.conditionDesc = forwardInfoViewModel.model.get("conditionDesc"); //状况说明
        for (var i = 0; i < assayItemInfoViewModel.collection.models.length; i++) {
            var assayItemInfo = {};
            assayItemInfo.itemId = assayItemInfoViewModel.collection.models[i].get("itemId");
            assayItemInfo.itemCode = assayItemInfoViewModel.collection.models[i].get("itemCode");
            assayItemInfo.itemName = assayItemInfoViewModel.collection.models[i].get("itemName");
            assayItemInfo.price = assayItemInfoViewModel.collection.models[i].get("price");
            if (inParam.forwardType === forwardType[0]) { 
                //化验
                forwardInfo.tAssayItemInfoList.push(assayItemInfo);
            } else if (inParam.forwardType === forwardType[1]) { 
                //预约
                forwardInfo.tInspectionInfoList.push(assayItemInfo);
            }
            
        }
        if (!!!forwardInfoViewModel.model.get("forwardType")) {
            appcan.window.openToast("检查类型为空，保存失败！", 2000, 5, 0);
            return;
        }
        if (forwardInfoViewModel.model.get("forwardType") === forwardType[0] && 
            forwardInfo.tAssayItemInfoList.length === 0) {
            appcan.window.openToast("请选择化验项目！", 2000, 5, 0);
            return;
        }
        if (forwardInfoViewModel.model.get("forwardType") === forwardType[1] && 
            forwardInfo.tInspectionInfoList.length === 0) {
            appcan.window.openToast("请选择检查项目！", 2000, 5, 0);
            return;
        }
        commonService.request(forwardInfo, {
            url: window.ServerURL + "/addTForwardInfo",
            success: function(res) {
                var msg = "";
                if (inParam.forwardType === forwardType[0]) { 
                    //化验
                    msg = "保存化验单";
                } else if (inParam.forwardType === forwardType[1]) { 
                    //预约
                    msg = "保存预约单";
                }
                if (res.result === "0") {
                    appcan.window.openToast(msg + "成功！", 2000, 5, 0);
                    uexWindow.evaluateScript("", "0", "closeWindow()");
                } else {
                    appcan.window.openToast(msg + "失败！", 2000, 5, 0);
                }
            }
        });    
    }
    
    //手势滑动开始坐标获取，直接监听BODY事件
    $("body").on("touchstart", function(event) {
        // 判断默认行为是否可以被禁用
        startX = event.changedTouches[0].pageX,
        startY = event.changedTouches[0].pageY;
        
    });
     
    //药品信息删除按钮显示
    var showDeleteBtn = function(event) {
        moveEndX = event.changedTouches[0].pageX,
        moveEndY = event.changedTouches[0].pageY,
        X = moveEndX - startX,
        Y = moveEndY - startY;
        //alert("startX:" + (moveEndX - startX) + "    startY:" + (moveEndY - startY));
        if ( X + 100 < 0 && 50 > Y && -50 < Y) {
            //左滑
            $(event.currentTarget).find(".deleteItem").removeClass("field-nodisplay");
            $(event.currentTarget).find(".deleteItem").addClass("field-display");
        } else if ( X - 100 > 0 && 50 > Y && -50 < Y) {
            //右滑
            $(event.currentTarget).find(".deleteItem").removeClass("field-display");
            $(event.currentTarget).find(".deleteItem").addClass("field-nodisplay");
        }
    }
    var doDeleteAssayItem = function(event) {
        var itemId = $(event.currentTarget).parents("li").find("[data-bind='text:itemId']").text().trim();
        var model = assayItemInfoViewModel.collection.where({"itemId": itemId});
        assayItemInfoViewModel.collection.remove(model);
        //册除完本行数据后，隐藏删除按钮
        $(event.currentTarget).parents("ul").find(".deleteItem").removeClass("field-display");
        $(event.currentTarget).parents("ul").find(".deleteItem").addClass("field-nodisplay");
        //计算金额，更新头表金额
        setSumFee();
    }
        
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorInfo = commonJs.getDoctor();
        if (inParam.forwardType === forwardType[0]) {
            assayItemInfoViewModel =  new(MVVM.ViewModel.extend({
                el: "#showForwardInfoView",
                collection: new AssayItemInfoCollection()
            }))();
        } else if (inParam.forwardType === forwardType[1]) {
            assayItemInfoViewModel =  new(MVVM.ViewModel.extend({
                el: "#showForwardInfoView",
                collection: new InspectionInfoCollection()
            }))();
        }
        getTaskInfo();
    }
    
    return {
        init: init,
        addAssayItem: addAssayItem,
        doSaveForwardInfo: doSaveForwardInfo,
        doDeleteAssayItem: doDeleteAssayItem,
        showDeleteBtn: showDeleteBtn
    }
}();

appcan.ready(function() {
    assayBillCreateContent.init();
});
