if(!window.assayBillViewContent){
    window.assayBillViewContent = {};
}

var assayBillViewContent = function() {
    var pageCount = 0, inParam, doctorInfo = {}, checkCount = 0, assayItemData = [],
        assayReportSlider = {}, forwardType = ["HY", "JC"];
    
    var forwardInfoModel = new ForwardInfoModel();
    var forwardInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".forwardInfos",
        model: forwardInfoModel
    }))();
    
    var assayItemInfoViewModel = {}
    
    var setEvaluateScore = function() {
        for (var i = 0; i < forwardInfoModel.get("evaluateScore"); i++) {
            $("#evaluateScore").find("[name='" + (i+1) + "']").removeClass("nochoice");
            $("#evaluateScore").find("[name='" + (i+1) + "']").addClass("choice");
        }
    }
    
    var getForwardInfo = function(){
        var param = _.clone(window.pagingParam);
        param.id = inParam.forwardId;
        commonService.request(param, {
            url: window.ServerURL + "/getTForwardDetailInfo",
            success: function(res) {
                forwardInfoViewModel.model.set(res.tForwardInfo);
                if (res.tForwardInfo.forwardType === forwardType[0]){
                    //化验项目
                    assayItemInfoViewModel.collection.set(res.tAssayItemInfoList);
                } else if (res.tForwardInfo.forwardType === forwardType[1]){
                    //检查项目
                    assayItemInfoViewModel.collection.set(res.tInspectionInfoList);
                }
                //报告明细
                setReportSliderData(res.tInsassReportList);
                setEvaluateScore();
            }
        });
    }
    
    var setReportSliderData = function(data) {
        var assayReportList = [];
        if (!!!data) return;
        for (var i = 0; i < data.length; i++) {
            var assayReport = {};
            assayReport.img = window.PicURL + data[i].reportPictureUrl;
            assayReport.label = data[i].reportRemark; //描述
            assayReport.rowData = data[i];
            assayReportList.push(assayReport);
        }
        assayReportSlider.set(assayReportList);
        
        $("#assayReportSlider").find(".utra.focus.bc-head").css("background-color", "#24bad6");
        //$("#assayReportSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("background-color", "rgba(0,0,0, 0)");
        $("#assayReportSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("background-color", "#e0e0e0");
        $("#assayReportSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("color", "#000000");
        
    }
    
    var initAssayReportSlider = function() {
        //化验报告图片轮播
        assayReportSlider = appcan.slider({
            selector : '#assayReportSlider',
            aspectRatio: 320/1000,
            hasLabel: true,
            index: 0,
            auto: 10000
        });
        
        assayReportSlider.on("clickItem", function(index, data){
            console.log(index, data);
            var outParam = "forwardId=" + inParam.forwardId;
            commonJs.openWindow("assayReportViewPage", "../../components/assay_report_view.html?" + outParam);
        });
    }
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorInfo = commonJs.getDoctor();
        if (inParam.forwardType === forwardType[0]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new AssayItemInfoCollection()
            }))();
        } else if (inParam.forwardType === forwardType[1]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new InspectionInfoCollection()
            }))();
        }
        
        initAssayReportSlider();
        getForwardInfo();
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    assayBillViewContent.init();
});
