if(!window.patientRelativEdit){
    window.patientRelativEdit = {};
}

var patientRelativEdit = function() {
    var inParam, headerHeight;
    var patientRelativModel = new PatientRelativModel();
    var pubEditParam = new PubEditParam();
    //声明viewmodel
    var patientRelativViewModel = new(MVVM.ViewModel.extend({
        el: "[data-control='CONTENT']",
        model: patientRelativModel
    }));

    var getPatientInfoSuccess = function(res) {
        patientRelativModel.set("patientId", res[0].id);
    }
    var getPatientInfo = function(patientId) {
        var param = _.clone(window.pagingParam);
        param.id = patientId;
        commonService.request(param, {
            url: window.ServerURL,
            success: getPatientInfoSuccess
        });
    }
    
    var doSaveSuccess = function(res) {
        if (res.result === "0") {
            appcan.window.openToast("保存成功", 2000, 50, 0);
            if (inParam.scriptPage === "selectPatientRelativPage") {
                appcan.frame.evaluateScript({
                    name: "selectPatientRelativPage",
                    popName: "selectPatientRelativContentPage",
                    scriptContent: "selectPatientRelativ.refreshPatientRelativ()"
                });
            }
            uexWindow.evaluateScript("", "0", "closeWindow()");
        } else {
            appcan.window.openToast(res.message, 2000, 50, 0);
        }
    }
    var doSave = function(){
        
        var data = {"patientId": patientRelativModel.get("patientId"),
            "relativRelCode": patientRelativModel.get("relativRelCode"),
            "relativRelName": patientRelativModel.get("relativRelName"), 
            "relativPhone": patientRelativModel.get("relativPhone"),
            "relativName": patientRelativModel.get("relativName"),
            "relativCardId": patientRelativModel.get("relativCardId"),
            "relativSex": patientRelativModel.get("relativSex"),
            "relativSoSeCard": patientRelativModel.get("relativSoSeCard"),
            "relativAge": patientRelativModel.get("relativAge")};
        commonService.request(data, {
            url: window.ServerURL + "/addTPatientRelativ",
            success: doSaveSuccess
        });
    }
    
    var getPubEditValue = function(res) {
        //console.log(res);
        var frame = appcan.require("frame");
        var value;
        if(typeof(res) === "string") {
           value = JSON.parse(res);
        } else if(typeof(res) === "object") {
            value = res;
        }
        if (value.fieldCode === "relativSex") {
            patientRelativModel.set("relativSex", value.fieldValue.relativSex);
            frame.close("relativSexPubPage");
        } else  if (value.fieldCode === "relativRelCode") {
            patientRelativModel.set("relativRelName", value.selectData.text);
            patientRelativModel.set("relativRelCode", value.fieldValue.relativRelCode);
            frame.close("relativRelNamePubPage");
        }
        //relativRelNamePubPage
        pubEditParam.removeLocStorage();
    }
    //获取亲属关系    
    appcan.button("#relativRelName", "btn-act", function() {
        var changeObjectValue = {"relativRelCode": patientRelativModel.get("relativRelCode"),
            "relativRelName": patientRelativModel.get("relativRelName")};
        var options = {fieldCode: "relativRelCode", fieldName: "亲属关系",
            editorType: "checkItem", fieldValue: changeObjectValue, codelistType: "patientRelativ"};       
        pubEditParam.saveLocStorage(options);
        //uexWindow.onGetPubEditValue = getPubEditValue;
        //uexWindow.subscribeChannelNotification("getPubEditValue", "onGetPubEditValue");
        var paramStr = "&parentPageName=patientRelativEditPage";
            paramStr += "&parentFrameName=patientRelativEditContentPage";
            paramStr += "&js=patientRelativEdit.getPubEditValue";
        appcan.frame.open("content", "../../components/pubEditValue.html?" + paramStr, 0, inParam.headerHeight, "relativRelNamePubPage");
          
    });
    
    appcan.button("#relativSex", "btn-act", function() {
        var changeObjectValue = {"relativSex": patientRelativModel.get("relativSex")};
        var options = {fieldCode: "relativSex", fieldName: "性别",
            editorType: "checkItem", fieldValue: changeObjectValue, codelistType: "genderType"};       
        pubEditParam.saveLocStorage(options);
        //uexWindow.onGetPubEditValue = getPubEditValue;
        //uexWindow.subscribeChannelNotification("getPubEditValue", "onGetPubEditValue");
        var paramStr = "&parentPageName=patientRelativEditPage";
            paramStr += "&parentFrameName=patientRelativEditContentPage";
            paramStr += "&js=patientRelativEdit.getPubEditValue";
        appcan.frame.open("content", "../../components/pubEditValue.html?" + paramStr, 0, inParam.headerHeight, "relativSexPubPage");
                 
    });
    
    appcan.button("#btnSave", "btn-act", function() {
       doSave(); 
    });
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        //设置咨询人ID
        patientRelativModel.set("patientId", !!inParam ? inParam.patientId : "");
        //getPatientInfo(!!inParam ? inParam.patientId || "1" : "1");
    }
    
    return {
        init: init,
        getPubEditValue: getPubEditValue
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    patientRelativEdit.init();
});








