if(!window.continueRecipeContentJs){
    window.continueRecipeContentJs = {};
}

var continueRecipeContentJs = function() {
	//声明viewmodel
    var ViewModelRecipe = new(MVVM.ViewModel.extend({
        el: "#continueRecipeListView",
        collection: new PrescriptionListCollection()
    }))();
	
	var pageParam, pageCount = 0, inParam;
    pageParam = _.clone(window.pagingParam);
    //处方数据
    var recipeData = [], recipeId = "";
    	
    var init = function() {
    	inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
    	//设置弹动事件
        // commonJs.listWindowBounce(loadPrescriptionList);
        loadPrescriptionList();
        //获取诊疗信息
        getTaskInfo();
    }
    
    //获取诊疗信息
    var getTaskInfo = function() {
        var param = _.clone(window.pagingParam);
        param.id = inParam.taskId;
        commonService.request(param, {
            url: window.ServerURL + "/getTaskInfoXf",
            success: function(res) {
            	recipeId = res[0].recipeId;
            }
        });
    }
    
    //加载处方列表数据
    var loadPrescriptionList = function(){
    	// var data = [{
						// "hospitalId": "医院编码",
						// "prescriptionNo": "医院HIS处方编号",
						// "createDate": "2019-07-12 17:39:40",//处方开具时间
						// "status": "1",//处方状态
						// "channel": "1",
						// "doctorNo": "医生或员工编号",
						// "doctorName": "医生姓名",
						// "prescriptionType": "处方类型",
						// "diagnosesName": "诊断名称-甲状腺",
						// "symptom": "症状-111",
						// "departmentNo": "部门编号",
						// "departmentName": "部门名称",
						// "medicalFree": 0,
						// "patientCardNo": "患者就诊卡号",
						// "patientNo": "医院患者编号",
						// "patientInfo": {
							// "patientIdCard": "患者身份证号",
							// "patientSex": 1,
							// "patientBirthday": "2017-07-01",
							// "patientName": "患者姓名",
							// "patientTelephone": "患者手机号",
							// "areaCode": "区号"
						// },
						// "drugDetailList": [{
							// "drugNo": "LX010109485",
							// "hospDrugNo": "院内药品编码",
							// "drugGenericName": "阿司匹林肠溶片（进）",
							// "amount": 2,
							// "spec": "规格",
							// "usageDosage": "用法用量"
						// }]
					// }]

    	recipeData = [];
	    var param = {};
	    param.phone = inParam.patientPhone;
	    param.status = '2';

        commonService.request(param, {
            url: window.ServerURL + "/getYygxTRecipeInfo",
            success: function(res) {
            	var length = 0;
            	if(res.data !==undefined){
            		length = res.data.length;
            	}else{
            		length = res.length;
            	}
            	for(var i=0; i< length; i++){
            		var returnObj;
	            	if(res.data !==undefined){
	            		returnObj = res.data[i];
	            	}else{
	            		returnObj = res[i]
	            	}
            		var address = "";
            		if(returnObj.tRecipeAddressXf !== null && returnObj.tRecipeAddressXf !==undefined){
            			if(returnObj.tRecipeAddressXf.patientAddress !== null){
            				address = returnObj.tRecipeAddressXf.patientAddress;
            			}
            		}
					var dataObj = {
						"recipeCode": returnObj.prescriptionNo,//处方单号
						"symptom": returnObj.symptom,//症状
						"taskResult": returnObj.taskResult,//诊断结果
						"createDate": returnObj.createDate,//时间
						"patientName": returnObj.patientInfo.patientName,//患者姓名
						"patientPhone": returnObj.patientInfo.patientTelephone,//患者手机号
						"address": address,//地址
						"patientAge": returnObj.patientInfo.patientBirthday,//患者出生日期
						"sex": returnObj.patientInfo.patientSex,//患者性别
						"tastDoctorName": returnObj.doctorName,//医生姓名
						"status": returnObj.status,//处方状态
						"recipeType": returnObj.prescriptionType,//处方类型
						"tRecipeDetailInfoList": []//药品信息
						
					}
					for(var j=0; j<returnObj.drugDetailList.length; j++){
						var drugObj = {
							"code": returnObj.drugDetailList[j].drugNo,//药品编码
							"name": returnObj.drugDetailList[j].drugGenericName,//药品编码
							"usageMethod": returnObj.drugDetailList[j].usageDosage,//用法用量
							"usageTotal": returnObj.drugDetailList[j].amount,//数量
							"speci": returnObj.drugDetailList[j].spec,//规格
						}
						dataObj.tRecipeDetailInfoList.push(drugObj);
					}
					recipeData.push(dataObj)
				}
            	// if (pageCount === 1) {
                    // ViewModelRecipe.collection.set(recipeData);
                // } else {
                    // ViewModelRecipe.collection.add(recipeData);
                // }
                ViewModelRecipe.collection.set(recipeData);
            }
        });
    }
    
    //加载处方单详细页
    var loadPrescriptionDetail = function(event){
    	var recipeCode = $(event.currentTarget).find("#recipeCode").text().trim();
    	for(var i=0; i<recipeData.length; i++){
    		if(recipeCode === recipeData[i].recipeCode){
    			appcan.locStorage.remove("recipeInfoConData");
    			appcan.locStorage.setVal("recipeInfoConData", recipeData[i]);
    			//诊疗Id
    			var dataParam = "&taskId="+inParam.taskId;
    			//处方Id
    			dataParam += "&recipeId="+recipeId;
    			//诊疗状态
    			dataParam += "&status="+inParam.status;
    			commonJs.openWindow("recipeInfoConDetailPage", "recipe_info_con_detail.html?"+dataParam);
    		}
    	}
    }
    
    //开新处方
    appcan.button("#recipeBillingBtn", "btn-act", function() {
    	//诊疗状态
    	var status = inParam.status;
    	//诊疗Id
    	var taskId = inParam.taskId;
	    // if (status === "DJF") {
            // uexWindow.confirm({
                     // title:"提示",
                     // message:"诊疗单据为【待缴费】，是否执行修改处方单。",
                     // buttonLabels:"确定, 取消"
                // },function(index){
                    // if (Number(index) === 0) {
                        // //data 按照按钮的索引返回值
	                    // var paramData = "taskId=" + taskId;
	                	// paramData += "&recipeId=" + recipeId;
	                    // commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?" + paramData);
                        // return;
                    // }
            // });
        // }
		
       if((recipeId === null || recipeId === "" || recipeId === undefined) && status != "YWC"){
	       appcan.window.alert({
	            title : "提示",
	            content : "确认新开处方？",
	            buttons :  ['确定', '取消'],
	            callback : function(err, data, dataType, optId) {
	                if(data=="0"){
				        if((recipeId === null || recipeId === "" || recipeId === undefined) && status != "YWC") {
				        	//by sushu 2019-05-08 多加一个参数
				        	var paramData = "taskId=" + taskId;
				        	paramData += "&recipeId=" + "";
				            commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?" + paramData);
				         } else {
				             if (status === "DJF") {
				                 appcan.window.openToast("此诊疗单已完成，不可开处方", 2000, 5, 0);
				             } else {
				                 appcan.window.openToast("此诊疗单已开处方", 2000, 5, 0);
				             }
				        }
	                }
	            }
	        });
       }else{
       		appcan.window.openToast("此诊疗单已开处方", 2000, 5, 0);
       }


    });
    

    
    return {
        init: init,
        loadPrescriptionDetail: loadPrescriptionDetail
    }
    
}();

appcan.ready(function() {
    continueRecipeContentJs.init();
});



