if(!window.diagnoseProcess){
    window.diagnoseProcess = {};
}

var diagnoseProcess = function() {
    var pageCount = 0, inParam, doctoryInfo = {};
    var taskInfoModel = new TaskInfoModel();
    
    //声明viewmodel
    var taskInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".taskInfo",
        model: taskInfoModel
    }));
    
    var getTaskInfoSuccess = function(res) {
        taskInfoModel.set(res[0]);
        refreshBtn();
    }
    var getTaskInfo = function(callback) {
        var param = _.clone(window.pagingParam);
        param.id = inParam.taskId || "_";
        param.doctoryId = doctorInfo.id;
        commonService.request(param, {
            url: window.ServerURL + "/getTaskInfoXf",
            success: function(res) {
                getTaskInfoSuccess(res);
                !!callback ? callback() : null;
            }
        });
    }
    
    appcan.button("#diagnoseBilling", "btn-act", function() {
        var diagnoseBilling = function() {
            if(!!!taskInfoModel.get("taskPayCode")) {
                var paramStr = "taskId=" + taskInfoModel.get("id");
                paramStr += "&parentPageName=diagnoseProcessPage";
                paramStr += "&parentFrameName=diagnoseProcessContentPage";
                paramStr += "&js=diagnoseProcess.getTaskInfo";
                commonJs.openWindow("diagnosisFeesPage", "diagnosis_fees.html?" + paramStr);
            } else {
                appcan.window.openToast("此诊疗单已开诊费", 2000, 5, 0);
            }
        }
        getTaskInfo(diagnoseBilling);
    });
    
    //查看患者档案
    appcan.button("#patientFile", "btn-act", function() {
    	commonService.request({id:taskInfoModel.get("patientId")}, {
            url: window.ServerURL + "/getPatientInfo",
            success: function(res) {
            	localStorage.setItem('patient',JSON.stringify({
		    		id:'',
		    		doctorId:taskInfoModel.get("tastDoctorId"),
		    		patientId:res[0].id,
		    		patientName:res[0].patientName,
		    		patientBirthDate:JSON.stringify(res[0].birthDate),
		    		patientSex:res[0].sex,
		    		patientPhone:res[0].patientPhone,
		    		signTime:JSON.stringify({}),
		    		patientIsAllergy:res[0].isAllergy
		    	}));
		        appcan.window.open({
	                name : "patientDetailPage",
	                data : "patientDetail.html?patientId="+res[0].id,
	                aniId : "2"
		        });
            }
        });
    });
    
    //退诊费
    appcan.button("#diagnoseRefundFee", "btn-act", function() {
        var diagnoseBilling = function() {
            if(!!!taskInfoModel.get("taskPayCode")) {
            	appcan.window.openToast("此诊疗单没有生成缴费单", 2000, 5, 0);
            } else {
            	if(taskInfoModel.get("status") === "YJF"){
            	}else{
            		appcan.window.openToast("此诊疗单不是已缴费状态，不能退费", 2000, 5, 0);
            	}
            }
        }
        updateReturnPayInfo(diagnoseBilling);
    });
    
    //退诊费更新
    var updateReturnPayInfo = function(diagnoseBilling){
	    var param = {};
	    param.id = taskInfoModel.get("taskPayId");
	    commonService.request(param, {
	        url: window.ServerURL + "/updateReturnPayXf",
	        success: function(res) {
	        	if(res.result == "0"){
	        		appcan.window.openToast("退费成功", 2000, 5, 0);
	        		getTaskInfo(null);
	        	}else{
	        		!!diagnoseBilling ? diagnoseBilling() : null;
	        		//appcan.window.openToast(res.message, 2000, 5, 0);
	        	}
	        }
	    });
    }
    
    //开处方
    appcan.button("#recipeBilling", "btn-act", function() {
        var recipeBilling = function() {
            var confirmCallback = function() {
                if(!!!taskInfoModel.get("recipeId") && taskInfoModel.get("status") != "YWC") {
                	//by sushu 2019-05-08 多加一个参数
                	var paramData = "taskId=" + taskInfoModel.get("id");
                	paramData += "&recipeId=" + "";
                    commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?" + paramData);
                 } else {
                 	appcan.window.openToast("此诊疗单已开处方", 2000, 5, 0);
                     // if (taskInfoModel.get("status") === "DJF") {
                         // appcan.window.openToast("此诊疗单已完成，不可开处方", 2000, 5, 0);
                     // } else {
                         // appcan.window.openToast("此诊疗单已开处方", 2000, 5, 0);
                     // }
                } 
            }
            if (taskInfoModel.get("status") === "DJF") {
                uexWindow.confirm({
                         title:"提示",
                         message:"诊疗单据为【待缴费】，是否执行处方开单。",
                         buttonLabels:"确定, 取消"
                    },function(index){
                        if (Number(index) === 0) {
                            //data 按照按钮的索引返回值
                            confirmCallback();
                            return;
                        }
                });
            } else {
                confirmCallback(); 
            }
        }
        getTaskInfo(recipeBilling);
    });
    
    //续方 by sushu 2019-07-08
    appcan.button("#continueRecipeBilling", "btn-act", function() {
    	//处方Id
    	var dataParam = "recipeId="+taskInfoModel.get("recipeId");
    	//诊疗状态
    	dataParam += "&status="+taskInfoModel.get("status");
    	//诊疗Id
    	dataParam += "&taskId="+taskInfoModel.get("id");
    	dataParam += "&patientPhone="+taskInfoModel.get("patientPhone");
    	commonJs.openWindow("continueRecipePage", "continue_recipe.html?"+dataParam);
    });
    
    //处方修改   by sushu 2019-05-08
    appcan.button("#recipeModify", "btn-act", function() {
        var recipeModify = function() {
            var confirmCallback = function() {
                if(!!taskInfoModel.get("recipeId") && taskInfoModel.get("status") != "YWC") {
                	var paramData = "taskId=" + taskInfoModel.get("id");
                	paramData += "&recipeId=" + taskInfoModel.get("recipeId");
                    commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?" + paramData);
                 } else {
                 	 if(!!!taskInfoModel.get("recipeId")){
                 	 	appcan.window.openToast("没有可修改的处方信息", 2000, 5, 0);
                 	 	return;
                 	 }
                     if (taskInfoModel.get("status") === "DJF") {
                         appcan.window.openToast("此诊疗单已完成，不可修改处方", 2000, 5, 0);
                     } else {
                         appcan.window.openToast("此诊疗单已开处方", 2000, 5, 0);
                     }
                } 
            }
            if (taskInfoModel.get("status") === "DJF") {
                uexWindow.confirm({
                         title:"提示",
                         message:"诊疗单据为【待缴费】，是否执行修改处方单。",
                         buttonLabels:"确定, 取消"
                    },function(index){
                        if (Number(index) === 0) {
                            //data 按照按钮的索引返回值
                            confirmCallback();
                            return;
                        }
                });
            } else {
                confirmCallback(); 
            }
        }
        getTaskInfo(recipeModify);
    });
    
    //完成接诊
    appcan.button("#btnCompleteDiagnose", "btn-act", function() {
        var completeDiagnose = function() {
            var confirmCallBack = function() {
                var param = _.clone(window.pagingParam);
                param.id = !!inParam ? inParam.taskId || "_" : "_";
                param.status = "YWC";
                commonService.request(param, {
                    url: url = window.ServerURL + "/updateTaskInfoXf",
                    success: function(res) {
                        if (res.result === "0") {
                            taskInfoModel.set("status", "YWC");
                            refreshBtn();
                            appcan.window.openToast("患者接诊完成", 500, 50, 0);
                            //返回到接诊列表页
			                if (!!inParam && !!inParam.parentFrameName) {
			    				appcan.window.evaluatePopoverScript(inParam.parentPageName, inParam.parentFrameName, inParam.js + "()");
			    			} else if(!!inParam & inParam.parentPageName){
			    				appcan.window.evaluateScript(inParam.parentPageName, inParam.js + "()");
			    			}
			    			uexWindow.evaluateScript("", "0", "commonJs.closeWindow('diagnoseProcessContentPage')");
                        } else {
                            appcan.window.openToast(res.message, 500, 50, 0);
                        }
                    }
                });
            }
            if (taskInfoModel.get("status") === "DJF") {
                uexWindow.confirm({
                         title:"提示",
                         message:"诊疗单据为【待缴费】，是否执行诊疗完成。",
                         buttonLabels:"确定, 取消"
                    },function(index){
                        if (Number(index) === 0) {
                            //data 按照按钮的索引返回值
                            confirmCallBack();
                            return;
                        }
                });
            } else {
                confirmCallBack();
            }
        }
        getTaskInfo(completeDiagnose);
    })
    
    //化验单
    appcan.button("#assayBilling", "btn-act", function() {
        var forwardBilling = function() {
            var confirmCallback = function() {
                if(taskInfoModel.get("status") != "YWC") {
                    var outParam = "forwardType=HY&taskId=" + taskInfoModel.get("id");
                    commonJs.openWindow("assayBillCreatePage", "../assay/assay_bill_create.html?" + outParam);
                    //commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?taskId=" + taskInfoModel.get("id"));
                 } else {
                     appcan.window.openToast("此诊疗单已完成，不可开化验单", 2000, 5, 0);
                } 
            }
            if (taskInfoModel.get("status") === "DJF") {
                uexWindow.confirm({
                         title:"提示",
                         message:"诊疗单据为【待缴费】，是否执行化验单。",
                         buttonLabels:"确定, 取消"
                    },function(index){
                        if (Number(index) === 0) {
                            //data 按照按钮的索引返回值
                            confirmCallback();
                            return;
                        }
                });
            } else {
                confirmCallback(); 
            }
        }
        getTaskInfo(forwardBilling);
    });
    
    //预约单
    appcan.button("#reservationBilling", "btn-act", function() {
        var forwardBilling = function() {
            var confirmCallback = function() {
                if(taskInfoModel.get("status") != "YWC") {
                    var outParam = "forwardType=JC&taskId=" + taskInfoModel.get("id");
                    commonJs.openWindow("assayBillCreatePage", "../assay/assay_bill_create.html?" + outParam);
                    //commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?taskId=" + taskInfoModel.get("id"));
                 } else {
                     appcan.window.openToast("此诊疗单已完成，不可开预约单", 2000, 5, 0);
                } 
            }
            if (taskInfoModel.get("status") === "DJF") {
                uexWindow.confirm({
                         title:"提示",
                         message:"诊疗单据为【待缴费】，是否执行预约单。",
                         buttonLabels:"确定, 取消"
                    },function(index){
                        if (Number(index) === 0) {
                            //data 按照按钮的索引返回值
                            confirmCallback();
                            return;
                        }
                });
            } else {
                confirmCallback(); 
            }
        }
        getTaskInfo(forwardBilling);
    });
    
    var refreshBtn = function() {
        $("#btnCompleteDiagnose").parents(".btn-line").toggleClass("field-nodisplay", taskInfoModel.get("status") === "YWC")
    }
    
    var init = function() {
        appcan.initBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorInfo = commonJs.getDoctor();
        getTaskInfo();
        //设置弹动事件
        commonJs.listWindowBounce(getTaskInfo);
        
    }
    return {
        init: init,
        getTaskInfo: getTaskInfo
    }
    
}();

appcan.ready(function() {
    diagnoseProcess.init();
});








