if(!!!window.diagnosisFees) {
    window.diagnosisFees = {};
}

var diagnosisFees = function() {
    var inParam, headerHeight;
    var taskInfo = {};
    
    //当前打开的frame页面，NAME:使用字段编码
    var pubEditParam = new PubEditParam({});
    var taskInfoModel = new TaskInfoModel();
    
    var diagnosisFeesViewModel = new (MVVM.ViewModel.extend({
        el: "[data-control='CONTENT']",
        model: taskInfoModel
    }));
    
    //声名修改值对应窗口回调函数
    var getPubEditValue = function(res) {
        var value = JSON.parse(res);
        taskInfoModel.set(value.fieldCode, value.fieldValue[value.fieldCode]);
    }
    //获取诊疗数据
    var getTaskInfoSuccess = function(res) {
        taskInfoModel.set(res[0]);   
        getDoctorDiagnosisFee();
        taskInfo = res[0];
    }
    var getTaskInfo = function(taskId) {
        var param = _.clone(window.pagingParam);
        param.id = taskId;
        commonService.request(param, {
            url: window.ServerURL + "/getTaskInfoXf",
            success: getTaskInfoSuccess
        });
    }
    
    var getDoctorDiagnosisFee = function() {
        //根据患都与医生的关系获取诊费信息
        var url = window.ServerURL + "/getDoctor";
        var param = {"patientId": taskInfoModel.get("patientId"),
            "id": taskInfoModel.get("tastDoctorId"),
            "pageIndex":1,
            "pageSize":10};
        var doctorInfo = {};
        commonJs.requestAjax(url, param, function(res) {
            if (!!res) {
               doctorInfo = res[0];
               if (doctorInfo.extend1 === "Y") {
                   taskInfoModel.set("taskPrice", doctorInfo.customerPrice);
               } else {
                   taskInfoModel.set("taskPrice", doctorInfo.platformPrice);
               }
               taskInfoModel.set("customerPrice", doctorInfo.customerPrice);
               taskInfoModel.set("platformPrice", doctorInfo.platformPrice);
               taskInfoModel.set("doctorTaskPrice", doctorInfo.taskPrice);
            }
        });
    }
    
    var getPatientRelativ = function(res) {
        if (!!res) {
            var patientRelativ
            if(typeof(res) === "string") {
               patientRelativ = JSON.parse(res);
            } else if(typeof(res) === "object") {
                patientRelativ = res;
            }
            taskInfoModel.set("extend1", "Y");
            taskInfoModel.set("relativRelCode", patientRelativ.relativRelCode);
            taskInfoModel.set("relativRelName", patientRelativ.relativRelName);
            taskInfoModel.set("relativName", patientRelativ.relativName);
            taskInfoModel.set("relativSex", patientRelativ.relativSex);
            taskInfoModel.set("relativAge", patientRelativ.relativAge);
        }
    }
    //选择患者信息
    appcan.button("#relativName", "btn-act", function() {
        switch(this.id) {
            case "relativName":
                if (taskInfoModel.get("status") === "YJF") {
                    return;
                }
                var paramStr = "patientId=" + taskInfoModel.get("patientId");
                paramStr += "&parentPageName=diagnosisFeesPage";
                paramStr += "&parentFrameName=diagnosisFeesContentPage";
                paramStr += "&js=diagnosisFees.getPatientRelativ";
                //放置到缓存里，用于家庭成员返回到本人信息  by sushu 2018-10-18
                appcan.locStorage.remove("taskInfoOnly");
                appcan.locStorage.setVal("taskInfoOnly", taskInfo);
                appcan.window.open({
                     name: "selectPatientRelativPage",
                     dataType: 0,
                     aniId: 2,
                     data: "../../components/select_patient_relativ.html?" + paramStr
                });
                break;    
            default:
                break;
        }
    });
    
    //设置病类信息
    var setIllnessCode = function(res) {
        var value;
        if(typeof(res) === "string") {
           value = JSON.parse(res);
        } else if(typeof(res) === "object") {
            value = res;
        }
        if (!!value) {
            taskInfoModel.set("illnessCode", value.illnessCode);
            taskInfoModel.set("illnessName", value.illnessName);
            appcan.frame.close("illnessNamePage");
        }
    }  
    appcan.button("#illnessName", "btn-act", function() {
        switch(this.id) {
            case "illnessName":
                openFrame = "illnessName";
                uexWindow.setIllnessCode = setIllnessCode;
                uexWindow.subscribeChannelNotification("setIllnessCode", "setIllnessCode");
   
                var paramStr = "illnessCode=" + taskInfoModel.get("illnessCode");
                paramStr += "&illnessName=" + taskInfoModel.get("illnessName");
                paramStr += "&parentPageName=diagnosisFeesPage";
                paramStr += "&parentFrameName=diagnosisFeesContentPage";
                paramStr += "&js=diagnosisFees.setIllnessCode";
                appcan.frame.open("content", "../../components/illnessType.html?" + paramStr, 0, inParam.headerHeight, "illnessNamePage");
                break;          
            default:
                break;
        }
    });
    
    var doSaveSuccess = function(res) {
        if(res.result === "0") {
            $("#btnConfirm").css("pointer-events", "none");
            $("#btnConfirm").addClass("disable");
            $("#relativName").css("pointer-events", "none");
            $("#illnessName").css("pointer-events", "none");
            appcan.window.openToast("生成患者诊费缴费单成功", 2000, 5, 0);
            appcan.window.evaluatePopoverScript(inParam.parentPageName, inParam.parentFrameName, inParam.js +"()");
            uexWindow.evaluateScript("", "0", "commonJs.closeWindow('diagnosisFeesContentPage')");      
        } else {
            appcan.window.openToast(res.message, 2000, 5, 0);
        }
    }
    var doSave = function() {
        var param = {
            "payOrderType": "ZL",
            "orderId": taskInfoModel.get("id"),
            "taskPrice": taskInfoModel.get("doctorTaskPrice"), //正常价格
            "customerPrice": taskInfoModel.get("customerPrice"),  //签约客户价格
            "platformPrice": taskInfoModel.get("platformPrice"),  //平台价格
            //存在新属关系时，患者信息传入新属数据
            "patientAge": taskInfoModel.get("relativAge") || taskInfoModel.get("patientAge"),
            "sex": taskInfoModel.get("relativSex") || taskInfoModel.get("sex"),
            "patientName": taskInfoModel.get("relativName") || taskInfoModel.get("patientName"),
            "illnessCode": taskInfoModel.get("illnessCode"),
            "illnessName": taskInfoModel.get("illnessName"),
            "sumfee": taskInfoModel.get("taskPrice"),
            "relativRelCode": taskInfoModel.get("relativRelCode") || "BR",
            "relativRelName": taskInfoModel.get("relativRelName") || "本人",
            "extend1": taskInfoModel.get("extend1") || "N"
        };
        commonService.request(param, {
            url: window.ServerURL + "/addPayXf",
            success: doSaveSuccess
        });
    }
    
    //确认诊费
    appcan.button("#btnConfirm", "btn-act", function() {
        //console.log(this.id);
        switch(this.id) {
            case 'btnConfirm':
            	appcan.window.alert({
		            title : "提示",
		            content : "确认开诊费？",
		            buttons :  ['确定', '取消'],
		            callback : function(err, data, dataType, optId) {
		                if(data=="0"){
		                	doSave();
		                }
		            }
		        });
                break;
            default:
                break;
        }
    });
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        getTaskInfo(!!inParam ? inParam.taskId || "_": "_");
        //选择家属
        appcan.window.subscribe("getPatientRelativ", getPatientRelativ);
    }
    
    return {
        init: init,
        getPatientRelativ: getPatientRelativ,
        setIllnessCode: setIllnessCode
    }
}();


appcan.ready(function() {
    diagnosisFees.init();
});
