
var DiagnosisListModel = MVVM.Model.extend({
    defaults: {"styleDisplay": "-webkit-box !important"},
    computeds: {
        //诊疗单据状态
        getStatus: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.taskStatus, status);
                return codelist.text || status;
            }
        },
        //开始时间
        getCreateDateStr: {
            deps: ["createDate"],
            get: function(createDate) {
                if (typeof(createDate) === "object" && _.allKeys(createDate).length === 0) {
                     return null;
                } else if(!!!createDate) {
                    return null;
                }
                return  commonJs.dateTimeToString(createDate);
            }
        },
        //患者性别
        getRelativSex: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["relativSex"],
            get: function(relativSex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, relativSex);
                return codelist.text || relativSex;
            }
        },
        //开始时间
        getCreateDate: {
            deps: ["createDate"],
            get: function(createDate) {
                if (typeof(createDate) === "object" && _.allKeys(createDate).length === 0) {
                     return null;
                } else if(!!!createDate) {
                    return null;
                }
                return  commonJs.dateTimeToString(createDate);
            }
        },
        //接诊时间
        getBeginTime: {
            deps: ["beginTime"],
            get: function(beginTime) {
                if (typeof(beginTime) === "object" && _.allKeys(beginTime).length === 0) {
                     return null;
                } else if(!!!beginTime) {
                    return null;
                }
                return  commonJs.dateTimeToString(beginTime);
            }
        },
        //结束时间
        getEndTime: {
            deps: ["endTime"],
            get: function(endTime) {
                if (typeof(endTime) === "object" && _.allKeys(endTime).length === 0) {
                     return null;
                } else if(!!!endTime) {
                    return null;
                }
                return  commonJs.dateTimeToString(endTime);
            }
        },
        //接诊按钮
        getJznone: {
            deps: ["status"],
            get: function(status) {
                
                jzflag=true;
                if(this.get("status") === "YZX"){
                    jzflag=false;
                }
                return jzflag;
                
            }
        },
        //诊疗、开单按钮
        getJznones: {
            deps: ["status"],
            get: function(status) {
                
                jzflags=true;
                if(this.get("status") === "YJF"||this.get("status") === "YJZ"||this.get("status") === "DJF"){
                    jzflags=false;
                }
                return jzflags;
            }
        }
    },
    sync: function(method, model, options) {
        switch (method) {
        case "create":

            break;
        case "update":

            break;
        case "patch":

            break;
        case "delete":

            break;
        default:
            break;
        }
    }
});
