
if(!window.patientDetail){
    window.patientDetail = {};
}

var patientDetail = function() {
	//获取列表页传来的患者信息
	var patientObj = JSON.parse(localStorage.getItem('patient'));
	localStorage.removeItem('patient');
    
    var pageCount = 0, pageParam, inParam;
    pageParam = _.clone(window.pagingParam);
    var receptionListModel = new ReceptionListModel();

    //viewmodel
    var ViewModel = new(MVVM.ViewModel.extend({
        el: "#receptionDetailList",
        model: receptionListModel
    }));
    
    //声明处方列表viewmodelPre
    var viewmodelPre = new(MVVM.ViewModel.extend({
        el: "#prescriptionListView",
        collection: new PrescriptionListCollection()
    
    }))();
        
    // var getTaskInfo = function(){
        // commonService.request(pageParam, {
            // url: window.ServerURL + "/getTaskInfoXf",
            // success: function(res) {
                // receptionListModel.set(res[0]);
            // }
        // });
    // }

	//获取患者基础信息--前一列表页传值
	var getPatientInfo = function(){
		receptionListModel.set({
			"patientName":patientObj.patientName,
			"patientBirthDate":JSON.parse(patientObj.patientBirthDate),
			"relativSex":patientObj.patientSex,
			"patientPhone":patientObj.patientPhone,
			"signTime":JSON.parse(patientObj.signTime),
			"isAllergy":patientObj.patientIsAllergy
		});
    }

	//加载处方列表数据
    var loadPrescriptionList = function(){
    	pageCount++;
        pageParam.pageIndex = pageCount;
        //tastDoctorId: patientObj.doctorId, 去掉
        commonService.request({tRecipeInfo: {patientId: patientObj.patientId}}, {
            url: window.ServerURL + "/getTRecipeInfoHeadXf",
            success: function(res) {
            	if (pageCount === 1) {
                    viewmodelPre.collection.set(res);
                } else {
                    viewmodelPre.collection.add(res);
                }
            }
        });
    }

    //开处方
    var diagnoseProc = function() {
        var outParam = "taskId=" + receptionListModel.get("id");
        commonJs.openWindow("diagnoseProcessPage", "diagnose_process.html?" + outParam);
    }
    
    //接诊
    var receive = function(){
        var param = _.clone(window.pagingParam);
    	param.id = receptionListModel.get("id");
    	param.status = "YJZ";
        commonService.request(param, {
            url: url = window.ServerURL + "/updateTaskInfoXf",
            success: getSuccess
        });
    }
    
    //医生与患者诊疗聊天
    var _doDiagnosisTreat = function() {
        //网易云信聊天
        commonJs.doNeteaseNim("d" + commonJs.getDoctor().doctorPhone, "p" + receptionListModel.get("patientPhone"));
    }
    
    var getSuccess=function(res) {
        if(res.result=="0"){
            getTaskInfo();
            //receptionListModel.set("status", "YJZ");
            appcan.window.openToast("接诊成功", 500, 50, 0);
        	//document.getElementById("status").innerHTML = getCodeListText(window.codeList.taskStatus, "YJZ");
        	/*
			$("#Box_receive").removeClass("block");
									$("#Box_receive").addClass("box_none");*/
			//$("#Box_receive").attr("pointer-events","none");
        }else{
        	
        }
    }
    //开单
    var billing =function() {
    	var param = "taskId=" + receptionListModel.get("id");
        param += "&parentPageName=receptionDetailPage";
        param += "&js=receptionDetail.getTaskInfo";
        commonJs.openWindow("diagnoseProcessPage", "diagnose_process.html?" + param);
    }
    
    //加载处方单详细页
    var loadPrescriptionDetail = function(event){
        var id = $(event.currentTarget).find("#id").text().trim();
        //根据状态判断修改处方
		var status = $(event.currentTarget).find("#status").text().trim();
		var taskId = $(event.currentTarget).find("#taskId").text().trim();
		if(status === "YKD" || status === "YSH" || status === "YBH"){
	        var paramData = "taskId=" + taskId;
        	paramData += "&recipeId=" + id;
            commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?" + paramData);
		}else{
			if (!!id) {
	             appcan.window.open({
	                    name : "recipeInfoDoctorPage",
	                    data : "recipe_info_doctor.html?id="+id,
	                    aniId : "2"
	                });
	        }
		}
    }
    	
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        pageParam.patientId = !!inParam ? inParam.patientId || "_" : "_";
        //getTaskInfo();
        
        //判断签约时间是否显示：1.从医生-我的患者列表页跳转过来的显示；2.其他暂时不显示
        if (patientObj.pageIdentify == 'patientList') {
        	$('#signTime').removeClass("field-nodisplay");
        } else { 
        	$('#signTime').addClass("field-display");
        }
        
        //获取患者基础信息
        getPatientInfo();
        //加载处方列表
        loadPrescriptionList();
    }
    
    return {
        // getTaskInfo : getTaskInfo,
        diagnoseProc : diagnoseProc,
        receive : receive,
        init: init,
        billing: billing,
        doDiagnosisTreat: _doDiagnosisTreat,
        loadPrescriptionDetail : loadPrescriptionDetail
    }
    
}();

appcan.ready(function() {
    appcan.button("#nav-left", "btn-act",
        function() {
            uexWindow.evaluatePopoverScript("patientListPage", "patientListContentPage", "patientList.backload()");
            appcan.window.close(-1);
        }
    );
    appcan.initBounce();
    patientDetail.init();
});



