if (!!!window.prescriptionOrder) {
    window.prescriptionOrder = {};
}
var prescriptionOrder = function() {
    var inParam, headerHeight,
    doctorInfo = {}, //医生信息
    taskInfo = {},
    patientInfo = {};
    //药品遍历参数
    var detailInfos = [], i = 0;
    
    var recipeInfoModel = new RecipeInfoModel();
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));
    var pubEditParam = new PubEditParam();
    var recipeDetailInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDetailInfosView",
        collection: new RecipeDetailInfoCollection()
    }));
        
    appcan.button("#btnAddDrug", "btn-act", function(event) {
        //var param = "selectorId=" ; //选药者ID
        var param = "selectorId=" + doctorInfo.id; //选药者ID    
        param += "&selectorType=DT"; //选药者类型：DT:医师、AT:药师 
        param += "&parentPageName=prescriptionOrderPage";
        param += "&parentFrameName=prescriptionOrderContentPage";
        param += "&js=prescriptionOrder.setSelectDrug"
        appcan.window.open({
                 name: "selectDrugPage",
                 dataType: 0,
                 aniId: 2,
                 data: "../../components/selectDrug.html?" + param,
        });
    });
    
    
    //声名修改值对应窗口回调函数
    var onGetPubEditValue = function(res) {
        var value = JSON.parse(res);
        prescriptionOrderViewModel.model.set(value.fieldCode, value.fieldValue[value.fieldCode]);
        uexWindow.onGetPubEditValue = onGetPubEditValue;
        uexWindow.subscribeChannelNotification("getPubEditValue", "onGetPubEditValue");
    }
    //设置病类信息
    var setIllnessCode = function(res) {
        var value = JSON.parse(res);
        if (!!value) {
            prescriptionOrderViewModel.model.set("illnessCode", value.illnessCode);
            prescriptionOrderViewModel.model.set("illnessName", value.illnessName);
        }
        //本次监听完成后，重新启动新的监听
        uexWindow.setIllnessCode = setIllnessCode;
        uexWindow.subscribeChannelNotification("setIllnessCode", "setIllnessCode");
    }    
    
    //页面间通信,患者与咨询者关系编辑页关闭后回调通信函数
    function onPatientInfoEditor(res){
        var patientRelativInfo = JSON.parse(res);
        recipeInfoViewModel.model.set("relativRelCode", patientRelativInfo.relativRelCode);
        recipeInfoViewModel.model.set("relativRelName", patientRelativInfo.relativRelName);
        recipeInfoViewModel.model.set("relativName", patientRelativInfo.relativName);
        recipeInfoViewModel.model.set("relativSex", patientRelativInfo.relativSex);
        recipeInfoViewModel.model.set("relativAge", patientRelativInfo.relativAge);
        //console.log("index2:"+res);
    }
    // 加密函数
    function compile(code)  
    {    
       var c=String.fromCharCode(code.charCodeAt(0)+code.length);  
       for(var i=1;i<code.length;i++){  
           c+=String.fromCharCode(code.charCodeAt(i)+code.charCodeAt(i-1));  
       }  
       return escape(c);  
    }  
    // 解密函数
    function uncompile(code)  
    {  
       code=unescape(code);  
       var c=String.fromCharCode(code.charCodeAt(0)-code.length);  
       for(var i=1;i<code.length;i++){  
           c+=String.fromCharCode(code.charCodeAt(i)-c.charCodeAt(i-1));  
       }  
       return c;  
    }  
    appcan.button("#relativName", "btn-act", function() {
        console.log(this);
        switch(this.id) {
            case "relativName":
                if (taskInfo.status != "YJZ" && taskInfo.status != "DJF") {
                    return;
                }
                var paramStr = "patientId=" + recipeInfoViewModel.model.get("patientId");
                paramStr += "&parentPageName=prescriptionOrderPage";
                paramStr += "&parentFrameName=prescriptionOrderContentPage";
                paramStr += "&js=prescriptionOrder.getPatientRelativ"
                //放置到缓存里，用于家庭成员返回到本人信息  by sushu 2018-10-18
                appcan.locStorage.remove("taskInfoOnly");
                appcan.locStorage.setVal("taskInfoOnly", taskInfo);
                appcan.window.open({
                     name: "selectPatientRelativPage",
                     dataType: 0,
                     aniId: 2,
                     data: "../../components/select_patient_relativ.html?" + paramStr
                });
               
                break;    
           case "isAllergy":
                
                var changeObjectValue = {"isAllergyCode": recipeInfoViewModel.model.get("isAllergyCode")};
                var options = {fieldCode: "isAllergyCode", fieldName: "过敏史",
                    editorType: "radiobox", fieldValue: changeObjectValue, codelistType: "yesOrNo"};       
                pubEditParam.saveLocStorage(options);
                uexWindow.onGetPubEditValue = onGetPubEditValue;
                uexWindow.subscribeChannelNotification("getPubEditValue", "onGetPubEditValue");
                //设置HEADER高度
                var fontSize = appcan.locStorage.getVal("defaultfontsize");
                var titHeight = window.headerHeightEm * Math.abs(fontSize.substr(0, fontSize.indexOf("px"))); //$('#diagnosisCostheader').offset().height;
                
                appcan.frame.open("content", "../../components/pubEditValue.html", 0, titHeight, "isAllergyCode");
                break; 
            default:
                break;
        }
    });
    //ani-act带动画效果
    
    var getRecipeInfoSuccess = function(res) {
        recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
        recipeDetailInfoViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDetailInfoList);
    }
    
    var getRecipeInfo = function(recipeId) {
        var param = _.clone(window.pagingParam);
        param.tRecipeInfo =  {
            id: recipeId
        }
        commonService.request(param, {
            url: window.ajaxUrl + "/getTRecipeInfoXf",
            success: getRecipeInfoSuccess
        });
    }
    //保存处方单信息回调方法
    var doAddRecipeInfoSuccess = function(res) {
        if (res.result != 0) {
        	detailInfos = [];
            appcan.window.alert("", "处方开单失败！" + res.message);
        } else {
            getRecipeInfo(res.id);
            refreshBtn();
            appcan.window.openToast("处方开单成功", 2000, 5, 0);
            uexWindow.evaluateScript("", "0", "commonJs.closeWindow('prescriptionOrderContentPage')");
            var param = "recipeId=" + res.id;
            param += "&patientPhone=" + patientInfo.patientPhone;
            param += "&patientName=" + patientInfo.patientName;
            param += "&address=" + "";
            param += "&editFlag=" + "0";
	        appcan.window.open({
	                 name: "recipeAddressEdit",
	                 dataType: 0,
	                 aniId: 2,
	                 data: "recipe_address_edit.html?" + param,
	        });
            appcan.window.evaluatePopoverScript("prescriptionListPage", "prescriptionListContentPage", "prescriptionList.init()");
            //更新诊疗操作
            appcan.window.evaluatePopoverScript("diagnoseProcessPage", "diagnoseProcessContentPage", "diagnoseProcess.init()");
            //更新续方处方列表
            appcan.window.evaluatePopoverScript("continueRecipePage", "continueRecipeContentPage", "continueRecipeContentJs.init()");
        }
    }
    //保存处方单信息
    var doAddrecipeInfo = function() {
       var data = {};
       data.tRecipeInfo = {};
       //修改时，传处方单id  by sushu 2019-05-09
       if(inParam.recipeId != ""){
       		data.tRecipeInfo.id = inParam.recipeId;
       }
       data.tRecipeInfo.taskId = recipeInfoModel.get("taskId");
       data.tRecipeInfo.relativRelCode = recipeInfoModel.get("relativRelCode");
       data.tRecipeInfo.relativRelName = recipeInfoModel.get("relativRelName");
       data.tRecipeInfo.relativName = recipeInfoModel.get("relativName");
       data.tRecipeInfo.relativSex = recipeInfoModel.get("relativSex");
       data.tRecipeInfo.relativAge = recipeInfoModel.get("relativAge");
       data.tRecipeInfo.isAllergy = recipeInfoModel.get("isAllergy");
       data.tRecipeInfo.taskResult = recipeInfoModel.get("taskResult");
       data.tRecipeInfo.extend1 = recipeInfoModel.get("extend1");
       // data.tRecipeInfo.supplyExplain = recipeInfoModel.get("supplyExplain");
       data.tRecipeInfo.symptom = recipeInfoModel.get("symptom");
       data.tRecipeInfo.recipeType = recipeInfoModel.get("recipeType");
       
       if(!!!recipeInfoModel.get("symptom")){
       		appcan.window.openToast("症状必填", 2000, 5, 0);
       		return;
       }
       if(!!!recipeInfoModel.get("taskResult")){
       		appcan.window.openToast("诊断结果必填", 2000, 5, 0);
       		return;
       }

       //轮询遍历药品信息
       getDrugDetailInfo(data);

    }
    
    //轮询遍历药品信息
    var getDrugDetailInfo = function(data){
    	if(recipeDetailInfoViewModel.collection.length > 0){
	        var detailInfo = {};
           	detailInfo.drugId = recipeDetailInfoViewModel.collection.models[i].get("drugId");
           	detailInfo.code = recipeDetailInfoViewModel.collection.models[i].get("code");
           	detailInfo.usageTotal = recipeDetailInfoViewModel.collection.models[i].get("usageTotal");
           	detailInfo.usageMethod = recipeDetailInfoViewModel.collection.models[i].get("usageMethod");
           	detailInfo.vender = recipeDetailInfoViewModel.collection.models[i].get("vender");
           	detailInfo.retailPrice = recipeDetailInfoViewModel.collection.models[i].get("retailPrice");
           	detailInfos.push(detailInfo);
           	if(!!!recipeDetailInfoViewModel.collection.models[i].get("usageTotal") || parseInt(recipeDetailInfoViewModel.collection.models[i].get("usageTotal")) <=0){
   			    i = 0;
       			detailInfos = [];
		       	appcan.window.openToast("药品数量必须大于0", 2000, 5, 0);
	       		return;
	       	}
           	if(!!!recipeDetailInfoViewModel.collection.models[i].get("usageMethod")){
   			    i = 0;
       			detailInfos = [];
		       	appcan.window.openToast("用法用量必填", 2000, 5, 0);
	       		return;
	       	}
           	i = i + 1;
	        if(i < recipeDetailInfoViewModel.collection.length){
   				getDrugDetailInfo(data);
   			}else{
   				i = 0;
		        data.tRecipeDetailInfoList = detailInfos;
		        //by sushu 2019-05-09
		        var url = window.ajaxUrl + "/addRecipeInfoXf";
		        commonService.request(data, {
		            url: url,
		            success: doAddRecipeInfoSuccess
		        });
   			}
			           	
    		//校验药品库存  by sushu 2019-07-17
       	   	// var param = {};
	       	// param.hospitalId = doctorInfo.mechanismId;
	       	// param.drugInfolList = [];
	       	// var drugObj = {};
	       	// drugObj.drugNo = recipeDetailInfoViewModel.collection.models[i].get("code");
	       	// drugObj.hospDrugNo = recipeDetailInfoViewModel.collection.models[i].get("code");
	       	// drugObj.amount = recipeDetailInfoViewModel.collection.models[i].get("usageTotal");
	       	// param.drugInfolList.push(drugObj);
       	   	// commonService.request(param, {
	           	// url: window.ServerURL + "/getYygxSelectDrugInvApp",
	           	// success: function(res){
	           		// if(res.error == "200" && res.success == true){
	           			// var detailInfo = {};
			           	// detailInfo.drugId = recipeDetailInfoViewModel.collection.models[i].get("drugId");
			           	// detailInfo.code = recipeDetailInfoViewModel.collection.models[i].get("code");
			           	// detailInfo.usageTotal = recipeDetailInfoViewModel.collection.models[i].get("usageTotal");
			           	// detailInfo.usageMethod = recipeDetailInfoViewModel.collection.models[i].get("usageMethod");
			           	// detailInfos.push(detailInfo);
	           			// i = i + 1;
	           			// if(i < recipeDetailInfoViewModel.collection.length){
	           				// getDrugDetailInfo(data);
	           			// }else{
	           				// i = 0;
					        // data.tRecipeDetailInfoList = detailInfos;
					        // //by sushu 2019-05-09
					        // var url = window.ajaxUrl + "/addRecipeInfoXf";
					        // commonService.request(data, {
					            // url: url,
					            // success: doAddRecipeInfoSuccess
					        // });
	           			// }
	           		// }else{
	           			// i = 0;
	           			// detailInfos = [];
	           			// appcan.window.openToast(recipeDetailInfoViewModel.collection.models[i].get("name") + res.msg, 2000, 5, 0);
	           		// }
	           	// }
	       	// });
    	} else {
    		appcan.window.openToast("没有药品", 2000, 5, 0);
    	}
    }
        
    appcan.button("#submitBtn", "btn-act", function() {
        //console.log(this.id);
        switch(this.id) {
            case 'submitBtn':
                appcan.window.alert({
		            title : "提示",
		            content : "确认开处方？",
		            buttons :  ['确定', '取消'],
		            callback : function(err, data, dataType, optId) {
		                if(data=="0"){
		                	doAddrecipeInfo();
		                }
		            }
		        });
                break;
            default:
                break;
        }
    });
    
    
    //接收已选择药品信息
    var setSelectDrug = function(res) {
        if (!!res){
            var drugInfo;
            if (typeof(res) === "string") {
                drugInfo = JSON.parse(res);
            } else {
                drugInfo = res;
            }
            var model = recipeDetailInfoViewModel.collection.where({"drugId": drugInfo.drugId || drugInfo.id});
            if (model.length > 0) {
                model[0].set("usageTotal", !!drugInfo.usageTotal ? Number(model[0].get("usageTotal")) + Number(drugInfo.usageTotal) : Number(model[0].get("usageTotal")) + 1);
            } else {
                var recipeDetailInfo = {};
                for (var key in recipeDetailInfoTable){
                    if (key != "id") {
                        if (!!drugInfo[key]) {
                            recipeDetailInfo[key] = drugInfo[key] || "";
                        }
                    } else {
                        recipeDetailInfo.drugId = drugInfo[key];
                    }
                }
                recipeDetailInfo.usageTotal = drugInfo.usageTotal || "1";
                //使用负数，保存删除时数据的正确性，因为删除时使用ID进行数据标记,保存数据时必须清空
                recipeDetailInfo.id = (Math.random() * 100000 * -1).toString().substr(0, 6);
                recipeDetailInfoViewModel.collection.add(recipeDetailInfo);
            }
            
        }    
    }
    
    //刷新按钮
    var refreshBtn = function() {
        if (!!recipeInfoModel.get("id")) {
            //修改线下支付审核完成按钮状态
            $("#btnFinishFeePayConfirm").css("pointer-events", "none");
            $("#btnFinishFeePayConfirm").addClass("disable");
            
            $("#btnDrugConfirm").css("pointer-events", "none");
            $("#btnDrugConfirm").addClass("disable");
            $("#btnAddDrug").css("display", "none");
            //药品数量编辑
            $(".number-editor").css("display", "none !important");
            $(".display-number").css("display", "initial !important");
            $(".deleteItem").removeClass("field-display");
            $(".deleteItem").addClass("field-nodisplay");
            // $("[data-bind='value:supplyExplain']").attr("readonly", "readonly");
            $("[data-bind='value:usageMethod']").attr("readonly", "readonly");
            $("[data-bind='value:taskResult']").attr("readonly", "readonly");
            $("#submitBtn").addClass("disable");
            $("#btnSelectRecipeTemplate").addClass("field-nodisplay");
            $(".addDrugClass").css("display", "none");
            $(".taskResultClass").css("display", "none !important");
        } else {
            $("#btnDrugConfirm").css("pointer-events", "auto");
            $("#btnDrugConfirm").removeClass("disable");
            $("#btnAddDrug").css("display", "block");
            //药品数量编辑
            $(".number-editor").css("display", "initial !important");
            $(".display-number").css("display", "none !important");
            
            //修改线下支付审核完成按钮状态
            $("#btnFinishFeePayConfirm").css("pointer-events", "auto");
            $("#btnFinishFeePayConfirm").removeClass("disable");
        }
    }
    
    var addDrug = function(event) {
        var num = Number($(event.currentTarget.parentElement).find("input").val()) + 1;
        $(event.currentTarget.parentElement).find("input").val(num).change();
        
    }
    
    var subtractDrug = function(event) {
        if (Number($(event.currentTarget.parentElement).find("input").val()) === 1) {
            return;
        }
        if (!!!$(event.currentTarget.parentElement).find("input").val().trim() || 
            Number($(event.currentTarget.parentElement).find("input").val()) <= 0) {
             num = 1;   
        } else {
            var num = Number($(event.currentTarget.parentElement).find("input").val()) - 1;
        }
        $(event.currentTarget.parentElement).find("input").val(num).change();
        
    }
    var usageTotalOnChange = function(self, value) {
        if (!!!value || (!!value && value < 0)) $(self).val(1);
    }
    
    var getTaskInfoSuccess = function(res) {
        taskInfo = res[0];
        var recipeInfo = {};
        for (var key in recipeInfoTable) {
            if (!!taskInfo[key]) {
                recipeInfo[key] = taskInfo[key];
            }
        }
        recipeInfo.taskId = recipeInfo.id;
        recipeInfo.tastDoctorId = doctorInfo.id; //开方医师ID
        recipeInfo.tastDoctorCode = doctorInfo.doctorCode; //开方医师编号
        recipeInfo.tastDoctorName = doctorInfo.doctorName; //开方医师姓名
        recipeInfo.tastDoctorType = doctorInfo.doctorType; //开方医师类别（Q全科 Z专科）
        recipeInfo.id = "";
        recipeInfoModel.set(recipeInfo);
        //获取患者信息
        var param = {id: recipeInfo.patientId};
        commonService.request(param, {
            url: window.ajaxUrl + "/getPatientInfo",
            success: function(res) {
                patientInfo = res[0];
                //只有开处方时赋值，修改处方时不赋值
                if(inParam.recipeId == ""){
                	recipeInfoModel.set("isAllergy", res[0].isAllergy || "无");
                }
            }
        });
    }
    
    var getTaskInfo = function(taskId) {
        var param = _.clone(window.pagingParam);
        param.id = taskId || "_";
        commonService.request(param, {
            url: window.ajaxUrl + "/getTaskInfoXf",
            success: getTaskInfoSuccess
        });
    }
    
    var getSelectRecipeTemplate = function(res) {
        if(!!res) {
            var recipeTemplate = JSON.parse(res);
            if (!!recipeTemplate.recipeTemplateDetails) {
                for (var i = 0; i < recipeTemplate.recipeTemplateDetails.length; i++) {
                    setSelectDrug(JSON.stringify(recipeTemplate.recipeTemplateDetails[i]));
                }
            }
        }
    }
    //症状 by sushu 2019-07-17
    appcan.button("#symptomBtn", "btn-act", function() {
	    var param = {
        	type: "symptom"  //区分类型
        };
        doSpeech(param);
    });
    //诊断结果 by sushu 2019-06-21
    appcan.button("#taskResultBtn", "btn-act", function() {
	    var param = {
        	type: "taskResult"  //区分类型
        };
        doSpeech(param);
    });
    
    //调用百度语音
    var doSpeech = function(param){
    	bethuneDoctor.startActivitySpeech(param, function (error, data) {
            if (!error){
            	if(data.type == "symptom"){
	            	var result = $("#input_symptom_result").val();
	            	recipeInfoModel.set("symptom",result+data.result);
            	}else if(data.type == "taskResult"){
	            	var result = $("#input_result").val();
	            	recipeInfoModel.set("taskResult",result+data.result);
            	}
                //alert("人脸识别:"+data.result);
            }else{
                alert("用户取消了操作");
            }
        });
    }
    
    //药品板板选择
    appcan.button("#btnSelectRecipeTemplate", "btn-act", function() {
        appcan.window.open({
             name: "selectRecipeTemplatePage",
             dataType: 0,
             aniId: 2,
             data: "select_recipe_template.html"
        });
    });
    var getPatientRelativ = function(res) {
        if (!!res) {
        	var patientRelativ;
        	if (typeof(res) === "string") {
                patientRelativ = JSON.parse(res);
            } else {
                patientRelativ = res;
            }
            recipeInfoModel.set("extend1", "Y");
            recipeInfoModel.set("relativRelCode", patientRelativ.relativRelCode);
            recipeInfoModel.set("relativRelName", patientRelativ.relativRelName);
            recipeInfoModel.set("relativName", patientRelativ.relativName);
            recipeInfoModel.set("relativSex", patientRelativ.relativSex);
            recipeInfoModel.set("relativAge", patientRelativ.relativAge);
        }
    }
    
    //手势滑动开始坐标获取，直接监听BODY事件
    $("body").on("touchstart", function(event) {
         // 判断默认行为是否可以被禁用
         startX = event.changedTouches[0].pageX,
         startY = event.changedTouches[0].pageY;
     });
     
     //药品信息删除按钮显示
    var showDeleteBtn = function(event) {
        moveEndX = event.changedTouches[0].pageX,
        moveEndY = event.changedTouches[0].pageY,
        X = moveEndX - startX,
        Y = moveEndY - startY;
        if ( X + 100 < 0 && 50 > Y && -50 < Y) {
            //左滑
            if (!!!recipeInfoModel.get("id")) {
                $(event.currentTarget).find(".deleteItem").removeClass("field-nodisplay");
                $(event.currentTarget).find(".deleteItem").addClass("field-display");
            }       
        } else if ( X - 100 > 0 && 50 > Y && -50 < Y) {
            //右滑
            if (!!!recipeInfoModel.get("id")) {
                $(event.currentTarget).find(".deleteItem").removeClass("field-display");
                $(event.currentTarget).find(".deleteItem").addClass("field-nodisplay");
            }   
        }
        /*
        if (!!!recipeInfoModel.get("id")) {
            if ($(event.currentTarget).find(".deleteItem.field-display").length > 0) {
                $(event.currentTarget).find(".deleteItem").removeClass("field-display");
                $(event.currentTarget).find(".deleteItem").addClass("field-nodisplay");
            } else {
                $(event.currentTarget).find(".deleteItem").removeClass("field-nodisplay");
                $(event.currentTarget).find(".deleteItem").addClass("field-display");
            }
        }
        */
    }
    var doDeleteDrug = function(event) {
        var drugId = $(event.currentTarget).parents("li").find("[data-bind='text:drugId']").text().trim();
        var model = recipeDetailInfoViewModel.collection.where({"drugId": drugId});
        recipeDetailInfoViewModel.collection.remove(model);
        // for (var i = 0; i < model.length; i++) {
            // recipeDetailInfoViewModel.collection.remove(model[i]);
        // }
        //册除完本行数据后，隐藏删除按钮
        $(event.currentTarget).parents("ul").find(".deleteItem").removeClass("field-display");
        $(event.currentTarget).parents("ul").find(".deleteItem").addClass("field-nodisplay");
        //计算金额，更新头表金额
    }
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        headerHeight = inParam.headerHeight;
        doctorInfo = commonJs.getDoctor();
        getTaskInfo(inParam.taskId || "_"); //调用页传入诊疗ID参数
        //监听选药品窗口选择信息   
        appcan.window.subscribe("setSelectDrug", setSelectDrug);
        //监听药品模板选择
        appcan.window.subscribe("getSelectRecipeTemplate", getSelectRecipeTemplate);
        //选择家属
        appcan.window.subscribe("getPatientRelativ", getPatientRelativ);
        
        //已开过处方，修改处方  by sushu 2019-05-08
        if(inParam.recipeId != ""){
        	//获取处方信息
        	getRecipeInfo(inParam.recipeId);
        }
        
        //recipeInfoModel.set(recipeInfoTestData);
        //recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        //recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        
    }
    
    //查看驳回原因
    appcan.button("#rejectBtn", "btn-act", function() {
    	var param = "bhReasonName="+recipeInfoModel.get("bhReasonName");
    	param += "&bhExplain="+recipeInfoModel.get("bhExplain");
    	appcan.window.open({
                 name: "rejectReasonPage",
                 dataType: 0,
                 aniId: 2,
                 data: "rejectInfo.html?" + param,
        });
    });
    
     return {
        init: init,
        subtractDrug: subtractDrug,
        addDrug: addDrug,
        showDeleteBtn: showDeleteBtn,
        doDeleteDrug: doDeleteDrug,
        usageTotalOnChange: usageTotalOnChange,
        setSelectDrug: setSelectDrug,
        getPatientRelativ: getPatientRelativ
    }

}();

appcan.ready(function() {
    prescriptionOrder.init();
});
