
if(!window.prescriptionList){
    window.prescriptionList = {};
}

var prescriptionList = function() {
    var tastDoctorId = "", doctorInfo = {}, pageCount = 0, pageParam;
    var recipeStatus = "0,1,2,3";
    pageParam = _.clone(window.pagingParam);
    var tRecipeInfo = {};
    tRecipeInfo.status = recipeStatus;
    pageParam.tRecipeInfo = tRecipeInfo;

    //声明viewmodel
    var ViewModel = new(MVVM.ViewModel.extend({
        el: "#prescriptionListView",
        collection: new PrescriptionListCollection()
    
    }))();
    
    
    
    //加载数据
    var loadPrescriptionList = function(){
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url: window.ServerURL + "/getTRecipeInfoHeadXf",
            success: function(res) {
                if (pageCount === 1) {
                    ViewModel.collection.set(res);
                } else {
                    ViewModel.collection.add(res);
                }
            }
        });
        //ViewModel.collection.fetch({selfViewModel: ViewModel, param: pageParam});
    }
    
    //加载详细页
    var loadPrescriptionDetail = function(event){
        var id = $(event.currentTarget).find("#id").text().trim();
        //根据状态判断修改处方   by sushu 2019-05-20
		var status = $(event.currentTarget).find("#status").text().trim();
		var taskId = $(event.currentTarget).find("#taskId").text().trim();
		if(status === "YKD" || status === "YSH" || status === "YBH"){
	        var paramData = "taskId=" + taskId;
        	paramData += "&recipeId=" + id;
            commonJs.openWindow("prescriptionOrderPage", "prescription_order_header.html?" + paramData);
		}else{
			if (!!id) {
				 appcan.locStorage.setVal('winName','recipeList');//设置一个标识,详情页用到
	             appcan.window.open({
	                    name : "recipeInfoDoctorPage",
	                    data : "recipe_info_doctor.html?id="+id,
	                    aniId : "2"
	                });
	        }
		}
    }
    
    //查询
    var searchPrescriptionList = function(){
        var searchParam = $("#searchParam").val();
        pageCount = 0;
        tRecipeInfo.patientName = searchParam;
        pageParam.tRecipeInfo = tRecipeInfo
        loadPrescriptionList();
    }
    
    //类型下拉加载
    var prescriptionStatusSelect = function(){
        
        var prescriptionStatusSelect = appcan.selectview({
            selector : "#prescriptionStatusSelect"
        });
        var prescriptionStatus = [{id: "999999", value: "ALL", text: "全部"}];
        for (var i in window.codeList.recipeStatus) {
            prescriptionStatus.push(window.codeList.recipeStatus[i]);
        }
        prescriptionStatusSelect.set(prescriptionStatus);
        prescriptionStatusSelect.on("select:click", function(obj, data) {
            tRecipeInfo.status = data[0].value === "ALL" ? recipeStatus : data[0].value;
            pageParam.tRecipeInfo = tRecipeInfo;
            if (data[0].value === "ALL") {
                 $("#prescriptionStatus").find("span").text("状态");
            } else {
                $("#prescriptionStatus").find("span").text(data[0].text);
            }            
            hidenSelector();
            setScollbar("enable");

            pageCount = 0;
            
            loadPrescriptionList();
        });
    }
    

    //隐藏下拉
    var hidenSelector = function(hidenFlag) {
        //使用延迟设置,避免连续点击问题
        setTimeout(function() {
            //全科职称
            $("#prescriptionStatus").find(".list-caret-size").addClass("list-caret-down");
            $("#prescriptionStatus").find(".list-caret-size").removeClass("list-caret-up-select");
            $("#prescriptionStatus").removeClass("filter-select-color");
            $("#prescriptionStatusSelect").removeClass("mask-show");
            
        }, 100);
    }
    

    var setScollbar = function(operate) {
        if (operate === "disable") {
            appcan.window.disableBounce();
            //禁止默认行为方法，防止滚动条滚动
            $(document).on("mousewheel", function(evt) {
                evt.preventDefault();
            }, false);
            $(document).on("touchmove", function(evt) {
                evt.preventDefault();
            });
        } else if (operate === "enable") {
            //检查默认行为方法是否禁用，禁用了则重新启用
            appcan.window.enableBounce();
            $(document).on("touchmove", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            });
            $(document).on("mousewheel", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            }, false);
        }
    }


    var checkOpenFilter = function(target) {
        if ($(target.parentElement).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
            //组件自身选中时，返回true
            if ($(target).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
                return true;
            } else {
                return false;
            }
        }
        return true;
    }

    //-------------------------------下拉点击事件--------------------------------------//
    $("#prescriptionStatus").on("tap", function(event) {

        if (!!!checkOpenFilter(event.currentTarget))
            return;
        event.cancelBubble = true;
        if ($(event.currentTarget).find("div[class='list-caret-size list-caret-down']").length > 0) {
            var maskTop = Number($("#divFilterItem").offset().height) + Number($("#divFilterItem").offset().top) - 2;
            $("#prescriptionStatusSelect").css("top", maskTop + "px");
            $("#prescriptionStatusSelect").addClass("mask-show");
            $(event.currentTarget).find(".list-caret-size").removeClass("list-caret-down");
            $(event.currentTarget).find(".list-caret-size").addClass("list-caret-up-select");
            $(event.currentTarget).addClass("filter-select-color");
            setScollbar("disable");
        } else {
            hidenSelector();
            setScollbar("enable");
        }
    }); 

    //时间控件
    $("#prescriptionDate").on("tap", function(event) {
        hidenSelector();
        setScollbar("enable");
        var _self = this;
        var okCallback = function(date) {
            pageParam.createDate = date.text;
            $("#prescriptionDate").find("span").text(date.text);
            pageCount = 0;
            loadPrescriptionList();
            _self.picker.dispose();
            _self.picker = null;
        }
        var clearCallback = function() {
            $("#prescriptionDate").find("span").text("开单日期");
            if (!!pageParam.createDate) {
                delete pageParam.createDate;
            }
            pageCount = 0;
            loadPrescriptionList();
            _self.picker.dispose();
            _self.picker = null;
        }
        if(_self.picker) {
            _self.picker.show(okCallback, clearCallback);
        } else {
            //var optionsJson = this.getAttribute('data-options') || '{}';
            var options = {"type":"date", "beginYear": 1901, bounceState: 1};
           //var id = this.getAttribute('id');
            /*
             * 首次显示时实例化组件
             * 示例为了简洁，将 options 放在了按钮的 dom 上
             * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
             */
            _self.picker = new Neusoft.DtPicker(options);
            _self.picker.show(okCallback, clearCallback);
        }
    });
    //---------------------------------------end---------------------------------//
    
    var init = function() {
		pageCount = 0;
        var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorInfo = commonJs.getDoctor();
        pageParam.tRecipeInfo.tastDoctorId = !!doctorInfo ? doctorInfo.id || "_" : "_";
        //设置弹动事件
        commonJs.listWindowBounce(loadPrescriptionList);
        loadPrescriptionList();
        //ViewModel.collection.fetch({selfViewModel: ViewModel, param: pageParam});

        //加载下拉
        prescriptionStatusSelect();

    }
    
    return {
        loadPrescriptionList : loadPrescriptionList,
        loadPrescriptionDetail : loadPrescriptionDetail,
        searchPrescriptionList : searchPrescriptionList,
        init: init
    }
    
}();

appcan.ready(function() {
    appcan.initBounce();
    prescriptionList.init();
});








