if (!window.recipeInfo) {
    window.recipeInfo = {};
}

var recipeInfo = function() {
    
    var inParam, recipeId, headerHeight, address="";  
    var self = this;
    //设置处方头表MODEL类   
    var recipeInfoModel = new RecipeInfoModel();
    var payInfo = {}, apothecaryInfo = {};
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));
    
    var recipeDetailInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDetailInfoView",
        collection: new RecipeDetailInfoCollection()
    }));
    
    var recipeDrugDetailViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDrugDetailsView",
        collection: new RecipeDrugDetailCollection()
    }));
    
    //设置评价标签状态，点亮星星    
    var setEvaluateTags = function() {
        for (var i = 1; i <= Number(recipeInfoModel.get("evaluateScore")); i++) {
            $("#evaluateScore").find("[name='" + i + "']").removeClass("nochoice");
            $("#evaluateScore").find("[name='" + i + "']").addClass("choice");
        }
    }
            
    var options = {};      
    var success = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
            setEvaluateTags();
            
            //处方地址
            if(res.tRecipeInfoVOList[0].tRecipeAddressXf.patientAddress!== null){
            	address = res.tRecipeInfoVOList[0].tRecipeAddressXf.patientAddress;
            }
            
            
            //调整按钮的显示状态
            refreshBtn();
            
            //写入调剂师信息、
            if (!!!recipeInfoModel.get("apothecaryId")) {
                recipeInfoModel.set("apothecaryId", apothecaryInfo.id);
                recipeInfoModel.set("apothecaryCode", apothecaryInfo.apothecaryCode);
                recipeInfoModel.set("apothecaryName", apothecaryInfo.apothecaryName);
            }
            recipeDetailInfoViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDetailInfoList); 
            // recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList);
        }
    }
    options.success = success;
    options.url = window.ServerURL + "/getTRecipeInfoXf";
    
    //根据处方单状态调整按钮的显示状态
    //规则:  已开具状态(0) -- 显示‘废方’按钮;
    //		其他状态 已审核(1) 已支付(2) 支付失败(3) -- 不显示‘废方’按钮;
    var refreshBtn = function() {
        if (recipeInfoModel.get("status") === "0") {
            $("#btnCancelRecipe").removeClass("field-nodisplay");
            $("#btnAddressEdit").removeClass("field-nodisplay");
        } else {
        	$("#btnCancelRecipe").addClass("field-display");
        	$("#btnAddressEdit").addClass("field-display");
        }
    } 
    
    //折叠与展开药品信息
    appcan.button("#expandDrugDetail", "btn-act", function() {
        if ($("#expandDrugDetail").find(".angle-down").length > 0) {
            $("#recipeDrugDetailsView").removeClass("field-nodisplay");
            $("#recipeDrugDetailsView").addClass("field-display");
            $("#expandDrugDetail").find(".angle-icon-size-1x").removeClass("angle-down");
            $("#expandDrugDetail").find(".angle-icon-size-1x").addClass("angle-up");
        } else if ($("#expandDrugDetail").find(".angle-up").length > 0){
            $("#recipeDrugDetailsView").addClass("field-nodisplay");
            $("#recipeDrugDetailsView").removeClass("field-display");
            $("#expandDrugDetail").find(".angle-icon-size-1x").addClass("angle-down");
            $("#expandDrugDetail").find(".angle-icon-size-1x").removeClass("angle-up");
        }
    });
    
    //查看电子处方单信息
    appcan.button("#btnLookRecipeInfo", "btn-act", function() {
        appcan.window.open({
            name: "e-PrescribingPage",
            dataType: 0,
            aniId: 2,
            data: "../../components/electronic_prescribing.html?id=" + recipeInfoModel.get("id")
        });
    });
    
    //地址维护
    appcan.button("#btnAddressEdit", "btn-act", function() {
	    var param = "recipeId=" + recipeInfoModel.get("id");
        param += "&patientPhone=" + recipeInfoModel.get("patientPhone");
        param += "&patientName=" + recipeInfoModel.get("patientName");
        param += "&address=" + address;
        param += "&editFlag=" + "1";
        appcan.window.open({
                 name: "recipeAddressEdit",
                 dataType: 0,
                 aniId: 2,
                 data: "recipe_address_edit.html?" + param,
        });
    });
    
    //废方按钮 -- 作废处方单
    appcan.button("#btnCancelRecipe", "btn-act", function() {
    	uexWindow.confirm({
                 title:"提示",
                 message:"请您慎用“废方”操作， 当您确认此操作前请务必提前联系患者或药房。确定执行废方操作?",
                 buttonLabels:"确定, 取消"
            },function(index){
                if (Number(index) === 0) {
                	var operateParam = {};
                	operateParam.id = recipeInfoModel.get("id");
                    commonService.request(operateParam, {
			            url: window.ServerURL + "/updateReturnTRecipeXf",
			            success: function(res) {
			            	if(res.result == '0'){
			            		appcan.window.openToast("操作成功", 2000, 5, 0);
			            		//获取前一列表页预先设置的标识
				 				var winName = appcan.locStorage.getVal('winName');
				 				appcan.locStorage.remove('winName');
				 				if (winName == 'recipeList') {//说明前一页面是处方列表页
				 					//执行列表的查询
				 					appcan.frame.evaluateScript({
					                    name: "prescriptionListPage",
					                    popName: "prescriptionListContentPage",
					                    scriptContent: "prescriptionList.searchPrescriptionList()"
					                });
				 				}
				 				//关闭当前页面
				 				appcan.window.close(-1);
				        	}else{
						        appcan.window.alert({
						            title : "提示",
						            content : "操作失败，"+res.message,
						            buttons : '确定'
						        });
				        	}
			            }
			        });
                    return;
                } else {
                	return;
                }
        });
    });
    
    appcan.button("#nav-left", "btn-act", function() {
       appcan.window.close(-1);
    });
    
    var setContentTop = function() {
        headerHeight = $('#recipeInfoHeader').offset().height;
        $("#recipeInfoContent").css("top", headerHeight);
    }
    
    window.onorientationchange = window.onresize = function() {
        setContentTop();
    }
       
    var init = function() {
        appcan.window.disableBounce();
        setContentTop();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        try {
            recipeId = inParam.id;
        } catch (e){
            
        }
        
        var recipeInfoPamar = _.clone(window.pagingParam);
        recipeInfoPamar.tRecipeInfo =  {
            id: recipeId
        }
        
        //获取药师信息
        commonService.request(recipeInfoPamar, options);
        
        /*
        recipeDetailInfoViewModel.collection.on("add", function(model, self, options) {
            console.log(model);
        });
        recipeInfoModel.set(recipeInfoTestData);
        recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        recipeDrugDetailViewModel.collection.set(recipeInfoTestData.tRecipeDrugDetailList);
        */
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    recipeInfo.init();
});
