

if (!window.recipeTemplateEditJs) {
    window.recipeTemplateEditJs = {};
}

var recipeTemplateEditJs = function() {
    var doctorId = "", doctorInfo;
    var addOrUpdate = "";
    var id = "";
    var deleteDrugId = "";
    var pageCount = 1;
    var pageParam;
    pageParam = _.clone(window.pagingParam);
    
    // var tRecipeTemplateDetailList = [];


    // var recipeTemplateViewModel = new (MVVM.ViewModel.extend({
        // el: "#recipeTemplateInfo",
        // model: new RecipeTemplateModel()
    // }));
    
    var recipeTemplateDetailListViewModel = new (MVVM.ViewModel.extend({
        el: "#recipeTemplateDetailsView",
        collection: new RecipeTemplateCollection()
    }));
            
    
    var loadData = function(){
        var data = JSON.stringify(pageParam);
        $.ajax({
            url : window.ajaxOuterUrl + "/getTRecipeTemplateXf",
            type : "POST",
            data : data,
            dataType : "json",
            contentType : "application/json;charset=UTF-8",
            success : function(data) {
                
                if (!!data && !!data.tRecipeTemplateVOList) {
                    var tRecipeTemplate = data.tRecipeTemplateVOList[0].tRecipeTemplate;
                    var tRecipeTemplateDetailList = data.tRecipeTemplateVOList[0].tRecipeTemplateDetailList;
                    var id =  tRecipeTemplate.id;
                    var templateDesc = tRecipeTemplate.templateDesc;
                    $("#templateDesc").val(templateDesc);
                    recipeTemplateDetailListViewModel.collection.set(tRecipeTemplateDetailList);
                }
            },
            error : function(e, err) {
                alert("接口失败");
            }
        }); 
    }
    
    //删除药品信息
    var doDeleteDrug = function(event) {
        deleteDrugId = $(event.currentTarget).parents("li").find("[data-bind='text:drugId']").text().trim();
        appcan.window.alert({
            title : "提示",
            content : "确认删除？",
            buttons :  ['确定', '取消'],
            callback : function(err, data, dataType, optId) {
                
                if(data=="0"){
                    
                    var model = recipeTemplateDetailListViewModel.collection.where({"drugId": deleteDrugId});
                    for (var i = 0; i < model.length; i++) {
                        recipeTemplateDetailListViewModel.collection.remove(model[i]);
                    } 
                }
            }
        });
    }
    
    //接收已选择药品信息
    var setSelectDrug = function(res) {
        if (!!res){
            var drugInfo;
            if (typeof(res) === "string") {
                drugInfo = JSON.parse(res);
            } else {
                drugInfo = res;
            }
            var model = recipeTemplateDetailListViewModel.collection.where({"drugId": drugInfo.id});
            if (model.length > 0) {
                model[0].set("usageTotal", Number(model[0].get("usageTotal")) + 1);
            } else {
                var recipeTemplateDetail = {};
                recipeTemplateDetail.drugId = drugInfo.id;
                recipeTemplateDetail.name = drugInfo.name;
                recipeTemplateDetail.form = drugInfo.form;
                recipeTemplateDetail.speci = drugInfo.speci;
                recipeTemplateDetail.packing = drugInfo.packing;
                //用法用量带过来  by sushu 2018-10-18
                recipeTemplateDetail.usageMethod = drugInfo.usageMethod;
                //厂商   by sushu 2019-07-10
                recipeTemplateDetail.vender = drugInfo.vender;
                recipeTemplateDetail.retailPrice = drugInfo.retailPrice;
                
                recipeTemplateDetail.usageTotal = "1";
                var tRecipeTemplateDetailList = getDetailList();
                tRecipeTemplateDetailList.push(recipeTemplateDetail);
                // recipeTemplateDetailListViewModel.collection.add(recipeTemplateDetail);
                recipeTemplateDetailListViewModel.collection.set(tRecipeTemplateDetailList);
            }
        }    
    }

    //新增药品信息
    var addDrugInfo = function(){
        var param = "selectorId=" + doctorId; //选药者ID
        param += "&selectorType=DT"; //选药者类型：DT:医师、AT:药师
        param += "&parentPageName=recipeTemplateEditPage";
        param += "&parentFrameName=recipeTemplateEditContentPage";
        param += "&js=recipeTemplateEditJs.setSelectDrug";
        appcan.window.open({
                 name: "selectDrugPage",
                 dataType: 0,
                 aniId: 2,
                 data: "../../components/selectDrug.html?" + param,
        });
    }
    
    //获取当前药品信息
    var getDetailList = function(){
        var tRecipeTemplateDetailList = [];

        for (var i = 0; i < recipeTemplateDetailListViewModel.collection.length; i++) {
            var model = recipeTemplateDetailListViewModel.collection.models[i];
            var tRecipeTemplateDetail = {
                "drugId" : model.get("drugId"),
                "name" : model.get("name"),
                "form" : model.get("form"),
                "speci" : model.get("speci"),
                "packing" : model.get("packing"),
                "usageMethod" : model.get("usageMethod"),
                "usageTotal" : model.get("usageTotal")
            }
            tRecipeTemplateDetailList.push(tRecipeTemplateDetail);
        }
        
        return tRecipeTemplateDetailList;
        
    }
    
    //保存模版
    var saveOrUpdateTemplate = function(){
        
        var url = "";
        var templateDesc = $("#templateDesc").val();
        var tRecipeTemplate = {
            "doctorId": doctorId,
            "templateDesc": templateDesc
        }
        
        if(addOrUpdate=="UPDATE"){
            tRecipeTemplate.id = id;
            url = window.ajaxOuterUrl + "/updateTRecipeTemplateXf";
        }else if(addOrUpdate=="ADD"){
            url = window.ajaxOuterUrl + "/addTRecipeTemplateXf";
        }
        
        
        var tRecipeTemplateDetailList = [];

        for (var i = 0; i < recipeTemplateDetailListViewModel.collection.length; i++) {
            var model = recipeTemplateDetailListViewModel.collection.models[i];
            var tRecipeTemplateDetail = {
                "drugId" : model.get("drugId"),
                "usageMethod" : model.get("usageMethod"),
                "usageTotal" : model.get("usageTotal"),
                "vender" : model.get("vender"),
                "retailPrice" : model.get("retailPrice")
            }
            tRecipeTemplateDetailList.push(tRecipeTemplateDetail);
        }
        
        //新增药品为空，不允许保存
        if(tRecipeTemplateDetailList.length == 0){
        	appcan.window.openToast("新增药品为空，不允许保存", 2000, 5, 0);
        	return;
        }
        
        var dataParam = {
            "tRecipeTemplate" : tRecipeTemplate,
            "tRecipeTemplateDetailList":tRecipeTemplateDetailList
        }
        
        var data = JSON.stringify(dataParam);


        $.ajax({
            url : url,
            type : "POST",
            data : data,
            dataType : "json",
            contentType : "application/json;charset=UTF-8",
            success : function(data) {
            	if(data.result == '0'){
	            	appcan.window.openToast("保存成功", 2000, 5, 0);
	                setTimeout(function() {
		                var ifFlush = "flush" + Math.random();
		                appcan.locStorage.setVal("ifFlush", ifFlush);
		                appcan.window.evaluatePopoverScript("recipeTemplateListPage","recipeTemplateListPageContent","recipeTemplateListJs.dataFlush()");
		                appcan.window.evaluatePopoverScript("selectRecipeTemplatePage","selectRecipeTemplageContentPage","selectRecipeTemplate.init()");
		                uexWindow.evaluateScript("", "0", "commonJs.closeWindow('recipeTemplateEditContentPage')");
		                // appcan.window.close(-1);
		                // uexWindow.setSlidingWindowEnabled(1);
		                // uexWindow.setMultilPopoverFlippingEnbaled(1);
	                }, 500);;
            	}else{
            		appcan.window.alert({
			            title : "提示",
			            content : "接口失败，"+res.message,
			            buttons : '确定'
			        });
            	}
                // appcan.window.alert({
                    // title : "提示",
                    // content : "保存成功",
                    // buttons : '确定',
                    // callback : function(err, data, dataType, optId) {
// 
                        // var ifFlush = "flush" + Math.random();
                        // appcan.locStorage.setVal("ifFlush", ifFlush);
                        // appcan.window.close(-1);
                        // uexWindow.setSlidingWindowEnabled(1);
                        // uexWindow.setMultilPopoverFlippingEnbaled(1);
// 
                    // }
                // });

            },
            error : function(e, err) {
                alert("接口失败");
            }
        }); 

    }
    
    //减少药品数量
    var subtractDrugNum = function(event) {
        if (Number($(event.currentTarget.parentElement).find("input").val()) === 1) {
            return;
        }
        if (!!!$(event.currentTarget.parentElement).find("input").val().trim() || 
            Number($(event.currentTarget.parentElement).find("input").val()) <= 0) {
             num = 1;   
        } else {
            var num = Number($(event.currentTarget.parentElement).find("input").val()) - 1;
        }
        $(event.currentTarget.parentElement).find("input").val(num).change();
    }
    
    
    //增加药品数量
    var addDrugNum = function(event) {
        var num = Number($(event.currentTarget.parentElement).find("input").val()) + 1;
        $(event.currentTarget.parentElement).find("input").val(num).change();
    }
    
    
       
    var init = function() {
        
        var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorInfo = commonJs.getDoctor();
         doctorId = !!doctorInfo ? doctorInfo.id || "_" : "_";
        if(inParam!=null&&typeof(inParam)!='undefined'){
            addOrUpdate =  inParam.addOrUpdate;
            if(addOrUpdate!=null&&addOrUpdate!="undefined"&&typeof(addOrUpdate)!='undefined'){
                if(addOrUpdate=="UPDATE"){
                    id =  inParam.id;
                    //查询数据

                    
                    //查询头行数据
                    pageParam.tRecipeTemplate = {
                        "id":id,
                        "doctorId":doctorId
                    }
                    
                    //加载数据
                    loadData();

                }
                
            }
            
        }

        //监听选药品窗口选择信息   
        appcan.window.subscribe("setSelectDrug", setSelectDrug);
        
    }
    
    return {
        init: init,
        subtractDrugNum: subtractDrugNum,
        addDrugNum: addDrugNum,
        addDrugInfo:addDrugInfo,
        doDeleteDrug: doDeleteDrug,
        saveOrUpdateTemplate:saveOrUpdateTemplate,
        setSelectDrug: setSelectDrug
    }
}();

appcan.ready(function() {
    recipeTemplateEditJs.init();
});
