

if (!window.recipeTemplateListJs) {
    window.recipeTemplateListJs = {};
}

var recipeTemplateListJs = function() {
    var doctorId = "", inParam, doctorInfo;
    var pageCount = 0;
    var pageParam;
    pageParam = _.clone(window.pagingParam);
    
    
    var recipeTemplateDetailListViewModel = new (MVVM.ViewModel.extend({
        el: "#prescriptionTemplateListView",
        collection: new RecipeTemplateCollection()
    }));
            
    
    var loadData = function(searchData){
        //查询头行数据

        
        
        var data = JSON.stringify(searchData);
        

        $.ajax({
            url : window.ajaxOuterUrl + "/getTRecipeTemplateXf",
            type : "POST",
            data : data,
            dataType : "json",
            contentType : "application/json;charset=UTF-8",
            success : function(data) {
                
                var templateList = [];
                if (!!data && !!data.tRecipeTemplateVOList) {
                    
                    for(var i=0;i<data.tRecipeTemplateVOList.length;i++){
                        var tRecipeTemplate = data.tRecipeTemplateVOList[i].tRecipeTemplate;
                        var tRecipeTemplateDetailList = data.tRecipeTemplateVOList[i].tRecipeTemplateDetailList;
                        tRecipeTemplate.tRecipeTemplateDetailList = tRecipeTemplateDetailList;
                        templateList.push(tRecipeTemplate);
                        // var id =  tRecipeTemplate[0].id;
                        // var templateDesc = tRecipeTemplate[0].templateDesc;
                    }
//                     
                    recipeTemplateDetailListViewModel.collection.set(templateList);

                }else{
                    recipeTemplateDetailListViewModel.collection.set(templateList);
                }

             

            },
            error : function(e, err) {
                alert("接口失败");
            }
        }); 
        
         
    }

    
    //删除模版
    var deleteTemplate = function(event){
         id = $(event.currentTarget).find("#id").text().trim();
         appcan.window.alert({
            title : "提示",
            content : "确认删除？",
            buttons :  ['确定', '取消'],
            callback : function(err, data, dataType, optId) {
                
                if(data=="0"){
                    var daraParam = JSON.stringify({"tRecipeTemplate":{"id":id}});
    
                    $.ajax({
                        url : window.ajaxUrl + "/deleteTRecipeTemplateXf",
                        type : "POST",
                        data : daraParam,
                        dataType : "json",
                        contentType : "application/json;charset=UTF-8",
                        success : function(data) {
                            var itemModel = recipeTemplateDetailListViewModel.collection.where({
                                id : id
                            });
                            recipeTemplateDetailListViewModel.collection.remove(itemModel);
                            appcan.window.openToast("删除成功", 2000, 5, 0);
    
                        },
                        error : function(e, err) {
                            alert("接口失败");
                        }
                    }); 
                }
            }
        });
         
    }
    
    //编辑模版
    var editTemplate = function(event){
         var id = $(event.currentTarget).find("#id").text().trim();
         var addOrUpdate = "UPDATE";
         

        appcan.window.open({
            name : "recipeTemplateEditPage",
            data : "recipe_template_edit.html?id="+id+"&doctorId=" + doctorId + "&addOrUpdate=" + addOrUpdate,
            aniId : "2"
        }); 

    }

    //查询模版
    var searchRecipeTemplateList = function(){
        var searchName = $("#searchParam").val();
        var data = {
            "tRecipeTemplate":{
                "doctorId" : doctorId,
                "templateDesc" : searchName,
            },
            "pageIndex" : 1,
            "pageSize" : 10
        }
        // var tRecipeTemplate
        loadData(data);
    }
    
    
    
    //编辑模版回调
    var editTemplateBack = function(res) {
          alert(1);
    }



    
  
    
    
       
    var init = function() {
        
        //加载数据
        //获取入参
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorInfo = commonJs.getDoctor();
        doctorId = !!doctorInfo ? doctorInfo.id || "_" : "_";
        pageParam.tRecipeTemplate = {
            "doctorId" : doctorId
        }

		commonJs.listWindowBounce(loadSelectList);
		loadSelectList()
        // loadData(pageParam);
        //监听模版回调
        // appcan.window.subscribe("editTemplateBack", editTemplateBack);
  
        //监听刷新
        // window.addEventListener('storage', function(e) {
            // //获取被修改值
            // if (e.key == 'ifFlush') {
                // var searchData = _.clone(window.pagingParam);
                // searchData.tRecipeTemplate = {
                    // "doctorId" : doctorId
                // }
                // loadData(searchData);
// 
            // }
        // }, false); 

        
    }
    
    //下拉更新
    var loadSelectList = function() {
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url: window.ServerURL + "/getTRecipeTemplateXf",
            success: function(res) {
            	var templateList = [];
            	if (!!res && !!res.tRecipeTemplateVOList){
	            	for(var i=0;i<res.tRecipeTemplateVOList.length;i++){
	                    var tRecipeTemplate = res.tRecipeTemplateVOList[i].tRecipeTemplate;
	                    var tRecipeTemplateDetailList = res.tRecipeTemplateVOList[i].tRecipeTemplateDetailList;
	                    tRecipeTemplate.tRecipeTemplateDetailList = tRecipeTemplateDetailList;
	                    templateList.push(tRecipeTemplate);
	                }
            	}
                if (pageCount === 1) {
                    recipeTemplateDetailListViewModel.collection.set(templateList);
                } else {
                    recipeTemplateDetailListViewModel.collection.add(templateList);
                }
            }
        });
    }
    
    //维护后刷新数据
    var dataFlush = function(){
    	pageCount = 0;
    	loadSelectList();
    }
    
    return {
        deleteTemplate : deleteTemplate,
        editTemplate : editTemplate,
        searchRecipeTemplateList : searchRecipeTemplateList,
        init: init,
        dataFlush: dataFlush
    }
}();

appcan.ready(function() {
    recipeTemplateListJs.init();
});
