if (!window.selectRecipeTemplate) {
    window.selectRecipeTemplate = {};
}

var selectRecipeTemplate = function() {
    
    var inParam, headerHeight, pageCount = 0;  
    var self = this;
    var doctoryInfo = {};

    var recipeTemplateViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeTemplateView",
        collection: new RecipeTemplateCollection()
    }));
        
    var getRecipeTemplateSuccess = function(res) {
    	//recipeTemplateViewModel.collection.remove(recipeTemplateViewModel.collection.models);
        var recipeTemplates = [];
        if (!!res.tRecipeTemplateVOList) {
            for (var i = 0; i < res.tRecipeTemplateVOList.length; i++) {
                var recipeTemplate = {};
                for (var key in res.tRecipeTemplateVOList[i].tRecipeTemplate) {
                    recipeTemplate[key] = res.tRecipeTemplateVOList[i].tRecipeTemplate[key];
                }
                //测试用写入随机ID
                recipeTemplate.id = Math.random().toString().substr(2, 10);
                
                recipeTemplate.recipeTemplateDetails = res.tRecipeTemplateVOList[i].tRecipeTemplateDetailList;
                recipeTemplates.push(recipeTemplate);
            }
            recipeTemplateViewModel.collection.add(recipeTemplates);
        } else {
            if (pageCount === 1) recipeTemplateViewModel.collection.remove(recipeTemplateViewModel.collection.models);
        }
    }
    
    var getRecipeTemplate = function(param) {
        commonService.request(param, {
            url: window.ServerURL + "/getTRecipeTemplateXf",
            success: getRecipeTemplateSuccess
        });
    }
    
    var _getSelectRecipeTemplate = function(event) {
        $(event.currentTarget).parent().find(".check-circle-o-size-1x").removeClass("check-blue");
        $(event.currentTarget).parent().find(".check-circle-o-size-1x").css("border", ".1em solid #ceced1");
        $(event.currentTarget).find(".check-circle-o-size-1x").addClass("check-blue");
        $(event.currentTarget).find(".check-circle-o-size-1x").css("border", ".1em solid #24bad6");
        var id = $(event.currentTarget).find("[data-bind='text:id']").text().trim();
        var recipeTemplate = recipeTemplateViewModel.collection.where({"id": id});
        //返回选择数据
        appcan.window.publish("getSelectRecipeTemplate", JSON.stringify(recipeTemplate[0]));
        uexWindow.evaluateScript("", "0", "close()");
    }
    
    var loadRecipeTemplate = function() {
       var templateDesc = $("[data-control='TEXT']").val().trim();
       // if (!!!templateDesc) {
           // appcan.window.alert("", "请输入查询信息");
           // return;
       // }
       pageCount++;
       var pagePamar = _.clone(window.pagingParam);
       pagePamar.pageIndex = pageCount;
       pagePamar.tRecipeTemplate = {};
       pagePamar.tRecipeTemplate.doctorId = doctoryInfo.id;
       pagePamar.tRecipeTemplate.templateDesc = templateDesc || "";
       getRecipeTemplate(pagePamar);
       //加载测试数据
       //getRecipeTemplateSuccess(recipeTemplateTestData);
    }   

    appcan.button("#btnSearch", "btn-act", function(event) {
    	recipeTemplateViewModel.collection.remove(recipeTemplateViewModel.collection.models);
       var templateDesc = $(event.currentTarget).parent().find("[data-control='TEXT']").val().trim();
       // if (!!!templateDesc) {
           // appcan.window.alert("", "请输入查询信息");
           // return;
       // }
       pageCount = 1;
       var pagePamar = _.clone(window.pagingParam);
       pagePamar.tRecipeTemplate = {};
       pagePamar.tRecipeTemplate.doctorId = doctoryInfo.id;
       pagePamar.tRecipeTemplate.templateDesc = templateDesc;
       getRecipeTemplate(pagePamar);
    });
    //[data-control='CONTENT']  data-control="CONTENT"
    $("#showRecipeTemplateView").on("mousewheel", function(event) {
        loadRecipeTemplate();
       //console.log("scrollTop: " + document.body.scrollTop)
       if (document.body.scrollTop > 300) {
           $(".search-top").css("position", "fixed");
           $(".search-top").find(".one-px-h-line").attr("hidden", null);
       } else if (document.body.scrollTop < 301) {
           $(".search-top").css("position", "relative");
           $(".search-top").find(".one-px-h-line").attr("hidden", "hidden");
       }
    });
    //手势结束时计算控件位置
    $("#showRecipeTemplateView").on("touchmove", function(event) {
        console.log("scrollTop: " + document.body.scrollTop);   
        if (document.body.scrollTop > 400) {
           $(".search-top").css("position", "fixed");
           $(".search-top").find(".one-px-h-line").attr("hidden", null);
       } else if (document.body.scrollTop < 401) {
           $(".search-top").css("position", "relative");
           $(".search-top").find(".one-px-h-line").attr("hidden", "hidden");
       }        
    });
    
    var init = function() {
    	pageCount = 0;
    	recipeTemplateViewModel.collection.remove(recipeTemplateViewModel.collection.models);
        appcan.initBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        headerHeight = inParam.headerHeight;
       
        //获取医师信息
        doctoryInfo = commonJs.getDoctor();
        var pagePamar = _.clone(window.pagingParam);
        pagePamar.tRecipeTemplate = {};
        pagePamar.tRecipeTemplate.doctorId = doctoryInfo.id;
        //getRecipeTemplate(pagePamar);
        
        //加载下拉事件
        commonJs.listWindowBounce(loadRecipeTemplate);
        //初始化加载模板  by sushu 2018-10-17
        loadRecipeTemplate();
        
        //setContentHeight();
        //本地测试数据加载
        //getRecipeTemplateSuccess(recipeTemplateTestData);
    }
       
    return {
        init: init,
        getSelectRecipeTemplate: _getSelectRecipeTemplate
    }
}();

appcan.ready(function() {
    selectRecipeTemplate.init();
});
