if(!window.doctorIndexHomeContent){
    window.doctorIndexHomeContent = {};
}

var doctorIndexHomeContent = function() {
    var pageCount = 0;
    var pageParam;
    var doctorInfoModel = new DoctorInfoModel();
    var appVersion, currentVersion;
    
    pageParam = _.clone(window.pagingParam);
    pageParam.tRecipeInfo = {};
    
    //声明viewmodel
    doctorInfoModel.set("awaitDiagnosisCount", 0);
    var doctorInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".doctorInfo",
        model: doctorInfoModel
    }));
    
    doctorInfoModel.on("change:awaitDiagnosisCount", function(model, keyValue) {
       $("[data-bind='text:awaitDiagnosisCount']").toggleClass("field-nodisplay", keyValue === 0);
    });    
    
    var doDoctorOnlineSuccess = function(res) {
        if (res.result != "0") {
            appcan.window.alert("", "更改在线状态失败，请检查设置是否正常连接网络！");
        } else {
            doctorInfoModel.set("onlineStatus", doctorInfoModel.get("newOnlineStatus"));
            //更新医生缓存数据
            appcan.locStorage.setVal("localDoctor", JSON.stringify(doctorInfoModel));
            delete doctorInfoModel.attributes.newOnlineStatus;
            uexWindow.evaluateScript("doctorIndexPage", "0", "doctorIndex.refreshDoctorState(" + JSON.stringify(doctorInfoModel) +")");
            //appcan.window.publish("doctorIndexRefreshState", JSON.stringify(doctorInfoModel));
            refreshBtn();
        }
    }
    var doDoctorOnline = function(status) {
        var param = _.clone(window.pagingParam);
        param.id = doctorInfoModel.get("id");
        param.onlineStatus = status;
        doctorInfoModel.set("newOnlineStatus", status);
        commonService.request(param, {
            url: window.ServerURL + "/updateDoctorOnline",
            success: doDoctorOnlineSuccess
        });
    }
    
    var _checkDoctorLogin = function() {
    	if(parseInt(currentVersion) !== parseInt(appVersion)){
    		return false;
    	}
        if (!!!doctorInfoModel.get("id")) {
            commonJs.openWindow("loginPage", "../login/login.html");
            return false;
        } else {
            return true;
        }
    }
    
    var _getAwaitDiagnosisCount = function() {
        var param = {};
        param.id = doctorInfoModel.get("id");
        commonService.request(param, {
            url: window.ServerURL + "/getDoctorWaitTaskXf",
            success: function(data) {
                doctorInfoModel.set("awaitDiagnosisCount", data);
            }
        });
    }
    
    //上线按钮功能
    appcan.button("#btnOnline", "btn-act", function(event) {
            // alert(1)
    		// var param = {
            	// accountREQ: "12312313"  //医生手机号
            // };
            // bethuneDoctor.startSpeech(param, function (error, data) {
                // if (!error){
                    // alert("人脸识别:"+data.result);
                // }else{
                    // alert("用户取消了操作");
                // }
            // });
            
       if(!_checkDoctorLogin()) return;
       if(!!!doctorInfoModel.get("onlineStatus") || doctorInfoModel.get("onlineStatus") === "N") {
           doDoctorOnline("Y");
           //更新医生所在经纬度  by suhsu 2018-12-29
           updateTDoctorLocation();
       }
    });
    
    //更新医生所在经纬度  by suhsu 2018-12-29
    var updateTDoctorLocation = function(){
    	uexBaiduMap.getCurrentLocation();
        uexBaiduMap.cbCurrentLocation=function(data){
            if(data=="undefined"||data=="null"||data==""){
                alert("坐标获取失败");
                return;
            }
            var tempLocation=JSON.parse(data);
            var x=tempLocation.longitude;
            var y=tempLocation.latitude;
	    	var param = {};
	        param.id = doctorInfoModel.get("id");
	        param.doctorId = doctorInfoModel.get("id");
	        param.doctorPhone = doctorInfoModel.get("doctorPhone");
	        param.lastLoginLongitude = x;
	        param.lastLoginLatitude = y;
	        commonService.request(param, {
	            url: window.ServerURL + "/updateTDoctorLocation",
	            success: updateTDoctorLocationSuccess
	        });
        }
    }
    
    var updateTDoctorLocationSuccess = function(res){
    	if (res.result != "0") {
            appcan.window.alert("", "更新经纬度失败，请检查设置是否正常连接网络！");
        }
    }
    
    appcan.button("#btnReception", "btn-act", function() {
        if(!_checkDoctorLogin()) return;
        if(doctorInfoModel.get("onlineStatus") === "N") {
            appcan.window.alert("", "您当前为离线状态，无法接诊！");
            return;
        } else if(doctorInfoModel.get("onlineStatus") === "R") {
            appcan.window.alert("", "您当前为接诊状态，无法接诊！");
            return;
        } else {
        	// checkCertification();
        	//已审核未认证、已认证状态都可以接诊
            var param = "doctorId=" + doctorInfoModel.get("id");
            commonJs.openWindow("receptionListPage", "diagnosis/receptionLists.html?" + param);
            
            //doctorInfoModel.set("onlineStatus", "R");
            //appcan.window.publish("doctorIndexRefreshState", JSON.stringify(doctorInfoModel));
        }
    });
    
    //检查是否有证书  by sushu 2019-05-29
    var checkCertification =function(){
    	//已注册，判断是否下证
        var param = {
        	accountREQ: doctorInfoModel.get("doctorPhone")  //医生手机号
        };
        bethuneDoctor.checkStatus(param,function (error, data) {
        	if (!error){
        		//已注册，手机无证书
        		if(data.userListMap == "{}" && data.errCode == "0x00000000"){
        			//没证书
					appcan.window.confirm({
					    title:'提示',
					    content:'无证书，是否前往下载证书？',
					    buttons:['确定','取消'],
					    callback:function(err,data,dataType,optId){
					        if(err){
					            //如果出错了
					            return;
					        }
					        //data 按照按钮的索引返回值
					        if(data == "0"){
								commonJs.openWindow("myCertificationInfoPage", "my/my_certification_info.html?certificationRole="+'DOCTOR');
			        			return false;
					        }
					    }
					});
                }else if(data.userListMap != "{}" && data.errCode == "0x00000000"){
                	//有证书，接诊
                	var param = "doctorId=" + doctorInfoModel.get("id");
            		commonJs.openWindow("receptionListPage", "diagnosis/receptionLists.html?" + param);
                }else{
					alert(data.errMsg);
                }
            }else{
            	alert(data.errMsg);
            }
        });
    }
    
    //下线按钮功能
    appcan.button("#btnOffline", "btn-act", function(event) {
        if(!_checkDoctorLogin()) return;
        if(doctorInfoModel.get("onlineStatus") === "Y") {
            //doctorInfoModel.set("onlineStatus", "N"); //设置医生为离线
            doDoctorOnline("N");
        } else if(doctorInfoModel.get("onlineStatus") === "R") {
            appcan.window.alert("", "您正在为患者接诊，无法下线！");
            return;
        }
    });
    
    
    //主页功能信息  by sushu 2019-07-03
    appcan.button(".func-button-rows .btn", "btn-act", function() {
		if(!_checkDoctorLogin()) return;
        var outParam = "doctoriId=" + doctorInfoModel.get("id");
        switch(this.id) {
            case "myInfo":
                //个人信息
                openUrl("physicianPersonalInfoPage", "my/physicianPersonalInformation.html?" + outParam);
                break;
            case "ecSeal":
                //证书管理-电子签章
            	//openUrl("myCertificationInfoPage", "my/my_certification_info.html?certificationRole="+'DOCTOR');
                break;
            case "recipeTemplate":
                //处方模板
                openUrl("recipeTemplateListPage", "diagnosis/recipe_template_list.html?" + outParam);
                break;
            case "recipeInfo":
                //处方列表
                openUrl("prescriptionListPage", "diagnosis/prescription_list.html?" + outParam);
                break;
            case "myBills":
                //我的账单
                openUrl("myBillsListPage", "bill/bill.html?" + outParam);
                break;
            case "historyDiagnosis":
                //诊启记录
                openUrl("diagnosisListPage", "diagnosis/diagnosis_list.html?" + outParam);
                break;
            case "btnPatientList":
                var param = "doctorId=" + doctorInfoModel.get("id");
            	openUrl("patientListPage", "diagnosis/patient_list.html?" + param);
                break;
            default:
                break;   
        }        
    });
    
    var openUrl = function(pageName, url) {
        appcan.window.open({
            name: pageName,
            dataType: 0,
            aniId: 2,
            data: url
        })
    }
    
    
    var refreshBtn = function() {
        if (!!!doctorInfoModel.get("id")) {
            // $("#btnOffline").find(".offline-on").addClass("offline-off");
            // $("#btnOffline").find(".offline-on").removeClass("offline-on");
            // $("#btnOnline").find(".online-off").addClass("online-off");
            // $("#btnOnline").find(".online-off").removeClass("online-off");
        } 
        if (doctorInfoModel.get("onlineStatus") === "Y") {
            $("#btnOnline").find(".online-on").addClass("online-off");
            $("#btnOnline").find(".online-on").removeClass("online-on");
            $("#btnOffline").find(".offline-off").addClass("offline-on");
            $("#btnOffline").find(".offline-off").removeClass("offline-off");
        } else if (!!!doctorInfoModel.get("onlineStatus") || doctorInfoModel.get("onlineStatus") === "N") {
            $("#btnOffline").find(".offline-on").addClass("offline-off");
            $("#btnOffline").find(".offline-on").removeClass("offline-on");
            $("#btnOnline").find(".online-off").addClass("online-on");
            $("#btnOnline").find(".online-off").removeClass("online-off");
        }
    }
    
    appcan.button("#btnPatientList", "btn-act", function() {
       var param = "doctorId=" + doctorInfoModel.get("id");
       commonJs.openWindow("patientListPage", "diagnosis/patient_list.html?" + param);
    });
    
    var _initModel = function() {
        if (!!!commonJs.getDoctor()) {
            for (var key in doctorInfoModel.attributes){
                doctorInfoModel.set(key, "");
            }
        } else {
            doctorInfoModel.set(commonJs.getDoctor());
        }
        refreshBtn();
        _getAwaitDiagnosisCount();
    }
        
    var init = function() {
    	commonJs.listWindowBounce(_getAwaitDiagnosisCount);
        // appcan.window.disableBounce();
        _initModel();
        //获取服务器版本
        getAppVersion();
    }
    
    //获取服务器版本
    var getAppVersion = function(){
		var url = window.ServerURL + "/getAppVersion"; 
    	var data = {};
    	data.configKey = 'doctorVersion';
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, function(res){
    		appVersion = res;
    		//当前程序版本
    		currentVersion();
    	}, function(e, err){
	    	appcan.window.alert({
	            title : "提示",
	            content : "接口调用失败，请联系管理员",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
    	});
    }
    
    //当前程序版本
    var currentVersion = function(){
    	uexWidgetOne.getCurrentWidgetInfo();
        uexWidgetOne.cbGetCurrentWidgetInfo = function(opId,dataType,data){
            var json = JSON.parse(data);
            currentVersion = json.version
            if(parseInt(currentVersion) !== parseInt(appVersion)){
                uexWindow.confirm({
	                     title:"提示",
	                     message:"当前app有新版本，请先更新",
	                     buttonLabels:"确定"
	                },function(index){
	                    if (Number(index) === 0) {
	                    	downApp();
	                    }
	            });
            }
        }
    }
    
    //下载程序
    var downApp = function(){
        var serverURL = "http://42.202.135.42:9999/sjarapk/doctor/doctor.apk";
        var savePath = "wgt://" + "doctor.apk";
        uexDownloaderMgr.createDownloader(1);
        uexDownloaderMgr.cbCreateDownloader = function(opId, dataType, data) {
            if(data == 0) {
                uexDownloaderMgr.download(1,serverURL, savePath, '0');//开始下载apk文件
            }
        };
        uexDownloaderMgr.onStatus=function(opId, fileSize, percent, status) {
            if(status == 0) {
                //下载中...
                appcan.window.openToast('下载进度：' + percent + '%', '', 5, 1);
                //uexWindow.toast('1','5', '下载进度：' + percent + '%', '');
            }
            else if (status == 1) {// 下载完成.
                //uexWindow.toast('1','5', '下载进度：100%', '');
                appcan.window.openToast('下载进度：100%', '', 5, 1);
                appcan.window.closeToast();
                //uexWindow.closeToast();
                uexDownloaderMgr.closeDownloader(1);//关闭下载对象

                var apkFilePath = savePath;

                uexFileMgr.isFileExistByPath(1,apkFilePath);//先判断下载好的apk是否存在
                //检查是否已经存在sd卡的回调函数（step:3）
                uexFileMgr.cbIsFileExistByPath = function(opId, dataType, data) {
                    if (data == 1) {
                        uexWidget.installApp(apkFilePath);//安装下载apk文件
                    }
                };

            }
            else {
                uexDownloaderMgr.closeDownloader(1);//关闭下载对象
            }
         };
    }
    
    return {
        init: init,
        initModel: _initModel,
        getAwaitDiagnosisCount: _getAwaitDiagnosisCount
    }
    
}();

appcan.ready(function() {
    appcan.initBounce();
    doctorIndexHomeContent.init();
});








