if(!window.certificationSignatureContentJs){
	window.certificationSignatureContentJs = {}
}
var certificationSignatureContentJs = function() {
	
	//返回上一页面
	appcan.button(".nav-btn", "btn-act", function() {
		appcan.window.close(-1);
	});
	
	var oCanvas = document.getElementById("canvas");
	oCanvas.width = $("#mycanvas").width();
	var bodyHeigtht = $("[data-control='CONTENT']").offset().height;
	var btnHeight = $("#subButton").offset().height;
	oCanvas.height = bodyHeigtht - btnHeight - 100;
	var signaturePad;
	var formData = new FormData();
	var mobile,name,idCardNum,id,certificationRole;
	
	
    var init = function() {
    	var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        if(inParam!=null&&typeof(inParam)!='undefined'){
            mobile = inParam.mobile;
            name = inParam.name;
            idCardNum = inParam.idCardNum;
            id = inParam.id;
            certificationRole = inParam.certificationRole;
        }
	    signaturePad = new SignaturePad(oCanvas, {
			backgroundColor: 'rgb(255, 255, 255)',
			penColor: 'rgb(0, 0, 0)',
			//minWidth: 1,
			maxWidth: 4.5 //字体加粗
		});
    }
    
    var nextClick = function() {
    	var data = signaturePad.toData();
    	if(signaturePad.isEmpty()){
    		alert("Please provide a signature first.");
    	}else{
    		var dataURL = signaturePad.toDataURL();
    		download(dataURL, "signature.png");
    	}
    }
    
    var download = function(dataURL, filename){
    	if(navigator.userAgent.indexOf("Safari") > -1 && navigator.userAgent.indexOf("Chrome") === -1){
    		window.open(dataURL);
    	}else{
    		var blob = dataURLToBlob(dataURL, filename);
    		var url = window.URL.createObjectURL(blob);
    		formData.append('id', id);
    		// formData.append('id', 1);
    		formData.append('autoSealUrl', blob);
    		sendAjax();
    	}
    }
    
    var dataURLToBlob = function(dataURL, filename){
    	var parts = dataURL.split(';base64,');
		var contentType = parts[0].split(":")[1];
		var raw = window.atob(parts[1]);
		var rawLength = raw.length;
		var uInt8Array = new Uint8Array(rawLength);
		for (var i = 0; i < rawLength; ++i) {
        	uInt8Array[i] = raw.charCodeAt(i);
  		}
  		return new File([uInt8Array],filename, { type: contentType });
    }
    
    //发送AJAX请求
	var sendAjax = function () {
		var url = "";
		if(certificationRole == "DOCTOR"){
			url = window.ajaxFormUrl+'/gatewayApp/ws/doctor/updateDoctorInfo';
		}else if(certificationRole == "PHARMACIST"){
			url = window.ajaxFormUrl+'/gatewayApp/ws/apothecary/updateApothecaryInfo';
		}
	     
	    $.ajax({
	        url: url,
	        type: 'POST',
	        data: formData,
	        async: false,
	        cache: false,
	        contentType: false,
	        // contentEncoding: 'charset=utf-8',
	        processData: false,
	        success: function(res) {
	        	if(JSON.parse(res).result == '0'){
					var paramData = "mobile="+mobile;
					paramData += "&name="+name;
					paramData += "&idCardNum="+idCardNum;
					paramData += "&certificationRole="+certificationRole;
					commonJs.openWindow("certificationShowHeadPage", "certification_show.html?"+paramData);
	        	}else{
			        appcan.window.alert({
			            title : "提示",
			            content : "提交失败，"+res.message,
			            buttons : '确定'
			        });
	        	}
	        },
	        error: function(e, err) {
		    	appcan.window.alert({
		            title : "提示",
		            content : "提交失败，请联系管理员",
		            buttons : '确定',
		            callback : function(err, data, dataType, optId) {
		
		            }
		        });
	        }
	    });
	}
	
	//清除
	var clearClick = function(){
		signaturePad.clear();
	}

    
    
    return {
        init: init,
        nextClick: nextClick,
        clearClick: clearClick
    }
}();


appcan.ready(function() {
    certificationSignatureContentJs.init();
});