if(!window.doctorInfoEditJs){
    window.doctorInfoEditJs = {};
}

var doctorInfoEditJs = function() {
    var editType = "";
    var currentText = "";
    var editInputId = "";
    var editText = "";
    var mechanismId, mechanismName, mechanismType, inParam;
    var mechanismFlag = 'false';
    
    $('input[id="doctorMechanismName"]').bind("input propertychange",function(){
    	mechanismFlag = 'true';
		mechanismNameClick();
	});

    //确定事件
    var commitInput = function(event) {
        
        var editData = {"editType":editType,"editInputId":editInputId};
        if (editType == "NAME") {
            //姓名
            var doctorName = $("#doctorName").val();
            editData.editText = doctorName;
        } else if (editType == "IDENTIFY") {
            //身份证号
            var doctorIdNumber = $("#doctorIdNumber").val();
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            if(reg.test(doctorIdNumber) === false){
	    		appcan.window.alert({
		            title : "提示",
		            content : "身份证不合法",
		            buttons : '确定'
		        });
		        return;
	    	}
            editData.editText = doctorIdNumber;
        } else if (editType == "UNIVERSITY") {
        	//毕业院校
        	var doctorUniversity = $("#doctorUniversity").val();
            editData.editText = doctorUniversity;
        } else if (editType == "BANKACCOUNT"){
        	//银行账号
        	var doctorBankAccount = $("#doctorBankAccount").val();
            editData.editText = doctorBankAccount;
        } else if (editType == "MECHANISMNAME"){
        	//单位
        	if(mechanismId == "undefined" || mechanismId == null || mechanismId == ""){
        		appcan.window.openToast("没有当前单位信息", 2000, 5, 0);
        		return;
        	}
        	editData.editText = mechanismName;
        	editData.mechanismId = mechanismId;
        	editData.mechanismName = mechanismName;
        	editData.mechanismType = mechanismType;
        } else if (editType == "POST"){
        	//职务
        	var doctorPost = $("#doctorPost").val();
            editData.editText = doctorPost;
        } else if (editType == "BUSINESSLICENSE"){
        	//执业证号
        	var doctorBusinessLicense = $("#doctorBusinessLicense").val();
            editData.editText = doctorBusinessLicense;
        }
        var frame = appcan.require("frame");
        frame.close("doctorInfoEditPage");
        appcan.window.close(-1);
		appcan.window.evaluatePopoverScript(inParam.parentPageName,inParam.parentFrameName, inParam.js+"("+JSON.stringify(editData)+")");
        //appcan.window.publish("setDoctorEditData", JSON.stringify(editData));
        //appcan.window.publish("closePage", "");
        
       

                
    }
    
    //清除input事件
    var clearInput = function(event){
        $(event.currentTarget).parent().find("input").val("");
        $("#commitInputBtn").css("color","#B1B1B1");
    }
    
    //确定按钮显示
    var showCommitButton = function(value){
        
         if(value!=null&&value!=""){
            if(value == currentText){
                $("#commitInputBtn").css("color","#B1B1B1");
            }else{
                $("#commitInputBtn").css("color","#178AFF");
                editText = value;
            }
        }else{
            $("#commitInputBtn").css("color","#B1B1B1");
        }
        

    }

    var init = function() {
        
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        
        
        if(inParam!=null&&typeof(inParam)!='undefined'){
            // patientId = inParam.patientId;
            editType = inParam.editType; 
            currentText = inParam.currentText;
            editInputId = inParam.editInputId;
            if(editType!=null&&editType!="undefined"&&typeof(editType)!="undefined"){
                if(editType == "NAME"){
                    //姓名
                    $("#name").addClass("ub");
                    $("#doctorName").val(currentText);
                }else if(editType == "IDENTIFY"){
                    //身份证号
                    $("#identifyNum").addClass("ub");
                    $("#doctorIdNumber").val(currentText);
                }else if(editType == "UNIVERSITY"){
                	//毕业院校
                	$("#university").addClass("ub");
                    $("#doctorUniversity").val(currentText);
                }else if(editType == "BANKACCOUNT"){
                	//银行账号
                	$("#bankAccount").addClass("ub");
                    $("#doctorBankAccount").val(currentText);
                }else if(editType == "MECHANISMNAME"){
                	//单位
                	$("#mechanismName").addClass("ub");
                    $("#doctorMechanismName").val(currentText);
                    //获取单位信息
                    mechanismNameClick();
                }else if(editType == "POST"){
                	//职务
                	$("#post").addClass("ub");
                    $("#doctorPost").val(currentText);
                }else if(editType == "BUSINESSLICENSE"){
                	//执业证号
                	$("#businessLicense").addClass("ub");
                    $("#doctorBusinessLicense").val(currentText);
                }
                
            }
        }        
    }
    
    //单位搜索点击事件
    var mechanismNameClick = function() {
    	var url = window.ServerURL + "/getTMechanismInfo"; 
    	var data = {};
    	data.pageIndex = 1;
    	data.pageSize = 10;
    	data.mechanismName = $("#doctorMechanismName").val();
    	if(inParam.role == "D"){
    		//医师
    		data.mechanismType = 'HS1,HS2,HS3';
    	}else if(inParam.role == "P"){
    		//药师
    		data.mechanismType = 'YF';
    	}
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, mechanismNameSuccess, mechanismNameFail);
    }
    
    //单位搜索成功回调
    var mechanismNameSuccess = function(res) {
    	if(res.length >= 1){
    		if(mechanismFlag == 'false'){
	    		mechanismId = res[0].id;
	    		mechanismName = res[0].mechanismName;
	    		mechanismType = res[0].mechanismType;
    			return;
    		}
    		$("#mechanism_name_div").attr("style"," display: block!important;");
    		var html = '';
	        $.each(res, function(commentIndex, comment){
	            html += '<li class="hint-li" mechanismId="'+comment.id+'" mechanismType="'+comment.mechanismType+'" mechanismName="'+comment.mechanismName+'" onclick="doctorInfoEditJs.mechanismSelectClick($(this))">' +
		                	comment.mechanismName +
		                '</li>';
	        });
			$('#mechanism_name_select').html(html);
    	}else{
    		mechanismId = "";
    		mechanismName = "";
    		mechanismType = "";
    	}
    }
    
    //单位搜索失败回调
    var mechanismNameFail = function(e, err) {
	    appcan.window.alert({
            title : "提示",
            content : "查询失败，请联系管理员",
            buttons : '确定',
            callback : function(err, data, dataType, optId) {

            }
        });
    }
    
    //单位选择事件
    var mechanismSelectClick = function(obj) {
    	mechanismId = $(obj).attr("mechanismId");
    	mechanismName = $(obj).attr("mechanismName");
    	mechanismType = $(obj).attr("mechanismType");
    	$("#doctorMechanismName").val(mechanismName);
    	$("#mechanism_name_div").attr("style"," display: none!important;");
    }
    
    
    return {
        commitInput: commitInput,
        clearInput: clearInput,
        showCommitButton:showCommitButton,
        init: init,
        mechanismSelectClick: mechanismSelectClick
    }
    
}();


appcan.ready(function() {

    appcan.button("#nav-left", "btn-act", function() {
        appcan.window.close(-1);
        uexWindow.setSlidingWindowEnabled(1);
        uexWindow.setMultilPopoverFlippingEnbaled(1);
    }); 

    doctorInfoEditJs.init();
});