/**
 * @author Nicro.Li
 */
if(!!!window.myNetworkContent){
    window.myNetworkContent = {};
}

var myNetworkContent = function() {
    var pageCount = 0, doctorInfo = {}, headerHeight, inParam, pageParam,
        networkViewModel;
    
    var getDoctorList = function(level) {
        var param = _.clone(window.pagingParam);
        pageCount++;
        param.pageIndex = pageCount;
        param.doctorId = !!!doctorInfo ? "_" : doctorInfo.id;
        param.level = level;
        //{"doctorId":"1","level":"3","pageIndex":1,"pageSize":10}
        commonService.request(param, {
            url: window.ajaxUrl + "/getUpDoctorInfo",
            success: function(res) {
                if (pageCount === 1) {
                    networkViewModel.collection.set(res);
                } else {
                    networkViewModel.collection.add(res);
                }
            }
        });
    }
    
    var showDoctorInfo = function(event) {
        var doctorId = $(event.currentTarget).find("[data-bind='text:id']").text().trim();
        var param = "showType=myNetwork&editFlag=N&doctoriId=" + doctorId;
        commonJs.openWindow("physicianPersonalInfoPage", "physicianPersonalInformation.html?" + param);
    }
    
    var init = function() {
        commonJs.listWindowBounce(getDoctorList);
        doctorInfo = commonJs.getDoctor();
    }
    
    var initFirst = function() {
        networkViewModel = new (MVVM.ViewModel.extend({
            el: "#doctorFirstNetworkShow",
            collection: new DoctorInfoCollection()
        }));
        init();        
        getDoctorList("1");
    }
    
    var initSecond = function() {
        networkViewModel = new (MVVM.ViewModel.extend({
            el: "#doctorSecondNetworkShow",
            collection: new DoctorInfoCollection()
        }));
        init();        
        getDoctorList("2");
    }
    
    var initThird = function() {
        networkViewModel = new (MVVM.ViewModel.extend({
            el: "#doctorThirdNetworkShow",
            collection: new DoctorInfoCollection()
        }));
        init();        
        getDoctorList("3");
    }
    
    return {
        initFirst: initFirst,
        initSecond: initSecond,
        initThird: initThird,
        showDoctorInfo: showDoctorInfo
    }
}();









