/**
 * @author Nicro.Li
 */
if(!!!window.myTeamAddContent){
    window.myTeamAddContent = {};
}

var myTeamAddContent = function() {
    var pageCount = 0, doctorInfo = {}, headerHeight, inParam, pageParam;
                
    var doctorTeamAddViewModel = new (MVVM.ViewModel.extend({
        el: "#doctorTeamAddShow",
        collection: new DoctorInfoCollection()
    }));    
    
    var getDoctorInfoList = function(doctorName) {
        var param = _.clone(window.pagingParam);
        pageCount++;
        param.pageIndex = pageCount;
        if (!!doctorName) {
            param.doctorName = doctorName;
        }
        commonService.request(param, {
            url: window.ajaxUrl + "/getDoctor",
            success: function(res) {
                if (pageCount === 1) {
                    doctorTeamAddViewModel.collection.set(res);
                } else {
                    doctorTeamAddViewModel.collection.add(res);
                }
                // var models = doctorTeamAddViewModel.collection.where({"id": doctorInfo.id});
                // if (models.length > 1) {
                    // doctorTeamAddViewModel.collection.remove(models);
                // }
            }
        });
    }
    
    var getDoctorInfo = function() {
        pageCount = 0;
        var doctorName = $("#searchParam").val();
        getDoctorInfoList(doctorName);
    }
    
    var showDoctorInfo = function(event) {
        var doctorId = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var param = "showType=myTeamAddcontent&editFlag=N&doctoriId=" + doctorId;
        commonJs.openWindow("physicianPersonalInfoPage", "physicianPersonalInformation.html?" + param);
    }
    
    var addDoctorTeam = function(event) {
        var byDoctorId = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var param = _.clone(window.pagingParam);
        param.doctorId =  doctorInfo != null ? doctorInfo.id : "_" ;
        param.byDoctorId = byDoctorId;
        //{"doctorId":"1","byDoctorId":"1","teamName":"团队名称"}
        commonService.request(param, {
            url: window.ajaxUrl + "/addTDoctorInviteInfo",
            success: function(res) {
                //alert(JSON.stringify(param));
                //alert(JSON.stringify(res));
                if (res.result === "0") {
                    appcan.window.openToast("添加医生成功，请等待添加医生确认加入团队。", 2000, 5, 0);
                } else {
                    appcan.window.openToast(res.message, 2000, 5, 0);
                }
                
            }
        });
        //var param = "showType=myNetwork&editFlag=N&doctoriId=" + doctorId;
        //commonJs.openWindow("physicianPersonalInfoPage", "physicianPersonalInformation.html?" + param);
    }
    
    
    var init = function() {
        commonJs.listWindowBounce(getDoctorInfoList);
        doctorInfo = commonJs.getDoctor();
        getDoctorInfoList();
    }
    
    return {
        init: init,
        addDoctorTeam: addDoctorTeam,
        showDoctorInfo: showDoctorInfo,
        getDoctorInfo: getDoctorInfo
    }
}();

appcan.ready(function() {
    myTeamAddContent.init();
});









