/**
 * @author Nicro.Li
 */
if(!!!window.myTeamConfirmContent){
    window.myTeamConfirmContent = {};
}

var myTeamConfirmContent = function() {
    var pageCount = 0, doctorInfo = {}, headerHeight, inParam, pageParam;
                
    var doctorInviteInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#doctorInviteInfoShow",
        collection: new DoctorInviteInfoCollection()
    }));    
    
    var getDoctorInviteInfoList = function(level) {
        var param = _.clone(window.pagingParam);
        pageCount++;
        param.pageIndex = pageCount;
        param.byDoctorId = !!!doctorInfo ? "_" : doctorInfo.id;
        param.status = "COMMIT";
        commonService.request(param, {
            url: window.ajaxUrl + "/getTDoctorInviteInfo",
            success: function(res) {
                if (pageCount === 1) {
                    doctorInviteInfoViewModel.collection.set(res);
                } else {
                    doctorInviteInfoViewModel.collection.add(res);
                }
            }
        });
    }
    
    var hiddenBtn = function(parent) {
        $(parent).addClass("field-nodisplay");
    }
    
    var showDoctorInfo = function(event) {
        var doctorId = $(event.currentTarget).parents("li").find("[data-bind='text:doctorId']").text().trim();
        var param = "showType=myTeamConfirmContent&editFlag=N&doctoriId=" + doctorId;
        commonJs.openWindow("physicianPersonalInfoPage", "physicianPersonalInformation.html?" + param);
    }
    
    var doAcceptTeam = function(event) {
        var id = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var parent = $(event.currentTarget).parent();
        var param = _.clone(window.pagingParam);
        param.doctorId =  doctorInfo != null ? doctorInfo.id : "_" ;
        param.id = id;
        param.status = "AGREED"; //window.codeList.doctorInviteStatus
        //{"Id":"1","status":"AGREED"}
        commonService.request(param, {
            url: window.ajaxUrl + "/updateTDoctorInviteInfo",
            success: function(res) {
                //alert(JSON.stringify(param));
                //alert(JSON.stringify(res));
                hiddenBtn(parent);
                appcan.window.openToast("同意加入医生团队成功。", 2000, 5, 0);
            }
        });
    }
    var doRejectTeam = function(event) {
        var id = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var parent = $(event.currentTarget).parent();
        var param = _.clone(window.pagingParam);
        param.doctorId =  doctorInfo != null ? doctorInfo.id : "_" ;
        param.id = id;
        param.status = "REFUSED"; //window.codeList.doctorInviteStatus
        //{"Id":"1","status":"AGREED"}
        commonService.request(param, {
            url: window.ajaxUrl + "/updateTDoctorInviteInfo",
            success: function(res) {
                //alert(JSON.stringify(param));
                //alert(JSON.stringify(res));
                hiddenBtn(parent);
                appcan.window.openToast("拒绝加入医生团队成功。", 2000, 5, 0);
            }
        });
    }
    
    var init = function() {
        appcan.initBounce();
        commonJs.listWindowBounce(getDoctorInviteInfoList);
        doctorInfo = commonJs.getDoctor();
        getDoctorInviteInfoList();
    }
    
    return {
        init: init,
        doAcceptTeam: doAcceptTeam,
        doRejectTeam: doRejectTeam,
        showDoctorInfo: showDoctorInfo
    }
}();

appcan.ready(function() {
    myTeamConfirmContent.init();
});









