/**
 * @author Nicro.Li
 */
if(!!!window.myTeamListContent){
    window.myTeamListContent = {};
}

var myTeamListContent = function() {
    var pageCount = 0, doctorInfo = {}, headerHeight, inParam, pageParam;
                
    var doctorTeamInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#doctorTeamInfoShow",
        collection: new DoctorTeamInfoCollection()
    }));    
    
    var getDoctorTeamList = function() {
        var param = _.clone(window.pagingParam);
        pageCount++;
        param.pageIndex = pageCount;
        param.teamId = !!!doctorInfo ? "_" : doctorInfo.id;
        commonService.request(param, {
            url: window.ajaxUrl + "/getTDoctorTeamInfo",
            success: function(res) {
                if (pageCount === 1) {
                    doctorTeamInfoViewModel.collection.set(res);
                } else {
                    doctorTeamInfoViewModel.collection.add(res);
                }
            }
        });
    }
    
    var showDoctorInfo = function(event) {
        var doctorId = $(event.currentTarget).parents("li").find("[data-bind='text:doctorId']").text().trim();
        var param = "showType=myTeamListcontent&editFlag=N&doctoriId=" + doctorId;
        commonJs.openWindow("physicianPersonalInfoPage", "physicianPersonalInformation.html?" + param);
    }
    
    var getInitList = function() {
        pageCount = 0;
        getDoctorTeamList();
    }  
    
    appcan.button("#btnAddDoctor", "btn-act", function() {
       commonJs.openWindow("myTeamAdd", "my_team_add.html"); 
    });
    
    //手势滑动开始坐标获取，直接监听BODY事件
    $("body").on("touchstart", function(event) {
         // 判断默认行为是否可以被禁用
         startX = event.changedTouches[0].pageX,
         startY = event.changedTouches[0].pageY;
     });
     
     //药品信息删除按钮显示
    var showDeleteBtn = function(event) {
        moveEndX = event.changedTouches[0].pageX,
        moveEndY = event.changedTouches[0].pageY,
        X = moveEndX - startX,
        Y = moveEndY - startY;
        
        if ( X + 100 < 0 && 50 > Y && -50 < Y) {
            //左滑
            $(event.currentTarget).find("#btnDelTeamDoctor").removeClass("field-nodisplay");
            $(event.currentTarget).find("#btnDelTeamDoctor").addClass("field-display");
        } else if ( X - 100 > 0 && 50 > Y && -50 < Y) {
            //右滑
            $(event.currentTarget).find("#btnDelTeamDoctor").removeClass("field-display");
            $(event.currentTarget).find("#btnDelTeamDoctor").addClass("field-nodisplay");
        }
    }
    
    var showDelBtn = function(event) {
        $(event.currentTarget).parents("li").find("#btnDelTeamDoctor").removeClass("field-nodisplay");
        $(event.currentTarget).parents("li").find("#btnDelTeamDoctor").addClass("field-display");
    }
    
    var deleteTeamDoctor = function(event) {
        var id = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var param = {"id": id};
        commonService.request(param, {
            url: window.ajaxUrl + "/deleteTDoctorTeamDoctor",
            success: function(res) {
                //alert(JSON.stringify(param));
                //alert(JSON.stringify(res));
                appcan.window.openToast("删除团队医生成功。", 2000, 5, 0);
                getInitList();
            }
        });
    }
    
    var init = function() {
        commonJs.listWindowBounce(getDoctorTeamList);
        doctorInfo = commonJs.getDoctor();
        getDoctorTeamList();
        
    }
    
    return {
        init: init,
        getInitList: getInitList,
        showDeleteBtn: showDeleteBtn,
        showDelBtn: showDelBtn,
        deleteTeamDoctor: deleteTeamDoctor,
        showDoctorInfo: showDoctorInfo
    }
}();

appcan.ready(function() {
    myTeamListContent.init();
});









