
if(!window.doctoeOccupation){
    window.doctoeOccupation = null;
}

var doctoeOccupation = function () {
    
    var inParam, doctorId, headerHeight, editFlag;
    var editType = "", certStatus="";
    var departmentList = [];
    
    var doctor = new DoctoePersonModel();
    var pubEditParam = new PubEditParam();
    
    var doctoeOccupationViewModel = new (MVVM.ViewModel.extend({
        el: "#doctorOccupationContent",
        model: doctor
    }));
    
     //加载个人信息界面
    var load = function(event) {
    	var outParam = "doctoriId=" + doctorId+ "&editFlag="+editFlag;
        appcan.window.open({
            name: "physicianPersonalInformationPage",
            data: "physicianPersonalInformation.html?" + outParam,
            dataType: 0,
            animID: 2
        });
            
        }
     //加载认证信息界面   
        var loadrz = function(event) {
    		var outParam = "doctoriId=" + doctorId+ "&editFlag="+editFlag;
            appcan.window.open({
                name: "physicianCertificationInformationPage",
                data: "physicianCertificationInformation.html?" + outParam,
                dataType: 0,
                animID: 2
            });
            
        }
        
    //加载个人签名
    var loadSignature = function(event){
    	var outParam = "doctoriId=" + doctorId+ "&editFlag="+editFlag;
        appcan.window.open({
            name: "physicianSignaturePage",
            data: "physicianSignature.html?" + outParam,
            dataType: 0,
            animID: 2
        });
    }
    
    
    var getDoctoeOccupation  = function() {
        var findParam = {"id": doctorId, "pageIndex":1 ,"pageSize": 10};
        doctoeOccupationViewModel.model.fetch({param: findParam});
        setTimeout(function() {
        	//by sushu 2020-02-19
        	//加载科室
        	getDepartmentByHospital();
        }, 200);
    }
    
    var init = function() {
        //些页面禁用弹动效果
        appcan.window.disableBounce();
        //获取入参
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        doctorId = !!inParam ? inParam.doctoriId || "_" : "_";
        headerHeight = !!inParam ? inParam.headerHeight || 0 : 0;
        editFlag = !!inParam ? inParam.editFlag || "N" : "N";
        //加载数据
        getDoctoeOccupation();
    }
    
    
    //编辑项
    var toEditPage = function(editType,id,event){
    	certStatus = doctor.get("certStatus");
    	if(editFlag == "Y" && certStatus == "WRZ"){
	    	editType = editType;
	        var currentText = $(event.currentTarget).find("#"+id).text().trim();
	        var paramStr = "&parentPageName=physicianOccupationInformationPage";
            paramStr += "&parentFrameName=physicianOccupationInformationPage";
            paramStr += "&js=doctoeOccupation.setDoctorEditData";
            paramStr += "&editType="+ editType+"&currentText="+currentText+"&editInputId="+id+"&role="+'D';
	        appcan.window.open({
	            name : "doctorInfoEditPage",
	            data : "doctor_info_edit.html?"+paramStr,
	            aniId : "2"
	        });
    	} 
    }
    
    //监听编辑项
    var setDoctorEditData = function(editJson){
    	var formData = new FormData();
    	formData.append('id',doctorId);
        editType = editJson.editType;
        var id = editJson.editInputId;
        $("#"+id).text(editJson.editText);
        if (editType == "MECHANISMNAME") {
            //单位
            doctor.set("mechanismId", editJson.mechanismId);
            doctor.set("mechanismName", editJson.mechanismName);
            doctor.set("mechanismType", editJson.mechanismType);
            formData.append('mechanismId',editJson.mechanismId);
            formData.append('mechanismName',encodeURIComponent(editJson.mechanismName));
            formData.append('mechanismType',editJson.mechanismType);
            //加载科室
            getDepartmentByHospital();
        }else if(editType == "POST"){
        	//职务
        	doctor.set("post", editJson.editText);
        	formData.append('post',encodeURIComponent(editJson.editText));
        }else if(editType == "BUSINESSLICENSE"){
        	//执业证号
        	doctor.set("businessLicense", editJson.editText);
        	formData.append('businessLicense',editJson.editText);
        }
        doSave(formData);
    }
    
    //保存
    var doSave = function(formData){
	    var url = window.ajaxFormUrl+'/gatewayApp/ws/doctor/updateDoctorInfo';
	    $.ajax({
	        url: url,
	        type: 'POST',
	        data: formData,
	        async: false,
	        cache: false,
	        contentType: false,
	        // contentEncoding: 'charset=utf-8',
	        processData: false,
	        success: function(res) {
	        	if(JSON.parse(res).result == '0'){
	        		appcan.window.openToast("更新成功", 2000, 5, 0);
	        	}else{
			        appcan.window.alert({
			            title : "提示",
			            content : "提交失败，"+res.message,
			            buttons : '确定'
			        });
	        	}
	        },
	        error: function(e, err) {
		    	appcan.window.alert({
		            title : "提示",
		            content : "提交失败，请联系管理员",
		            buttons : '确定',
		            callback : function(err, data, dataType, optId) {
		
		            }
		        });
	        }
	    });
    }
    
    
    //带码表公共点击事件
    var commonClick = function(editType){
    	certStatus = doctor.get("certStatus");
    	//允许编辑
    	if(editFlag == "Y" && certStatus == "WRZ"){
    		var changeObjectValue;
    		var options;
    		if(editType == "doctorTitle"){
    			changeObjectValue = {"doctorTitle": doctor.get("titleCode")};
	        	options = {fieldCode: "doctorTitle", fieldName: "职称",
	            editorType: "checkItem", fieldValue: changeObjectValue, codelistType: "doctorTitle"};    
    		}else if(editType == "education"){
    			changeObjectValue = {"education": doctor.get("education")};
	        	options = {fieldCode: "education", fieldName: "学历",
	            editorType: "checkItem", fieldValue: changeObjectValue, codelistType: "education"};
    		}else if(editType == "openBank"){
    			changeObjectValue = {"openBank": doctor.get("openBankCode")};
	        	options = {fieldCode: "openBank", fieldName: "开户行",
	            editorType: "checkItem", fieldValue: changeObjectValue, codelistType: "openBank"};
    		}else if(editType == "doctorType"){
    			changeObjectValue = {"doctorType": doctor.get("doctorType")};
	        	options = {fieldCode: "doctorType", fieldName: "科别",
	            editorType: "checkItem", fieldValue: changeObjectValue, codelistType: "doctorType"};
    		}
	        pubEditParam.saveLocStorage(options);
	        var paramStr = "&parentPageName=physicianOccupationInformationPage";
	            paramStr += "&parentFrameName=physicianOccupationInformationPage";
	            paramStr += "&js=doctoeOccupation.getPubEditValue";
	        appcan.frame.open("content", "../../components/pubEditValue.html?" + paramStr, 0, inParam.headerHeight, "physicianCommonPubPage");
    	}
    }
    
    //获取编辑值
    var getPubEditValue = function(res){
    	var formData = new FormData();
    	formData.append('id',doctorId);
    	var frame = appcan.require("frame");
        var value;
        if(typeof(res) === "string") {
           value = JSON.parse(res);
        } else if(typeof(res) === "object") {
            value = res;
        }
        if (value.fieldCode === "doctorTitle") {
            doctor.set("titleCode", value.fieldValue.doctorTitle);
            doctor.set("titleName", getCodeListText(window.codeList.doctorTitle,value.fieldValue.doctorTitle));
            formData.append('titleCode',value.fieldValue.doctorTitle);
            formData.append('titleName',encodeURIComponent(getCodeListText(window.codeList.doctorTitle,value.fieldValue.doctorTitle)));
            getPrice(value.fieldValue.doctorTitle,formData);
            return;
        } else  if (value.fieldCode === "education") {
            doctor.set("education", value.fieldValue.education);
            formData.append('education',value.fieldValue.education);
        } else  if (value.fieldCode === "openBank") {
            doctor.set("openBankCode", value.fieldValue.openBank);
            doctor.set("openBankName", getCodeListText(window.codeList.openBank,value.fieldValue.openBank));
            formData.append('openBankCode',value.fieldValue.openBank);
            formData.append('openBankName',encodeURIComponent(getCodeListText(window.codeList.openBank,value.fieldValue.openBank)));
        } else if (value.fieldCode === "doctorType"){
        	doctor.set("doctorType", value.fieldValue.doctorType);
            formData.append('doctorType',value.fieldValue.doctorType);
        }
        frame.close("physicianCommonPubPage");
        pubEditParam.removeLocStorage();
        doSave(formData);
    }
    
    //根据职称获取诊疗费、平台价、签约价
    var getPrice = function(titleCode,formData) {
    	var url = window.ServerURL + "/getTTitlePrice"; 
    	var data = {};
    	data.titleCode = titleCode;
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, function(res){
    		if(res.length > 0){
	    		doctor.set("taskPrice", res[0].taskPrice);
	    		doctor.set("customerPrice", res[0].customerPrice);
	    		doctor.set("platformPrice", res[0].platformPrice);
	    		formData.append('taskPrice', res[0].taskPrice);
	    		formData.append('customerPrice', res[0].customerPrice);
	    		formData.append('platformPrice', res[0].platformPrice);
	    		var frame = appcan.require("frame");
	    		frame.close("physicianCommonPubPage");
                pubEditParam.removeLocStorage();
	    		doSave(formData);
    		}
    	}, function(e, err){
	    	appcan.window.alert({
	            title : "提示",
	            content : "查询失败，请联系管理员",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
    	});
    }
    
    //擅长病种
    var diseaseClick = function(){
    	certStatus = doctor.get("certStatus");
    	if(editFlag == "Y" && certStatus == "WRZ"){
	    	appcan.locStorage.setVal('illnessCode', doctor.get("illnessCode"));
	    	appcan.locStorage.setVal('illnessName', doctor.get("illnessName"));
	    	//根据不同的点击事件，base_info_pop显示不同的信息
	        var paramStr = "&parentPageName=physicianOccupationInformationPage";
	        paramStr += "&parentFrameName=physicianOccupationInformationPage";
	        paramStr += "&js=doctoeOccupation.setDiseaseData";
	        paramStr += "&selectType=" + 'DISEASE';
	        appcan.frame.open("content", "../../login/base_info_pop.html?" + paramStr, 0, headerHeight, 'baseInfo');
    	}
    }
    
    //订阅疾病信息值
    var setDiseaseData = function(res){
    	var formData = new FormData();
    	formData.append('id',doctorId);
    	var illnessData = res;
    	doctor.set("illnessCode", illnessData.code.join(','));
    	doctor.set("illnessName", illnessData.name.join(','));
    	formData.append('illnessCode',illnessData.code.join(','));
    	formData.append('illnessName',encodeURIComponent(illnessData.name.join(',')));
    	doSave(formData);
    }
    
    //科室点击事件
    var doctorDepartmentClick = function(){
    	certStatus = doctor.get("certStatus");
    	if(editFlag == "Y" && certStatus == "WRZ"){
	    	if(departmentList.length <= 0){
	    		appcan.window.alert({
		            title : "提示",
		            content : "当前单位没有科室来源",
		            buttons : '确定'
		        });
		        return;
	    	}
	    	var _self = this;
	        var layer = 1;
	        if (_self.department) {
	            _self.department.show(function(items) {
	                doctor.set("departmentName", items[layer - 1].text);
	                doctor.set("departmentCode", items[layer - 1].value);
	                var formData = new FormData();
	    			formData.append('id',doctorId);
	    			formData.append('departmentCode',doctor.get("departmentCode"));
	    			formData.append('departmentName',encodeURIComponent(doctor.get("departmentName")));
	    			doSave(formData);
	            });
	        } else {
	            _self.department = new Neusoft.PopPicker({
	                layer: layer
	            });
	            _self.department.setData(departmentList);
	            _self.department.show(function(items) {
	                doctor.set("departmentName", items[layer - 1].text);
	                doctor.set("departmentCode", items[layer - 1].value);
	                var formData = new FormData();
	    			formData.append('id',doctorId);
	    			formData.append('departmentCode',doctor.get("departmentCode"));
	    			formData.append('departmentName',encodeURIComponent(doctor.get("departmentName")));
	    			doSave(formData);
	                // _self.title.dispose();
	                // _self.title = null;
	            });
	        }
    	}
    }
    
    //加载科室
    var getDepartmentByHospital = function(){
    	var url = window.ServerURL + "/getDepartmentByHospital"; 
    	var data = {};
    	data.mechanismId = doctor.get("mechanismId");
    	data.departmentLevel = '1';
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, function(res){
    		//
    		if(JSON.stringify(res) != "{}" && res[1].length > 0){
    			for(var i=0; i<res[1].length; i++){
    				var objData = {};
    				objData.id = res[1][i].id;
    				objData.value = res[1][i].departmentCode;
    				objData.text = res[1][i].fullName;
    				departmentList.push(objData);
    			}
    		}
    	}, function(e, err){
	    	appcan.window.alert({
	            title : "提示",
	            content : "接口调用失败，请联系管理员",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
    	});
    }
    
        
    return {
    	load: load,
    	loadrz: loadrz,
    	loadSignature: loadSignature,
        init: init,
        toEditPage: toEditPage,
        setDoctorEditData: setDoctorEditData,
        commonClick: commonClick,
        getPubEditValue: getPubEditValue,
        diseaseClick: diseaseClick,
        setDiseaseData: setDiseaseData,
        doctorDepartmentClick: doctorDepartmentClick
    }    
}();

appcan.ready(function() {
    doctoeOccupation.init();
});
