
doctorInfoTable.styleDisplay = "-webkit-box !important";
var DoctoePersonModel = MVVM.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : doctorInfoTable,
    
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
       //对数据进行转换并且返viewmodel
       getEducation : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["education"],
            get : function(education) {
                var codelist = commonJs.getCodelistData(window.codeList.education, education);
                return codelist.text || education;
            }
        },
        getSex : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["sex"],
            get : function(sex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, sex);
                return codelist.text || sex;
            }
        },
        getTitleCode : {
                    deps : ["titleCode"],
                    get : function(titleCode) {
                        var codelist = commonJs.getCodelistData(window.codeList.doctorTitle, titleCode);
                        return codelist.text || titleCode;
                    }
               },
        
        getDepartmentName : {
                    deps : ["departmentCode"],
                    get : function(departmentCode) {
                        var codelist = commonJs.getCodelistData(window.codeList.department, departmentCode);
                        return codelist.text || departmentCode;
                    }
               },
        getTaskPrice : {
                    deps : ["taskPrice"],
                    get : function(taskPrice) {
                        if(taskPrice==""){
                        	
                        }else{
                        	taskPrice = "￥"+ taskPrice;
                        }
                        return  taskPrice;
                    }
               },
        getPlatformPrice : {
                    deps : ["platformPrice"],
                    get : function(platformPrice) {
                        if(platformPrice==""){
                        	
                        }else{
                        	platformPrice = "￥"+ platformPrice;
                        }
                        return  platformPrice;
                    }
               },
        getCustomerPrice : {
            deps : ["customerPrice"],
            get : function(customerPrice) {
                if(customerPrice==""){
                	
                }else{
                	customerPrice = "￥"+ customerPrice;
                }
                return  customerPrice;
            }
        },
        //身证份正面
        getCardIdPicture1 : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["cardIdPicture1"],
            get : function(cardIdPicture1) {
                return window.PicURL + cardIdPicture1;
            }
        },
        //身份证反面
        getCardIdPicture2 : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["cardIdPicture2"],
            get : function(cardIdPicture2) {
                return window.PicURL + cardIdPicture2;
            }
        },
        //医师执业证
        getBusinessPicture1 : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["businessPicture1"],
            get : function(businessPicture1) {
                return window.PicURL + businessPicture1;
            }
        },
        //医师执业证详情页
        getBusinessPicture2 : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["businessPicture2"],
            get : function(businessPicture2) {
                return window.PicURL + businessPicture2;
            }
        },
        //专业技师执业证
        getTitlePicture1 : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["titlePicture1"],
            get : function(titlePicture1) {
                return window.PicURL + titlePicture1;
            }
        },
        //专业技师执业证详情页
        getTitlePicture2 : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["titlePicture2"],
            get : function(titlePicture2) {
                return window.PicURL + titlePicture2;
            }
        },
        //医师类别 
        getDoctorType : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["doctorType"],
            get : function(doctorType) {
                var codelist = commonJs.getCodelistData(window.codeList.doctorType, doctorType);
                return codelist.text || doctorType;
            },
        }
        
        
    },
    
    
    
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            console.log("patch");
            break;
        case "delete":
            console.log("delete");
            break;
        case "read":
            
            var param = options.param || {
                "pageIndex": 1,
                "pageSize": 10
            };
           var doctorPersonService = new DoctorPersonService(param, options);
            doctorPersonService.getDoctor();
            //diagnosisCostPostService.request(param, options);
            break;
        default:
            break;
        }
    }
});

