if(!window.physicianSignatureContentJs){
	window.physicianSignatureContentJs = {}
}
var physicianSignatureContentJs = function() {
	var editFlag, doctorId;
    var certStatus="";
    
    var doctor = new DoctoePersonModel();
    var doctoePersonViewModel = new (MVVM.ViewModel.extend({
        el: "#doctorPersonContent",
        model: doctor
    }));
	
	//返回上一页面
	appcan.button(".nav-btn", "btn-act", function() {
		appcan.window.close(-1);
	});
	
	var oCanvas = document.getElementById("autoSealUrlCanvas");
	oCanvas.width = $("#mycanvas").width();
	var bodyHeigtht = $("[data-control='CONTENT']").offset().height;
	var btnHeight = $("#subButton").offset().height;
	oCanvas.height = Number((bodyHeigtht - btnHeight - 100)/2);
	var ctx = oCanvas.getContext('2d');
	var signaturePad;
	var formData = new FormData();
	
    var init = function() {
    	var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
    	doctorId = !!inParam ? inParam.doctoriId || "_" : "_";
        //是否可以编辑页面资料
        editFlag = !!inParam ? inParam.editFlag || "Y" : "Y";
        //加载数据
        getDoctorPerson();
    }
    
    var getDoctorPerson = function() {
        var findParam = {"id": doctorId, "pageIndex":1 ,"pageSize": 10};
        doctoePersonViewModel.model.fetch({param: findParam});
    }
    
    var loadAutoSealUrl = function(){
    	//是否可以修改
    	certStatus = doctor.get("certStatus");
    	if(editFlag == "Y" && certStatus == "WRZ"){
    		$("#subButton").removeClass("field-nodisplay");
    	}else{
    		$("#subButton").addClass("field-nodisplay");
    	}
    	
        var img = new Image();
		img.onload = function(){
			// 将图片画到canvas上面上去！
			ctx.drawImage(img,100,100);
		}
		img.src = window.PicURL + doctor.get("autoSealUrl") + "?temp=" + Math.random();
		signaturePad = new SignaturePad(oCanvas, {
			backgroundColor: 'rgb(240, 240, 240)',
			penColor: 'rgb(0, 0, 0)',
			//minWidth: 1,
			maxWidth: 5.5 //字体加粗
		});
    }
    
    //清除按钮
    var clearClick = function() {
    	signaturePad.clear();
    }
    
    var submitSaveClick = function(){
    	if(signaturePad.isEmpty()){
    		alert("请先完成签名,再提交认证!");
    	}else{
    		var dataURL = signaturePad.toDataURL();
    		download(dataURL, "signature.png");
    	}
    }
    
    var download = function(dataURL, filename){
    	if(navigator.userAgent.indexOf("Safari") > -1 && navigator.userAgent.indexOf("Chrome") === -1){
    		window.open(dataURL);
    	}else{
    		var blob = dataURLToBlob(dataURL, filename);
    		var url = window.URL.createObjectURL(blob);
    		// formData.append('id', id);
    		formData.append('id', doctorId);
    		formData.append('autoSealUrl', blob);
    		sendAjax();
    	}
    }
    
    var dataURLToBlob = function(dataURL, filename){
    	var parts = dataURL.split(';base64,');
		var contentType = parts[0].split(":")[1];
		var raw = window.atob(parts[1]);
		var rawLength = raw.length;
		var uInt8Array = new Uint8Array(rawLength);
		for (var i = 0; i < rawLength; ++i) {
        	uInt8Array[i] = raw.charCodeAt(i);
  		}
  		return new File([uInt8Array],filename, { type: contentType });
    }
    
    //发送AJAX请求
	var sendAjax = function () {
	     
	    var url = window.ajaxFormUrl+'/gatewayApp/ws/doctor/updateDoctorInfo';
	     
	    $.ajax({
	        url: url,
	        type: 'POST',
	        data: formData,
	        async: false,
	        cache: false,
	        contentType: false,
	        // contentEncoding: 'charset=utf-8',
	        processData: false,
	        success: function(res) {
	        	if(JSON.parse(res).result == '0'){
	        		appcan.window.openToast("更新成功", 2000, 5, 0);
	        	}else{
			        appcan.window.alert({
			            title : "提示",
			            content : "提交失败，"+res.message,
			            buttons : '确定'
			        });
	        	}
	        },
	        error: function(e, err) {
		    	appcan.window.alert({
		            title : "提示",
		            content : "提交失败，请联系管理员",
		            buttons : '确定',
		            callback : function(err, data, dataType, optId) {
		
		            }
		        });
	        }
	    });
	}
    
    
    return {
        init: init,
        loadAutoSealUrl: loadAutoSealUrl,
        clearClick: clearClick,
        submitSaveClick: submitSaveClick
    }
}();


appcan.ready(function() {
    physicianSignatureContentJs.init();
});