if(!window.institutionInfoJs){
	window.institutionInfoJs = {}
}
var institutionInfoJs = function() {
	
	var mechanismModel = new MechanismModel();
    var mechanismInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#mechanismInfoView",
        model: mechanismModel
    }));

    var init = function() {
    	
    }
    
    //机构类别点击事件
    var mechanismTypeClick = function(){
    	var _self = this;
        var layer = 1;
        if (_self.picker) {
            _self.picker.show(function(items) {
                mechanismModel.set("mechanismType", items[layer - 1].text);
            });
        } else {
            _self.picker = new Neusoft.PopPicker({
                layer: layer
            });
            _self.picker.setData(window.codeList.mechanismType);
            _self.picker.show(function(items) {
                mechanismModel.set("mechanismType", items[layer - 1].text);
                _self.picker.dispose();
                _self.picker = null;
            });
        }
    }
    
    //执照有效期点击事件
    var businessLicenseTimeClick = function() {
    	var _self = this;
        if(_self.picker) {
            _self.picker.show(function (rs) {
            	mechanismModel.set("businessLicenseTime", rs.text);
            });
        } else {
            var options = {"type":"date", "beginYear": 1901};
            /*
             * 首次显示时实例化组件
             * 示例为了简洁，将 options 放在了按钮的 dom 上
             * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
             */
            _self.picker = new Neusoft.DtPicker(options);
            _self.picker.show(function(rs) {
                /*
                 * rs.value 拼合后的 value
                 * rs.text 拼合后的 text
                 * rs.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
                 * rs.m 月，用法同年
                 * rs.d 日，用法同年
                 * rs.h 时，用法同年
                 * rs.i 分（minutes 的第二个字母），用法同年
                 */
                mechanismModel.set("businessLicenseTime", rs.text);
                /* 
                 * 返回 false 可以阻止选择框的关闭
                 * return false;
                 */
                /*
                 * 释放组件资源，释放后将将不能再操作组件
                 * 通常情况下，不需要示放组件，new DtPicker(options) 后，可以一直使用。
                 * 当前示例，因为内容较多，如不进行资原释放，在某些设备上会较慢。
                 * 所以每次用完便立即调用 dispose 进行释放，下次用时再创建新实例。
                 */
                _self.picker.dispose();
                _self.picker = null;
            });
        }
    }
    
    //下一步点击事件
    var nextClick5 = function(){
		appcan.window.open({
			name : "jigouInfo",
			dataType : 0,
			aniId : 2,
			data : "jigou_info_head.html"
		});
    }
    
    return {
        init: init,
        mechanismTypeClick: mechanismTypeClick,
        businessLicenseTimeClick: businessLicenseTimeClick,
        nextClick5:nextClick5
    }
}();


appcan.ready(function() {
    institutionInfoJs.init();
});