if(!window.pharmacistRegInfoJs){
	window.pharmacistRegInfoJs = {}
}
var pharmacistRegInfoJs = function() {
	
	var loginUser = JSON.parse(appcan.locStorage.getVal("loginUser"));
	var formData = new FormData();
	var fileList = null;
	
	var apothecaryInfoModel = new ApothecaryInfoModel();
    var apothecaryInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#apothecaryInfoView",
        model: apothecaryInfoModel
    }));
    
    // $('#mechanismName').keyup(function(event) {
        // if(13 == event.keyCode) {
            // mechanismNameClick();
        // }
    // })
    $('input[id="mechanismName"]').bind("input propertychange",function(){
		mechanismNameClick();
	});
    
    //类别-默认药师
    var docType = 'yaoshi';
    //头像是否上传标识
    var headPictureFlag = false;
    var headPicture = null;

    var init = function() {
    	apothecaryInfoModel.set("headPicture", window.doctorPhoto.manDefaultUrl);
	    apothecaryInfoModel.set("apothecaryTypeCode", 'YS');
	    apothecaryInfoModel.set("apothecaryTypeName", '药师');
	    
	    if(loginUser.headPicture != null && loginUser.headPicture != ""){
    		apothecaryInfoModel.set("headPicture", loginUser.headPicture);
    	}else{
    		if(apothecaryInfoModel.get("sex") == 'MAN'){
    			apothecaryInfoModel.set("headPicture", window.doctorPhoto.manDefaultUrl);
    		}else if(apothecaryInfoModel.get("sex") == 'WOMAN'){
    			apothecaryInfoModel.set("headPicture", window.doctorPhoto.womanDefaultUrl);
    		}else{
    			apothecaryInfoModel.set("headPicture", window.doctorPhoto.manDefaultUrl);
    		}
    	}
    }
    
    //单位搜索点击事件
    var mechanismNameClick = function() {
    	var url = window.ServerURL + "/getTMechanismInfo"; 
    	var data = {};
    	data.pageIndex = 1;
    	data.pageSize = 10;
    	data.mechanismName = $("#mechanismName").val();
    	data.mechanismType = 'YF';
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, mechanismNameSuccess, mechanismNameFail);
    }
    
    //单位搜索成功回调
    var mechanismNameSuccess = function(res) {
    	if(res.length > 0){
    		$("#mechanism_name_div").attr("style"," display: block!important;");
    	}
	    var html = '';
        $.each(res, function(commentIndex, comment){
            html += '<li class="hint-li" mechanismId="'+comment.id+'" mechanismCode="'+comment.mechanismCode+'" mechanismName="'+comment.mechanismName+'" onclick="pharmacistRegInfoJs.mechanismSelectClick($(this))">' +
	                	comment.mechanismName +
	                '</li>';
        });
		$('#mechanism_name_select').html(html);
    }
    
    //单位搜索失败回调
    var mechanismNameFail = function(e, err) {
	    appcan.window.alert({
            title : "提示",
            content : "查询失败，请联系管理员",
            buttons : '确定',
            callback : function(err, data, dataType, optId) {

            }
        });
    }
    
    //单位选择事件
    var mechanismSelectClick = function(obj) {
    	var mechanismId = $(obj).attr("mechanismId");
    	var mechanismName = $(obj).attr("mechanismName");
    	var mechanismCode = $(obj).attr("mechanismCode");
    	apothecaryInfoModel.set("mechanismId", mechanismId);
    	apothecaryInfoModel.set("mechanismName", mechanismName);
    	apothecaryInfoModel.set("mechanismCode", mechanismCode);
    	$("#mechanism_name_div").attr("style"," display: none!important;");
    }
    
    //性别点击事件
    var sexClick = function() {
        var _self = this;
        var layer = 1;
        if (_self.sex) {
            _self.sex.show(function(items) {
                apothecaryInfoModel.set("sex", items[layer - 1].value);
                setHeadPic();
            });
        } else {
            _self.sex = new Neusoft.PopPicker({
                layer: layer
            });
            _self.sex.setData(window.codeList.genderType);
            _self.sex.show(function(items) {
                apothecaryInfoModel.set("sex", items[layer - 1].value);
                setHeadPic();
                // _self.sex.dispose();
                // _self.sex = null;
            });
        }
    }
    //根绝性别设置默认头像
    var setHeadPic = function(){
    	if(headPictureFlag == false && apothecaryInfoModel.get("sex") == 'MAN'){
        	apothecaryInfoModel.set("headPicture", window.doctorPhoto.manDefaultUrl);
        }else if(headPictureFlag == false && apothecaryInfoModel.get("sex") == 'WOMAN'){
        	apothecaryInfoModel.set("headPicture", window.doctorPhoto.womanDefaultUrl);
        }
    }
    
    //加载省市区事件
    var cityClick = function() {
		 // params = {
             // x:0,
             // y:"",
             // width:window.screen.width,
             // height:900,
             // src:"res://city.json",
             // select:[17,9,0]
          // };
          // uexWheelPickView.open(JSON.stringify(params));
        var _self = this;
        var layer = 3
        if (!!_self.city) {
            _self.city.show(function(items) {
            	apothecaryInfoModel.set("regionId", items.id);
            	apothecaryInfoModel.set("regionCode", items.regionCode);
            	apothecaryInfoModel.set("regionDesc", items.fullName);
            });
        } else {
            _self.city = new Neusoft.DistrictPicker({
                layer: layer
            });
            _self.city.show(function(items) {
            	apothecaryInfoModel.set("regionId", items.id);
            	apothecaryInfoModel.set("regionCode", items.regionCode);
            	apothecaryInfoModel.set("regionDesc", items.fullName);
            	// _self.city.dispose();
                // _self.city = null;
            }, {regionCode: ""});
        }
    }
    
    //类别-药师点击事件
    var type1Click = function() {
    	docType = 'yaoshi';
    	$("#type2").addClass("check-border");
    	$("#type2").removeClass("check-full");
    	$("#type2").html("");
    	$("#type1").addClass("check-full");
    	$("#type1").html('<div class="check-circle-o-size-2x check-white"></div>');
    	apothecaryInfoModel.set("apothecaryTypeCode", 'YS');
    	apothecaryInfoModel.set("apothecaryTypeName", '药师');
    }
    
    //药师-调剂师点击事件
    var type2Click = function() {
    	docType = 'tiaoji';
    	$("#type1").addClass("check-border");
    	$("#type1").removeClass("check-full");
    	$("#type1").html("");
    	$("#type2").addClass("check-full");
    	$("#type2").html('<div class="check-circle-o-size-2x check-white"></div>');
    	apothecaryInfoModel.set("apothecaryTypeCode", 'TJS');
    	apothecaryInfoModel.set("apothecaryTypeName", '调剂师');
    }
    
    //下一步
    var nextClick4 = function(){
    	//非空校验
    	if(apothecaryInfoModel.get("apothecaryName") == null || apothecaryInfoModel.get("apothecaryName") == ""){
			appcan.window.alert({
	            title : "提示",
	            content : "姓名不能为空",
	            buttons : '确定'
	        });
	        return;
    	}
    	if(apothecaryInfoModel.get("sex") == null || apothecaryInfoModel.get("sex") == ""){
			appcan.window.alert({
	            title : "提示",
	            content : "性别不能为空",
	            buttons : '确定'
	        });
	        return;
    	}
    	if(apothecaryInfoModel.get("cardId") == null || apothecaryInfoModel.get("cardId") == ""){
			appcan.window.alert({
	            title : "提示",
	            content : "身份证不能为空",
	            buttons : '确定'
	        });
	        return;
    	}
    	if(apothecaryInfoModel.get("businessLicense") == null || apothecaryInfoModel.get("businessLicense") == ""){
			appcan.window.alert({
	            title : "提示",
	            content : "职业证不能为空",
	            buttons : '确定'
	        });
	        return;
    	}
    	if(apothecaryInfoModel.get("mechanismId") == null || apothecaryInfoModel.get("mechanismId") == ""){
			appcan.window.alert({
	            title : "提示",
	            content : "单位不能为空",
	            buttons : '确定'
	        });
	        return;
    	}
    	appcan.locStorage.setVal('apothecaryInfo', apothecaryInfoModel);
    	submitSaveClick();
    }
    
    //提交认证
    var submitSaveClick = function(){
    	// formData.append('id','8a84faca662d697f01662d7bd7a00001');
    	formData.append('id',loginUser.id);
    	//头像
    	if(fileList != null){
    		formData.append('headPicture',fileList[0]);
    	}else{
    		formData.append('headPicture',headPicture);
    	}
    	//姓名
    	formData.append('apothecaryName',encodeURIComponent(apothecaryInfoModel.get("apothecaryName")));
    	//性别
    	formData.append('sex',apothecaryInfoModel.get("sex"));
    	//身份证
    	formData.append('cardId',apothecaryInfoModel.get("cardId"));
    	//执业证
    	formData.append('businessLicense',apothecaryInfoModel.get("businessLicense"));
    	//单位
    	formData.append('mechanismId',apothecaryInfoModel.get("mechanismId"));
    	formData.append('mechanismName',encodeURIComponent(apothecaryInfoModel.get("mechanismName")));
    	formData.append('mechanismCode',apothecaryInfoModel.get("mechanismCode"));
    	//类别
    	formData.append('apothecaryTypeCode',apothecaryInfoModel.get("apothecaryTypeCode"));
    	formData.append('apothecaryTypeName',encodeURIComponent(apothecaryInfoModel.get("apothecaryTypeName")));
    	//地区
    	formData.append('regionId',apothecaryInfoModel.get("regionId"));
    	formData.append('regionCode',apothecaryInfoModel.get("regionCode"));
    	formData.append('regionDesc',encodeURIComponent(apothecaryInfoModel.get("regionDesc")));
    	sendAjax();
    }
    
    //发送AJAX请求
	var sendAjax = function () {
	    var url = window.ajaxFormUrl+'/gatewayApp/ws/apothecary/updateApothecaryInfo';
	    $.ajax({
	        url: url,
	        type: 'POST',
	        data: formData,
	        async: false,
	        cache: false,
	        contentType: false,
	        processData: false,
	        success: function(res) {
	        	if(JSON.parse(res).result == '0'){
				    appcan.window.open({
						name : "youshiInfo",
						dataType : 0,
						aniId : 2,
						data : "youshi_info_up_head.html"
					});
	        	}else{
			        appcan.window.alert({
			            title : "提示",
			            content : "提交失败，"+res.message,
			            buttons : '确定'
			        });
	        	}
	        },
	        error: function(e, err) {
		    	appcan.window.alert({
		            title : "提示",
		            content : "提交失败，请联系管理员",
		            buttons : '确定',
		            callback : function(err, data, dataType, optId) {
		
		            }
		        });
	        }
	    });
	}
    
    //上传头像
    var imgChange = function(obj1, obj2){
    	headPictureFlag = true;
	    //获取点击的文本框
		var file = document.getElementById("fileImage");
		//获取的图片文件
		fileList = file.files;
		apothecaryInfoModel.set("headPicture", window.URL.createObjectURL(file.files[0]));
    }
    
    //相机点击事件
    var photoClick = function(){
    	$("#modeLayer1").show();
    }
    
    //拍照
    var photographClick = function(){
    	$("#modeLayer1").hide();
    	uexCamera.open(0,100);
		uexCamera.cbOpen = function(opCode, dataType, data){
			uploadFileService(data);
		}
    }
    
    //相册选择
    var selectphotoClick = function(){
    	$("#modeLayer1").hide();
    	// uexImage.openPicker(JSON.stringify({"min": 1, "max":1}),function(error,info){
    		// if(error == -1){
				// alert("cancelled!");
			// }else if(error == 0){
				// var imageInfo = JSON.parse(info);
				// uploadFileService(imageInfo.data[0]);
			// }else{
				// alert("error");
			// }
   		// });
   		uexImage.openPicker(JSON.stringify({"min": 1, "max":1}));
   		uexImage.onPickerClosed = function (info){
   			var imageInfo = JSON.parse(info);
   			uploadFileService(imageInfo.data[0]);
   		}
    }
    
    //上传服务器
    var uploadFileService = function(urlString){
		var uploader = uexUploaderMgr.create({
			      url: window.uploadHttp,
			      type: 1
			});
		if(!!!uploader){
		    alert("创建失败!");
		    return;
		}
		var headJson = {
			// "id": "1",
			"id": loginUser.id,
			"pictureName": "headPicture",
			"pictureType": "apothecary", 
			"patientCode": "adidlslsidkdks"
		};
		var ret = uexUploaderMgr.setHeaders(uploader, JSON.stringify(headJson)); 
		uexUploaderMgr.uploadFile(uploader, urlString, "headPicture", 1, 640,function(packageSize, percent, responseString, status){
		    switch (status) {
		    case 0:
		        document.getElementById('percentage').innerHTML = "上传包大小:"+packageSize+"<br>上传进度:"+percent+"%";
		        break;
		    case 1:
		        appcan.window.openToast("上传成功", 2000, 5, 0);
		        headPicture = responseString;
		        apothecaryInfoModel.set("headPicture", responseString + "?temp=" + Math.random());
		        break;
		    case 2:
		        alert("上传失败");
		        break;
		    }
		});
    }
    
    //取消
    var cancelClick = function(){
    	$("#modeLayer1").hide();
    }
    
    return {
        init: init,
        sexClick: sexClick,
        cityClick: cityClick,
        type1Click: type1Click,
        type2Click: type2Click,
        mechanismSelectClick: mechanismSelectClick,
        nextClick4: nextClick4,
        imgChange: imgChange,
        photoClick: photoClick,
        photographClick: photographClick,
        selectphotoClick: selectphotoClick,
        cancelClick: cancelClick
    }
}();


appcan.ready(function() {
    pharmacistRegInfoJs.init();
});