if(!window.assayOrgAppointmentContent){
    window.assayOrgAppointmentContent = {};
}

var assayOrgAppointmentContent = function() {
    var pageCount = 0, inParam, checkCount = 0, forwardType = ["HY", "JC"];
    
    var forwardInfoModel = new ForwardInfoModel();
    var forwardInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".forwardInfos",
        model: forwardInfoModel
    }))();
    
    var assayItemInfoViewModel = {};
    
    var getForwardInfo = function(){
        var param = _.clone(window.pagingParam);
        param.id = inParam.forwardId;
        commonService.request(param, {
            url: window.ServerURL + "/getTForwardDetailInfo",
            success: function(res) {
                forwardInfoViewModel.model.set(res.tForwardInfo);
                if (res.tForwardInfo.forwardType === forwardType[0]){
                    //化验项目
                    assayItemInfoViewModel.collection.set(res.tAssayItemInfoList);
                } else if (res.tForwardInfo.forwardType === forwardType[1]){
                    //检查项目
                    assayItemInfoViewModel.collection.set(res.tInspectionInfoList);
                }
            }
        });
    }
    
    $("#selectAppointmentDate").on("click", function() {
        var _self = this;
        var hArray = [];
        for (var i = 8; i < 19; i++) {
           hArray.push({
                text: i > 9 ? i : "0" + i,
                value: i > 9 ? i : "0" + i
            });
        }
        if(_self.picker) {
            _self.picker.show(function (rs) {
                var appointmentDate = new Date(rs.text + ":00");
                var endTime = new Date(appointmentDate.getTime() + 3600000);
                forwardInfoModel.set("forwardTime", rs.text + ":00" + "--" + commonJs.timeToString(endTime).substring(0, 5));
                //$("#selectAppointmentDate").find("[data-bind='text:appointmentDate']").text();
            });
        } else {
            var date = new Date();
            var options = {"type":"hour", "beginYear": date.getFullYear(), "beginMonth": date.getMonth() + 1,
                "beginDay": date.getHours() > 18 ? date.getDate() + 1 : date.getDate(), "beginHours": date.getHours() > 18 ? 8 : date.getHours()};
            options.customData = {};
            options.customData.h = hArray;
            _self.picker = new Neusoft.DtPicker(options);
            _self.picker.show(function(rs) {
                var appointmentDate = new Date(rs.text + ":00");
                var endTime = new Date(appointmentDate.getTime() + 3600000);
                forwardInfoModel.set("forwardTime", rs.text + ":00" + "--" + commonJs.timeToString(endTime).substring(0, 5));
                //$("#selectAppointmentDate").find("[data-bind='text:appointmentDate']").text(rs.text + ":00" + "--" + commonJs.timeToString(endTime).substring(0, 5));
                _self.picker.dispose();
                _self.picker = null;
            });
        }
    });
    
    appcan.button("#btnOk", "btn-act", function() {
        var forwardInfo = {
            "id": forwardInfoModel.get("id"),
            "status":"YYY",
            "forwardTime": forwardInfoModel.get("forwardTime"),
            "forwardExplain": forwardInfoModel.get("forwardExplain")
        };
        commonService.request(forwardInfo, {
            url: window.ServerURL + "/updateTForwardInfo",
            success: function(res) {
                if (res.result === "0") {
                    $(".btn-line").addClass("field-nodisplay");
                    appcan.window.evaluatePopoverScript("assayBillListPage", "assayBillListContentPage", "assayBillListContent.backload()");
                    appcan.window.openToast("预约成功！", 2000, 50, 0);
                    uexWindow.evaluateScript("", "0", "closeWindow()");                       
                } else {
                    appcan.window.openToast("预约失败！", 2000, 50, 0);
                    return;
                }                  
            }
        });     
    });
    
    //退费  by sushu 2019-05-29
    appcan.button("#btnRefundFee", "btn-act", function() {
        var param = {};
	    param.id = forwardInfoModel.get("taskPayId");
	    commonService.request(param, {
	        url: window.ServerURL + "/updateReturnPayXf",
	        success: function(res) {
	        	if(res.result == "0"){
	        		appcan.window.openToast("退费成功", 2000, 5, 0);
	        		appcan.window.evaluatePopoverScript("assayBillListPage", "assayBillListContentPage", "assayBillListContent.backload()");
	        		uexWindow.evaluateScript("", "0", "closeWindow()");
	        	}else{
	        		appcan.window.openToast(res.message, 2000, 5, 0);
	        	}
	        }
	    });
    });
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        if (inParam.forwardType === forwardType[0]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new AssayItemInfoCollection()
            }))();
        } else if (inParam.forwardType === forwardType[1]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new InspectionInfoCollection()
            }))();
        }
        getForwardInfo();
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    assayOrgAppointmentContent.init();
});
