if(!window.assayOrgReportContent){
    window.assayOrgReportContent = {};
}

var assayOrgReportContent = function() {
    var pageCount = 0, inParam, checkCount = 0, assayReportSlider = {}, forwardType = ["HY", "JC"];
    
    var forwardInfoModel = new ForwardInfoModel();
    var forwardInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".forwardInfos",
        model: forwardInfoModel
    }))();
    
    var assayItemInfoViewModel = {};
    
    var getForwardInfo = function(){
        var param = _.clone(window.pagingParam);
        param.id = inParam.forwardId;
        commonService.request(param, {
            url: window.ServerURL + "/getTForwardDetailInfo",
            success: function(res) {
                forwardInfoViewModel.model.set(res.tForwardInfo);
                if (res.tForwardInfo.forwardType === forwardType[0]){
                    //化验项目
                    assayItemInfoViewModel.collection.set(res.tAssayItemInfoList);
                } else if (res.tForwardInfo.forwardType === forwardType[1]){
                    //检查项目
                    assayItemInfoViewModel.collection.set(res.tInspectionInfoList);
                }
                setReportSliderData(res.tInsassReportList);
            }
        });
    }
    
    appcan.button("#btnOk", "btn-act", function() {
        if (!!!assayReportSlider.option.itemCount || assayReportSlider.option.itemCount == 0) {
            appcan.window.openToast("未上传检验报告！", 2000, 50, 0);
            return;
        }
        var forwardInfo = {
            "id": forwardInfoModel.get("id"),
            "status":"YWC"
        };
        commonService.request(forwardInfo, {
            url: window.ServerURL + "/updateTForwardInfo",
            success: function(res) {
                if (res.result === "0") {
                    $(".btn-line").addClass("field-nodisplay");
                    appcan.window.evaluatePopoverScript("assayBillListPage", "assayBillListContentPage", "assayBillListContent.backload()");
                    appcan.window.openToast("检验已完成！", 2000, 50, 0);
                    uexWindow.evaluateScript("", "0", "closeWindow()");                       
                } else {
                    appcan.window.openToast("更新状态失败！", 2000, 50, 0);
                    return;
                }
            }
        });     
    });
    
    var setReportSliderData = function(data) {
        if (!!!data) return;
        var assayReportList = [];
        for (var i = 0; i < data.length; i++) {
            var assayReport = {};
            assayReport.img = window.PicURL + data[i].reportPictureUrl;
            assayReport.label = data[i].reportRemark; //描述
            assayReport.rowData = data[i];
            assayReportList.push(assayReport);
        }
        assayReportSlider.set(assayReportList);
        
        $("#assayReportSlider").find(".utra.focus.bc-head").css("background-color", "#24bad6");
        //$("#assayReportSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("background-color", "rgba(0,0,0, 0)");
        $("#assayReportSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("background-color", "#e0e0e0");
        $("#assayReportSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("color", "#000000");
    }
    
    var initAssayReportSlider = function() {
        //化验报告图片轮播
        assayReportSlider = appcan.slider({
            selector : '#assayReportSlider',
            aspectRatio: 320/1000,
            hasLabel: true,
            index: 0,
            auto: 10000
        });
        
        assayReportSlider.on("clickItem", function(index, data){
            console.log(index, data);
            var outParam = "forwardId=" + inParam.forwardId;
            commonJs.openWindow("assayReportViewPage", "../../components/assay_report_view.html?" + outParam);
        });
    }
     
    //拍照上传检验报告
    appcan.button("#uploadReport", "btn-act", function() {
        // if(!!!$("#reportName").find("input").val()) {
            // appcan.window.openToast("请输入检验报告说明！", 2000, 50, 0);
            // return;
        // }
        uexCamera.open(0,100);
        uexCamera.cbOpen = function(opCode, dataType, data){
            uploadFileService(data);
        }
    });
    
    //上传服务器
    var uploadFileService = function(urlString){
        var uploader = uexUploaderMgr.create({
            url: window.uploadHttp,
            type: 1
        });
        if(!!!uploader){
            return;
        }
        var headJson = {
            "id": forwardInfoModel.get("id"),
            "pictureName": "report",
            "pictureType": "forward", 
            "reportRemark": encodeURIComponent($("#reportName").find("input").val())
        };
        var ret = uexUploaderMgr.setHeaders(uploader, JSON.stringify(headJson)); 
        uexUploaderMgr.uploadFile(uploader, urlString, "headPicture", 1, 640,
            function(packageSize, percent, responseString, status){
                switch (status) {
                case 0:
                    document.getElementById('percentage').innerHTML = "上传包大小:"+packageSize+"<br>上传进度:"+percent+"%";
                    break;
                case 1:
                    appcan.window.openToast("上传成功", 2000, 5, 0);
                    $("#reportName").find("input").val("");
                    //重新加载数据
                    getForwardInfo();
                    break;
                case 2:
                    alert("上传失败");
                    break;
                }
        });
    }
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        if (inParam.forwardType === forwardType[0]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new AssayItemInfoCollection()
            }))();
        } else if (inParam.forwardType === forwardType[1]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new InspectionInfoCollection()
            }))();
        }
        initAssayReportSlider();
        getForwardInfo();
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    assayOrgReportContent.init();
});
