if(!window.orgIndexHomeContent){
    window.orgIndexHomeContent = {};
}

var orgIndexHomeContent = function() {
    var pageCount = 0;
    var pageParam;
    pageParam = _.clone(window.pagingParam);
    
    mechanismTable.appointmentCount = 0;
    mechanismTable.accomplishCount = 0;
    mechanismTable.reportCount = 0;
    var mechanismInfoModel = new MechanismModel();
    var mechanismInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".mechanismInfo",
        model: mechanismInfoModel
    }));
    
    var getMechanismWaitCount = function() {
        commonService.request({"tastMechanismId": mechanismInfoModel.get("id")}, {
            url: window.ServerURL + "/getTMechanismWaitCount",
            success: function(res) {
                //预约
                if (res.waitYY > 0) {
                    $("[data-bind='text:appointmentCount']").parent().removeClass("field-nodisplay");
                    mechanismInfoModel.set("appointmentCount", res.waitYY);
                }
                //完成
                if (res.waitWC > 0) {
                    $("[data-bind='text:accomplishCount']").parent().removeClass("field-nodisplay");
                    mechanismInfoModel.set("accomplishCount", res.waitWC);
                }
                //上传报告
                if (res.waitSCBG > 0) {
                    $("[data-bind='text:reportCount']").parent().removeClass("field-nodisplay");
                    mechanismInfoModel.set("reportCount", res.waitSCBG);
                }
            }
        });
    }
    
    //预约
    appcan.button("#btnReservation", "btn-act", function() {
        var outParam = "status=YJF&funType=Reservation";
        commonJs.openWindow("assayBillListPage", "assay/assay_bill_list.html?" + outParam);
    });
    
    //完成
    appcan.button("#btnAccomplish", "btn-act", function() {
        var outParam = "status=YYY&funType=Accomplish";
        commonJs.openWindow("assayBillListPage", "assay/assay_bill_list.html?" + outParam);
    });
    
    //报告
    appcan.button("#btnReport", "btn-act", function() {
        var outParam = "status=YJY&funType=Report";
        commonJs.openWindow("assayBillListPage", "assay/assay_bill_list.html?" + outParam);
    });
    
    //预约服务
    appcan.button(".reservation", "btn-act", function() {
        var outParam = "forwardType=JC";
        commonJs.openWindow("assayBillListPage", "assay/assay_bill_list.html?" + outParam);
    });
    
    //化验检测
    appcan.button(".assay", "btn-act", function() {
        var outParam = "forwardType=HY";
        commonJs.openWindow("assayBillListPage", "assay/assay_bill_list.html?" + outParam);
    });
    
    //上门服务  by sushu 2019-03-07
    appcan.button(".visitingService", "btn-act", function() {
    	var outParam = "sourceType="+"SMFW" + "&forwardType="+"Home";
        commonJs.openWindow("orgServiceListPage", "../patient/roomService/org_service_list.html?"+outParam);
    });
    
    //远程医疗  by sushu 2019-03-19
    appcan.button(".telemedicine", "btn-act", function() {
    	var outParam = "sourceType="+"YCYL" + "&forwardType="+"Home";
        commonJs.openWindow("orgServiceListPage", "../patient/roomService/org_service_list.html?"+outParam);
    });
    
    var _initModel = function() {
        mechanismInfoModel.clearData();
        mechanismInfoModel.set(commonJs.getOrganization());
        getMechanismWaitCount();
    }
        
    var init = function() {
        _initModel();
        //apothecaryInfoModel.set(commonJs.getApothecary("YS"));
        //pageParam.tRecipeInfo.apothecaryId = apothecaryInfoModel.get("id");
        //appcan.window.subscribe("auditPharmacistIndexHomeSearchRecipeInfo", searchRecipeInfo);
        
        //设置弹动事件
        //commonJs.listWindowBounce(loadPrescriptionList);
        //ViewModel.collection.fetch({selfViewModel: ViewModel, param: pageParam});


    }
    
    return {
        init: init,
        initModel: _initModel,
        getMechanismWaitCount: getMechanismWaitCount
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    orgIndexHomeContent.init();
});








