if(!window.myAddressEditContentJs){
	window.myAddressEditContentJs = {}
}
var myAddressEditContentJs = function() {
	
	var patientAddressModel = new PatientAddressModel();
    var patientAddressViewModel = new (MVVM.ViewModel.extend({
        el: "#patientAddressInfoView",
        model: patientAddressModel
    }));

	var id, patientInfo;
	
    var init = function() {
    	patientInfo = commonJs.getPatient();
    	var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        if(inParam!=null&&typeof(inParam)!='undefined'){
            id = inParam.id;
        }
        if(id === null || id === ""){
        	patientAddressModel.set("isDefault", "N");
        }else{
        	//获取信息
        	getPatientAddressInfo();
        }
    }
    
    //获取信息
    var getPatientAddressInfo = function(){
    	var dataParam = {};
    	dataParam.id = id;
    	dataParam.patientId = patientInfo.id;
    	commonService.request(dataParam, {
            url: window.ServerURL + "/getTPatientAddress",
            success: function(res) {
            	patientAddressModel.set(res[0]);
            	var obj=$(".switch");
            	if(res[0].isDefault == "N"){
            		obj.removeClass("bc-head");
            		obj.attr("data-checked","false");
            	}else{
            		obj.addClass("bc-head");
            		obj.attr("data-checked","true");
            	}
            }
        });
    }
    
    //Switch开关组件
	appcan.switchBtn(".switch", function(obj, value) {
   		if(value === true){
   			patientAddressModel.set("isDefault", "Y");
   		}else{
   			patientAddressModel.set("isDefault", "N");
   		}
	})
	
	//加载省市区事件
    var cityClick = function() {
        var _self = this;
        var layer = 3
        if (_self.city) {
            _self.city.show(function(items) {
            	patientAddressModel.set("regionId", items.id);
            	patientAddressModel.set("regionCode", items.regionCode);
            	patientAddressModel.set("regionDesc", items.fullName);
            });
        } else {
            _self.city = new Neusoft.DistrictPicker({
                layer: layer
            });
            _self.city.show(function(items) {
            	patientAddressModel.set("regionId", items.id);
            	patientAddressModel.set("regionCode", items.regionCode);
            	patientAddressModel.set("regionDesc", items.fullName);
            }, {regionCode: ""});
        }
    }
    
    //保存
    var saveClick = function() {
    	//校验
    	if(patientAddressModel.get("patientName")==null || patientAddressModel.get("patientName")==""){
    		appcan.window.openToast("姓名不能为空", 2000, 5, 0);
    		return;
    	}
    	if(patientAddressModel.get("patientPhone")==null || patientAddressModel.get("patientPhone")==""){
    		appcan.window.openToast("手机号不能为空", 2000, 5, 0);
    		return;
    	}
    	if(patientAddressModel.get("regionCode")==null || patientAddressModel.get("regionCode")==""){
    		appcan.window.openToast("地区不能为空", 2000, 5, 0);
    		return;
    	}
    	if(patientAddressModel.get("address")==null || patientAddressModel.get("address")==""){
    		appcan.window.openToast("详细地址不能为空", 2000, 5, 0);
    		return;
    	}
    	var url = window.ServerURL + "/updateTPatientAddress"; 
    	var data = {};
    	if(id === null || id === ""){
    		//新增
    		data.extend1 = "A";
    	}else{
    		//修改
    		data.extend1 = "U";
    		data.id = id;
    	}
    	data.patientId = patientInfo.id;
    	data.patientPhone = patientAddressModel.get("patientPhone");
    	data.patientName = patientAddressModel.get("patientName");
    	data.regionId = patientAddressModel.get("regionId");
    	data.regionCode = patientAddressModel.get("regionCode");
    	data.regionDesc = patientAddressModel.get("regionDesc");
    	data.address = patientAddressModel.get("address");
    	data.isDefault = patientAddressModel.get("isDefault");
        var param = JSON.stringify(data);
        commonJs.requestAjax(url, param, function(res) {
       		if(res.result == "0"){
       			//是否设为默认地址
		       	var url = window.ServerURL + "/updateTPatientAddress"; 
		    	var data = {};
		    	data.extend1 = "S";
				data.id = res.id;
				data.patientId = patientInfo.id;
				data.isDefault = patientAddressModel.get("isDefault");
				var param = JSON.stringify(data);
				commonJs.requestAjax(url, param, function(res) {
	       		if(res.result == "0"){
	       			appcan.window.openToast("保存成功！", 2000, 5, 0);
	       			appcan.window.evaluatePopoverScript("myAddressListPage","myAddressListContentPage", "myAddressListContentJs.init()");
	       			uexWindow.evaluateScript("", "0", "closeWindow()");
	       		}else{
		       		appcan.window.alert({
		                title : "提示",
		                content : "接口失败",
		                buttons : '确定',
		                callback : function(err, data, dataType, optId) {
		
		                }
		            });
	       		}
	
		        }, function(e, err) {
		
		            appcan.window.alert({
		                title : "提示",
		                content : "接口失败",
		                buttons : '确定',
		                callback : function(err, data, dataType, optId) {
		
		                }
		            }); 
		
		        });
       		}else{
	       		appcan.window.alert({
	                title : "提示",
	                content : "接口失败",
	                buttons : '确定',
	                callback : function(err, data, dataType, optId) {
	
	                }
	            });
       		}

        }, function(e, err) {

            appcan.window.alert({
                title : "提示",
                content : "接口失败",
                buttons : '确定',
                callback : function(err, data, dataType, optId) {

                }
            }); 

        });
    };
    
    //删除
    var deleteClick = function(){
		var url = window.ServerURL + "/updateTPatientAddress"; 
		var data = {};
		data.extend1 = "D";
		data.id = id;
		var param = JSON.stringify(data);
		commonJs.requestAjax(url, param, function(res) {
		if(res.result == "0"){
			appcan.window.openToast("删除成功！", 2000, 5, 0);
			appcan.window.evaluatePopoverScript("myAddressListPage","myAddressListContentPage", "myAddressListContentJs.init()");
			uexWindow.evaluateScript("", "0", "closeWindow()");
		}else{
	   		appcan.window.alert({
	            title : "提示",
	            content : "接口失败",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
		}
	
	    }, function(e, err) {
	
	        appcan.window.alert({
	            title : "提示",
	            content : "接口失败",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        }); 
	
	    });
    }
    
    return {
        init: init,
        cityClick: cityClick,
        saveClick: saveClick,
        deleteClick: deleteClick
    }
}();


appcan.ready(function() {
    myAddressEditContentJs.init();
});