if(!window.assayBillEvaluateContent){
    window.assayBillEvaluateContent = {};
}

var assayBillEvaluateContent = function() {
    var pageCount = 0, inParam, patientInfo = {}, checkCount = 0, evaluateType = "YYFW";
    
    var forwardInfoModel = new ForwardInfoModel();
    var forwardInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".forwardInfos",
        model: forwardInfoModel
    }))();
    
    evaluateitemsTable.score = 0;
    var evaluateItemsViewModel = new (MVVM.ViewModel.extend({
        el: "#showEvaluateItemsView",
        collection: new EvaluateItemsCollection()
    }));
    
    var getForwardInfo = function(){
        var param = _.clone(window.pagingParam);
        param.id = inParam.forwardId;
        commonService.request(param, {
            url: window.ServerURL + "/getTForwardDetailInfo",
            success: function(res) {
                // commonService.request({"id": res.tForwardInfo.tastDoctorId}, {
                    // url: window.ServerURL + "/getDoctor",
                    // success: function(doctorRes) {
                        // forwardInfoViewModel.model.set("tastDoctorPic", doctorRes[0].headPicture);
                    // }
                // });
                forwardInfoViewModel.model.set(res.tForwardInfo);
            }
        });
    }
    
    var getEvaluateItems = function() {
        var param = {"itemType": evaluateType};
        commonService.request(param, {
            url: window.ServerURL + "/getTEvaluateItems",
            success: function(res) {
                evaluateItemsViewModel.collection.set(res);
            }
        });
    }
    
    appcan.button(".syntheticalEvaluate", "but-act", function() {
        var score = $(event.srcElement).attr("data-index");
        forwardInfoModel.set("evaluateScore", Number(score));
        // for (var i = 0; i < $(event.currentTarget).children().length; i++) {
            // var children = $(event.currentTarget).children()[i];
            // $(children).toggleClass("choice", score >= $(children).attr("data-index"));
            // $(children).toggleClass("nochoice", !(score >= $(children).attr("data-index")));
        // }
    });
    
    //设置评价标签状态，点亮星星    
    var setEvaluateTags = function() {
        var itemId = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var itemModel = evaluateItemsViewModel.collection.where({id: itemId});
        var score = $(event.currentTarget).attr("data-index");
        itemModel[0].set("score", Number(score));
    }
    
    //更新评价信息
    var addEvaluate = function() {
        if (!!!forwardInfoModel.get("evaluateScore") || forwardInfoModel.get("evaluateScore") === 0) {
            appcan.window.openToast("綜合评价未评价", 2000, 50, 0);
            return;
        }
        //生成更新数据集
        var evaluateInfo = {
            "orderType": evaluateType,
            "orderId": forwardInfoModel.get("id"),
            "orderNumber": forwardInfoModel.get("forwardCode"),
            "evaluateOpinion": "",
            "scoreSum": forwardInfoModel.get("evaluateScore"),
            "tEvaluateVO": []
        }
        for(var i = 0; i < evaluateItemsViewModel.collection.length; i++) {
            var item = {
                "itemId": evaluateItemsViewModel.collection.models[i].get("id"),
                "itemType": evaluateType,
                "itemCode": evaluateItemsViewModel.collection.models[i].get("itemCode"),
                "itemName": evaluateItemsViewModel.collection.models[i].get("itemName"),
                "score": evaluateItemsViewModel.collection.models[i].get("score")
            }
            evaluateInfo.tEvaluateVO.push(item);
        }
        commonService.request(evaluateInfo, {
            url: window.ServerURL + "/addtTEvaluateXf",
            success: function(res) {
                if (res.result === "0") {
                    appcan.window.openToast("化验单评价成功", 2000, 50, 0);
                    if(!!inParam.pageName){
                    	appcan.window.evaluatePopoverScript(inParam.pageName, inParam.pageFrameName, inParam.js + "()");
                    }else{
                    	appcan.window.evaluatePopoverScript("assayBillListPage", "assayBillListContentPage", "assayBillListContent.backload()");
                    }
                    uexWindow.evaluateScript("", "0", "closeWindow()");
                    appcan.window.evaluateScript("assayBillViewPage", "commonJs.closeWindow()");
                } else {
                    appcan.window.alert("", res.message);
                }
            }
        })
    }
    
    appcan.button("#btnOk", "btn-act", function() {
        addEvaluate();
    });
        
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        patientInfo = commonJs.getPatient();
        getForwardInfo();
        //初始评审列表
        getEvaluateItems();
    }
    
    return {
        init: init,
        setEvaluateTags: setEvaluateTags
    }
}();

appcan.ready(function() {
    assayBillEvaluateContent.init();
});
