if(!window.assayOrgSelectContent){
    window.assayOrgSelectContent = {};
}

var assayOrgSelectContent = function() {
    var pageCount = 0, inParam, headerHeight, assayItemData = [], 
        forwardType = ["HY", "JC"];
    
    forwardInfoTable.tastDoctorPic = "";
    var forwardInfoModel = new ForwardInfoModel();
    var forwardInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".forwardInfos",
        model: forwardInfoModel
    }))();
    
    var assayItemInfoViewModel = {};
    
    var getForwardInfo = function(){
        var param = _.clone(window.pagingParam);
        param.id = inParam.forwardId;
        commonService.request(param, {
            url: window.ServerURL + "/getTForwardDetailInfo",
            success: function(res) {
                commonService.request({"id": res.tForwardInfo.tastDoctorId}, {
                    url: window.ServerURL + "/getDoctor",
                    success: function(doctorRes) {
                        forwardInfoViewModel.model.set("tastDoctorPic", doctorRes[0].headPicture);
                    }
                });
                if (!!!res.tForwardInfo.tastWay || res.tForwardInfo.tastWay === "0") {
                    
                } else if (res.tForwardInfo.tastWay === "1"){
                    $(".circle-unselect.nursesVisit").addClass("circle-select");
                    $(".circle-unselect.nursesVisit").removeClass("circle-unselect");
                    $(".circle-select.orgCenter").addClass("circle-unselect");
                    $(".circle-select.orgCenter").removeClass("circle-select");
                }
                res.tForwardInfo.taskSumfee = res.tForwardInfo.sumFee;
                forwardInfoViewModel.model.set(res.tForwardInfo);
                if (res.tForwardInfo.forwardType === forwardType[0]){
                    //化验项目
                    assayItemInfoViewModel.collection.set(res.tAssayItemInfoList);
                } else if (res.tForwardInfo.forwardType === forwardType[1]){
                    //检查项目
                    assayItemInfoViewModel.collection.set(res.tInspectionInfoList);
                }
                
            }
        });
    }
    
    var doSelectMechanism = function(data) {
        if (typeof(data) === "string") {
            data = JSON.stringify(data);
        }
        forwardInfoModel.set("tastMechanismId", data.id);
        forwardInfoModel.set("tastMechanismName", data.mechanismName);
        forwardInfoModel.set("tastMechanismType", data.mechanismType);
    }
    
    appcan.button("#searachBtn", "but-act", function() {
        if (forwardInfoModel.get("status") === "DJF") {
            return;
        }
        switch(this.id) {
            case 'searachBtn':
                var pageParam = "headerHeight=" + headerHeight;
                pageParam += "&pageName=assayOrgSelectPage";
                pageParam += "&pageFrameName=assayOrgSelectContentPage";
                pageParam += "&js=assayOrgSelectContent.doSelectMechanism";
                commonJs.openWindow("assayOrgSearchPage", "assay_org_search.html?" + pageParam);
            default:
                break;
        }
    });
    
    
    var closeWindow = function() {
        $(".btn-line").addClass("field-nodisplay");
        appcan.window.evaluatePopoverScript("assayBillListPage", "assayBillListContentPage", "assayBillListContent.backload()");
        //待缴费列表去缴费  by sushu 2019-04-17
        appcan.window.evaluatePopoverScript("awaitPaymentOrdersListPage", "awaitPaymentOrdersContentPage", "awaitPaymentOrders.refreshLoadData()");
        uexWindow.evaluateScript("", "0", "closeWindow()");
    }
    appcan.button("#btnOk", "but-act", function() {
        switch(this.id) {
            case 'btnOk':
            	//待缴费状态直接去缴费，已开单状态先更新   by sushu 2019-04-17
            	if(forwardInfoModel.get("status") == "DJF"){
			        var pageParam = "headerHeight=" + headerHeight;
                    pageParam += "&id=" + forwardInfoModel.get("taskPayId");
                    pageParam += "&pageName=assayOrgSelectPage";
                    pageParam += "&pageFrameName=assayOrgSelectContentPage";
                    pageParam += "&js=assayOrgSelectContent.closeWindow";
                    appcan.frame.open("content", "../../components/paymentMode.html?" + pageParam, 0, headerHeight, 'paymentModePage');
            	}else{
	            	var forwardInfo = {
	                    "id": forwardInfoModel.get("id"),
	                    "status":"DJF",
	                    "tastMechanismId": forwardInfoModel.get("tastMechanismId"),
	                    "tastWay": String(!!forwardInfoModel.get("tastWay") ? forwardInfoModel.get("tastWay") : "0"),
	                    "taskSumfee": Number(forwardInfoModel.get("taskSumfee"))
	                };
	                commonService.request(forwardInfo, {
	                    url: window.ServerURL + "/updateTForwardInfo",
	                    success: function(res) {
	                        if (res.result === "0") {
	                        	//点击缴费后，弹出支付页面，关闭支付页面再点击缴费
	                        	forwardInfoModel.set("status", "DJF");
	                        	forwardInfoModel.set("taskPayId", res.id);
	                            var pageParam = "headerHeight=" + headerHeight;
	                            pageParam += "&id=" + res.id;
	                            pageParam += "&pageName=assayOrgSelectPage";
	                            pageParam += "&pageFrameName=assayOrgSelectContentPage";
	                            pageParam += "&js=assayOrgSelectContent.closeWindow";
	                            appcan.frame.open("content", "../../components/paymentMode.html?" + pageParam, 0, headerHeight, 'paymentModePage');                        
	                        } else {
	                            appcan.window.openToast("更新化验单缴费信息失败！", 2000, 50, 0);
	                            return;
	                        }                  
	                    }
	                });
            	}                
            default:
                break;
        }
    });
    
    var getNursesVisitPrice = function(type) {
        if (type === 0) {
            forwardInfoViewModel.model.set("taskSumfee", (Number(forwardInfoModel.get("taskSumfee")) 
                - Number(forwardInfoModel.get("thedoorFee"))).toFixed(2));
            forwardInfoModel.set("tastWay", 0);
            forwardInfoModel.set("thedoorFee", null);
        } else if (type === 1) {
            forwardInfoModel.set("tastWay", 1);
            commonService.request({"mechanismId": forwardInfoModel.get("tastMechanismId")}, {
                url: window.ServerURL + "/getTMechanismThedoorPrice",
                success: function(res) {
                    forwardInfoViewModel.model.set("thedoorFee", res);
                    forwardInfoViewModel.model.set("taskSumfee", (Number(forwardInfoModel.get("taskSumfee")) + res).toFixed(2));
                }
            });
        }
    }
    
    var selectAssayMode = function(event) {
        if (forwardInfoModel.get("status") === "DJF" || !!!forwardInfoModel.get("tastMechanismId")) {
            return;
        }
        for (var i = 0; i < $(event.currentTarget).parent("div").find(".circle-select").length; i++) {
            var obj = $($(event.currentTarget).parent("div").find(".circle-select")[i]);
            obj.removeClass("circle-select");
            obj.addClass("circle-unselect");
        }
        $(event.currentTarget).addClass("circle-select");
        $(event.currentTarget).removeClass("circle-unselect");
        if (!!$(event.currentTarget).hasClass("orgCenter")) {
            //alert("orgCenter");
            getNursesVisitPrice(0);
        }
        if (!!$(event.currentTarget).hasClass("nursesVisit")) {
            //alert("nursesVisit");
            getNursesVisitPrice(1);
            //forwardInfoModel.set("tastWay", 1);
        }
    } 
      
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        headerHeight = inParam.headerHeight;
        if (inParam.forwardType === forwardType[0]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new AssayItemInfoCollection()
            }))();
        } else if (inParam.forwardType === forwardType[1]) {
            assayItemInfoViewModel = new(MVVM.ViewModel.extend({
                el: "#assayItemView",
                collection: new InspectionInfoCollection()
            }))();
        }
        getForwardInfo();
    }
    
    return {
        init: init,
        selectAssayMode: selectAssayMode,
        doSelectMechanism: doSelectMechanism,
        closeWindow: closeWindow
    }
}();

appcan.ready(function() {
    assayOrgSelectContent.init();
});
