if(!!!window.buyMedicineAssess) {
    window.buyMedicineAssess = {}
}

var buyMedicineAssess = function() {
    var inParam, headerHeight, evaluateType = "GY";  
    var self = this;
    //设置处方头表MODEL类   
    var recipeInfoModel = new RecipeInfoModel();
    var patientInfo = {};
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));
    
    var recipeDrugDetailViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDrugDetailsView",
        collection: new RecipeDrugDetailCollection()
    }));
    
    evaluateitemsTable.score = 0;
    var evaluateItemsViewModel = new (MVVM.ViewModel.extend({
        el: "#showEvaluateItemsView",
        collection: new EvaluateItemsCollection()
    }));
               
    var getRecipeInfoSuccess = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);            
            recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList);
        }
    }
    
    var getRecipeInfo = function() {
        var recipeInfoParam = _.clone(window.pagingParam);
        recipeInfoParam.tRecipeInfo =  {
            id: !!inParam ? inParam.orderId  || "_" : "_"
        }
        //获取药师信息
        commonService.request(recipeInfoParam, {
            url: window.ServerURL + "/getTRecipeInfoXf",
            success: getRecipeInfoSuccess
        });
    }
    
    var getEvaluateItems = function() {
        var param = {"itemType": evaluateType};
        commonService.request(param, {
            url: window.ServerURL + "/getTEvaluateItems",
            success: function(res) {
                evaluateItemsViewModel.collection.set(res);
            }
        });
    }
    //更新评价信息
    var addEvaluate = function() {
        if (!!!recipeInfoModel.get("evaluateScore") || recipeInfoModel.get("evaluateScore") === 0) {
            appcan.window.openToast("綜合评价未评价", 2000, 50, 0);
            return;
        }
        //生成更新数据集
        var evaluateInfo = {
            "orderType": evaluateType,
            "orderId": recipeInfoModel.get("id"),
            "orderNumber": recipeInfoModel.get("recipeCode"),
            "evaluateOpinion": "",
            "scoreSum": recipeInfoModel.get("evaluateScore"),
            "tEvaluateVO": []
        }
        for(var i = 0; i < evaluateItemsViewModel.collection.length; i++) {
            var item = {
                "itemId": evaluateItemsViewModel.collection.models[i].get("id"),
                "itemType": evaluateType,
                "itemCode": evaluateItemsViewModel.collection.models[i].get("itemCode"),
                "itemName": evaluateItemsViewModel.collection.models[i].get("itemName"),
                "score": evaluateItemsViewModel.collection.models[i].get("score")
            }
            evaluateInfo.tEvaluateVO.push(item);
        }
        commonService.request(evaluateInfo, {
            url: window.ServerURL + "/addtTEvaluateXf",
            success: function(res) {
                if (res.result === "0") {
                    appcan.window.openToast("购药评价成功", 2000, 50, 0);
                    appcan.window.evaluatePopoverScript("patientAssessListPage", "patientAssessListcontentPage", "patientAssessList.refreshLoad()")
                    setTimeout(function() {
                        appcan.window.close(-1);
                    }, 500);
                } else {
                    appcan.window.alert("", res.message);
                }
            }
        })
    }
    
    appcan.button("#btnOk", "btn-act", function() {
        //更新评价信息
        addEvaluate(); 
    });
    
    appcan.button("#nav-left", "btn-act", function() {
       appcan.window.close(-1); 
    });
    
    appcan.button(".syntheticalEvaluate", "but-act", function() {
        for(var i = 0; i < evaluateItemsViewModel.collection.length; i++) {
            if (evaluateItemsViewModel.collection.models[i].get("score") === 0) {
                appcan.window.openToast(evaluateItemsViewModel.collection.models[i].get("itemName") + "未评价", 2000, 50, 0);
                return;
            }
        }
        var score = $(event.srcElement).attr("data-index");
        recipeInfoModel.set("evaluateScore", Number(score));
        for (var i = 0; i < $(event.currentTarget).children().length; i++) {
            var children = $(event.currentTarget).children()[i];
            $(children).toggleClass("choice", score >= $(children).attr("data-index"));
            $(children).toggleClass("nochoice", !(score >= $(children).attr("data-index")));
        }
    });
    
    //设置评价标签状态，点亮星星    
    var setEvaluateTags = function() {
        var itemId = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var itemModel = evaluateItemsViewModel.collection.where({id: itemId});
        var score = $(event.currentTarget).attr("data-index");
        itemModel[0].set("score", Number(score));
    }
       
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        //获取处方单信息
        getRecipeInfo();
        //初始评审列表
        getEvaluateItems();
    }
    
    return {
        init: init,
        setEvaluateTags: setEvaluateTags
    }
}();

appcan.ready(function() {
   buyMedicineAssess.init(); 
});
