if(!!!window.diagnosisAssess) {
    window.diagnosisAssess = {}
}

var diagnosisAssess = function() {
    var inParam, headerHeight, doctorInfo = {}, patientInfo = {}, evaluateType = "ZL";  
    var self = this;
    //设置处方头表MODEL类   
    var taskInfoModel = new TaskInfoModel();
    taskInfoModel.set("headPicture", "");
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".taskInfo",
        model: taskInfoModel
    }));
   
    evaluateitemsTable.score = 0;
    var evaluateItemsViewModel = new (MVVM.ViewModel.extend({
        el: "#showEvaluateItemsView",
        collection: new EvaluateItemsCollection()
    }));
               
    var getTaskInfoSuccess = function(res) {
        if (!!res) {
            var param = {
                id: res[0].tastDoctorId
            }
            commonService.request(param, {
                url: window.ServerURL + "/getDoctor",
                success: function(data) {
                    res[0].headPicture = window.PicURL + (!!data[0].headPicture ? data[0].headPicture : window.doctorPhoto.manDefaultUrl);
                    taskInfoModel.set(res[0]);
                    if(data[0].doctorType === "Q"){
                   		$("[data-bind='text:getTastDoctorType']").text("全科");
                    }else{
                   		$("[data-bind='text:getTastDoctorType']").text(data[0].departmentName);
                    }
                }
            });
        }
    }
    
    var getTaskInfo = function() {
        var param = _.clone(window.pagingParam);
        param.id =  !!inParam ? inParam.taskId  || "_" : "_";
        //获取诊疗信息
        commonService.request(param, {
            url: window.ServerURL + "/getTaskInfoXf",
            success: getTaskInfoSuccess
        });
    }
    
    var getEvaluateItems = function() {
        var param = {"itemType": evaluateType};
        commonService.request(param, {
            url: window.ServerURL + "/getTEvaluateItems",
            success: function(res) {
                evaluateItemsViewModel.collection.set(res);
            }
        });
    }
    //更新评价信息
    var addEvaluate = function() {
        if (!!!taskInfoModel.get("evaluateScore") || taskInfoModel.get("evaluateScore") === 0) {
            appcan.window.openToast("綜合评价未评价", 2000, 50, 0);
            return;
        }
        //生成更新数据集
        var evaluateInfo = {
            "orderType": evaluateType,
            "orderId": taskInfoModel.get("id"),
            "orderNumber": taskInfoModel.get("code"),
            "evaluateOpinion": "",
            "scoreSum": taskInfoModel.get("evaluateScore"),
            "tEvaluateVO": []
        }
        for(var i = 0; i < evaluateItemsViewModel.collection.length; i++) {
            var item = {
                "itemId": evaluateItemsViewModel.collection.models[i].get("id"),
                "itemType": evaluateType,
                "itemCode": evaluateItemsViewModel.collection.models[i].get("itemCode"),
                "itemName": evaluateItemsViewModel.collection.models[i].get("itemName"),
                "score": evaluateItemsViewModel.collection.models[i].get("score")
            }
            evaluateInfo.tEvaluateVO.push(item);
        }
        commonService.request(evaluateInfo, {
            url: window.ServerURL + "/addtTEvaluateXf",
            success: function(res) {
                if (res.result === "0") {
                    appcan.window.openToast("诊疗评价成功", 1000, 50, 0);
                    if(!!inParam.pageName) {
                        appcan.window.evaluatePopoverScript(inParam.pageName, inParam.pageFrameName, inParam.js + "()");
                    }
                    //appcan.window.evaluatePopoverScript("patientAssessListPage", "patientAssessListcontentPage", "patientAssessList.refreshLoad()")
                    setTimeout(function() {
                        appcan.window.close(-1);
                    }, 500);
                    
                } else {
                    appcan.window.alert("", res.message);
                }
            }
        })
    }
    
    appcan.button("#btnOk", "btn-act", function() {
        //更新评价信息
        addEvaluate(); 
    });
    
    appcan.button("#nav-left", "btn-act", function() {
       appcan.window.close(-1); 
    });
    
    appcan.button(".syntheticalEvaluate", "but-act", function() {
        for(var i = 0; i < evaluateItemsViewModel.collection.length; i++) {
            if (evaluateItemsViewModel.collection.models[i].get("score") === 0) {
                appcan.window.openToast(evaluateItemsViewModel.collection.models[i].get("itemName") + "未评价", 2000, 50, 0);
                return;
            }
        }
        var score = $(event.srcElement).attr("data-index");
        taskInfoModel.set("evaluateScore", Number(score));
        for (var i = 0; i < $(event.currentTarget).children().length; i++) {
            var children = $(event.currentTarget).children()[i];
            $(children).toggleClass("choice", score >= $(children).attr("data-index"));
            $(children).toggleClass("nochoice", !(score >= $(children).attr("data-index")));
        }
    });
    
    //设置评价标签状态，点亮星星    
    var setEvaluateTags = function() {
        var itemId = $(event.currentTarget).parents("li").find("[data-bind='text:id']").text().trim();
        var itemModel = evaluateItemsViewModel.collection.where({id: itemId});
        var score = $(event.currentTarget).attr("data-index");
        itemModel[0].set("score", Number(score));
    }
       
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        //获取诊疗单信息
        getTaskInfo();
        //初始评审列表
        getEvaluateItems();
    }
    
    return {
        init: init,
        setEvaluateTags: setEvaluateTags
    }
}();

appcan.ready(function() {
   diagnosisAssess.init(); 
});
