if (!window.drugFeePayment) {
    window.drugFeePayment = null;
}

var drugFeePayment = function() {
    var inParam, recipeId, headerHeight;  
    var self = this;    
    var recipeInfoModel = new RecipeInfoModel();
    var payInfo = {};
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#drugFeePaymentContent",
        model: recipeInfoModel,
        collection: new RecipeDrugDetailCollection()
    }));
            
    var success = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            getPayInfo("0");
            setTimeout(function() {
                //写入缴费单号、缴费类型
                res.tRecipeInfoVOList[0].tRecipeInfo.payOrderCode = payInfo.code;
                res.tRecipeInfoVOList[0].tRecipeInfo.payOrderType = payInfo.payOrderType;
                recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
                recipeInfoViewModel.collection.add(res.tRecipeInfoVOList[0].tRecipeDrugDetailList); 
            }, 100);            
        }
    }
    var options = {};
    options.success = success;
    options.url = window.ServerURL + "/getTRecipeInfoXf";
    
    var dragenter = function(event) {
        console.log("dragenter");
    }
    
    /*
    $('#tastDoctorName').on("swipe", function(event){
        console.log("tastDoctorName  swipe");
        appcan.window.openToast("swipe 诊费缴费单功", 2000, 5, 0);
    });
    $('#tastDoctorName').on("longTap",function(event){
        console.log("tastDoctorName  longTap");
        appcan.window.openToast("longTap 诊费缴费单功", 2000, 5, 0);
        $("#itemDelete").css("display", "block");
    });
    $('#tastDoctorName').on("tap", function(event){
        console.log("tastDoctorName  tao");
        appcan.window.openToast("tao 诊费缴费单功", 2000, 5, 0);
    });
    */
    var getPay = function() {
        getPayInfo("1");
    }
    var getPayInfo = function(status) {
        var param = {}; //_.clone(window.pagingParam);
        //param.status = status;
        param.orderId = recipeId;
        param.pageIndex = _.clone(window.pagingParam).pageIndex;
        param.pageSize = _.clone(window.pagingParam).pageSize;
    
        var url = window.ServerURL + "/getPayXf";
        
        commonJs.requestAjax(url, JSON.stringify(param), 
            function(res) {
                if (res.length > 0) {
                    payInfo = res[0];
                }
                refreshBtn();
            }, function(e) {
                
            }
        );
    }
    
    var refreshBtn = function() {
        if (payInfo.status != "0"){
            $("#btnToFeePayment").css("pointer-events", "none");
            $("#btnToFeePayment").addClass("disable");
            $("#btnRecipeInfo").removeClass("field-nodisplay");
        } else {
            $("#btnToFeePayment").removeClass("field-nodisplay");
            $("#btnRecipeInfo").removeClass("field-nodisplay");
        }
    }
        
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        recipeId = inParam.id  || "_";
        headerHeight = inParam.headerHeight;
        var recipeInfoPamar = _.clone(window.pagingParam);
        recipeInfoPamar.tRecipeInfo =  {
            id: recipeId
        }
        commonService.request(recipeInfoPamar, options);
        //recipeInfoModel.set(recipeInfoTestValue);
        //recipeInfoViewModel.collection.add(recipeInfoTestValue.tRecipeDrugDetailList);        
    }
    
    appcan.button("#btnRecipeInfo", "btn-act", function() {
        var param = "id=" + recipeInfoModel.get("id");
        commonJs.openWindow("ecPrescribingPage", "../../components/electronic_prescribing.html?" + param);
    });
    
    appcan.button("#btnToFeePayment", "btn-act", function() {
       var pageParam = "headerHeight=" + headerHeight;
        pageParam += "&id=" + payInfo.id;
        pageParam += "&pageName=drugFeePaymentPage";
        pageParam += "&pageFrameName=drugFeePaymentContentPage";
        pageParam += "&js=drugFeePayment.closeWindow";
        appcan.frame.open("content", "../../components/paymentMode.html?" + pageParam, 0, headerHeight, 'paymentModePage');   
    });
    
    //支付成功后直接跳转到列表页
    var _closeWindow = function() {
        //返回待缴费列表并刷新数据
        appcan.window.evaluatePopoverScript("awaitPaymentOrdersListPage", "awaitPaymentOrdersContentPage", "awaitPaymentOrders.refreshLoadData()");
        uexWindow.evaluateScript("", "0", "commonJs.closeWindow()");
    }
    
    return {
        init: init,
        getPay: getPay,
        closeWindow: _closeWindow
    }
}();

appcan.ready(function() {
    drugFeePayment.init();
    appcan.window.subscribe("feePaymentSuccess", function(res) {
        //加载数据
        //getPay();
    });
   //recipeInfoService.request({param: "test"}, drugFeePayment);
});
