var pjflag,jfflag;
var diagnosisTreatFeeDetailModel = MVVM.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults: taskInfoTable,
    //在model创建后执行的方法
    initialize: function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate: function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds: {
        
        getStatus: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                var codelist = commonJs.getCodelistData(window.treatCodeList.treatStatus, status);
                return codelist.text || status;
            }
        },
        
        getCreateDate: {
                    deps: ["createDate"],
                    get: function(createDate) {
                    	
                    	//json格式的转换报错
                        return !!!createDate ? null : commonJs.dateTimeToString(createDate);
                        /*return commonJs.dateTimeToString(beginTime.time);*/
                    }
                },
         getBeginTime: {
                    deps: ["beginTime"],
                    get: function(beginTime) {
                    	
                    	//json格式的转换报错
                        return !!!beginTime ? null : commonJs.dateTimeToString(beginTime);
                        /*return commonJs.dateTimeToString(beginTime.time);*/
                    }
                },
          getEndTime: {
                    deps: ["endTime"],
                    get: function(endTime) {
                    	
                    	//json格式的转换报错
                        return !!!endTime ? null : commonJs.dateTimeToString(endTime);
                        /*return commonJs.dateTimeToString(beginTime.time);*/
                    }
                },
        
        //性别
        getSex: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["relativSex"],
            get: function(relativSex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, relativSex);
                return codelist.text || relativSex;
            }
        },
        getPjnone: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["evaluateStatus"],
            get: function(evaluateStatus) {
                pjflag = true;
                if(this.get("status") === "YWC" && (evaluateStatus === "DPJ" || !!!evaluateStatus)){
                	pjflag = false;
                }
                return pjflag;
            }
        },
        getJfnone: {
            //这里是参数的依赖，也可以使用this.get("username")
            deps: ["status"],
            get: function(status) {
                jfflag = true;
                if(status === "DJF"){
                	jfflag = false;
                }
                return jfflag;
            }
        }
        
        
        
    },
    parse: function(data) {
        //console.log(data);
        return data;
    },
    sync: function(method, model, options) {
        switch (method) {
        case "create":
            console.log("create");
            break;
        case "update":
            console.log("update");
            var param = {
                "payOrderType": "ZL",
                "taskInfoId": model.get("id"),
                "patientAge": model.get("patientAge"),
                "sex": model.get("sex"),
                "patientName": model.get("patientName"),
                "illnessCode": model.get("illnessCode"),
                "illnessName": model.get("illnessName"),
                "sumfee": model.get("taskPrice")
            };
            var diagnosisTreatFeeDetailService = new DiagnosisTreatFeeDetailService(param, options);
            diagnosisTreatFeeDetailService.getTaskInfo();
            break;
        case "patch":
            console.log("patch");
            break;
        case "delete":
            console.log("delete");
            break;
        case "read":
            console.log("read");
            
            var param = options.param || {
                "pageIndex": 1,
                "pageSize": 10
            };
           var diagnosisTreatFeeDetailService = new DiagnosisTreatFeeDetailService(param, options);
            diagnosisTreatFeeDetailService.getPay();
            //diagnosisCostPostService.request(param, options);
            break;
        default:
            break;
        }
    }
});

