if (!window.diagnosisUnfinishTreatRecord) {
    window.diagnosisUnfinishTreatRecord = {};
}

var diagnosisUnfinishTreatRecord = function() {

    var inParam = {};
    var payId;
    var pageCount = 0;
    var pageParam = _.clone(window.pagingParam);
    pageParam.pageIndex = pageCount;
    pageParam.status = "YZX,YJZ,DJF,YJF,YTF";
    pageParam.beginTime = "";
    var diagnosisTreatRecordViewModel = new (MVVM.ViewModel.extend({
    el: "#showDiagnosisTreatRecordView",
    collection: new DiagnosisTreatRecordCollection()
    }));
    //下拉更新
    var downOrUpLoadData = function() {
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url : window.ServerURL + "/getTaskInfoXf",
            success : function(res) {
                if (pageCount === 1) {
                    diagnosisTreatRecordViewModel.collection.set(res);
                } else {
                    diagnosisTreatRecordViewModel.collection.add(res);
                }
            }
        });

    }
    var _refreshLoadData = function() {
        pageCount = 0;
        downOrUpLoadData();
    }
    //加载详细页面
    var loadFeeConfirm = function(event) {
        var id = $(event.currentTarget).find("#itemId").text().trim();
        if (!!id) {
            var payModel = diagnosisTreatRecordViewModel.collection.where({
                "id" : id
            });

            appcan.window.open({
                name : "diagnosisTreatUnfinishDetailPage",
                data : "diagnosisTreatUnfinishDetail.html?taskId=" + payModel[0].get("id"),
                dataType : 0,
                animID : 2
            });

        }
    }
    var setScollbar = function(operate) {
        if (operate === "disable") {
            appcan.window.disableBounce();
            //禁止默认行为方法，防止滚动条滚动
            $(document).on("mousewheel", function(evt) {
                evt.preventDefault();
            }, false);
            $(document).on("touchmove", function(evt) {
                evt.preventDefault();
            });
        } else if (operate === "enable") {
            //检查默认行为方法是否禁用，禁用了则重新启用
            appcan.window.enableBounce();
            $(document).on("touchmove", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            });
            $(document).on("mousewheel", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            }, false);
        }
    }
    var hidenPayOrderTypeFilter = function(hidenFlag) {
        //使用延迟设置,避免连续点击问题
        setTimeout(function() {
            $("#treatRecordType").find(".list-caret-size").addClass("list-caret-down");
            $("#treatRecordType").find(".list-caret-size").removeClass("list-caret-up-select");
            $("#treatRecordType").removeClass("filter-select-color");
            $("#treatRecordTypeSelect").removeClass("mask-show");
        }, 100);
    }
    var treatRecordTypeInit = function() {

        var treatRecordTypeSelect = appcan.selectview({
            selector : "#treatRecordTypeSelect"
        });
        var treatRecordType = [{
            id : "999999",
            value : "ALL",
            text : "全部"
        }];
        for (var i in window.treatCodeList.treatStatuses) {
            treatRecordType.push(window.treatCodeList.treatStatuses[i]);
        }
        treatRecordTypeSelect.set(treatRecordType);
        treatRecordTypeSelect.on("select:click", function(obj, data) {
            pageParam.status = data[0].value === "ALL" ? "YZX,YJZ,DJF,YJF,YTF" : data[0].value;
            if (data[0].value === "ALL") {
                $("#treatRecordType").find("span").text("类型");
            } else {
                $("#treatRecordType").find("span").text(data[0].text);
            }
            hidenPayOrderTypeFilter();
            setScollbar("enable");
            //加载数据
            pageCount = 0;
            downOrUpLoadData();
        });
    }
    var checkOpenFilter = function(target) {
        if ($(target.parentElement).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
            //组件自身选中时，返回true
            if ($(target).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
                return true;
            } else {
                return false;
            }
        }
        return true;
    }
    //点击类型时，触发事件
    $("#treatRecordType").on("tap", function(event) {
        if (!!!checkOpenFilter(event.currentTarget))
            return;
        event.cancelBubble = true;
        if ($(event.currentTarget).find("div[class='list-caret-size list-caret-down']").length > 0) {
            //获取 #divFilterItem div  的高度和
            var maskTop = Number($("#divFilterItem").offset().height) + Number($("#divFilterItem").offset().top) - 2;
            $("#treatRecordTypeSelect").css("top", maskTop + "px");
            $("#treatRecordTypeSelect").addClass("mask-show");
            $(event.currentTarget).find(".list-caret-size").removeClass("list-caret-down");
            $(event.currentTarget).find(".list-caret-size").addClass("list-caret-up-select");
            $(event.currentTarget).addClass("filter-select-color");
            setScollbar("disable");

        } else {
            hidenPayOrderTypeFilter();
            setScollbar("enable");

        }
    });

    $("#treatRecordDate").on("click", function(event) {
        hidenPayOrderTypeFilter();
        setScollbar("enable");
        var _self = this;
        var okCallback = function(date) {
            pageParam.createDate = date.text;
            $("#treatRecordDate").find("span").text(date.text);
            //$("#selectDate").find("[data-bind='text:apothecaryName']").text(rs.text);
            pageCount = 0;
            downOrUpLoadData();
            _self.picker.dispose();
            _self.picker = null;
        }
        var clearCallback = function() {
            $("#treatRecordDate").find("span").text("诊疗日期");
            if (!!pageParam.createDate) {
                delete pageParam.createDate;
            }
            pageCount = 0;
            downOrUpLoadData();
            _self.picker.dispose();
            _self.picker = null;
        }
        if (_self.picker) {
            _self.picker.show(okCallback, clearCallback);
        } else {
            var options = {
                "type" : "date",
                "beginYear" : 1901,
                bounceState : 1
            };
            /*
             * 首次显示时实例化组件
             * 示例为了简洁，将 options 放在了按钮的 dom 上
             * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
             */
            _self.picker = new Neusoft.DtPicker(options);
            _self.picker.show(okCallback, clearCallback);
        }
    });

    $("#treatRecordTypeSelect").on("tap", function(event) {
        if (event.eventPhase != 3) {
            event.cancelBubble = true;
            console.log("treatRecordTypeSelect");
            hidenPayOrderTypeFilter();
        }
    });

    var init = function() {

        //设置弹动事件
        commonJs.listWindowBounce(downOrUpLoadData);
        //获取页面的传参
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        var patientId = inParam.patientId;
        if (patientId == "" || patientId == undefined) {
            pageParam.patientId = "_";
        } else {
            pageParam.patientId = patientId;
        }
        downOrUpLoadData();
            
        treatRecordTypeInit();
    }

    return {
        loadFeeConfirm : loadFeeConfirm,
        init : init,
        refreshLoadData : _refreshLoadData

    }
}();

//当渲染所有组件后执行
appcan.ready(function() {
    appcan.initBounce();
    //浮动页面拖动效果
    diagnosisUnfinishTreatRecord.init();
});

