if (!window.recipeInfo) {
    window.recipeInfo = {};
}

var recipeInfo = function() {
    
    var inParam, recipeId, headerHeight;  
    var self = this;
    //设置处方头表MODEL类   
    var recipeInfoModel = new RecipeInfoModel();
    var payInfo = {}, apothecaryInfo = {};
    
    //处方信息
    var recipeInfoConData = JSON.parse(appcan.locStorage.getVal("recipeInfoConData"));
    
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));
    
    var recipeDetailInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDetailInfoView",
        collection: new RecipeDetailInfoCollection()
    }));
    
    var recipeDrugDetailViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDrugDetailsView",
        collection: new RecipeDrugDetailCollection()
    }));
    
    //设置评价标签状态，点亮星星    
    var setEvaluateTags = function() {
        for (var i = 1; i <= Number(recipeInfoModel.get("evaluateScore")); i++) {
            $("#evaluateScore").find("[name='" + i + "']").removeClass("nochoice");
            $("#evaluateScore").find("[name='" + i + "']").addClass("choice");
        }
    }
            
    var options = {};      
    var success = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
            setEvaluateTags();
            //设置按钮显示
            refreshBtn();
            //写入调剂师信息、
            if (!!!recipeInfoModel.get("apothecaryId")) {
                recipeInfoModel.set("apothecaryId", apothecaryInfo.id);
                recipeInfoModel.set("apothecaryCode", apothecaryInfo.apothecaryCode);
                recipeInfoModel.set("apothecaryName", apothecaryInfo.apothecaryName);
            }
            recipeDetailInfoViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDetailInfoList); 
            recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList); 
        }
    }
    options.success = success;
    options.url = window.ServerURL + "/getTRecipeInfoXf";
    
    //折叠与展开药品信息
    appcan.button("#expandDrugDetail", "btn-act", function() {
        if ($("#expandDrugDetail").find(".angle-down").length > 0) {
            $("#recipeDrugDetailsView").removeClass("field-nodisplay");
            $("#recipeDrugDetailsView").addClass("field-display");
            $("#expandDrugDetail").find(".angle-icon-size-1x").removeClass("angle-down");
            $("#expandDrugDetail").find(".angle-icon-size-1x").addClass("angle-up");
        } else if ($("#expandDrugDetail").find(".angle-up").length > 0){
            $("#recipeDrugDetailsView").addClass("field-nodisplay");
            $("#recipeDrugDetailsView").removeClass("field-display");
            $("#expandDrugDetail").find(".angle-icon-size-1x").addClass("angle-down");
            $("#expandDrugDetail").find(".aangle-icon-size-1x").removeClass("angle-up");
        }
    });
    
    appcan.button("#btnFetchDrugQRcode", "btn-act", function() {
        appcan.window.open({
            name: "fetchDrugQRcode",
            dataType: 0,
            aniId: 2,
            data: "recipe_info_qrcode.html?recipeCode=" + recipeInfoModel.get("recipeCode")
        });
    });
    
    //查看电子处方单信息
    appcan.button("#btnLookRecipeInfo", "btn-act", function() {
        appcan.window.open({
            name: "e-PrescribingPage",
            dataType: 0,
            aniId: 2,
            data: "../../components/electronic_prescribing.html?id=" + recipeInfoModel.get("id")
        });
    });
    
    //查看推荐药房
    appcan.button("#btnRecommendPharmacy", "btn-act", function() {
        appcan.window.open({
            name: "e-PrescribingPage",
            dataType: 0,
            aniId: 2,
            data: "recommend_pharmacy.html?id=" + recipeInfoModel.get("id")
        });
    });
    
    appcan.button("#nav-left", "btn-act", function() {
       appcan.window.close(-1);
    });
    
    var refreshBtn = function() {
        var style = function(target, displayFlag) {
            target.toggleClass("field-nodisplay", !displayFlag);
        }
        // if (recipeInfoModel.get("status") === "YSH") {
            // style($("#btnFetchDrugQRcode"), true);
            // style($("#btnRecommendPharmacy"), true);
            // style($("#btnLookRecipeInfo"), true);
        // } else if (recipeInfoModel.get("status") === "YSH" || recipeInfoModel.get("status") === "YXY"
            // || recipeInfoModel.get("status") === "YJF" || recipeInfoModel.get("status") === "YWC" 
            // || recipeInfoModel.get("status") === "YGB") {
            // style($("#btnLookRecipeInfo"), true);
        // }
        style($("#btnLookRecipeInfo"), true);
    }    
    var setContentTop = function() {
        headerHeight = $('#recipeInfoHeader').offset().height;
        $("#recipeInfoContent").css("top", headerHeight);
    }
    
    window.onorientationchange = window.onresize = function() {
        setContentTop();
    }
        
       
    var init = function() {
        appcan.window.disableBounce();
        setContentTop();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        try {
            recipeId = inParam.id  || "_";
        } catch (e){
            
        }
        
        if(recipeId !== "_"){
	        var recipeInfoPamar = _.clone(window.pagingParam);
	        recipeInfoPamar.tRecipeInfo =  {
	            id: recipeId
	        }
	        
	        //获取药师信息
	        commonService.request(recipeInfoPamar, options);
        }else{
        	recipeInfoModel.set(recipeInfoConData);
        	recipeDetailInfoViewModel.collection.set(recipeInfoConData.tRecipeDetailInfoList);
        	//根据处方单号查询本系统是否有处方单数据
        	funGetTRecipeInfoHeadXf(recipeInfoConData.recipeCode);
            // recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList); 
        }
        
        /*
        recipeDetailInfoViewModel.collection.on("add", function(model, self, options) {
            console.log(model);
        });
        recipeInfoModel.set(recipeInfoTestData);
        recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        recipeDrugDetailViewModel.collection.set(recipeInfoTestData.tRecipeDrugDetailList);
        */
    }
    
    //
    var funGetTRecipeInfoHeadXf = function(recipeCode){
    	var pageParam = {};
    	pageParam.tRecipeInfo = {"recipeCode": recipeCode}
    	commonService.request(pageParam, {
            url: window.ServerURL + "/getTRecipeInfoHeadXf",
            success: function(res) {
            	if(res.length > 0){
            		recipeInfoModel.set("id", res[0].id);
            		recipeInfoModel.set("illnessName", res[0].illnessName);//病类
            		recipeInfoModel.set("taskResult", res[0].taskResult);//诊断结果
            		recipeInfoModel.set("supplyExplain", res[0].supplyExplain);//补充说明
            		//设置按钮显示
            		refreshBtn();
            	}
            }
        });
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    recipeInfo.init();
});
