
if(!window.mysigneddoctor){
    window.mysigneddoctor = {};
}

var mysigneddoctor = function() {
    var pageCountQ = 1;
    var pageParamQ;
    pageParamQ = _.clone(window.pagingParam);
    pageParamQ.doctorType = "Q";
    pageParamQ.patientId = "1";
    
    var pageCountZ = 1;
    var pageParamZ;
    pageParamZ = _.clone(window.pagingParam);
    pageParamZ.doctorType = "Z";
    pageParamZ.patientId = "1";
    
    
    //声明viewmodel
    //全科医生
    var ViewModelQ = new(MVVM.ViewModel.extend({
        el: "#CustomListView_l2bSwK",
        collection: new MySignedDoctorCollection()
    
    }))();
    
    //专科医生
    var ViewModelZ = new(MVVM.ViewModel.extend({
        el: "#CustomListView_dHaFRF",
        collection: new MySignedDoctorCollection()
    
    }))();
    
    
    //加载全科医生数据
    var loadDoctorQ = function(){
        
        pageCountQ++;
        pageParamQ.pageIndex = pageCountQ;

        ViewModelQ.collection.fetch({selfViewModel: ViewModelQ, param: pageParamQ});
    }
    
    //加载专科医生数据
    var loadDoctorZ = function(){
        
        pageCountZ++;
        pageParamZ.pageIndex = pageCountZ;

        ViewModelZ.collection.fetch({selfViewModel: ViewModelZ, param: pageParamZ});
    }
    
    //加载详细页
    var loadDoctorDetail = function(event){
        var doctorId = $(event.currentTarget).find("#doctor_id").text().trim(); 
        if (!!doctorId) {
             appcan.locStorage.setVal("doctorId",doctorId);
             appcan.window.open({
                    name : "doctor_detail",
                    data : "doctor_detail.html?doctorId="+doctorId,
                    aniId : "2"
                });
        }
    }
    
    //签约、解约
    var signDoctor = function(event){

        event.cancelBubble = true;
        var doctorId = $(event.currentTarget).find("#doctor_id").text().trim();
        var ifSigned = $(event.currentTarget).find("#if_signed").text().trim();
        var patientId = "1";
        
        var isTp;
        var content;
        if (ifSigned == "Y") {
            isTp = "N";
            content = "解约成功";
        } else {
            isTp = "Y";
            content = "签约成功";
        }
        

        var daraParam = JSON.stringify({
            "doctorId" : doctorId,
            "patientId" : patientId,
            "isTp" : isTp
        }); 
        var url = window.ajaxOuterUrl + "/addOrDeleteDoctorPatientInfo";
        
       commonJs.requestAjax(url, daraParam, function(res) {


            appcan.window.alert({
                title : "提示",
                content : content,
                buttons : '确定',
                callback : function(err, data, dataType, optId) {
                    window.location.reload();
                }
            }); 


        }, function(e, err) {

            appcan.window.alert({
                title : "提示",
                content : "接口失败",
                buttons : '确定',
                callback : function(err, data, dataType, optId) {

                }
            }); 

        });
    }
    
    // 咨询
    var adviceToDoctor = function(event){
        event.cancelBubble = true;
        var doctorId = $(event.currentTarget).find("#doctor_id").text().trim();

        var patientId = "1";
        //查询患者是否有未完成的诊疗记录
        var checkData = JSON.stringify({
            "patientId" : patientId,
            "tastDoctorId" : doctorId,
            "status" : "YZX,YJZ,DJF,YJF"
        });
        
        var checkUrl = window.ajaxOuterUrl + "/getTaskInfoXf";
        var checkParam = JSON.stringify(checkData);
        commonJs.requestAjax(checkUrl, checkParam, function(res) {
            console.log(res);
            
            if (res.length > 0) {

                appcan.window.alert({
                    title : "提示",
                    content : "存在未完成的诊疗记录",
                    buttons : '确定',
                    callback : function(err, data, dataType, optId) {

                    }
                });  
            }else{
                //生成诊疗记录

                var dataList = JSON.stringify({
                    "patientId" : patientId,
                    "tastDoctorId" : doctorId
                }); 
                
                var addUrl = window.ajaxOuterUrl + "/addTaskInfoXf";
                commonJs.requestAjax(addUrl, dataList, function(res) {

                    appcan.window.alert({
                        title : "提示",
                        content : "已生成诊疗记录",
                        buttons : '确定',
                        callback : function(err, data, dataType, optId) {
                            window.location.reload();
                        }
                    }); 

                }, function(e, err) {

                    appcan.window.alert({
                        title : "提示",
                        content : "接口失败",
                        buttons : '确定',
                        callback : function(err, data, dataType, optId) {

                        }
                    }); 

                }); 
            }

        }, function(e, err) {

            appcan.window.alert({
                title : "提示",
                content : "接口失败",
                buttons : '确定',
                callback : function(err, data, dataType, optId) {

                }
            });

        });

    }
    
    var init = function() {
        //设置弹动事件
        commonJs.listWindowBounce(loadDoctorQ);
        commonJs.listWindowBounce(loadDoctorZ);
        ViewModelQ.collection.fetch({selfViewModel: ViewModelQ, param: pageParamQ});
        ViewModelZ.collection.fetch({selfViewModel: ViewModelZ, param: pageParamZ});
        
    }
    
    return {
        loadDoctorQ : loadDoctorQ,
        loadDoctorZ : loadDoctorZ,
        loadDoctorDetail : loadDoctorDetail,
        signDoctor : signDoctor,
        adviceToDoctor : adviceToDoctor,
        init: init
    }
    
}();

appcan.ready(function() {
    appcan.initBounce();
    mysigneddoctor.init();
});



