if(!window.healthRecordListIllnessJs){
    window.healthRecordListIllnessJs = {};
}

var healthRecordListIllnessJs = function() {
	var pageCount = 0;
    var pageParam, patientInfo;
    pageParam = _.clone(window.pagingParam);
    pageParam.patientId = "";
    pageParam.type = "Y";
    
    //声明viewmodel
    var ViewModel = new(MVVM.ViewModel.extend({
        el: "#CustomListView_l2bSwK",
        collection: new PatientArchivesCollection()
    }))();
    
    var init = function() {
        patientInfo = commonJs.getPatient();
        pageParam.patientId = !!patientInfo ? patientInfo.id || "_" : "_";
        //设置弹动事件
        commonJs.listWindowBounce(loadSelectList);
        loadSelectList();
    }
    
    //下拉更新
    var loadSelectList = function() {
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url: window.ServerURL + "/getTPatientArchives",
            success: function(res) {
                if (pageCount === 1) {
                    ViewModel.collection.set(res);
                } else {
                    ViewModel.collection.add(res);
                }
            }
        });
    }
    
    //时间控件
    $("#recipeTime").on("tap", function(event) {
        setScollbar("enable");
        var _self = this;
        var datePickerCallback = function(date) {
            pageParam.recipeTime = date.text;
            $("#recipeTime").find("span").text(date.text);
            pageCount = 0;
            loadSelectList();
            _self.payTimepicker.dispose();
            _self.payTimepicker = null;
        }
        var clearPickerCallback = function() {
            $("#recipeTime").find("span").text("诊断时间");
            if (!!pageParam.recipeTime) {
                delete pageParam.recipeTime;
            }
            pageCount = 0;
            loadSelectList();
            _self.payTimepicker.dispose();
            _self.payTimepicker = null;
        }
        if(_self.payTimepicker) {
            _self.payTimepicker.show(datePickerCallback, clearPickerCallback);
        } else {
            var options = {"type":"date", bounceState: 1};
            /*
             * 首次显示时实例化组件
             * 示例为了简洁，将 options 放在了按钮的 dom 上
             * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
             */
            _self.payTimepicker = new Neusoft.DtPicker(options);
            _self.payTimepicker.show(datePickerCallback, clearPickerCallback);
        }
    });
    
    var setScollbar = function(operate) {
        if (operate === "disable") {
            appcan.window.disableBounce();
            //禁止默认行为方法，防止滚动条滚动
            $(document).on("mousewheel", function(evt) {
                evt.preventDefault();
            }, false);
            $(document).on("touchmove", function(evt) {
                evt.preventDefault();
            });
        } else if (operate === "enable") {
            //检查默认行为方法是否禁用，禁用了则重新启用
            appcan.window.enableBounce();
            $(document).on("touchmove", function(evt) {
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            });
            $(document).on("mousewheel", function(evt) {
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            }, false);
        }
    }
    
    //加载详细页
    var loadPrescriptionDetail = function(event){
        var recipeId = $(event.currentTarget).find("#recipeId").text().trim(); 

        if (!!recipeId) {
            commonJs.openWindow("recipeInfoPatientPage", "../diagnosistreat/recipe_info_patient.html?id="+recipeId);
        }
    }

    
    return {
        init: init,
        loadPrescriptionDetail: loadPrescriptionDetail
    }
    
}();

appcan.ready(function() {
    appcan.initBounce();
    healthRecordListIllnessJs.init();
});