if(!window.myIndex){
    window.myIndex = {};
}

var myIndex = function() {
    var pageCount = 0, inParam, patientInfo = {};
    
    var patientInfoModel = new PatientInfoModel();
    patientInfoModel.set("waitPayFeesCount", "");
    patientInfoModel.set("waitSendingCount", "");
    patientInfoModel.set("waitReceivingCount", "");
    patientInfoModel.set("waitEvaluateCount", "");
    patientInfoModel.set("waitDrugCount", "");
    
     //声明viewmodel
    var patientInfoiewModel = new(MVVM.ViewModel.extend({
        el: ".patientInfo",
        model: patientInfoModel
    }));

    var openUrl = function(pageName, url) {
        appcan.window.open({
            name: pageName,
            dataType: 0,
            aniId: 2,
            data: url
        })
    }
    
    var doCheckLogin = function() {
        if (!patientInfoModel.get("id")) {
            openUrl("loginPage", "../login/login.html");
            return false;
        } else {
            return true;
        }
    }
    
    appcan.button("#doLogin", "btn-act", function() {
        doCheckLogin();
    });
    
    //患者待处理处件
    appcan.button(".col-3.tab_item", "btn-act", function() {
        if (!doCheckLogin()) return;
        var outParam = "patientId=" + patientInfoModel.get("id");
        switch(this.id) {
            case "waitPayFees":
                //待缴费
                outParam += "&status=0";
                openUrl("awaitPaymentOrdersListPage", "../diagnosis/awaitPaymentOrders.html?" + outParam);
                break;                
            case "waitSending":
                //待发货
                break;
            case "waitReceiving":
                //待收货
                break;
            case "waitEvaluate":
                //待评价
                openUrl("patientAssessListPage", "../diagnosis/patient_assess_list.html?" + outParam);
                break;
            default:
                break;
        }
    });    
    
    var doLoginOut = function() {
        appcan.locStorage.remove("localPatient");
        appcan.locStorage.remove("loginUser");
        patientInfoModel.set("headPicture", window.patientPhoto.unLoginDefaultUrl);
        $(".patient-photo").css("background-color", "#e4e4e4");
        //跳转致首页
        appcan.window.evaluateScript("patientIndexPage", "patientIndex.toHomePage(1)");
        appcan.window.close(-1);
    }        
    
    appcan.button(".data-row-pd-left-1em", "btn-act", function() {
        if (this.id != "updateSoft" && this.id != "exit") {
            if (!doCheckLogin()) return;
        }
        var inParam = "patientId=" + patientInfoModel.get("id");
        switch(this.id) {
            case "myInfo":
                //我的   
                openUrl("patientInfoPage", "my_info_edit.html?" + inParam);
                break;
            case "myDoctor":
                //我的签约医生
                inParam += "&doctorType=Q";
                openUrl("mySignedDoctorListPage", "../finddoctor/my_signed_doctor.html?" + inParam);
                break;
            case "myFamily":
                //我的家庭成员
                openUrl("patientRelativListPage", "patient_relative_list.html?" + inParam);
                break;
            case "myAddress":
                //我的地址
                openUrl("myAddressListPage", "../address/my_address_list.html?" + inParam);
                break;
            case "historyDiagnosis":
                //诊疗记录
                openUrl("diagnosisTreatListPage", "../diagnosistreat/diagnosisTreatRecord.html?" + inParam);
                
                //diagnosistreat/diagnosisTreatRecord.html
                break;
            case "historyDiagnosisFees":
                //缴费历史
                inParam += "&status=ALL";
                openUrl("awaitPaymentOrdersListPage", "../diagnosis/awaitPaymentOrders.html?" + inParam);
                break;
            case "recipeInfo":
                //处方单
                //openUrl("myBillsListPage", "../bill/bill.html");
                openUrl("prescriptionListPage", "../diagnosis/prescription_list.html?" + inParam);
                break;
            case "reservationBill":
                //预约单
                inParam += "&forwardType=JC"
                openUrl("assayBillListPage", "../assay/assay_bill_list.html?" + inParam);
                break;
            case "assayBill":
                //化验单
                inParam += "&forwardType=HY"
                openUrl("assayBillListPage", "../assay/assay_bill_list.html?" + inParam);
                break;
            case "healthFile":
                //健康档案
                openUrl("healthRecordListPage", "../healthRecord/health_record_list.html?" + inParam);
                break;
            case "updoor":
                //上门服务
                inParam += "&sourceType="+"SMFW";
                openUrl("patientServiceListPage", "../roomService/patient_service_list.html?" + inParam);
                break;
            case "telemedicine":
                //远程医疗
                inParam += "&sourceType="+"YCYL";
                openUrl("patientServiceListPage", "../roomService/patient_service_list.html?" + inParam);
                break;
            case "download":
                //下载链接
                openUrl("downloadPage", "download.html");
                break;
            case "feedback":
                //意见反馈
                openUrl("feedbackPage", "feedback.html?" + inParam);
                break;
            case "scan":
                //扫呀扫
                break;
            case "updateSoft":
                //软件更新
                //openUrl("demoListPage", "../../demo/demo_list.html");
                break;
            case "exit":
                //退出（登出当前用户）
                appcan.window.alert({
		            title : "提示",
		            content : "确认退出？",
		            buttons :  ['确定', '取消'],
		            callback : function(err, data, dataType, optId) {
		                if(data=="0"){
                			doLoginOut();
		                }
		            }
		        });
                //uexWidgetOne.exit();
                break;
            default:
                break;   
        }        
    });
    
    //待缴费
    var _getAwaitPayFessCount = function() {
        var param = {
            id: patientInfoModel.get("id")
        }
        commonService.request(param, {
            url: window.ServerURL + "/getPatientWaitPayCountXf",
            success: function(data) {
                patientInfoModel.set("waitPayFeesCount", data);
                _setAwaitCountStyle();
            }
        });
    }
    //待评价
    var _getAwaitCount = function() {
        var param = {
            id: patientInfoModel.get("id")
        }
        commonService.request(param, {
            url: window.ServerURL + "/getPatientWaitCountXf",
            success: function(data) {
                if (!!data) {
                    patientInfoModel.set("waitEvaluateCount", data.waitEvaCount);
                    patientInfoModel.set("waitDrugCount", data.waitDrugCount);
                    patientInfoModel.set("waitPayFeesCount", data.waitPayCount);
                    _setAwaitCountStyle();
                }
                
            }
        });
    }
    
    /**
     * 设置统计角标提示信息 
     */
    var _setAwaitCountStyle = function() {
        var style = function(target, displayFlag){
            if (target.find(".count.field-nodisplay").length === 0 && !displayFlag) {
                target.find(".count").addClass("field-nodisplay");
                target.find(".count").removeClass("field-display");
            }
            if (target.find(".count.field-display").length === 0 && displayFlag) {
                target.find(".count").addClass("field-display");
                target.find(".count").removeClass("field-nodisplay");
            }
        }
        style($("#waitPayFees"), !!patientInfoModel.get("waitPayFeesCount"));
        //style($("#waitSending"), !!patientInfoModel.get("waitSendingCount"));
        //style($("#waitReceiving"), !!patientInfoModel.get("waitReceivingCount"));
        style($("#waitEvaluate"), !!patientInfoModel.get("waitEvaluateCount"));
        style($("#recipeInfo"), !!patientInfoModel.get("waitDrugCount"));
    }
    
    var _initModel = function() {
        patientInfoModel.clearData();
        patientInfoModel.set(commonJs.getPatient());
        if (!!!patientInfoModel.get("id")) {
            patientInfoModel.set("headPicture", window.patientPhoto.unLoginDefaultUrl);
            $(".patient-photo").css("background-color", "#e4e4e4");
        } else {
            $(".patient-photo").css("background-color", "#86cd69");
        }
        if(!!!patientInfoModel.get("headPicture")) {
            if (patientInfoModel.get("sex") === "WOMAN") {
                patientInfoModel.set("headPicture", window.patientPhoto.girlDefaultUrl);
            } else {
                patientInfoModel.set("headPicture", window.patientPhoto.manDefaultUrl);
            }
        }
        //获取待处理角标统计数据
        _getAwaitCount();
    }
    
    var init = function() {
        appcan.window.disableBounce();
        _initModel();
        $(".patientInfo").offset().height;
        $("#itemTop").height($(".patientInfo").offset().height);
    }
    
    var resetHeadPicture = function(value){
    	patientInfoModel.set("headPicture", value);
    }
    
    //退出
    var existClick = function() {
    	if(!!patientInfoModel.get("id")){
		   	appcan.window.alert({
	            title : "提示",
	            content : "确认退出？",
	            buttons :  ['确定', '取消'],
	            callback : function(err, data, dataType, optId) {
	                if(data=="0"){
	        			doLoginOut();
	                }
	            }
	        });
    	}
    }
    
    return {
        init: init,
        initModel: _initModel,
        getAwaitCount: _getAwaitCount,
        resetHeadPicture: resetHeadPicture,
        existClick: existClick
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    myIndex.init();
});








