if(!window.myInfoEditJs){
    window.myInfoEditJs = {};
}

var myInfoEditJs = function() {
	
	var patientInfoModel = new PatientInfoModel();
    var patientInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#myInfoEditContent",
        model: patientInfoModel
    }));
    
    var editType = "";
    var selectType = "";
    var patientId  = "";
    var regionCode = "";
    var formData = new FormData();
    
    //编辑项
    var toEditPage = function(editType,id,event){
        editType = editType;
        var currentText = $(event.currentTarget).find("#"+id).text().trim();
        
        appcan.window.open({
            name : "patient_info_edit",
            data : "patient_info_edit.html?editType=" + editType+"&currentText="+currentText+"&editInputId="+id,
            aniId : "2"
        }); 

       
    }
    
    //选择性别
    var chooseSex = function(event){
        selectType = "SEX";

        var currentText = $(event.currentTarget).find("#sex").text().trim();
        var currentValue = getCodeListValue(window.codeList.genderType,currentText);
        var data = "patient_info_select.html?selectType="+selectType;
        if(currentValue!=null&&currentValue!=""){
            data = data+"&currentValue="+currentValue;
        }
        if(currentText!=null&&currentText!=""){
            data = data+"&currentText="+currentText;
        }
        appcan.window.open({
            name : "patient_relative_select.html",
            data : data ,
            aniId : "2"
        }); 

    }
    
    //出生年月
    $("#birthDateDiv").on("click", function() {
        var _self = this;
        var okCallback = function(date) {
        	var birthdayTimestamp = new Date(date.text).getTime();
        	var currentTimestamp = new Date().getTime()
        	if(birthdayTimestamp > currentTimestamp){
        		clearCallback();
	        	appcan.window.alert({
		            title : "提示",
		            content : "出生年月不能大于当前时间",
		            buttons : '确定'
		        });
		        return;
        	}
            var year = date.y.text+'年';
            var month = date.m.text+'月';
            var day = date.d.text+'日';
            $("[data-bind='text:birthDate']").text(year+month+day);
            var patientData = {"id":patientId};
            patientData.birthDate = date.text;
            updateMyInfo(patientData);
            // _self.picker.dispose();
            // _self.picker = null;
        }
        var clearCallback = function() {
            $("[data-bind='text:birthDate']").text("");
            // _self.picker.dispose();
            // _self.picker = null;
        }
        if(!!_self.picker) {
            _self.picker.show(okCallback, clearCallback);
        } else {
            var options = {"type":"date", "beginYear": 1901};
            _self.picker = new Neusoft.DtPicker(options);
            _self.picker.show(okCallback, clearCallback);
        }
    });
    
    //跳转地区
    var toSelectArea = function(event){
        // appcan.window.open({
            // name : "areaSelect",
            // data : "areaSelect.html?patientId",
            // aniId : "2"
        // }); 

        var _self = this;
        var layer = 3
        if (!!_self.picker) {
            _self.picker.show(function(items) {
                $("#selectAddress").find("[data-bind='text:address']").text(items.fullName);
            });
        } else {
            _self.picker = new Neusoft.DistrictPicker({
                layer : layer
            });
            //console.log(picker);
            //_self.picker.setData(dataList);
            //console.log(dataList);

            _self.picker.show(function(items) {
                //objText.val(text.substr(0, text.length - 1));
                console.log(items);
                var fullName = items.fullName;
                $("#district").text(fullName);
                var regionId = items.id;
                var regionCode = items.regionCode;
                var regionDesc = items.fullName;
                var patientData = {"id":patientId};

                patientData.regionId = regionId;
                patientData.regionCode = regionCode;
                patientData.regionDesc = regionDesc;
                regionCode = regionCode;
                updateMyInfo(patientData);

            }, {regionCode: regionCode});
        }

    } 
    
    //监听选择
    var setSelectData = function(res){
        var patientData = {"id":patientId};
        var selectJson = JSON.parse(res);
        selectType = selectJson.selectType;
        if (selectType == "SEX") {
        	// if(selectJson.selectValue == "WOMAN"){
        		// patientInfoModel.set("headPicture", window.patientPhoto.girlDefaultUrl);
        	// }else{
        		// patientInfoModel.set("headPicture", window.patientPhoto.manDefaultUrl);
        	// }
            $("#sex").text(selectJson.selectText);
            patientData.sex = getCodeListValue(window.codeList.genderType,selectJson.selectText);
            updateMyInfo(patientData);
        } 

    }
    
    //监听编辑项
    var setEditData = function(res){
        var patientData = {"id":patientId};
        var editJson = JSON.parse(res);
        editType = editJson.editType;
        var id = editJson.editInputId;
        $("#"+id).text(editJson.editText);
        if (editType == "NAME") {
            //姓名
            patientData.patientName = editJson.editText;
        } else if (editType == "PHONE") {
            //手机号
            patientData.phoneNum = editJson.editText;
        } else if (editType == "IDENTIFY") {
            //身份证号
            patientData.soSeCard = editJson.editText;
        } else if (editType == "ADDRESS") {
            //详细地址
            patientData.address = editJson.editText;
        } else if (editType == "ALLERGIC") {
            //过敏史
            patientData.isAllergy = editJson.editText;
        }
        updateMyInfo(patientData);
    }
    
    //监听地址
    var setAddress = function(res){
        var patientData = {"id":patientId};
        var addressJson = JSON.parse(res);
        var address = addressJson.selectAddress;
        $("#district").text(address);
        patientData.regionId = addressJson.regionId;
        patientData.regionCode = addressJson.regionCode;
        patientData.regionDesc = addressJson.regionDesc;
        updateMyInfo(patientData);
    }
    
    //更新患者信息
    var updateMyInfo = function(dataJson){
        
        var param = JSON.stringify(dataJson); 
        var updateUrl = window.ajaxOuterUrl+"/updateTPatient";
        $.ajax({
            url : updateUrl,
            type : "POST",
            data : param,
            dataType : "json",
            contentType : "application/json;charset=UTF-8",
            success : function(data) {
            	if(data.result == '0'){
	        		appcan.window.openToast("更新成功", 2000, 5, 0);
	        		getPatientNewInfo();
	        	}else{
			        appcan.window.alert({
			            title : "提示",
			            content : "提交失败，"+res.message,
			            buttons : '确定'
			        });
	        	}
            },
            error : function(e, err) {
                alert("接口失败");
            }
        });
    }
    
    //查询患者信息
    var getPatientNewInfo = function(){
    	var patientParam = JSON.stringify({"id":patientId});
        var url = window.ServerURL + "/getPatientInfo";
        commonJs.requestAjax(url, patientParam, function(res) {
            if (!!res) {
            	appcan.locStorage.remove("localPatient");
            	appcan.locStorage.setVal("localPatient", JSON.stringify(res[0]));
            	appcan.window.evaluatePopoverScript("patientIndexPage", "myIndexContentPage", "myIndex.initModel()");
            } else {
                appcan.window.alert({
                    title : "提示",
                    content : "登录失败，请联系管理员",
                    buttons : '确定',
                    callback : function(err, data, dataType, optId) {
    
                    }
                });
            }
    
        }, function(e, err) {

            appcan.window.alert({
                title : "提示",
                content : "登录失败，请联系管理员",
                buttons : '确定',
                callback : function(err, data, dataType, optId) {
    
                }
            });

        });
    }
    
    var init = function() {
        //查询患者数据
        var patientInfo = commonJs.getPatient();
        patientId = !!patientInfo ? patientInfo.id || "_" : "_";
        //生成诊疗记录

        var param = JSON.stringify({
            "id" : patientId
        });
        var dataUrl = window.ajaxOuterUrl + "/getPatientInfo";
        $.ajax({
            url : dataUrl,
            type : "POST",
            data : param,
            dataType : "json",
            contentType : "application/json;charset=UTF-8",
            success : function(data) {
                if(data.length>0){
                	 patientId = data[0].id;
                     $("#patientName").text(data[0].patientName); 
                     $("#sex").text(getCodeListText(window.codeList.genderType,data[0].sex)); 
                     $("#phoneNum").text(data[0].patientPhone); 
                     $("#idNum").text(data[0].soSeCard); 
                     $("#district").text(data[0].regionDesc); 
                     $("#detailAddress").text(data[0].address); 
                     $("#allergic").text(data[0].isAllergy);
                     if(data[0].headPicture != null && data[0].headPicture != ""){
                     	patientInfoModel.set("headPicture", data[0].headPicture);
                     }else{
                     	patientInfoModel.set("headPicture", window.patientPhoto.manDefaultUrl);
                     }
                     regionCode = data[0].regionCode;
                     var oDate = new Date(data[0].birthDate);
                     var oYear = oDate.getFullYear();
                     var oMonth = oDate.getMonth()+1;
                     var oDay = oDate.getDate();
                     var birthDate = oYear+'年'+oMonth+'月'+oDay+'日';
                     $("[data-bind='text:birthDate']").text(birthDate);
                }else{
                	patientInfoModel.set("headPicture", window.patientPhoto.manDefaultUrl);
                }

            },
            error : function(e, err) {
            	patientInfoModel.set("headPicture", window.patientPhoto.manDefaultUrl);
                alert("接口失败");
            }
        }); 
       appcan.window.subscribe("setSelectData", setSelectData);
       appcan.window.subscribe("setEditData", setEditData);
       appcan.window.subscribe("selectAddress", setAddress);
       
    }
    
    //切换头像  by sushu 2018-10-16
    var headPicChange = function(){
    	//获取点击的文本框
		var file = document.getElementById("fileImage");
		patientInfoModel.set("headPicture", window.URL.createObjectURL(file.files[0]));
		formData.append('id',patientId);
		formData.append('headPicture',file.files[0]);
		sendAjax();
    }
    
    //上传头像发送AJAX请求  by sushu 2018-10-16
	var sendAjax = function () {
	    var url = window.ajaxFormUrl+'/gatewayApp/ws/patient/updatePatientInfo';
	    $.ajax({
	        url: url,
	        type: 'POST',
	        data: formData,
	        async: false,
	        cache: false,
	        contentType: false,
	        processData: false,
	        success: function(res) {
	        	if(JSON.parse(res).result == '0'){
	        		
	        	}else{
			        appcan.window.alert({
			            title : "提示",
			            content : "头像上传失败，"+res.message,
			            buttons : '确定'
			        });
	        	}
	        },
	        error: function(e, err) {
		    	appcan.window.alert({
		            title : "提示",
		            content : "头像上传失败，请联系管理员",
		            buttons : '确定',
		            callback : function(err, data, dataType, optId) {
		
		            }
		        });
	        }
	    });
	}
	
	
	 //相机点击事件
    var photoClick = function(){
    	$("#modeLayer1").show();
    }
    
    //拍照
    var photographClick = function(){
    	$("#modeLayer1").hide();
    	uexCamera.open(0,100);
		uexCamera.cbOpen = function(opCode, dataType, data){
			uploadFileService(data);
		}
    }
    
    //相册选择
    var selectphotoClick = function(){
    	$("#modeLayer1").hide();
    	// uexImage.openPicker(JSON.stringify({"min": 1, "max":1}),function(error,info){
    		// if(error == -1){
				// alert("cancelled!");
			// }else if(error == 0){
				// var imageInfo = JSON.parse(info);
				// uploadFileService(imageInfo.data[0]);
			// }else{
				// alert("error");
			// }
   		// });
   		uexImage.openPicker(JSON.stringify({"min": 1, "max":1}));
   		uexImage.onPickerClosed = function (info){
   			var imageInfo = JSON.parse(info);
   			uploadFileService(imageInfo.data[0]);
   		}
    }
    
    //上传服务器
    var uploadFileService = function(urlString){
		var uploader = uexUploaderMgr.create({
			      url: window.uploadHttp,
			      type: 1
			});
		if(!!!uploader){
		    alert("创建失败!");
		    return;
		}
		var headJson = {
			// "id": "1",
			"id": patientId,
			"pictureName": "headPicture",
			"pictureType": "patient", 
			"patientCode": "adidlslsidkdks"
		};
		var ret = uexUploaderMgr.setHeaders(uploader, JSON.stringify(headJson)); 
		uexUploaderMgr.uploadFile(uploader, urlString, "headPicture", 1, 640,function(packageSize, percent, responseString, status){
		    switch (status) {
		    case 0:
		        document.getElementById('percentage').innerHTML = "上传包大小:"+packageSize+"<br>上传进度:"+percent+"%";
		        break;
		    case 1:
		        appcan.window.openToast("上传成功", 2000, 5, 0);
		        patientInfoModel.set("headPicture", responseString + "?temp=" + Math.random());
        		appcan.window.evaluatePopoverScript("patientIndexPage", "myIndexContentPage", "myIndex.resetHeadPicture" + "('" + responseString + "')")
        		getPatientNewInfo();
		        break;
		    case 2:
		        alert("上传失败");
		        break;
		    }
		});
    }
    
    //取消
    var cancelClick = function(){
    	$("#modeLayer1").hide();
    }
    
    return {
        toEditPage:toEditPage,
        chooseSex:chooseSex,
        toSelectArea:toSelectArea,
        init: init,
        headPicChange: headPicChange, //切换头像
        photoClick: photoClick,
        photographClick: photographClick,
        selectphotoClick: selectphotoClick,
        cancelClick: cancelClick
    }
    
}();


appcan.ready(function() {
    appcan.button("#nav-left", "btn-act", function() {
        appcan.window.close(-1);
        uexWindow.setSlidingWindowEnabled(1);
        uexWindow.setMultilPopoverFlippingEnbaled(1);
    }); 

    myInfoEditJs.init();
});