if(!window.patientIndex){
    window.patientIndex = {};
}

var patientIndex = function() {
    var pageCount = 0, headerHeight=0, outParam, pageParam, openIndex = [];
    var patientInfoModel = new PatientInfoModel();
    var appVersion, currentVersion;
    
    pageParam = _.clone(window.pagingParam);
    
    //声明viewmodel
    var patientInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".patientInfo",
        model: patientInfoModel
    }));

    var patientFooterTab = appcan.tab({
        selector : $("[data-control='TAB']"),
        hasIcon : true,
        hasAnim : false,
        hasLabel : true,
        hasBadge : false,
        index : 0,
        data : [{
            "label" : "首页",
            "icon" : "app-home"
        },
		// {
            // "label" : "信息",
            // "icon" : "app-information"
        // }, {
            // "label" : "一键呼叫",
            // "icon" : "app-one-touch-calling"
        // }, {
            // "label" : "发现",
            // "icon" : "app-discover"
        // }, 
        {
            "label" : "我的",
            "icon" : "app-my"
        }]
    });
    
    var frame = appcan.require('frame');
    //页脚按钮点击事件
    patientFooterTab.on("click", function(obj, index) {
        if (index != 0 && index != 4) {
           // return;
        }
        if(parseInt(currentVersion) !== parseInt(appVersion)){
        	return;
        }
        var openFlag = _.indexOf(openIndex, index) >= 0;
        outParam = "patientId=" + patientInfoModel.get("id");
        switch (index) {
            case 0:
                if (openFlag) {
                	appcan.window.evaluatePopoverScript("patientIndexPage", "homeIndexContentPage", "patientIndexHomeContent.getAwaitCount()");
                    appcan.frame.bringToFront("homeIndexContentPage");
                    return;
                }                
                appcan.frame.open("content", "patient_index_home_content.html?" + outParam, 0, headerHeight, 'homeIndexContentPage');
                break;
            // case 1:
                // if (openFlag) {
                    // appcan.frame.bringToFront("informationIndexContentPage");
                    // return;
                // }
                // appcan.frame.open("content", "patient_index_information_content.html?" + outParam, 0, headerHeight, 'informationIndexContentPage');
                // openIndex.push(index);
                // break;
            // case 2:
                // if (openFlag) {
                    // appcan.frame.bringToFront("oneTouchCallingIndexContentPage");
                    // return;
                // }
                // appcan.frame.open("content", "patient_index_one_touch_calling_content.html?" + outParam, 0, headerHeight, 'oneTouchCallingIndexContentPage');
                // openIndex.push(index);
                // break;
            // case 3:
                // if (openFlag) {
                    // appcan.frame.bringToFront("discoverIndexContentPage");
                    // return;
                // }
                // appcan.frame.open("content", "patient_index_discover_content.html?" + outParam, 0, headerHeight, 'discoverIndexContentPage');
                // openIndex.push(index);
                // break;
            case 1:
                if (openFlag) {
                    //每次切换页面后进入时重新获取角标统计信息
                    appcan.window.evaluatePopoverScript("patientIndexPage", "myIndexContentPage", "myIndex.getAwaitCount()");
                    appcan.frame.bringToFront("myIndexContentPage");
                    return;
                }
                appcan.frame.open("content", "my/my_info_content.html?" + outParam, 0, headerHeight, 'myIndexContentPage');
                openIndex.push(index);
                break;   
            default:
                break;
        }
    });
    
    var toHomePage = function(index) {
        var openFlag = _.indexOf(openIndex, 0) >= 0;
        delete openIndex[_.indexOf(openIndex, index)];
        console.log("toHomePage");
        //设置TAB按钮是否点亮
        $("#patientFooterTab").find(".sc-text-active").removeClass("sc-text-active");
        $("#patientFooterTab").find("[data-index='0']").find(".item.sc-text-tab").addClass("sc-text-active");
        if (openFlag) {
            appcan.frame.bringToFront("homeIndexContentPage");
            appcan.window.evaluatePopoverScript("patientIndexPage", "homeIndexContentPage", "patientIndexHomeContent.initModel()");
            return;
        }                
        appcan.frame.open("content", "patient_index_home_content.html?" + outParam, 0, headerHeight, 'homeIndexContentPage');
    }
    
    var doCheckLogin = function() {
        if (!!!patientInfoModel.get("id")) {
            commonJs.openWindow("loginPage", "login/login.html");
            return false;
        } else {
            return true;
        }
    }
    
    //我的家庭医生
    appcan.button("#Box_gp","btn-act",function(){
        if (!doCheckLogin()) return;
        var patientId = patientInfoModel.get("id");
        var doctorType = "Q";
        appcan.window.open({
            name : "my_doctor",
            data : "finddoctor/my_doctor.html?patientId="+patientId+"&doctorType="+doctorType,
            aniId : "2"
        }); 

    });
    
    //我的专科医生
    appcan.button("#Box_spec","btn-act",function(){
        if (!doCheckLogin()) return;
        var patientId = patientInfoModel.get("id");
        var doctorType = "Z";
        appcan.window.open({
            name : "my_doctor",
            data : "finddoctor/my_doctor.html?patientId="+patientId+"&doctorType="+doctorType,
            aniId : "2"
        });

    });
    
    //找医生
    appcan.button("#Box_my_find_doctor","btn-act",function(){
        if (!doCheckLogin()) return;
        appcan.window.open({
            name : "find_doctor",
            data : "finddoctor/find_doctor.html",
            aniId : "2"
        }); 
    });
    
    var _initModel = function() {
        patientInfoModel.clearData();
        patientInfoModel.set(commonJs.getPatient());
        //初始延迟5秒获取极光推送ID
        setTimeout(function() {
            commonJs.getJpushRegistrationId(patientInfoModel.get("id"), "P");
        }, 5000);
    }
    
    var _exitProgram = function(keyCode) {
        //监听返回键，按返回键时提示退出系统
        if (keyCode === 0) {
            uexWidgetOne.exit();
        }
    }
    
    var init = function() {
    	//获取全部科室
    	// getDepartment();
    	
        appcan.window.disableBounce();
        _initModel();
        //监听物理退出键按钮
        uexWindow.setReportKey(0, 1);
        uexWindow.onKeyPressed = _exitProgram;
        var titHeight = 0;
        var footerHeight = $("[data-control='FOOTER']").offset().height;
        var contentHeight = $("[data-control='PAGE']").offset().height - titHeight - footerHeight;
        //appcan.frame.open("content", "pharmacist_index_content.html?headerHeight=" + titHeight, 0, titHeight, "pharmacistIndexContentPage");
        //appcan.window.subscribe("doctorIndexRefreshState", refreshDoctorState);
        appcan.frame.open("content", "patient_index_home_content.html?" + outParam, 0, 0, 'homeIndexContentPage'); 
        openIndex.push(0);
        window.onorientationchange = window.onresize = function() {
            appcan.frame.resize("content", 0, titHeight);
        }
        uexWindow.evaluateScript({name: "root", type: "0", js: "closeWindow()"});
        //获取服务器版本
        getAppVersion();
        /*
        frame.openMulti({
            popName:'indexContent',
            content:{
                content:[{
                    inPageName:'homeIndexContentPage',
                    inUrl:"patient_index_home_content.html?headerHeight=" + titHeight,
                    inData:''
                 },{
                    inPageName:'informationIndexContentPage',
                    inUrl:"patient_index_information_content.html?headerHeight=" + titHeight,
                    inData:''
                },{
                    inPageName:'oneTouchCallingIndexContentPage',
                    inUrl:"patient_index_one_touch_calling_content.html?headerHeight=" + titHeight,
                    inData:''
                },{
                    inPageName:'discoverIndexContentPage',
                    inUrl:"patient_index_discover_content.html?headerHeight=" + titHeight,
                    inData:''
                },{
                    inPageName:'myIndexContentPage',
                    inUrl:"my/my_info_content.html",
                    inData:''
                }
               ]
            },
            left: 0, 
            top: titHeight,
            height: contentHeight,
            dataType: 0,
            indexSelected: 0
        });
        
        window.onorientationchange = window.onresize = function() {
            frame.resize("content", 0, titHeight);
        }
        */
    }
    
    //科室信息
    var getDepartment = function(){
    	var url = window.ServerURL + "/getDepartment"; 
    	var data = {};
    	data.departmentLevel = '1';
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, function(res){
    		//
    		if(JSON.stringify(res) != "{}" && res[1].length > 0){
    			var departmentList = [];
    			for(var i=0; i<res[1].length; i++){
    				var objData = {};
    				objData.id = res[1][i].id;
    				objData.value = res[1][i].departmentCode;
    				objData.text = res[1][i].fullName;
    				departmentList.push(objData);
    			}
    			appcan.locStorage.setVal("departmentListData", departmentList);
    		}
    	}, function(e, err){
	    	appcan.window.alert({
	            title : "提示",
	            content : "接口调用失败，请联系管理员",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
    	});
    }
    
    //获取服务器版本
    function getAppVersion(){
		var url = window.ServerURL + "/getAppVersion"; 
    	var data = {};
    	data.configKey = 'patientVersion';
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, function(res){
    		appVersion = res;
    		//当前程序版本
    		currentVersion();
    	}, function(e, err){
	    	appcan.window.alert({
	            title : "提示",
	            content : "接口调用失败，请联系管理员",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
    	});
    }
    
    //当前程序版本
    function currentVersion(){
    	uexWidgetOne.getCurrentWidgetInfo();
        uexWidgetOne.cbGetCurrentWidgetInfo = function(opId,dataType,data){
            var json = JSON.parse(data);
            currentVersion = json.version
        }
    }
    
    return {
        init: init,
        toHomePage: toHomePage, //主页跳转
        initModel: _initModel
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    patientIndex.init();
});