if(!window.patientIndexHomeContent){
    window.patientIndexHomeContent = {};
}

var patientIndexHomeContent = function() {
    var pageCount = 0;
    var pageParam;
    var patientInfoModel = new PatientInfoModel();
    patientInfoModel.set("waitPayFeesCount", "");
    patientInfoModel.set("waitEvaluateCount", "");
    patientInfoModel.set("waitTaskCount", "");
    var appVersion, currentVersion;
    
    pageParam = _.clone(window.pagingParam);
    
    //声明viewmodel
    var healthInformationViewModel = new(MVVM.ViewModel.extend({
        el: "#showHealthInformationVeiw",
        collection: new HealthInformationCollection()
    }));
    
    var patientInfoiewModel = new(MVVM.ViewModel.extend({
        el: ".patientInfo",
        model: patientInfoModel
    }));
        
    var getHealthInformationSuccess = function(res) {
        healthInformationViewModel.collection.set(res);
    }

    var getHealthInformations = function() {
       commonService.request(pageParam, {
           url: window.ServerURL + "",
           success: getHealthInformationSuccess
       });    
    }
        
    var initAdvertisingSlider = function() {
        //广告图片轮播
        var slider = appcan.slider({
            selector : '#advertisingSlider',
            aspectRatio:320/1000,
            hasLabel:true,
            index:0,
            auto:5000
        });
        
        var advertisingInfos = [];
        for (var i = 0; i < advertisingInfoTestData.length; i++) {
            if (advertisingInfoTestData[i].sliderFlag === "Y") {
                var advertisingInfo = {};
                advertisingInfo.img = advertisingInfoTestData[i].titlePictureUrl;
                advertisingInfo.label = advertisingInfoTestData[i].synopsis;
                advertisingInfo.rowData = advertisingInfoTestData[i];
                advertisingInfos.push(advertisingInfo);
            }
        }
        slider.set(advertisingInfos);
        
        $("#advertisingSlider").find(".utra.focus.bc-head").css("background-color", "#24bad6");
         $("#advertisingSlider").find(".uinn1.ulev-1.ut-s.label.sc-text-hint").css("background-color", "rgba(0,0,0, 0)");
        // $(document).on('touchmove',function(){
            // return false;
        // });
        slider.on("clickItem", function(index, data){
            console.log(index, data);
        });
    }
    
    
    var doCheckLogin = function() {
    	if(parseInt(currentVersion) !== parseInt(appVersion)){
    		return false;
    	}
        if (!!!patientInfoModel.get("id")) {
            commonJs.openWindow("loginPage", "login/login.html");
            return false;
        } else {
            return true;
        }
    }
        
    
    //签约医生  by sushu 2019-04-04
    appcan.button(".icon.qydoctor-icon", "btn-act", function() {
    	if(!doCheckLogin()) return;
    	var inParam = "patientId=" + patientInfoModel.get("id");
    	inParam += "&doctorType=Q";
        commonJs.openWindow("mySignedDoctorListPage", "finddoctor/my_signed_doctor.html?" + inParam);
    });
    
    //上门服务  by sushu 2019-03-06
    appcan.button(".icon.smdoctor-icon", "btn-act", function() {
    	if(!doCheckLogin()) return;
        commonJs.openWindow("selectItemPage", "roomService/select_item.html?sourceType="+"SMFW");
    });
    
    //预约服务  by sushu 2019-04-04
    appcan.button(".icon.yydoctor-icon", "btn-act", function() {
        commonJs.openWindow("find_doctor", "finddoctor/find_doctor.html");
    });
    
    //远程医疗  by sushu 2019-03-19
    appcan.button(".icon.ycdoctor-icon", "btn-act", function() {
    	if(!doCheckLogin()) return;
        commonJs.openWindow("selectItemPage", "roomService/select_item.html?sourceType="+"YCYL");
    });
    
    //商业保险
    appcan.button(".icon.sydoctor-icon", "btn-act", function() {
        // commonJs.openWindow("doctorLogin", "../../views/demo/pictureUploadTest.html");
    });
    
    //康复指导
    appcan.button(".icon.kfdoctor-icon", "btn-act", function() {
        // commonJs.openWindow("doTest", "../../views/login/test.html");
    });
    
    //我的家庭医生
    appcan.button("#btnGeneralDoctor","btn-act",function(){
        if(!doCheckLogin()) return;
        var patientId = patientInfoModel.get("id");
        var doctorType = "Q";
        appcan.window.open({
            name : "my_doctor",
            data : "finddoctor/my_doctor.html?patientId="+patientId+"&doctorType="+doctorType,
            aniId : "2"
        }); 

    });
    
    //我的专病医生
    appcan.button("#btnSpecialistDoctor","btn-act",function(){
        if(!doCheckLogin()) return;
        var patientId = patientInfoModel.get("id");
        var doctorType = "Z";
        appcan.window.open({
            name : "my_doctor",
            data : "finddoctor/my_doctor.html?patientId="+patientId+"&doctorType="+doctorType,
            aniId : "2"
        }); 

    });
    
    //找医生
    appcan.button(".btnSearchDoctor","btn-act",function(){
    	if(parseInt(currentVersion) !== parseInt(appVersion)){
    		return;
    	}
        appcan.window.open({
            name : "find_doctor",
            data : "finddoctor/find_doctor.html",
            aniId : "2"
        }); 
    });
    
    //患者待处理处件  by sushu 2019-07-05
    appcan.button(".patientInfo .btn", "btn-act", function() {
        if (!doCheckLogin()) return;
        var outParam = "patientId=" + patientInfoModel.get("id");
        switch(this.id) {
            case "waitPayFees":
                //待缴费
                outParam += "&status=0";
                commonJs.openWindow("awaitPaymentOrdersListPage", "diagnosis/awaitPaymentOrders.html?" + outParam);
                break;
            case "waitEvaluate":
                //待评价
                commonJs.openWindow("patientAssessListPage", "diagnosis/patient_assess_list.html?" + outParam);
                break;
            case "waitTask":
                //待诊疗
                commonJs.openWindow("diagnosisUnfinishTreatListPage", "diagnosistreat/diagnosisUnfinishTreatRecord.html?" + outParam);
                break;
            default:
                break;
        }
    }); 
    
    //操作指引
    appcan.button("#operationalGuideline", "btn-act", function() {
        commonJs.openWindow("operationalGuidelinePage", "my/operational_guideline.html");
    });
    
    //代缴费、待评价  by sushu 2019-07-03
    var _getAwaitCount = function() {
        var param = {
            id: patientInfoModel.get("id")
        }
        commonService.request(param, {
            url: window.ServerURL + "/getPatientWaitCountXf",
            success: function(data) {
                if (!!data) {
                    patientInfoModel.set("waitEvaluateCount", data.waitEvaCount);
                    patientInfoModel.set("waitPayFeesCount", data.waitPayCount);
                    patientInfoModel.set("waitTaskCount", data.waitTaskCount);
                    _setAwaitCountStyle();
                }
                
            }
        });
    }
    
    /**
     * 设置统计角标提示信息   by sushu 2019-07-03
     */
    var _setAwaitCountStyle = function() {
        var style = function(target, displayFlag){
            if (target.find(".wait-count.field-nodisplay").length === 0 && !displayFlag) {
                target.find(".wait-count").addClass("field-nodisplay");
                target.find(".wait-count").removeClass("field-display");
            }
            if (target.find(".wait-count.field-display").length === 0 && displayFlag) {
                target.find(".wait-count").addClass("field-display");
                target.find(".wait-count").removeClass("field-nodisplay");
            }
        }
        style($("#waitPayFees"), !!patientInfoModel.get("waitPayFeesCount"));
        style($("#waitEvaluate"), !!patientInfoModel.get("waitEvaluateCount"));
        style($("#waitTask"), !!patientInfoModel.get("waitTaskCount"));
    }
    
    var _initModel = function() {
        patientInfoModel.clearData();
        patientInfoModel.set(commonJs.getPatient());
        //获取待处理角标统计数据  by sushu 2019-07-03
        _getAwaitCount();
    }
    
    var init = function() {
        // appcan.window.disableBounce();
        commonJs.listWindowBounce(_getAwaitCount);
        _initModel();
        //广告轮播注释掉  by sushu 2019-07-03
        //initAdvertisingSlider();
        // getHealthInformationSuccess(healthInformationTestData);
        //获取服务器版本
        getAppVersion();
        //滚动提示
        //initMessageSlider();
        initMessageScroll();
    }
    
    //logo点击事件
    var logoClick = function(){
    	if(parseInt(currentVersion) !== parseInt(appVersion)){
    		return;
    	}
    	appcan.window.open({
            name : "operateInstructionsPage",
            data : "my/operate_instructions.html",
            aniId : "2"
        }); 
    }
    
	//获取服务器版本
    function getAppVersion(){
		var url = window.ServerURL + "/getAppVersion"; 
    	var data = {};
    	data.configKey = 'patientVersion';
        var param = JSON.stringify(data);
    	commonJs.requestAjax(url, param, function(res){
    		appVersion = res;
    		//当前程序版本
    		currentVersion();
    	}, function(e, err){
	    	appcan.window.alert({
	            title : "提示",
	            content : "接口调用失败，请联系管理员",
	            buttons : '确定',
	            callback : function(err, data, dataType, optId) {
	
	            }
	        });
    	});
    }
    
    //当前程序版本
    function currentVersion(){
    	uexWidgetOne.getCurrentWidgetInfo();
        uexWidgetOne.cbGetCurrentWidgetInfo = function(opId,dataType,data){
            var json = JSON.parse(data);
            currentVersion = json.version
            if(parseInt(currentVersion) !== parseInt(appVersion)){
                uexWindow.confirm({
	                     title:"提示",
	                     message:"当前app有新版本，请先更新",
	                     buttonLabels:"确定"
	                },function(index){
	                    if (Number(index) === 0) {
	                    	downApp();
	                    }
	            });
            }
        }
    }
    
    //下载程序
    function downApp(){
        var serverURL = "http://42.202.135.42:9999/sjarapk/patient/patient.apk";
        var savePath = "wgt://" + "patient.apk";
        uexDownloaderMgr.createDownloader(1);
        uexDownloaderMgr.cbCreateDownloader = function(opId, dataType, data) {
            if(data == 0) {
                uexDownloaderMgr.download(1,serverURL, savePath, '0');//开始下载apk文件
            }
        };
        uexDownloaderMgr.onStatus=function(opId, fileSize, percent, status) {
            if(status == 0) {
                //下载中...
                uexWindow.toast('1','5', '下载进度：' + percent + '%', '');
            }
            else if (status == 1) {// 下载完成.
                uexWindow.toast('1','5', '下载进度：100%', '');
                uexWindow.closeToast();
                uexDownloaderMgr.closeDownloader(1);//关闭下载对象

                var apkFilePath = savePath;

                uexFileMgr.isFileExistByPath(1,apkFilePath);//先判断下载好的apk是否存在
                //检查是否已经存在sd卡的回调函数（step:3）
                uexFileMgr.cbIsFileExistByPath = function(opId, dataType, data) {
                    if (data == 1) {
                        uexWidget.installApp(apkFilePath);//安装下载apk文件
                    }
                };

            }
            else {
                uexDownloaderMgr.closeDownloader(1);//关闭下载对象
            }
         };
    }
    
    //滚动提示
    var initMessageSlider = function() {
        //化验报告图片轮播
        var messageSlider = appcan.slider({
            selector : '#messageSlider',
            // aspectRatio: 1/13,
            hasContent:true,
            hasIndicator:true,
            index: 0,
            auto: 3000
        });

        //展示报告说明
        messageSlider.set([{
        	note:'众志成城，战胜疫情！您的处方稍后将由'
        },{
        	note:'智慧药房与您联系并可送药上门，敬请等待！'
        }])
        //assayReport.note = "众志成城，战胜疫情！您的处方稍后将由智慧药房与您联系并可送药上门，敬请等待！"; //描述
        
        $("#messageSlider").find(".slider-group").css("text-align", "center");
        $("#messageSlider").find(".slider-group").css("font-size", "1.1em");
        $("#messageSlider").find(".slider-group").css("color", "#FF0000");
        $("#messageSlider").find(".slider-group").css("margin", "0.5em 0");
    }
    
    var initMessageScroll = function(){
    	var speed=10;
  		var MyMar = null;
 		var scroll_begin = document.getElementById("scroll_begin"); 
 		var scroll_end = document.getElementById("scroll_end"); 
 		var scroll_div = document.getElementById("scroll_div"); 
 		scroll_end.innerHTML=scroll_begin.innerHTML;
 		var Marquee = function(){
	 		if(scroll_end.offsetWidth-scroll_div.scrollLeft<=0){
	 			scroll_div.scrollLeft-=scroll_begin.offsetWidth;
	 		}else{
	 			scroll_div.scrollLeft++;
	 		}
 		}
 		MyMar=setInterval(Marquee,speed);
    }
    
    return {
        init: init,
        initModel: _initModel,
        getAwaitCount: _getAwaitCount,
        logoClick: logoClick
    }
    
}();

appcan.ready(function() {
    appcan.initBounce();
    patientIndexHomeContent.init();
});








