if(!window.orgServiceListContentJs){
	window.orgServiceListContentJs = {}
}
var orgServiceListContentJs = function() {
	var pageCount = 0;
    var pageParam, itemInfos, forwardType, organizationInfo, sourceType;//来源类型，判断上门服务、远程医疗
    pageParam = _.clone(window.pagingParam);
	
	//返回上一页面
	appcan.button(".nav-btn", "btn-act", function() {
		appcan.window.close(-1);
	});
	
	//声明viewmodel
    var ViewModel = new(MVVM.ViewModel.extend({
        el: "#orgServiceListContentView",
        collection: new UpdoorInfoCollection()
    }))();
	
    var init = function() {
    	pageCount = 0
    	//机构信息
    	organizationInfo = commonJs.getOrganization();
    	var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        if(inParam!=null&&typeof(inParam)!='undefined'){
        	//首页、我的展示列表，查询状态不同
            forwardType = inParam.forwardType;
            sourceType = inParam.sourceType
            if(forwardType == "Home"){
            	//已提交、已缴费、已确认
            	pageParam.status = "YTJ,YJF,YQR";
            }else if(forwardType == "My"){
            }
        }
        pageParam.tastMechanismId = organizationInfo.id;
    	//设置弹动事件
        commonJs.listWindowBounce(loadSelectList);
        loadSelectList();
        //获取项目信息
        getTServiceItems();
        //加载状态下拉条件
        prescriptionStatusSelect();
    }
    
    //下拉更新
    var loadSelectList = function() {
        pageCount++;
        pageParam.pageIndex = pageCount;
        if(sourceType == "SMFW"){
        	pageParam.forwardType = "SMFW";
        }else if(sourceType == "YCYL"){
        	pageParam.forwardType = "YCYL";
        }
        commonService.request(pageParam, {
            url: window.ServerURL + "/getTUpdoorInfo",
            success: function(res) {
                if (pageCount === 1) {
                    ViewModel.collection.set(res);
                } else {
                    ViewModel.collection.add(res);
                }
            }
        });
    }
    
    //获取项目信息
    var getTServiceItems = function(){
    	var dataParam = {};
    	if(sourceType == "SMFW"){
    		dataParam.itemTypeCode = "SMFW";
    	}else if(sourceType == "YCYL"){
    		dataParam.itemTypeCode = "YCYL";
    	}
        commonService.request(dataParam, {
            url: window.ServerURL + "/getTServiceItems",
            success: function(res) {
            	itemInfos = res;
		        //加载项目下拉条件
		        prescriptionItemSelect();
            }
        });
    }
    
    //项目下拉加载
    var prescriptionItemSelect = function(){
        var prescriptionItemSelect = appcan.selectview({
            selector : "#prescriptionItemSelect"
        });
        var prescriptionItem = [{id: "999999", value: "ALL", text: "全部"}];
        for (var i in itemInfos) {
        	var item = {};
        	item.id = itemInfos[i].id;
        	item.value = itemInfos[i].itemCode;
        	item.text = itemInfos[i].itemName;
        	prescriptionItem.push(item);
        }
        prescriptionItemSelect.set(prescriptionItem);
        prescriptionItemSelect.on("select:click", function(obj, data) {
            //console.log(data);
            var serverItemId = data[0].value === "ALL" ? "" : data[0].id;
            pageParam.serverItemId = serverItemId;
            if (data[0].value === "ALL") {
                 $("#serverItemId").find("span").text("项目");
            } else {
                $("#serverItemId").find("span").text(data[0].text);
            }            
            hidenSelector();
            setScollbar("enable");

            pageCount = 0;
            
            loadSelectList();
        });
    }
    
    //项目控件
    $("#serverItemId").on("tap", function(event) {

        if (!!!checkOpenFilter(event.currentTarget))
            return;
        event.cancelBubble = true;
        if ($(event.currentTarget).find("div[class='list-caret-size list-caret-down']").length > 0) {
            var maskTop = Number($("#divFilterItem").offset().height) + Number($("#divFilterItem").offset().top) - 2;
            $("#prescriptionItemSelect").css("top", maskTop + "px");
            $("#prescriptionItemSelect").addClass("mask-show");
            $(event.currentTarget).find(".list-caret-size").removeClass("list-caret-down");
            $(event.currentTarget).find(".list-caret-size").addClass("list-caret-up-select");
            $(event.currentTarget).addClass("filter-select-color");
            setScollbar("disable");
        } else {
            hidenSelector();
            setScollbar("enable");
        }
    });
    
    //状态下拉加载
    var prescriptionStatusSelect = function(){
        
        var prescriptionStatusSelect = appcan.selectview({
            selector : "#prescriptionStatusSelect"
        });
        var prescriptionStatus = [{id: "999999", value: "ALL", text: "全部"}];
        for (var i in window.codeList.updoorStatus) {
        	//根据展示来源页面不同，显示状态不同
        	if(forwardType == "Home"){
            	//已提交、已缴费、已确认
	            if (window.codeList.updoorStatus[i].value === "YTJ" || window.codeList.updoorStatus[i].value === "YJF" 
	              || window.codeList.updoorStatus[i].value === "YQR") {
	                prescriptionStatus.push(window.codeList.updoorStatus[i]);
	            }
            }else if(forwardType == "My"){
            	prescriptionStatus.push(window.codeList.updoorStatus[i]);
            }
        }
        prescriptionStatusSelect.set(prescriptionStatus);
        prescriptionStatusSelect.on("select:click", function(obj, data) {
            //console.log(data);
            var status = data[0].value === "ALL" ? "" : data[0].value;
            pageParam.status = status;
            if (data[0].value === "ALL") {
                 $("#status").find("span").text("状态");
            } else {
                $("#status").find("span").text(data[0].text);
            }            
            hidenSelector();
            setScollbar("enable");

            pageCount = 0;
            
            loadSelectList();
        });
    }
    
    //状态控件
    $("#status").on("tap", function(event) {

        if (!!!checkOpenFilter(event.currentTarget))
            return;
        event.cancelBubble = true;
        if ($(event.currentTarget).find("div[class='list-caret-size list-caret-down']").length > 0) {
            var maskTop = Number($("#divFilterItem").offset().height) + Number($("#divFilterItem").offset().top) - 2;
            $("#prescriptionStatusSelect").css("top", maskTop + "px");
            $("#prescriptionStatusSelect").addClass("mask-show");
            $(event.currentTarget).find(".list-caret-size").removeClass("list-caret-down");
            $(event.currentTarget).find(".list-caret-size").addClass("list-caret-up-select");
            $(event.currentTarget).addClass("filter-select-color");
            setScollbar("disable");
        } else {
            hidenSelector();
            setScollbar("enable");
        }
    });
    
    var checkOpenFilter = function(target) {
        if ($(target.parentElement).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
            //组件自身选中时，返回true
            if ($(target).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
                return true;
            } else {
                return false;
            }
        }
        return true;
    }
    
    //时间控件
    $("#createDate").on("tap", function(event) {
        hidenSelector();
        setScollbar("enable");
        var _self = this;
        var datePickerCallback = function(date) {
            pageParam.createDate = date.text;
            $("#createDate").find("span").text(date.text);
            pageCount = 0;
            loadSelectList();
            _self.payTimepicker.dispose();
            _self.payTimepicker = null;
        }
        var clearPickerCallback = function() {
            $("#createDate").find("span").text("提交日期");
            if (!!pageParam.createDate) {
                delete pageParam.createDate;
            }
            pageCount = 0;
            loadSelectList();
            _self.payTimepicker.dispose();
            _self.payTimepicker = null;
        }
        if(_self.payTimepicker) {
            _self.payTimepicker.show(datePickerCallback, clearPickerCallback);
            //appcan.window.enableBounce();
        } else {
            //var optionsJson = this.getAttribute('data-options') || '{}';
            var options = {"type":"date", bounceState: 1};
           //var id = this.getAttribute('id');
            /*
             * 首次显示时实例化组件
             * 示例为了简洁，将 options 放在了按钮的 dom 上
             * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
             */
            _self.payTimepicker = new Neusoft.DtPicker(options);
            _self.payTimepicker.show(datePickerCallback, clearPickerCallback);
            //appcan.window.enableBounce();
        }
    });
    
    //隐藏下拉
    var hidenSelector = function(hidenFlag) {
        //使用延迟设置,避免连续点击问题
        setTimeout(function() {
            //项目、状态
            $("#serverItemId").find(".list-caret-size").addClass("list-caret-down");
            $("#serverItemId").find(".list-caret-size").removeClass("list-caret-up-select");
            $("#serverItemId").removeClass("filter-select-color");
            $("#status").find(".list-caret-size").addClass("list-caret-down");
            $("#status").find(".list-caret-size").removeClass("list-caret-up-select");
            $("#status").removeClass("filter-select-color");
            $("#prescriptionItemSelect").removeClass("mask-show");
            $("#prescriptionStatusSelect").removeClass("mask-show");
        }, 100);
    }
    
    var setScollbar = function(operate) {
        if (operate === "disable") {
            appcan.window.disableBounce();
            //禁止默认行为方法，防止滚动条滚动
            $(document).on("mousewheel", function(evt) {
                evt.preventDefault();
            }, false);
            $(document).on("touchmove", function(evt) {
                evt.preventDefault();
            });
        } else if (operate === "enable") {
            //检查默认行为方法是否禁用，禁用了则重新启用
            appcan.window.enableBounce();
            $(document).on("touchmove", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            });
            $(document).on("mousewheel", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            }, false);
        }
    }
    
    //详细页
    var serviceDetailClick = function(event){
    	var serviceId = $(event.currentTarget).find("#id").text().trim();
    	var status = $(event.currentTarget).find("#status").text().trim();
    	var param = "serviceId="+serviceId+"&sourceType="+sourceType;
	    if(forwardType == "Home"){
        	//已提交、已缴费、已确认
        	if(status == "YTJ"){
        		commonJs.openWindow("orgConfirmPage", "org_confirm.html?"+param);
        	}else if(status == "YJF"){
        		commonJs.openWindow("serviceCompletePage", "service_complete.html?"+param);
        	}else{
        		commonJs.openWindow("orgServiceDetailPage", "org_service_detail.html?"+param);
        	}
        }else if(forwardType == "My"){
        	commonJs.openWindow("orgServiceDetailPage", "org_service_detail.html?"+param);
        }
    }
    
    //搜索事件
    var searchClick = function(){
    	pageCount = 0;
    	pageParam.extend1 = $("#patientSearch").val().trim();
    	loadSelectList();
    }
    
    //重新加载
    var reload = function(){
    	pageCount = 0;
    	loadSelectList();
    }
    
    return {
        init: init,
        serviceDetailClick: serviceDetailClick,
        searchClick: searchClick,
        reload: reload
    }
}();


appcan.ready(function() {
    orgServiceListContentJs.init();
});