if(!window.selectOrgContentJs){
	window.selectOrgContentJs = {}
}
var selectOrgContentJs = function() {
	var itemId, sourceType; //项目ID  来源类型，判断上门服务、远程医疗
	var orgInfos = [];
	var num = 1;
	var patientInfo;
    
	//返回上一页面
	appcan.button(".nav-btn", "btn-act", function() {
		appcan.window.close(-1);
	});
	
	//声明viewmodel
	var vMechanismServiceRelModel = new VMechanismServiceRelModel();
    var vMechanismServiceRelViewModel = new (MVVM.ViewModel.extend({
        el: ".selectOrgInfoView",
        model: vMechanismServiceRelModel
    }));
    
    var upDoorInfolModel = new UpdoorInfoModel();
    var upDoorInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".patientAddressInfoView",
        model: upDoorInfolModel
    }));
	
    var init = function() {
    	//患者信息
    	patientInfo = commonJs.getPatient();
        var inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        if(inParam!=null&&typeof(inParam)!='undefined'){
            itemId = inParam.id;
            sourceType = inParam.sourceType
            var itemName = inParam.itemName;
            $("#itemName").text(itemName);
        }
        //根据服务项目查询机构
		getTServiceMechanismInfo();
		//获取患者地址信息
		getPatientAddressInfo();
    }
    
    //获取机构信息
    var getTServiceMechanismInfo = function(){
    	var url = window.ServerURL + "/getTServiceMechanism"; 
    	var data = {};
    	data.pageIndex = 1;
    	data.pageSize = 10;
    	data.id = itemId;
        var param = JSON.stringify(data);
        commonJs.requestAjax(url, param, function(res) {
       		if(res.length > 0){
       			for(var i=0; i<res.length; i++){
       				var orgItem = {};
       				orgItem = _.clone(res[i]);
       				orgItem.id = res[i].mechanismId;
       				orgItem.value = res[i].mechanismCode;
       				orgItem.text = res[i].mechanismName;
       				orgInfos.push(orgItem)
       			}
		        //机构选择事件
		        orgClick();
       		}else{
	       		appcan.window.alert({
	                title : "提示",
	                content : "当前所选择的项目没有对应的机构信息",
	                buttons : '确定',
	                callback : function(err, data, dataType, optId) {
	
	                }
	            });
       		}

        }, function(e, err) {

            appcan.window.alert({
                title : "提示",
                content : "接口失败",
                buttons : '确定',
                callback : function(err, data, dataType, optId) {

                }
            }); 

        });
    }
    
    //获取患者地址信息
    var getPatientAddressInfo = function(){
    	var dataParam = {};
    	dataParam.patientId = patientInfo.id;
    	commonService.request(dataParam, {
            url: window.ServerURL + "/getTPatientAddress",
            success: function(res) {
            	var patientAddressFlag = false;
            	for(var i=0; i<res.length; i++){
            		if(res[i].isDefault == "Y"){
            			patientAddressFlag = true;
            			upDoorInfolModel.set(res[i]);
            			upDoorInfolModel.set("addressId", res[i].id);
            		}
            	}
            	if(patientAddressFlag == false && res.length > 0){
            		upDoorInfolModel.set(res[0]);
            		upDoorInfolModel.set("addressId", res[0].id);
            	}
            }
        });
    }
    
    //机构点击事件
    var orgClick = function() {
        var _self = this;
        var layer = 1;
        if (_self.org) {
            _self.org.show(function(items) {
                // doctorInfoModel.set("sex", items[layer - 1].value);
            });
        } else {
            _self.org = new Neusoft.PopPicker({
                layer: layer
            });
            _self.org.setData(orgInfos);
            _self.org.show(function(items) {
            	vMechanismServiceRelModel.set("mechanismId", items[0].id);
            	vMechanismServiceRelModel.set("itemName", items[0].itemName);
            	vMechanismServiceRelModel.set("mechanismName", items[0].mechanismName);
            	vMechanismServiceRelModel.set("address", items[0].address);
            	vMechanismServiceRelModel.set("countryPrice", items[0].countryPrice);
            	var totalPrice = "￥"+ vMechanismServiceRelModel.get("countryPrice");
        		$("#totalPrice").text(totalPrice);
                // _self.sex.dispose();
                // _self.sex = null;
            });
        }

    }
    
    //减少服务次数
    var subtractDrugNum = function(event) {
        if (Number($(event.currentTarget.parentElement).find("input").val()) === 1) {
            return;
        }
        if (!!!$(event.currentTarget.parentElement).find("input").val().trim() || 
            Number($(event.currentTarget.parentElement).find("input").val()) <= 0) {
            num = 1;   
        } else {
            num = Number($(event.currentTarget.parentElement).find("input").val()) - 1;
        }
        $(event.currentTarget.parentElement).find("input").val(num).change();
        var totalPrice = "￥"+ num*vMechanismServiceRelModel.get("countryPrice");
        $("#totalPrice").text(totalPrice);
    }
    
    //增加服务次数
    var addDrugNum = function(event) {
        num = Number($(event.currentTarget.parentElement).find("input").val()) + 1;
        $(event.currentTarget.parentElement).find("input").val(num).change();
        var totalPrice = "￥"+ num*vMechanismServiceRelModel.get("countryPrice");
        $("#totalPrice").text(totalPrice);
    }
    
    //确定点击事件
    var submitClick = function(){
    	var patientId = !!patientInfo ? patientInfo.id || "_" : "_";
    	var forwardExplain = $("#forwardExplain").val();
    	var url = window.ServerURL + "/addTUpdoorInfo"; 
    	var data = {};
    	if(sourceType == "SMFW"){
    		data.forwardType = "SMFW";
    	}else if(sourceType == "YCYL"){
    		data.forwardType = "YCYL";
    	}
    	data.patientId = patientId;
    	data.tastMechanismId = vMechanismServiceRelModel.get("mechanismId");
    	data.serverItemId = itemId;
    	data.tastCount = num;
    	data.forwardExplain = forwardExplain;
    	data.addressId = upDoorInfolModel.get("addressId");
        var param = JSON.stringify(data);
        commonJs.requestAjax(url, param, function(res) {
       		if(res.result == "0"){
       			var inParam = "patientId=" + patientId + "&sourceType="+sourceType;
       			commonJs.openWindow("patientServiceListPage", "../roomService/patient_service_list.html?" + inParam);
				appcan.window.openToast("提交成功！", 2000, 5, 0);
       		}else{
	       		appcan.window.alert({
	                title : "提示",
	                content : "接口失败,"+res.message,
	                buttons : '确定',
	                callback : function(err, data, dataType, optId) {
	
	                }
	            });
       		}

        }, function(e, err) {

            appcan.window.alert({
                title : "提示",
                content : "接口失败",
                buttons : '确定',
                callback : function(err, data, dataType, optId) {

                }
            }); 

        });
    }
    
    //患者地址点击事件
    var getPatientAddressClick = function(){
		appcan.window.open({
            name: 'patientAddressListPage',
            dataType: 0,
            aniId: 2,
            data: 'patient_address_list.html?id='+patientInfo.id
        })
    }
    
    //加载选择的患者地址
    var reloadPatientAddress = function(itemInfo){
    	upDoorInfolModel.set(itemInfo);
    	upDoorInfolModel.set("addressId", itemInfo.id);
    }
    
    return {
        init: init,
        orgClick: orgClick,
        subtractDrugNum: subtractDrugNum,
        addDrugNum: addDrugNum,
        submitClick: submitClick,
        getPatientAddressClick: getPatientAddressClick,
        reloadPatientAddress: reloadPatientAddress
    }
}();


appcan.ready(function() {
    selectOrgContentJs.init();
});