if(!window.auditPharmacistIndex){
    window.auditPharmacistIndex = {};
}

var auditPharmacistIndex = function() {
    var pageCount = 0, headerHeight, queryHeight, contentHeight, outParam, pageParam, openIndex = [];
    var apothecaryInfoModel = new ApothecaryInfoModel();
    
    pageParam = _.clone(window.pagingParam);
    
    //声明viewmodel
    var apothecaryInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".apothecaryInfo",
        model: apothecaryInfoModel
    }));
    
    var recipeInfoViewModel = new(MVVM.ViewModel.extend({
        el: "#showRecipeInfoView",
        collection: new RecipeInfoCollection()
    })); 
    
    //加载详细页
    var loadRecipeInfoDetail = function(event){
        var id = $(event.currentTarget).find("[data-bind='text:id']").text().trim(); 
        appcan.window.open({
            name: "apothecaryPrescribePage",
            dataType: 0,
            aniId: 2,
            data: "chomedicine/apothecaryPrescribe.html?id=" + id
        });
    }

    //查询处方历史
    appcan.button("#historyPrescription", "btn-act", function() {
        /*
        if(!!pageParam.tRecipeInfo.recipeCode) {
            delete pageParam.tRecipeInfo.recipeCode;
        }
        pageCount = 0;
        //loadRecipeInfo();
        appcan.window.publish("auditPharmacistIndexHomeSearchRecipeInfo", JSON.stringify({"id": "id"}));
        */
        
        appcan.window.open({
            name: "historicalPrescriptionPage",
            dataType: 0,
            aniId: 2,
            data: "historicalPrescription/historicalPrescription.html"
        });
    });
    
    var searchRecipeInfo = function(recipeCode) {
        appcan.window.evaluatePopoverScript("auditPharmacistIndex", "homeIndexContentPage", "auditPharmacistIndexHomeContent.searchRecipeInfo(" + JSON.stringify({"recipeCode": recipeCode}) + ")");
        //appcan.window.publish("auditPharmacistIndexHomeSearchRecipeInfo", JSON.stringify({"recipeCode": recipeCode}));
    }
    
    appcan.button("#btnSearch", "btn-act", function(event) {
        var recipeCode = $(event.currentTarget).parent().find("[data-control='TEXT']").val().trim();
        if(!!!recipeCode) {
            appcan.window.openToast("请输入处方单号", 2000, 5, 0);
            return;
        }
        searchRecipeInfo(recipeCode);
    });

    var auditPharmacistFooterTab = appcan.tab({
        selector : $("#auditPharmacistFooterTab"),
        hasIcon : true,
        hasAnim : false,
        hasLabel : true,
        hasBadge : false,
        index : 0,
        data : [{
            "label" : "首页",
            "icon" : "app-home"
        }, {
            "label" : "信息",
            "icon" : "app-information"
        }, {
            "label" : "工作室",
            "icon" : "app-office"
        }, {
            "label" : "发现",
            "icon" : "app-discover"
        }, {
            "label" : "我的",
            "icon" : "app-my"
        }]
    });
    
    var frame = appcan.require('frame');
    //页脚按钮点击事件
    auditPharmacistFooterTab.on("click", function(obj, index) {
        if (index != 0 && index != 4) {
           return;
        }
        var openFlag = _.indexOf(openIndex, index) >= 0;
        _setHeader(index);
        switch (index) {
            case 0:
                if (openFlag) {
                    appcan.frame.bringToFront("homeIndexContentPage");
                    return;
                }                
                appcan.frame.open("content", "audit_pharmacist_index_home_content.html?" + outParam, 0, headerHeight, 'homeIndexContentPage');
                break;
            case 1:
                if (openFlag) {
                    appcan.frame.bringToFront("informationIndexContentPage");
                    return;
                }
                appcan.frame.open("content", "audit_pharmacist_index_information_content.html?" + outParam, 0, headerHeight - queryHeight, 'informationIndexContentPage');
                openIndex.push(index);
                break;
            case 2:
                if (openFlag) {
                    appcan.frame.bringToFront("officeIndexContentPage");
                    return;
                }
                appcan.frame.open("content", "audit_pharmacist_index_office_content.html?" + outParam, 0, headerHeight - queryHeight, 'officeIndexContentPage');
                openIndex.push(index);
                break;
            case 3:
                if (openFlag) {
                    appcan.frame.bringToFront("discoverIndexContentPage");
                    return;
                }
                appcan.frame.open("content", "audit_pharmacist_index_discover_content.html?" + outParam, 0, headerHeight - queryHeight, 'discoverIndexContentPage');
                openIndex.push(index);
                break;
            case 4:
                if (openFlag) {
                    appcan.window.resizePopover("myIndexContentPage", 0, headerHeight - queryHeight, $("[data-control='PAGE']").offset().width, contentHeight + queryHeight);
                    appcan.frame.bringToFront("myIndexContentPage");
                    return;
                }
                appcan.frame.open("content", "audit_pharmacist_my_info.html?" + outParam, 0, headerHeight - queryHeight, 'myIndexContentPage');
                openIndex.push(index);
                break;   
            default:
                break;
        }
    });
    // auditPharmacistFooterTab.on("click", function(obj, index) {
       // frame.selectMulti("indexContent", index);
    // });
    
    //打开相机扫描二维码
    appcan.button("#scanQRcode", "btn-act", function() {
        uexScanner.open(scannerSuccess);    
    });
    
    /**
     * 
     * @param {Object} status 回调函数状态值： 0-调用相机并打开成功   1-失败
     * @param {Object} data
     */
    var scannerSuccess = function(status, data) {
        switch(status) {
        case 0:
            $("[data-control='TEXT']").val(data.code);
            var param = {};
            param.tRecipeInfo = {};
            param.tRecipeInfo.recipeCode = data.code;
            param.tRecipeInfo.extend1 = "N";
            param.tRecipeInfo.apothecaryId = apothecaryInfoModel.get("id");
            commonService.request(param, {
                url: window.ServerURL + "/getTRecipeInfoHeadXf",
                success: function(res) {
                    if (res.length > 0) {
                        appcan.window.open({
                            name: "apothecaryPrescribePage",
                            dataType: 0,
                            aniId: 2,
                            data: "chomedicine/apothecaryPrescribe.html?recipeCode=" + data.code
                        });
                        searchRecipeInfo(data.code);
                    } else {
                        appcan.window.openToast("未查询到取药处方", 2000, 50, 0);
                    }
                }
            });
            
            break;
        case 1:
            appcan.window.alert("", "打开相机失败，请检查是否已授权");
            break;
        default:
            break;
        }
    }
    
    appcan.button("#doLogin", "btn-act", function() {
        if (!commonJs.checkPharmacistLogin()) return;
    });   
    
    var _setHeader = function(tabIndex) {
        if (!!!apothecaryInfoModel.get("id")){
            apothecaryInfoModel.set("headPicture", window.doctorPhoto.unLoginDefaultUrl);
            $(".user-photo").css("background-color", "#e4e4e4");
            $(".isLoginOut.field-nodisplay").addClass("field-display");
            $(".isLoginOut.field-nodisplay").removeClass("field-nodisplay");
            $(".isLogin.field-display").addClass("field-nodisplay");
            $(".isLogin.field-display").removeClass("field-display");
        } else {
            $(".user-photo").css("background-color", "#09b1d2");
            $(".isLoginOut.field-display").addClass("field-nodisplay");
            $(".isLoginOut.field-display").removeClass("field-display");
            $(".isLogin.field-nodisplay").addClass("field-display");
            $(".isLogin.field-nodisplay").removeClass("field-nodisplay");
        }
        var style = function(target, displayFlag) {
            if (displayFlag) {
                target.removeClass("field-nodisplay");
                target.addClass("field-display");
            } else {
                target.removeClass("field-display");
                target.addClass("field-nodisplay");
            }
        }
        tabIndex = tabIndex || "0";
        if (!!tabIndex) {
            style($(".queryDiv"), "0" === tabIndex);
            style($("#scanQRcode"), "0" === tabIndex);
            style($("#historyPrescription"), "0" === tabIndex);
            //每次切换时，如果切换到首页，则把其它的页面重置位置信息
            for (var i in openIndex) {
                if (openIndex[i] === 4 && tabIndex === "0") {
                    appcan.window.resizePopover("myIndexContentPage", 0, headerHeight, $("[data-control='PAGE']").offset().width, contentHeight);
                }
            }
        }
    }
    
    var toHomePage = function(index) {
        var openFlag = _.indexOf(openIndex, 0) >= 0;
        delete openIndex[_.indexOf(openIndex, index)];
        //设置TAB按钮是否点亮
        $("#auditPharmacistFooterTab").find(".sc-text-active").removeClass("sc-text-active");
        $("#auditPharmacistFooterTab").find("[data-index='0']").find(".item.sc-text-tab").addClass("sc-text-active");
        //初始化数据，设置各项显示信息
        _initModel();
        if (openFlag) {
            appcan.frame.bringToFront("homeIndexContentPage");
            appcan.window.evaluatePopoverScript("auditPharmacistIndex", "homeIndexContentPage", "auditPharmacistIndexHomeContent.initModel()");
            return;
        }                
        appcan.frame.open("content", "audit_pharmacist_index_home_content.html?" + outParam, 0, headerHeight, 'homeIndexContentPage');
    }
    //清除已录入单号查询条件
    var _clearSearch = function() {
        $("#btnSearch").parent().find("[data-control='TEXT']").val("");
    }
    
    var _initModel = function() {
        apothecaryInfoModel.clearData();
        apothecaryInfoModel.set(commonJs.getApothecary("YS"));
        pageParam.tRecipeInfo = {};
        pageParam.tRecipeInfo.apothecaryId = apothecaryInfoModel.get("id");
        _setHeader();
        //初始延迟5秒获取极光推送ID
        setTimeout(function() {
            commonJs.getJpushRegistrationId(apothecaryInfoModel.get("id"), "A");
        }, 5000);
    }
    
    var _exitProgram = function(keyCode) {
        //监听返回键，按返回键时提示退出系统
        if (keyCode === 0) {
            uexWidgetOne.exit();
        }
    }
    
    var init = function() {
        _initModel();
        //监听物理退出键按钮
        uexWindow.setReportKey(0, 1);
        uexWindow.onKeyPressed = _exitProgram;
        //设置弹动事件
        //commonJs.listWindowBounce(loadPrescriptionList);
        //ViewModel.collection.fetch({selfViewModel: ViewModel, param: pageParam});
        headerHeight = $('.doctor-index').offset().height + 2;
        queryHeight = $(".queryDiv").offset().height;
        var footerHeight = $('[data-control="FOOTER"').offset().height;
        contentHeight = $("[data-control='PAGE']").offset().height - headerHeight - footerHeight;
        appcan.frame.open("content", "audit_pharmacist_index_home_content.html?headerHeight=" + headerHeight, 0, headerHeight, 'homeIndexContentPage'); 
        openIndex.push(0);
        uexWindow.evaluateScript({name: "root", type: "0", js: "closeWindow()"});
        outParam = "apothecaryId=" + apothecaryInfoModel.get("id"); 
        outParam += "&headerHeight=" + headerHeight;
        window.onorientationchange = window.onresize = function() {
            appcan.frame.resize("content", 0, titHeight);
        }
    }
    
    return {
        init: init,
        loadRecipeInfoDetail: loadRecipeInfoDetail,
        toHomePage: toHomePage,
        initModel: _initModel,
        clearSearch: _clearSearch
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    auditPharmacistIndex.init();
});








