if(!window.auditPharmacistIndexHomeContent){
    window.auditPharmacistIndexHomeContent = {};
}

var auditPharmacistIndexHomeContent = function() {
    var pageCount = 0;
    var pageParam;
    var apothecaryInfoModel = new ApothecaryInfoModel();
    
    pageParam = _.clone(window.pagingParam);
    pageParam.tRecipeInfo = {};
        
    var recipeInfoViewModel = new(MVVM.ViewModel.extend({
        el: "#showRecipeInfoView",
        collection: new RecipeInfoCollection()
    })); 
    
    //加载详细页
    var loadRecipeInfoDetail = function(event){
        var id = $(event.currentTarget).find("[data-bind='text:id']").text().trim();
        var code =  $(event.currentTarget).find("[data-bind='text:recipeCode']").text().trim();
        appcan.window.open({
            name: "apothecaryPrescribePage",
            dataType: 0,
            aniId: 2,
            data: "chomedicine/apothecaryPrescribe.html?recipeCode=" + code
        });
    }
    
    var getRecipeInfoSuccess = function(res) {
        recipeInfoViewModel.collection.set(res);
    }
    
    var loadRecipeInfo = function() {
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url: window.ServerURL + "/getTRecipeInfoHeadXf",
            success: getRecipeInfoSuccess
        });
    }
    
    var searchRecipeInfo = function(res) {
        if(!!res) {
            var recipeInfo;
            if(typeof(res) === "string") {
                recipeInfo = JSON.parse(res); 
            } else {
                recipeInfo = res; 
            }
            pageCount = 0;
            pageParam.tRecipeInfo.extend1 = "N"; //查询药师待处理处方标志
            if (!!recipeInfo.recipeCode) {
                pageParam.tRecipeInfo.recipeCode = recipeInfo.recipeCode;
            } else {
                delete pageParam.tRecipeInfo.recipeCode;      
            }
        } else {
            pageParam.tRecipeInfo = {};
        }
        loadRecipeInfo();
    }
    
    var _initModel = function() {
        apothecaryInfoModel.clearData();
        apothecaryInfoModel.set(commonJs.getApothecary());
        recipeInfoViewModel.collection.remove(recipeInfoViewModel.collection.models);
    }
        
    var init = function() {
        
        apothecaryInfoModel.set(commonJs.getApothecary("YS"));
        pageParam.tRecipeInfo.apothecaryId = apothecaryInfoModel.get("id");
        appcan.window.subscribe("auditPharmacistIndexHomeSearchRecipeInfo", searchRecipeInfo);
        
        //设置弹动事件
        //commonJs.listWindowBounce(loadPrescriptionList);
        //ViewModel.collection.fetch({selfViewModel: ViewModel, param: pageParam});


    }
    
    // $.scrollbox($("body")).on("releaseToReload", function() {//After Release or call reload function,we reset the bounce
        // $("#auditPharmacistContent").trigger("reload", this);
    // }).on("onReloading", function(a) {//if onreloading status, drag will trigger this event
    // }).on("dragToReload", function() {//drag over 30% of bounce height,will trigger this event
    // }).on("draging", function(status) {//on draging, this event will be triggered.
    // }).on("release", function() {//on draging, this event will be triggered.
    // }).on("scrollbottom", function() {//on scroll bottom,this event will be triggered.you should get data from server
        // $("#auditPharmacistContent").trigger("more", this);
    // }).hide();
    
    return {
        init: init,
        loadRecipeInfoDetail: loadRecipeInfoDetail,
        searchRecipeInfo: searchRecipeInfo,
        initModel: _initModel
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    auditPharmacistIndexHomeContent.init();
});








