if (!window.adjustPrescribe) {
    window.adjustPrescribe = {};
}

var adjustPrescribe = function() {
    
    var inParam, recipeId, headerHeight;  
    var self = this;
    //设置处方头表MODEL类   
    var recipeInfoModel = new RecipeInfoModel();
    var payInfo = {};
    var apothecaryInfo = {};
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));

    var recipeDrugDetailViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDrugDetailsView",
        collection: new RecipeDrugDetailCollection()
    }));
    
    var options = {};      
    var success = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
            //写入调剂师信息、
            recipeInfoModel.set("adjustId", apothecaryInfo.id);
            recipeInfoModel.set("adjustCode", apothecaryInfo.apothecaryCode);
            recipeInfoModel.set("adjustName", apothecaryInfo.apothecaryName);
            recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList); 
            setTimeout(function() {
                 refreshBtn();
            }, 100);        
        }
    }   
    options.success = success;
    options.url = window.ServerURL + "/getTRecipeInfoXf";
    
    var sumAmount = function() {
        if (recipeDrugDetailViewModel.collection.length > 0) {
            var amount = 0;
            for (var i = 0; i < recipeDrugDetailViewModel.collection.length; i++) {
                var model = recipeDrugDetailViewModel.collection.models[i];
                amount += Math.round((model.get("sale") || 1) * model.get("retailPrice") * model.get("usageTotal") * 100) / 100;
            }
            //保证加减后金额精度
            amount = Math.round(amount * 100) / 100;
            //更新药品总金额
            recipeInfoModel.set("drugSumfee", amount);
        } else {
            recipeInfoModel.set("drugSumfee", 0);
        }
    }
        
    //刷新按钮
    var refreshBtn = function() {
        if (recipeInfoModel.get("status") === "YJF") {
            //药品数量编辑
           $("#btnChoiceDrugFinish").removeClass("disable");
           $("#btnChoiceDrugFinish").css("pointer-events", "auto");
        } else {
            $("#btnChoiceDrugFinish").addClass("disable");
            $("#btnChoiceDrugFinish").css("pointer-events", "none");
        }
    }
    
    //查看电子处方单信息
    appcan.button("#btnLookRecipeInfo", "btn-act", function() {
        appcan.window.open({
            name: "e-PrescribingPage",
            dataType: 0,
            aniId: 2,
            data: "../../components/electronic_prescribing.html?id=" + recipeInfoModel.get("id")
        });
    });
    
    //调剂师选药完成回调
    var doFinishSuccess = function(res) {
        if (res.result === "0") {
            var recipeInfoPamar = _.clone(window.pagingParam);
            recipeInfoPamar.tRecipeInfo =  {
                id: recipeId
            }
            commonService.request(recipeInfoPamar, options);
            appcan.window.openToast("处方药品选药成功", 2000, 5, 0);
            uexWindow.evaluateScript("", "0", "closeWindow()");
        } else {
            appcan.window.openToast("处方药品选药失败！\n" + res.message, 2000, 5, 0);
        }
        //提交更新数据结构 
        //{"tRecipeInfo":{"id":"8a84faca65aec56a0165b2a4cdcb001a","status":"YXY","apothecaryId":"1","adjustId":"2"},
        //"tRecipeDrugDetailList":[{"drugId":"","usageTotal":1},{"drugId":"","usageTotal":1}]}
    }
    
    appcan.button("#btnChoiceDrugFinish", "btn-act", function() {
        //生成外方单数据
        console.log("选药完成"); 
        var data = {};
        data.tRecipeInfo = {
            "id": recipeInfoModel.get("id"),
            "status": "YWC",
            "apothecaryId": "",
            "adjustId": recipeInfoModel.get("adjustId")};
       //提交后台保存更新数据
       commonService.request(data, {
           "url": window.ServerURL + "/updateTRecipeInfo",
           success: doFinishSuccess
       });
    });
    
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        recipeId = inParam.id  || "_";
        headerHeight = inParam.headerHeight;
        var recipeInfoPamar = _.clone(window.pagingParam);
        recipeInfoPamar.tRecipeInfo =  {
            id: recipeId
        }
        //获取药师信息
        apothecaryInfo = commonJs.getApothecary("TJS");
        commonService.request(recipeInfoPamar, options);
        
        /*
        recipeDetailInfoViewModel.collection.on("add", function(model, self, options) {
            console.log(model);
        });
        recipeInfoModel.set(recipeInfoTestData);
        recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        recipeDrugDetailViewModel.collection.set(recipeInfoTestData.tRecipeDrugDetailList);
        */
    }
    
    //退药费  by sushu 2019-05-16
    appcan.button("#drugRefundFee", "btn-act", function() {
    	//获取缴费单信息
	    var param = {"orderId": recipeInfoModel.get("id"), "payOrderType": "GY"};
	    commonService.request(param, {
            url: window.ServerURL + "/getPayXf",
            success: function(res){
		        var param = {};
			    param.id = res[0].id;
			    commonService.request(param, {
			        url: window.ServerURL + "/updateReturnPayXf",
			        success: function(res) {
			        	if(res.result == "0"){
			        		appcan.window.openToast("退费成功", 2000, 5, 0);
			        		appcan.window.evaluateScript("homeIndexContentPage", "pharmacistIndexHomeContent.init()");
			        		uexWindow.evaluateScript("", "0", "closeWindow()");
			        	}else{
			        		appcan.window.openToast(res.message, 2000, 5, 0);
			        	}
			        }
			    });
            }
        });
    });
       
    return {
        init: init
    }
}();

appcan.ready(function() {
    adjustPrescribe.init();
});
