if (!window.apothecaryPrescribe) {
    window.apothecaryPrescribe = {};
}

var apothecaryPrescribe = function() {
    
    var inParam, recipeId, headerHeight;  
    var self = this;
    //设置处方头表MODEL类   
    var recipeInfoModel = new RecipeInfoModel();
    var payInfo = {}, apothecaryInfo = {};
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));
    
    var recipeDetailInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDetailInfoView",
        collection: new RecipeDetailInfoCollection()
    }));
    
    var recipeDrugDetailViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDrugDetailsView",
        collection: new RecipeDrugDetailCollection()
    }));
            
    var options = {};
    var startX, startY, moveEndX, moveEndY, X, Y;       
    var success = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
            //写入调剂师信息、
            if (!!!recipeInfoModel.get("apothecaryId")) {
                recipeInfoModel.set("apothecaryId", apothecaryInfo.id);
                recipeInfoModel.set("apothecaryCode", apothecaryInfo.apothecaryCode);
                recipeInfoModel.set("apothecaryName", apothecaryInfo.apothecaryName);
            }
            recipeDetailInfoViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDetailInfoList); 
            recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList); 
            setTimeout(function() {
                 refreshBtn();
            }, 100);       
        }
    }
    
    //手势滑动开始坐标获取，直接监听BODY事件
    $("body").on("touchstart", function(event) {
         // 判断默认行为是否可以被禁用
         startX = event.changedTouches[0].pageX,
         startY = event.changedTouches[0].pageY;
     });
     /*
     $("#patientName").on("touchend", function(event) {    
        moveEndX = event.changedTouches[0].pageX,
        moveEndY = event.changedTouches[0].pageY,
        X = moveEndX - startX,
        Y = moveEndY - startY;
        //左滑  X < 0 右滑 X >0 下拉 Y > 0 上拖 Y < 0        
        console.log("touchend X: " + X);
        console.log("touchend Y: " + Y);
        console.log("touchend moveEndX: " + moveEndX);
        console.log("touchend startX: " + startX);
        console.log("touchend moveEndY: " + moveEndY);
        console.log("touchend startY: " + startY);
        
    });
    */
    
    options.success = success;
    options.url = window.ServerURL + "/getTRecipeInfoXf";
    
    //药品信息删除按钮显示
    var showDeleteBtn = function(event) {
        moveEndX = event.changedTouches[0].pageX,
        moveEndY = event.changedTouches[0].pageY,
        X = moveEndX - startX,
        Y = moveEndY - startY;
        if ( X + 100 < 0 && 50 > Y && -50 < Y) {
            //左滑
            if (recipeInfoModel.get("status") === "YSH") {
                $(event.currentTarget).find(".deleteItem").removeClass("field-nodisplay");
                $(event.currentTarget).find(".deleteItem").addClass("field-display");
            }       
        } else if ( X - 100 > 0 && 50 > Y && -50 < Y) {
            //右滑
            if (recipeInfoModel.get("status") === "YSH") {
                $(event.currentTarget).find(".deleteItem").removeClass("field-display");
                $(event.currentTarget).find(".deleteItem").addClass("field-nodisplay");
            }   
        }
    }
    var doDeleteDrug = function(event) {
        var drugId = $(event.currentTarget).parents("li").find("[data-bind='text:drugId']").text().trim();
        var model = recipeDrugDetailViewModel.collection.where({"drugId": drugId});
        for (var i = 0; i < model.length; i++) {
            recipeDrugDetailViewModel.collection.remove(model[i]);
        }
        //册除完本行数据后，隐藏删除按钮
        $(event.currentTarget).parents("ul").find(".deleteItem").removeClass("field-display");
        $(event.currentTarget).parents("ul").find(".deleteItem").addClass("field-nodisplay");
        //计算金额，更新头表金额
        sumAmount();
    }
    
    //刷新按钮
    var refreshBtn = function() {
        if (recipeInfoModel.get("status") != "YSH") {
            //修改线下支付审核完成按钮状态
            $("#btnFinishFeePayConfirm").css("pointer-events", "none");
            $("#btnFinishFeePayConfirm").addClass("disable");
            
            $("#btnDrugConfirm").css("pointer-events", "none");
            $("#btnDrugConfirm").addClass("disable");
            $("#btnAddDrug").css("display", "none");
            //药品数量编辑
            $(".number-editor").css("display", "none !important");
            $(".display-number").css("display", "initial !important");
            $(".deleteItem").removeClass("field-display");
            $(".deleteItem").addClass("field-nodisplay");
            $("[data-bind='value:supplyExplain']").attr("readonly", "readonly")
        } else {
            $("#btnDrugConfirm").css("pointer-events", "auto");
            $("#btnDrugConfirm").removeClass("disable");
            $("#btnAddDrug").css("display", "block");
            //药品数量编辑
            $(".number-editor").css("display", "initial !important");
            $(".display-number").css("display", "none !important");
            
            //修改线下支付审核完成按钮状态
            $("#btnFinishFeePayConfirm").css("pointer-events", "auto");
            $("#btnFinishFeePayConfirm").removeClass("disable");
        }
    }
    
    var sumAmount = function() {
        if (recipeDrugDetailViewModel.collection.length > 0) {
            var amount = 0;
            for (var i = 0; i < recipeDrugDetailViewModel.collection.length; i++) {
                var model = recipeDrugDetailViewModel.collection.models[i];
                amount += Math.round((model.get("sale") || 1) * model.get("retailPrice") * model.get("usageTotal") * 100) / 100;
            }
            //保证加减后金额精度
            amount = Math.round(amount * 100) / 100;
            //更新药品总金额
            recipeInfoModel.set("drugSumfee", amount);
        } else {
            recipeInfoModel.set("drugSumfee", 0);
        }
    }
    
    //接收已选择药品信息
    var setSelectDrug = function(res) {
        if (!!res){
            var drugInfo;
            if (typeof(res) === "string") {
                drugInfo = JSON.parse(res);
            } else {
                drugInfo = res;
            } 
            var model = recipeDrugDetailViewModel.collection.where({"drugId": drugInfo.id});
            if (model.length > 0) {
                model[0].set("usageTotal", Number(model[0].get("usageTotal")) + 1);
            } else {
                var recipeDrugDetail = {};
                for (var key in recipeDrugDetailTable){
                    if (key != "id") {
                        if (!!drugInfo[key]) {
                            recipeDrugDetail[key] = drugInfo[key] || "";
                        }
                    } else {
                        recipeDrugDetail.drugId = drugInfo[key];
                    }
                }
                recipeDrugDetail.usageTotal = "1";
                //recipeDrugDetail.id = (Math.random() * 100000 * -1).toString().substr(0, 6);
                
                recipeDrugDetailViewModel.collection.add(recipeDrugDetail);
            }
            //计算金额，更新头表金额
            sumAmount();
        }    
    }
    
    //药师审药完成患者未支付回调
    var doConfirmSuccess = function(res) {
        
        if (res.result === "0") {
            var recipeInfoPamar = _.clone(window.pagingParam);
            recipeInfoPamar.tRecipeInfo =  {
                id: recipeId
            }
            commonService.request(recipeInfoPamar, options);
            appcan.window.openToast("处方药品审核成功", 2000, 5, 0);
            appcan.window.evaluatePopoverScript("auditPharmacistIndex", "homeIndexContentPage", "auditPharmacistIndexHomeContent.initModel()");
            appcan.window.evaluateScript("auditPharmacistIndex", "auditPharmacistIndex.clearSearch()");
            setTimeout(function() {            
                uexWindow.evaluateScript("", "0", "commonJs.closeWindow('apothecaryPrescribeContentPage')");
            }, 500);
        } else {
            appcan.window.openToast("处方药品审核失败！\n" + res.message, 2000, 5, 0);
        }
        //提交更新数据结构 
        //{"tRecipeInfo":{"id":"8a84faca65aec56a0165b2a4cdcb001a","status":"YXY","apothecaryId":"1","adjustId":"2"},
        //"tRecipeDrugDetailList":[{"drugId":"","usageTotal":1},{"drugId":"","usageTotal":1}]}
    }
    
    appcan.button("#btnDrugConfirm", "btn-act", function() {
    	//检查是否有证书   by sushu 2019-02-13
		checkCertificationDrugConfirm();
        // //生成外方单数据
       // var data = {};
       // data.tRecipeInfo = {
           // "id": recipeInfoModel.get("id"),
           // "status": "YXY",
           // "apothecaryId": recipeInfoModel.get("apothecaryId"),
           // "adjustId": ""};
      // data.tRecipeDrugDetailList = [];
       // var drugDetail = {};
       // for (var i = 0; i < recipeDrugDetailViewModel.collection.length; i++) {
           // var model = recipeDrugDetailViewModel.collection.models[i];
           // var drugDetail = {
               // "drugId": model.get("drugId"),
               // "usageTotal": model.get("usageTotal")
           // }
           // data.tRecipeDrugDetailList.push(drugDetail);
       // }
       // //提交后台保存更新数据
       // commonService.request(data, {
           // "url": window.ServerURL + "/updateTRecipeInfo",
           // success: doConfirmSuccess
       // });
    });
    
    //检查是否有证书   by sushu 2019-02-13
    var checkCertificationDrugConfirm = function(){
    	//已注册，判断是否下证
        var param = {
        	accountREQ: apothecaryInfo.apothecaryPhone  //药师手机号
        };
        bethuneDoctor.checkStatus(param,function (error, data) {
        	if (!error){
        		//已注册，手机无证书
        		if(data.userListMap == "{}" && data.errCode == "0x00000000"){
        			//没证书
        			commonJs.openWindow("myCertificationInfoPage", "../../doctor/my/my_certification_info.html?certificationRole="+'PHARMACIST');
        			return false;
                }else if(data.userListMap != "{}" && data.errCode == "0x00000000"){
                	//有证书
			        //生成外方单数据
			        var data = {};
			        data.tRecipeInfo = {
			           "id": recipeInfoModel.get("id"),
			           "status": "YXY",
			           "apothecaryId": recipeInfoModel.get("apothecaryId"),
			           "adjustId": ""};
			        data.tRecipeDrugDetailList = [];
			        var drugDetail = {};
			        for (var i = 0; i < recipeDrugDetailViewModel.collection.length; i++) {
			           var model = recipeDrugDetailViewModel.collection.models[i];
			           var drugDetail = {
			               "drugId": model.get("drugId"),
			               "usageTotal": model.get("usageTotal")
			           }
			           data.tRecipeDrugDetailList.push(drugDetail);
			        }
			        //提交后台保存更新数据
			        commonService.request(data, {
			           "url": window.ServerURL + "/updateTRecipeInfo",
			           success: doConfirmSuccess
			        });
                }else{
					alert(data.errMsg);
                }
            }else{
            	alert(data.errMsg);
            }
        });
    }
    
    //药师审药完成患者已支付 回调
    var doFinishFeePayConfirmSuccess = function(res) {
        if (res.result === "0") {
            var recipeInfoPamar = _.clone(window.pagingParam);
            recipeInfoPamar.tRecipeInfo =  {
                id: recipeId
            }
            commonService.request(recipeInfoPamar, options);
            appcan.window.openToast("处方药品审核成功", 2000, 5, 0);
            appcan.window.evaluatePopoverScript("auditPharmacistIndex", "homeIndexContentPage", "auditPharmacistIndexHomeContent.initModel()");
            appcan.window.evaluateScript("auditPharmacistIndex", "auditPharmacistIndex.clearSearch()");
            setTimeout(function() {            
                uexWindow.evaluateScript("", "0", "commonJs.closeWindow('apothecaryPrescribeContentPage')");
            }, 500);
        } else {
            appcan.window.openToast("处方药品审核失败！\n" + res.message, 2000, 5, 0);
        }
        //提交更新数据结构 
        //{"tRecipeInfo":{"id":"8a84faca65aec56a0165b2a4cdcb001a","status":"YXY","apothecaryId":"1","adjustId":"2"},
        //"tRecipeDrugDetailList":[{"drugId":"","usageTotal":1},{"drugId":"","usageTotal":1}]}
    }
    
    appcan.button("#btnFinishFeePayConfirm", "btn-act", function() {
    	//检查是否有证书   by sushu 2019-02-13
		checkCertificationFinishFeePayConfirm();
        // //生成外方单数据
       // var data = {};
       // data.tRecipeInfo = {
           // "id": recipeInfoModel.get("id"),
           // "status": "YJF",
           // "apothecaryId": recipeInfoModel.get("apothecaryId"),
           // "adjustId": ""};
      // data.tRecipeDrugDetailList = [];
       // var drugDetail = {};
       // for (var i = 0; i < recipeDrugDetailViewModel.collection.length; i++) {
           // var model = recipeDrugDetailViewModel.collection.models[i];
           // var drugDetail = {
               // "drugId": model.get("drugId"),
               // "usageTotal": model.get("usageTotal")
           // }
           // data.tRecipeDrugDetailList.push(drugDetail);
       // }
       // //提交后台保存更新数据
       // commonService.request(data, {
           // "url": window.ServerURL + "/updateTRecipeInfo",
           // success: doFinishFeePayConfirmSuccess
       // });
    });
    
    //检查是否有证书   by sushu 2019-02-13
    var checkCertificationFinishFeePayConfirm = function(){
    	//已注册，判断是否下证
        var param = {
        	accountREQ: apothecaryInfo.apothecaryPhone  //药师手机号
        };
        bethuneDoctor.checkStatus(param,function (error, data) {
        	if (!error){
        		//已注册，手机无证书
        		if(data.userListMap == "{}" && data.errCode == "0x00000000"){
        			//没证书
        			commonJs.openWindow("myCertificationInfoPage", "../../doctor/my/my_certification_info.html?certificationRole="+'PHARMACIST');
        			return false;
                }else if(data.userListMap != "{}" && data.errCode == "0x00000000"){
                	//有证书
			        //生成外方单数据
			        var data = {};
			        data.tRecipeInfo = {
			           "id": recipeInfoModel.get("id"),
			           "status": "YJF",
			           "apothecaryId": recipeInfoModel.get("apothecaryId"),
			           "adjustId": ""};
			        data.tRecipeDrugDetailList = [];
			        var drugDetail = {};
			        for (var i = 0; i < recipeDrugDetailViewModel.collection.length; i++) {
			           var model = recipeDrugDetailViewModel.collection.models[i];
			           var drugDetail = {
			               "drugId": model.get("drugId"),
			               "usageTotal": model.get("usageTotal")
			           }
			           data.tRecipeDrugDetailList.push(drugDetail);
			        }
			        //提交后台保存更新数据
			        commonService.request(data, {
			           "url": window.ServerURL + "/updateTRecipeInfo",
			           success: doFinishFeePayConfirmSuccess
			        });
                }else{
					alert(data.errMsg);
                }
            }else{
            	alert(data.errMsg);
            }
        });
    }
       
    var init = function() {
        appcan.window.disableBounce();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        recipeId = !!!inParam ? "_" : inParam.id;
        headerHeight = !!!inParam ? 0 : inParam.headerHeight;
        var recipeInfoPamar = _.clone(window.pagingParam);
        recipeInfoPamar.tRecipeInfo = {}
        if (!!recipeId) {
            recipeInfoPamar.tRecipeInfo.id = recipeId;
        }
        if (!!inParam && !!inParam.recipeCode) {
            recipeInfoPamar.tRecipeInfo.recipeCode = inParam.recipeCode;
        }
        
        //监听选药品窗口选择信息   
        appcan.window.subscribe("setSelectDrug", setSelectDrug);
        //获取药师信息
        apothecaryInfo = commonJs.getApothecary("YS");
        commonService.request(recipeInfoPamar, options);
        
        /*
        recipeDetailInfoViewModel.collection.on("add", function(model, self, options) {
            console.log(model);
        });
        recipeInfoModel.set(recipeInfoTestData);
        recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        recipeDrugDetailViewModel.collection.set(recipeInfoTestData.tRecipeDrugDetailList);
        */
    }
    
    appcan.button("#btnAddDrug", "btn-act", function(event) {
        var param = "selectorId=" + recipeInfoModel.get("apothecaryId"); //选药者ID
        param += "&selectorType=AT"; //选药者类型：DT:医师、AT:药师 
        param += "&parentPageName=apothecaryPrescribePage";
        param += "&parentFrameName=apothecaryPrescribeContentPage";
        param += "&js=apothecaryPrescribe.setSelectDrug";
        //接收已选中的药品信息
        //uexWindow.setSelectDrug = setSelectDrug;
        //uexWindow.subscribeChannelNotification("setSelectDrug", "setSelectDrug");
        appcan.window.open({
                 name: "selectDrugPage",
                 dataType: 0,
                 aniId: 2,
                 data: "../../components/selectDrug.html?" + param,
        });
    });
    
    var subtractDrug = function(event) {
        if (Number($(event.currentTarget.parentElement).find("input").val()) === 1) {
            return;
        }
        if (!!!$(event.currentTarget.parentElement).find("input").val().trim() || 
            Number($(event.currentTarget.parentElement).find("input").val()) <= 0) {
             num = 1;   
        } else {
            var num = Number($(event.currentTarget.parentElement).find("input").val()) - 1;
        }
        $(event.currentTarget.parentElement).find("input").val(num).change();
        //console.log("减少药品数量");
        //计算金额，更新头表金额
        sumAmount();
    }
    
    var addDrug = function(event) {
        var num = Number($(event.currentTarget.parentElement).find("input").val()) + 1;
        $(event.currentTarget.parentElement).find("input").val(num).change();
        //console.log("增加药品数量"); 
        //计算金额，更新头表金额
        sumAmount();
    }
    
    var usageTotalOnChange = function(self, value) {
        if (!!!value) $(self).val(1);
        //计算金额，更新头表金额
        setTimeout(function() {
            sumAmount();    
        }, 100);
        
        //console.log("增加药品数量"); 
    }
    
    //查看电子处方单信息
    appcan.button("#btnLookRecipeInfo", "btn-act", function() {
        appcan.window.open({
            name: "e-PrescribingPage",
            dataType: 0,
            aniId: 2,
            data: "../../components/electronic_prescribing.html?id=" + recipeInfoModel.get("id")
        });
    });
    
    //驳回  by susshu 2019-05-09
    appcan.button("#btnRejectRecipeInfo", "btn-act", function() {
    	var paramData = "id="+recipeInfoModel.get("id");//处方ID
    	paramData += "&apothecaryId="+recipeInfoModel.get("apothecaryId");//药师
    	appcan.window.open({
            name: "rejectPage",
            dataType: 0,
            aniId: 2,
            data: "rejectPage.html?"+paramData
        });
    });
    
    return {
        init: init,
        subtractDrug: subtractDrug,
        addDrug: addDrug,
        usageTotalOnChange: usageTotalOnChange,
        showDeleteBtn: showDeleteBtn,
        doDeleteDrug: doDeleteDrug,
        setSelectDrug: setSelectDrug
    }
}();

appcan.ready(function() {
    apothecaryPrescribe.init();
});
