if (!window.recipeInfo) {
    window.recipeInfo = {};
}

var recipeInfo = function() {
    
    var inParam, recipeId, headerHeight;  
    var self = this;
    //设置处方头表MODEL类   
    var recipeInfoModel = new RecipeInfoModel();
    var payInfo = {}, apothecaryInfo = {};
    var recipeInfoViewModel = new (MVVM.ViewModel.extend({
        el: ".recipeInfo",
        model: recipeInfoModel
    }));
    
    var recipeDetailInfoViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDetailInfoView",
        collection: new RecipeDetailInfoCollection()
    }));
    
    var recipeDrugDetailViewModel = new (MVVM.ViewModel.extend({
        el: "#showRecipeDrugDetailsView",
        collection: new RecipeDrugDetailCollection()
    }));
            
    var options = {};      
    var success = function(res) {
        if (!!res && !!res.tRecipeInfoVOList) {
            recipeInfoModel.set(res.tRecipeInfoVOList[0].tRecipeInfo);
            //设置评价标签
            setEvaluateTags();
            recipeDetailInfoViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDetailInfoList); 
            recipeDrugDetailViewModel.collection.set(res.tRecipeInfoVOList[0].tRecipeDrugDetailList);
        }
    }
    options.success = success;
    options.url = window.ServerURL + "/getTRecipeInfoXf";
    
    //折叠与展开药品信息
    appcan.button("#expandRecipeDetail", "btn-act", function() {
        if ($("#expandRecipeDetail").find(".angle-down").length > 0) {
            $("#recipeDetailInfoView").removeClass("field-nodisplay");
            $("#recipeDetailInfoView").addClass("field-display");
            $("#expandRecipeDetail").find(".angle-icon-size-1x").removeClass("angle-down");
            $("#expandRecipeDetail").find(".angle-icon-size-1x").addClass("angle-up");
        } else if ($("#expandRecipeDetail").find(".angle-up").length > 0){
            $("#recipeDetailInfoView").addClass("field-nodisplay");
            $("#recipeDetailInfoView").removeClass("field-display");
            $("#expandRecipeDetail").find(".angle-icon-size-1x").addClass("angle-down");
            $("#expandRecipeDetail").find(".angle-icon-size-1x").removeClass("angle-up");
        }
    });
    
    //查看电子处方单信息
    appcan.button("#btnLookRecipeInfo", "btn-act", function() {
        appcan.window.open({
            name: "e-PrescribingPage",
            dataType: 0,
            aniId: 2,
            data: "../../components/electronic_prescribing.html?id=" + recipeInfoModel.get("id")
        });
    });
    
    //退药费  by sushu 2019-05-15
    appcan.button("#drugRefundFee", "btn-act", function() {
    	//获取缴费单信息
	    var param = {"orderId": recipeInfoModel.get("id"), "payOrderType": "GY"};
	    commonService.request(param, {
            url: window.ServerURL + "/getPayXf",
            success: function(res){
		        var param = {};
			    param.id = res[0].id;
			    commonService.request(param, {
			        url: window.ServerURL + "/updateReturnPayXf",
			        success: function(res) {
			        	if(res.result == "0"){
			        		appcan.window.openToast("退费成功", 2000, 5, 0);
			        		appcan.window.evaluatePopoverScript("historicalPrescriptionPage", "diagnosisListPage", "prescriptionList.init()");
			        		appcan.window.close(-1);
			        	}else{
			        		appcan.window.openToast(res.message, 2000, 5, 0);
			        	}
			        }
			    });
            }
        });
    });
    
    appcan.button("#nav-left", "btn-act", function() {
       appcan.window.close(-1);
    });
    
    var setContentTop = function() {
        headerHeight = $('#recipeInfoHeader').offset().height;
        $("#recipeInfoContent").css("top", headerHeight);
    }
    
    window.onorientationchange = window.onresize = function() {
        setContentTop();
    }
        
    //设置评价标签状态，点亮星星    
    var setEvaluateTags = function() {
        for (var i = 1; i <= Number(recipeInfoModel.get("evaluateScore")); i++) {
            $("#evaluateScore").find("[name='" + i + "']").removeClass("nochoice");
            $("#evaluateScore").find("[name='" + i + "']").addClass("choice");
        }
    }
       
    var init = function() {
        appcan.window.disableBounce();
        setContentTop();
        inParam = commonJs.urlQueryToJSON(uexWindow.getUrlQuery());
        try {
            recipeId = inParam.id  || "1s";
        } catch (e){
            
        }
        
        var recipeInfoPamar = _.clone(window.pagingParam);
        recipeInfoPamar.tRecipeInfo =  {
            id: recipeId
        }
        
        //获取药师信息
        commonService.request(recipeInfoPamar, options);
        
        /*
        recipeDetailInfoViewModel.collection.on("add", function(model, self, options) {
            console.log(model);
        });
        recipeInfoModel.set(recipeInfoTestData);
        recipeDetailInfoViewModel.collection.set(recipeInfoTestData.tRecipeDetailInfoList);
        recipeDrugDetailViewModel.collection.set(recipeInfoTestData.tRecipeDrugDetailList);
        */
    }
    
    return {
        init: init
    }
}();

appcan.ready(function() {
    recipeInfo.init();
});
