
recipeInfoTable.payOrderCode = ""; //缴费单号
recipeInfoTable.payOrderType = ""; //缴费类型
var DrugPayRecipeInfoModel = CommonBase.Model.extend({
    //defaults,散列（或函数）用于为模型指定默认属性。
    defaults : recipeInfoTable,
    //在model创建后执行的方法
    initialize : function() {
        //console.log("数据初始化");
        return;
    },
    // 默认情况下validate在save之前调用，也可以在set之前调用。 如果validate返回一个错误， save不会继续，该模型的属性将不被修改。
    validate : function(attrs, options) {
        //console.log(attrs, options);
    },
    //可以理解为对应model的实时计算，比如这里的model里面的username发生了变化，那么对应的<span data-bind="text:add"></span>也会发生变化
    computeds : {
        //医师类别 
        getTastDoctorType : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["tastDoctorType"],
            get : function(tastDoctorType) {
                var codelist = commonJs.getCodelistData(window.codeList.doctorType, tastDoctorType);
                return codelist.text || tastDoctorType;
            },
        },
        //单据状态
        getStatus : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["status"],
            get : function(status) {
                var codelist = commonJs.getCodelistData(window.codeList.recipeStatus, status);
                return codelist.text || status;
            }
        },
        //性别
        getSex : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["sex"],
            get : function(sex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, sex);
                return codelist.text || sex;
            }
        },
        //亲属性别
        getRelativSex : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["relativSex"],
            get : function(relativSex) {
                var codelist = commonJs.getCodelistData(window.codeList.genderType, relativSex);
                return codelist.text || relativSex;
            }
        },
        getPayOrderType : {
            //这里是参数的依赖，也可以使用this.get("username")
            deps : ["payOrderType"],
            get : function(payOrderType) {
                var codelist = commonJs.getCodelistData(window.codeList.payOrderType, payOrderType);
                return codelist.text || payOrderType;
            }
        },
        //开方时间
        getCreateDate: {
            deps: ["createDate"],
            get: function(createDate) {
                return commonJs.dateTimeToString(createDate);
            }
        },
        //药师审药时间
        getApothecaryAudiTime: {
            deps: ["apothecaryAudiTime"],
            get: function(apothecaryAudiTime) {
                if (typeof(apothecaryAudiTime) === "object" && _.allKeys(apothecaryAudiTime).length === 0) {
                     return null;
                } else if(!!!apothecaryAudiTime) {
                    return null;
                }
                return commonJs.dateTimeToString(apothecaryAudiTime);
            }
        },
        getAdjustAudiTime: {
            deps:["adjustAudiTime"],
            get : function(adjustAudiTime) {
                if (typeof(adjustAudiTime) === "object" && _.allKeys(adjustAudiTime).length === 0) {
                     return null;
                } else if(!!!adjustAudiTime) {
                    return null;
                }
                return commonJs.dateTimeToString(adjustAudiTime);
            }
        },
        getDrugSumfee: {
            deps:["drugSumfee"],
            get: function(drugSumfee) {
                return commonJs.moneyFormat(drugSumfee);
            }
        },
        getIsAllergy: {
            deps: ["isAllergy"],
            get: function(isAllergy) {
                var codelist = commonJs.getCodelistData(window.codeList.yOrW, isAllergy);
                return codelist.text || isAllergy;
            }
        },
         getDrugPayTime: {
            deps:["drugPayTime"],
            get : function(drugPayTime) {
                if (typeof(drugPayTime) === "object" && _.allKeys(drugPayTime).length === 0) {
                     return null;
                } else if(!!!drugPayTime) {
                    return null;
                }
                return commonJs.dateTimeToString(drugPayTime);
            }
        },
        getDrugSumfees: {
            deps:["drugSumfee"],
            get: function(drugSumfee) {
                var sumfee =commonJs.moneyFormat(drugSumfee);
                if(sumfee==null){
                	sumfee='0.00';
                }
                var taskSumfees= "￥"+sumfee ;
                
                        return taskSumfees;
            }
        }
    },
    parse : function(data) {
        return data;
    },
    sync : function(method, model, options) {
        switch (method) {
        case "create":
            break;
        case "update":
            break;
        case "patch":
            break;
        case "delete":
            break;
        case "read":
            break;
        default:
            break;
        }
    }
});

