if(!window.pharmacistIndex){
    window.pharmacistIndex = {};
}

var pharmacistIndex = function() {
    var pageCount = 0, headerHeight, outParam, pageParam, openIndex = [];
    var apothecaryInfoModel = new ApothecaryInfoModel();
    
    pageParam = _.clone(window.pagingParam);
    pageParam.tRecipeInfo = {};
    
    //声明viewmodel
    var apothecaryInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".apothecaryInfo",
        model: apothecaryInfoModel
    }));

    var pharmacistFooterTab = appcan.tab({
        selector : $("#pharmacistFooterTab"),
        hasIcon : true,
        hasAnim : false,
        hasLabel : true,
        hasBadge : false,
        index : 0,
        data : [{
            "label" : "首页",
            "icon" : "app-home"
        }, {
            "label" : "信息",
            "icon" : "app-information"
        }, {
            "label" : "工作室",
            "icon" : "app-office"
        }, {
            "label" : "发现",
            "icon" : "app-discover"
        }, {
            "label" : "我的",
            "icon" : "app-my"
        }]
    });
    
    var frame = appcan.require('frame');
    //页脚按钮点击事件
    pharmacistFooterTab.on("click", function(obj, index) {
        if (index != 0 && index != 4) {
           return;
        }
        _setHeader(index);
        var openFlag = _.indexOf(openIndex, index) >= 0;        
        switch (index) {
            case 0:
                if (openFlag) {
                    appcan.frame.bringToFront("homeIndexContentPage");
                    return;
                }                
                appcan.frame.open("content", "pharmacist_index_home_content.html?" + outParam, 0, headerHeight, 'homeIndexContentPage');
                break;
            case 1:
                openIndex.push(index);
                break;
            case 2:
                
                break;
            case 3:
                openIndex.push(index);
                break;
            case 4:
                if (openFlag) {
                    appcan.frame.bringToFront("myIndexContentPage");
                    return;
                }
                appcan.frame.open("content", "audit_pharmacist_my_info.html?" + outParam, 0, headerHeight, 'myIndexContentPage');
                openIndex.push(index);
                break;   
            default:
                break;
        }
    });
    
    //查询处方历史
    appcan.button("#historyPrescription", "btn-act", function() {
        commonJs.openWindow("historicalPrescriptionPage", "historicalPrescription/historicalPrescription.html");
        /*
        appcan.window.open({
            name: "historicalPrescriptionPage",
            dataType: 0,
            aniId: 2,
            data: "historicalPrescription/historicalPrescription.html"
        });
        */
    });
    
    var _setHeader = function(tabIndex) {
        if (!!!apothecaryInfoModel.get("id")){
            apothecaryInfoModel.set("headPicture", window.doctorPhoto.unLoginDefaultUrl);
            $(".user-photo").css("background-color", "#c6c6c6");
            $(".isLoginOut.field-nodisplay").addClass("field-display");
            $(".isLoginOut.field-nodisplay").removeClass("field-nodisplay");
            $(".isLogin.field-display").addClass("field-nodisplay");
            $(".isLogin.field-display").removeClass("field-display");
        } else {
            $(".user-photo").css("background-color", "#09b1d2");
            $(".isLoginOut.field-display").addClass("field-nodisplay");
            $(".isLoginOut.field-display").removeClass("field-display");
            $(".isLogin.field-nodisplay").addClass("field-display");
            $(".isLogin.field-nodisplay").removeClass("field-nodisplay");
        }
        var style = function(target, displayFlag) {
            if (displayFlag) {
                target.removeClass("field-nodisplay");
                target.addClass("field-display");
            } else {
                target.removeClass("field-display");
                target.addClass("field-nodisplay");
            }
        }
        tabIndex = tabIndex || 0;
        if (!!tabIndex) {
            style($("#historyPrescription"), 0 === tabIndex);
        }
    }
    
    var toHomePage = function(index) {
         _initModel()
        var openFlag = _.indexOf(openIndex, 0) >= 0;
        delete openIndex[_.indexOf(openIndex, index)];
        //设置TAB按钮是否点亮
        $("#pharmacistFooterTab").find(".sc-text-active").removeClass("sc-text-active");
        $("#pharmacistFooterTab").find("[data-index='0']").find(".item.sc-text-tab").addClass("sc-text-active");
        if (openFlag) {
            appcan.frame.bringToFront("homeIndexContentPage");
            appcan.window.evaluatePopoverScript("pharmacistIndex", "homeIndexContentPage", "pharmacistIndexHomeContent.initModel()");
            return;
        }                
        appcan.frame.open("content", "audit_pharmacist_index_home_content.html?" + outParam, 0, headerHeight, 'homeIndexContentPage');
    }
    
    var _initModel = function() {
        apothecaryInfoModel.clearData();
        apothecaryInfoModel.set(commonJs.getApothecary("TJS"));
        _setHeader();
        //初始延迟5秒获取极光推送ID
        setTimeout(function() {
            commonJs.getJpushRegistrationId(apothecaryInfoModel.get("id"), "A");
        }, 5000);
    }
    
    var _exitProgram = function(keyCode) {
        //监听返回键，按返回键时提示退出系统
        if (keyCode === 0) {
            uexWidgetOne.exit();
        }
    }
    
    var init = function() {
        appcan.window.disableBounce();
        //监听物理退出键按钮
        uexWindow.setReportKey(0, 1);
        uexWindow.onKeyPressed = _exitProgram;
        _initModel();
        headerHeight = $('.doctor-index').offset().height;
        var footerHeight = $('[data-control="FOOTER"').offset().height;
        var contentHeight = $("[data-control='PAGE']").offset().height - headerHeight - footerHeight;
        outParam = "apothecaryId=" + apothecaryInfoModel.get("id"); 
        outParam += "&headerHeight=" + headerHeight;
        appcan.frame.open("content", "pharmacist_index_home_content.html?" + outParam, 0, headerHeight, "homeIndexContentPage");
        $("#pharmacistFooterTab").find(".sc-text-active").removeClass("sc-text-active");
        $("#pharmacistFooterTab").find("[data-index='0']").find(".item.sc-text-tab").addClass("sc-text-active");
        openIndex.push(0);
        uexWindow.evaluateScript({name: "root", type: "0", js: "closeWindow()"});
    }
    
    //点击登录  by sushu 2019-04-12
    appcan.button("#doLogin", "btn-act", function() {
        commonJs.openWindow("loginPage", "../login/login.html");
    });
    
    return {
        init: init,
        initModel: _initModel,
        toHomePage: toHomePage
    }
    
}();

appcan.ready(function() {
    //appcan.initBounce();
    pharmacistIndex.init();
});








