if(!window.pharmacistIndexHomeContent){
    window.pharmacistIndexHomeContent = {};
}

var pharmacistIndexHomeContent = function() {
    var pageCount = 0;
    var pageParam;
    var apothecaryInfoModel = new ApothecaryInfoModel();
    
    pageParam = _.clone(window.pagingParam);
    
    //声明viewmodel
    var apothecaryInfoViewModel = new(MVVM.ViewModel.extend({
        el: ".apothecaryInfo",
        model: apothecaryInfoModel
    }));
    
    var recipeInfoViewModel = new(MVVM.ViewModel.extend({
        el: "#showRecipeInfoView",
        collection: new RecipeInfoCollection()
    })); 
    
    //加载详细页
    var loadRecipeInfoDetail = function(event){
        var id = $(event.currentTarget).find("[data-bind='text:id']").text().trim(); 
        appcan.window.open({
            name: "adjustPrescribePage",
            dataType: 0,
            aniId: 2,
            data: "chomedicine/adjust_prescribe.html?id=" + id
        });
    }
    
    var getRecipeInfoSuccess = function(res) {
        //console.log(pageParam);
        pageCount === 1 ? recipeInfoViewModel.collection.set(res) : recipeInfoViewModel.collection.add(res);
    }
    
    var loadRecipeInfo = function() {
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url: window.ServerURL + "/getTRecipeInfoByAdjustWait",
            success: getRecipeInfoSuccess
        });
    }
    
    var reloadRecipeInfo = function(res) {
        pageCount = 0;
        loadRecipeInfo();
    }
    
    var _initModel = function() {
        apothecaryInfoModel.clearData();
        apothecaryInfoModel.set(commonJs.getApothecary());
        pageParam.adjustId = apothecaryInfoModel.get("id");
        recipeInfoViewModel.collection.remove(recipeInfoViewModel.collection.models);
    }
    
    var init = function() {
        _initModel();
        //设置弹动事件
        commonJs.listWindowBounce(loadRecipeInfo);
        loadRecipeInfo();
        appcan.window.subscribe("pharmacistIndexHomeReload", reloadRecipeInfo);
        //ViewModel.collection.fetch({selfViewModel: ViewModel, param: pageParam});
    }
    return {
        init: init,
        initModel: _initModel,
        loadRecipeInfoDetail: loadRecipeInfoDetail,
        loadRecipeInfo: loadRecipeInfo,
        reloadRecipeInfo: reloadRecipeInfo
    }
    
}();

appcan.ready(function() {
    appcan.initBounce();
    pharmacistIndexHomeContent.init();
});








