/**
 * 区域弹出选择列表插件
 * 此组件依赖 PopPicker，请在页面中先引入 neusoft.picker.css + neusoft.js + neusoft.picker.js
 * varstion 1.0.0
 * by lizhen
 * date 2018-04-26
 */

(function($, window, document) {

	//创建 DOM
	$.dom = function(str) {
		if (typeof(str) !== 'string') {
			if ((str instanceof Array) || (str[0] && str.length)) {
				return [].slice.call(str);
			} else {
				return [str];
			}
		}
		if (!$.__create_dom_div__) {
			$.__create_dom_div__ = document.createElement('div');
		}
		$.__create_dom_div__.innerHTML = str;
		return [].slice.call($.__create_dom_div__.childNodes);
	};
	
	var panelBuffer = '<div class="district-picker-panel">\
            <div class="ub ub-f1">\
                <div class="ub ub-f1 ub-pc ub-pc" style="line-height: 2.5em">\
                    <span class="font-30">区域选择</span>\
                </div>\
                <div class="ub ub-pc ub-ac btn" data-id="district-cancel" style="width: 1.5em">\
                    <div class="close-icon-size-1x close-icon close"></div>\
                </div>\
            </div>\
            <div class="one-px-h-line"></div>\
            <div class="ub ub-f1 district-picker-body">\
                <div class="col-4 float-left">\
                    <ul class="select-list">\
                        <li class="province">\
                          <div class="ub ub-f1">\
                            <div class="ub ub-ver select-line-pd">\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line" style="display: block"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="unselect-item-flag select-active"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line bg-color"></div>\
                              </div>\
                            </div>\
                            <div class="select-item ub ub-f1 ub-ac" style="">\
                              <span class="font-30" data-id="name">请选择</span>\
                            </div>\
                          </div>\
                        </li>\
                        <li class="city">\
                          <div class="ub ub-f1">\
                            <div class="ub ub-ver select-line-pd">\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line bg-color"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="unselect-item-flag"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line bg-color"></div>\
                              </div>\
                            </div>\
                            <div class="select-item ub ub-f1 ub-ac" style="">\
                              <span hidden="hidden" class="font-30" data-id="name">请选择</span>\
                            </div>\
                          </div>\
                        </li>\
                        <li class="county">\
                          <div class="ub ub-f1">\
                            <div class="ub ub-ver select-line-pd">\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line bg-color"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="unselect-item-flag"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line bg-color "></div>\
                              </div>\
                            </div>\
                            <div class="select-item ub ub-f1 ub-ac" style="">\
                              <span hidden="hidden" class="font-30" data-id="name">请选择</span>\
                            </div>\
                          </div>\
                        </li>\
                        <li class="town">\
                          <div class="ub ub-f1">\
                            <div class="ub ub-ver select-line-pd">\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line bg-color"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="unselect-item-flag"></div>\
                              </div>\
                              <div class="ub ub-ac ub-pc select-line">\
                                <div class="connect-line" style="display: block"></div>\
                              </div>\
                            </div>\
                            <div class="select-item ub ub-f1 ub-ac" style="">\
                              <span hidden="hidden" class="font-30" data-id="name">请选择</span>\
                            </div>\
                          </div>\
                        </li>\
                    </ul>\
                </div>\
                <div class="col-8 float-left">\
                    <div class="district-data">\
                        <div class="item noselect">\
                            <span>暂不选择</span>\
                        </div>\
                        <div class="septal-line">\
                            <div class="one-px-h-line"></div>\
                        </div>\
                        <ul data-id="district-data-list">\
                        </ul>\
                    </div>\
                </div>\
            </div>\
            <div class="one-px-h-line"></div>\
        </div>';

	var pickerDataBuffer = '<li>\
                                <div class="ub ub-f1 ub-ac item">\
                                    <div class="ub ub-f1">\
                                        <span data-id="name"></span>\
                                    </div>\
                                    <div class="ub ub-ac right">\
                                        <div class="check-icon-size-1x"></div>\
                                    </div>\
                                </div>\
                                <div class="septal-line">\
                                    <div class="one-px-h-line"></div>\
                                </div>\
                            </li>';

	//定义弹出选择器类
	/**
	 * 区域弹出选择列表插件
	 * 此组件依赖 PoPicker，请在页面中先引入 mui.poppicker.css + mui.poppicker.js + mui.picker.css + mui.picker.js + 
	 * varstion 1.0.0
	 * by lizhen
	 * date 2018-04-26
	 */
	var DistrictPicker = $.DistrictPicker = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.layer = self.options.layer || 4;
			self.panel = $.dom(panelBuffer)[0];
			document.body.appendChild(self.panel);
			self.cancel = self.panel.querySelector('[data-id="district-cancel"]');
			self.dataContent = self.panel.querySelector('[data-id="district-data-list"]');
			self.body = self.panel.querySelector(".district-picker-body");
			//声名滚动条滚动位置
			self.options.scrollTop = 0;
			//var pickerElement = $.dom(pickerDataBuffer)[0];
			//self.dataContent.appendChild(pickerElement);
			self.mask = $.createMask();
			//缓存数据，提高数据使用效率，每次查询前先检查缓数据里面是否存在，无则再从数据库加载数据
			self.districtData = {};
			//加载测试数据
			self.districtData = districtData;
			self.getLoadDistrict();
			self.cancel.addEventListener('tap', function(event) {
				self.hide();
			}, false);

			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			
			//已选中数据项点击事件监听
			for (var i = 0; i < self.body.querySelector(".select-list").querySelectorAll("li").length; i++) {
			    self.body.querySelector(".select-list").querySelectorAll("li")[i].addEventListener("tap", function(event) {
                    _selectListClick(self, event);
                });
			}
			//暂不选择功能事件监听
			self.body.querySelector(".district-data").querySelector(".noselect").addEventListener("tap", function(event) {
			   _noselectClick(self, event); 
			});
			
			//防止滚动穿透
		    // self.panel.addEventListener($.EVENT_START, function(event) {
                // event.preventDefault();
                // //event.stopPropagation();
            // }, false);
            // self.panel.addEventListener($.EVENT_MOVE, function(event) {
                // event.preventDefault();
                // //event.stopPropagation();
            // }, false);
		},
		_createPicker: function() {
			var self = this;
			var layer = self.options.layer || 4;
			var width = (100 / layer) + '%';
		},
		//显示, 有传入区域编码时，自动把各区域数据加载出来
		show: function(callback, districtData) {
			var self = this;
			//增加滚动条防穿透样式
			//self.options.scrollTop = document.scrollingElement.scrollTop;
            document.body.classList.add("picker-show");
            //document.body.style.top = -self.options.scrollTop + 'px';
            
			self.callback = callback;
			//传入当前已选中数据,该数据必须与区域展开最大级数编码
			if (!!districtData && !!districtData.regionCode){
			    _initSelectElement(self, districtData.regionCode);
			}
			//页面弱动状态值bounceState:   1:允许当前页面弱动  0:禁止当前页面终弹动
            //由于当前面板默认事件无法关闭弹动事件，所以增加参数bounceState，如果允许弹动时，选择器显示时先禁止页面弹动，关闭时再开启
            if (self.options.bounceState === 1) {
			    appcan.window.disableBounce();
			}			
			self.mask.show();
			self.panel.classList.add('district-active');
            //处理物理返回键
            self.__back = $.back;
            $.back = function() {
                self.hide();
            };
		},
		//隐藏
		hide: function() {
			var self = this;
			//恢复body滚动条及滚动位置
			document.body.classList.remove("picker-show");
            //document.scrollingElement.scrollTop = self.options.scrollTop;
			//启用弹动事件
			if (self.options.bounceState === 1) {
                appcan.window.enableBounce();
            }
			if (self.disposed) return;
			self.panel.classList.remove('district-active');
			self.mask.close();
			//处理物理返回键
			$.back=self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for (var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});
	
	DistrictPicker.prototype.getLoadDistrict = function(parentData, level) {
	    var param, self = this;
	    
	    //TODO 此处代码为数据库数据加载，因为异步调用，在此处数据加载完成后，再调用渲染方法
	    //level不为空时，表示查询parentData同级数据
	    if (!!level) {
	        param = {"regionLevel": !!level ? String(level) || "1" : "1", "parentRegId": !!parentData ? parentData.parentRegId || "-1" : "-1"};
	    } else {
	        //查询当前数据的下一级区域
	        param = {"regionLevel": !!parentData ? String(Number(parentData.regionLevel) + 1) : "1", "parentRegId": !!parentData ? parentData.regionCode || "-1" : "-1"};
	    }
	    var districtData;
	    /*
	    //加载数据库数据
	    var url = self.options.url || window.ServerURL + "/getTRegion";
	    window.$.ajax({
            url : url,
            type : "POST",
            async: false,
            data : JSON.stringify(param),//this.pretreatment(data, option),
            dataType: "json",
            contentType: "application/json;charset=utf-8",
            success : function(data) {
                districtData = data;
                self.setData(districtData, parentData);
            },
            error : function(e, err) {
                
            }
        });
        
	    */
	    //加载本地JS数据
	    if (!!!parentData) {
	        districtData = self.districtData.province;
	    } else {
	        whereArray = !!!level ? {parentRegId: parentData.regionCode} : {parentRegId: parentData.parentRegId};
	        switch(level || Number(parentData.regionLevel) +1){
                case 1:
                    districtData = self.districtData.province;
                    break;
                case 2:
                    districtData = _.where(self.districtData.city, whereArray);
                    break;
                case 3:
                    districtData = _.where(self.districtData.county, whereArray);
                    break;
                case 4:
                    districtData = _.where(self.districtData.town, whereArray);
                    break;
                default:
                    break;
            }
        }
	    self.setData(districtData, parentData);
	    
	}
	
	//渲染选择区域数据
	DistrictPicker.prototype.setData = function(data, selectData) {
	    var self = this;
	    if (self.dataContent.children.length > 0) {
	       while (self.dataContent.children.length != 0) {
	           self.dataContent.removeChild(self.dataContent.children[0]);
	       }
	    }
	    //无数据时则直接退出，不进行渲染
	    if (!!!data) return;
	    for (var i = 0; i < data.length; i++) {
	        var pickerElement = $.dom(pickerDataBuffer)[0];
	        pickerElement.querySelector('[data-id="name"]').innerHTML =  data[i].regionDesc;
	        pickerElement.data = data[i];
	        //暂不选择项在加载数据时清空，如果为已选择数据，则赋值已选中数据
	        self.body.querySelector(".district-data").querySelector(".noselect").data = null;
	        if (!!selectData && selectData.regionCode === data[i].regionCode) {
    	        pickerElement.querySelector(".check-icon-size-1x").classList.add("check-blue");
                pickerElement.querySelector(".check-icon-size-1x").classList.add("select-active");
                self.body.querySelector(".district-data").querySelector(".noselect").data = data[i];
            }
	        pickerElement.addEventListener("tap", function() {
	            _doSelectItem(self, event);
	        });
	       
	        self.dataContent.appendChild(pickerElement);
	    }
	}
	
	/**
	 * 创建地址选择框，传入区域编码初始数据
	 */
	var _initSelectElement = function(obj, regionCode) {
	    var param = {regionCode: regionCode};
	    //加载测试数据
        var url = obj.options.url || window.ServerURL + "/getTRegion";
	    for (var i = obj.options.layer; i > 0; i--) {
	        /* 
	        //加载远程数据库数据
	        param.regionLevel = String(i);
	        window.$.ajax({
                url : url,
                type : "POST",
                async: false,
                data : JSON.stringify(param),//this.pretreatment(data, option),
                dataType: "json",
                contentType: "application/json;charset=utf-8",
                success : function(data) {
                    var districtData = data.length > 0 ? data[0] : null;
                    if(!!!districtData) return;
                    var element = _getElement(obj, i);
                    element.querySelector("[data-id='name']").innerHTML = districtData.regionDesc;
                    element.querySelector("[data-id='name']").removeAttribute("hidden");
                    element.querySelector(".unselect-item-flag").classList.add("select-item-flag");
                    element.querySelector(".unselect-item-flag").classList.add("select-active");
                    element.querySelector(".unselect-item-flag").classList.remove("unselect-item-flag");
                    element.querySelectorAll(".connect-line")[0].classList.add("select-active");
                    element.data = districtData;
                    if (i-1 > 0) {
                        var priorElement = _getElement(obj, i-1);     
                        priorElement.querySelectorAll(".connect-line")[1].classList.add("select-active");
                    }
                    param = {regionCode: districtData.parentRegId};
                    if (i === obj.options.layer) {
                        obj.getLoadDistrict(districtData, i);
                        _setScroolBy(obj, districtData);
                    }
                },
                error : function(e, err) {
                    
                }
            });
             */
            //加载本地JS数据
	        if (i === 4) {
                districtData = _.where(obj.districtData.town, param)[0];        
            } else if (i === 3) {
                districtData = _.where(obj.districtData.county, param)[0];        
            } else if (i === 2) {
                districtData = _.where(obj.districtData.city, param)[0];            
            } else  if (i === 1) {
    	        districtData = _.where(obj.districtData.province, param)[0];
    	    }
    	    if(!!!districtData) return;
            var element = _getElement(obj, i);
            element.querySelector("[data-id='name']").innerHTML = districtData.regionDesc;
            element.querySelector("[data-id='name']").removeAttribute("hidden");
            element.querySelector(".unselect-item-flag").classList.add("select-item-flag");
            element.querySelector(".unselect-item-flag").classList.add("select-active");
            element.querySelector(".unselect-item-flag").classList.remove("unselect-item-flag");
            element.querySelectorAll(".connect-line")[0].classList.add("select-active");
            element.data = districtData;
            if (i-1 > 0) {
                var priorElement = _getElement(obj, i-1);     
                priorElement.querySelectorAll(".connect-line")[1].classList.add("select-active");
            }
            param = {regionCode: districtData.parentRegId};
            if (i === obj.options.layer) {
                obj.getLoadDistrict(districtData, i);
                _setScroolBy(obj, districtData);
            }
    	    
        }
	}
	
	/**
	 * 滚动条定位到已选中数据行
	 *  @param   obj   区域选择对象
	 *  @param   selectData  已选中数据
	 */
	var _setScroolBy = function(obj, selectData) {
	    var size = obj.body.querySelector(".district-data").clientHeight / 20;
	    var itemHeight = size * 3 + 1;
	    var liObjs = obj.body.querySelector(".district-data").querySelectorAll("li");
	    for (var i = 0; i < liObjs.length; i++) {
	        if (selectData.regionCode === liObjs[i].data.regionCode) {
	            var scrollTop;
	            if (i > 4) {
	                scrollTop = (i - 2) * itemHeight;
	            }
	            obj.body.querySelector(".district-data").scrollTop = scrollTop;
	            return;
	        }
	    }   
	
	}
	
	//根据LEVEL获取对应的DOM
	var _getElement = function(obj, level) {
        var element;
        switch(level){
            case 1:
                element = obj.body.querySelector(".select-list").querySelector(".province");
                break;
            case 2:
                element = obj.body.querySelector(".select-list").querySelector(".city");
                break;
            case 3:
                element = obj.body.querySelector(".select-list").querySelector(".county");
                break;
            case 4:
                element = obj.body.querySelector(".select-list").querySelector(".town");    
                break;
            default:
                break;
        }
        return element;
	}
	
	/**
	 * 区域选
	 */
	var _doSelectItem = function(obj, event) {
	    var data = event.currentTarget.data;
	    var selectElement = _getElement(obj, Number(data.regionLevel))
	    var nextElement = _getElement(obj, Number(data.regionLevel) + 1);
        var selectData = selectElement.data; //选中项原来的选中数据
        selectElement.data = data;
        //设置暂不选择项的数据为当前选中节点数据，点击该项时，本级选中数据将被清空
        obj.body.querySelector(".district-data").querySelector(".noselect").data = data;
        if (!!!selectData){
            selectElement.querySelector("[data-id='name']").innerHTML = data.regionDesc;
            selectElement.querySelector(".unselect-item-flag").classList.add("select-item-flag");
            selectElement.querySelector(".unselect-item-flag").classList.add("select-active");
            selectElement.querySelector(".unselect-item-flag").classList.remove("unselect-item-flag");        
             
            //下一结点显示选择信息
            if (Number(data.regionLevel) < obj.options.layer) {
                selectElement.querySelectorAll(".connect-line")[1].classList.add("select-active");
                nextElement.querySelector(".unselect-item-flag").classList.add("select-active");
                nextElement.querySelectorAll(".connect-line")[0].classList.add("select-active");
                nextElement.querySelector("[data-id='name']").removeAttribute("hidden");
            }
        } else if (!!selectData && selectData.regionCode !== data.regionCode) {
            selectElement.querySelector("[data-id='name']").innerHTML = data.regionDesc;
            //删除多余项
            _checkOrDelSelectListChild(obj, event.currentTarget, "select");
        }
        if (!!obj.dataContent.querySelector(".select-active")) {
            obj.dataContent.querySelector(".select-active").classList.remove("check-blue");
            obj.dataContent.querySelector(".select-active").classList.remove("select-active");
        }
        event.currentTarget.querySelector(".check-icon-size-1x").classList.add("check-blue");
        event.currentTarget.querySelector(".check-icon-size-1x").classList.add("select-active");
        //区域允许选择级数，最高为4级
        if (Number(data.regionLevel) < obj.options.layer) {
            //选择数据，查询下一层数据时不传入LEVEL值
            obj.getLoadDistrict(data);
        } else {
            obj.hide();
            obj.callback(data);
        }
	}
	
	var _selectListClick = function(obj, event) {
	    var data = event.currentTarget.data;
	    obj.getLoadDistrict(data, Number(data.regionLevel));
	    //设置暂不选择项的数据为当前选中节点数据，点击该项时，本级选中数据将被清空
        obj.body.querySelector(".district-data").querySelector(".noselect").data = data;
        //设置滚动条位置
        _setScroolBy(obj, data);
	}
	
	//检查当前新选中项，与已在列表选中项数据是否一致，不一致则删除子节点数据
	var _checkOrDelSelectListChild = function(obj, target, options) {
	    //检查当前选中节点是否存下节点，有则清除数据
	    var selectProc = function(element, state) {
	        //已选中数据清空
	        element.data = null;
	        if (state) {
                element.querySelector("[data-id='name']").innerHTML = "请选择";
                element.querySelector(".select-item-flag").classList.add("unselect-item-flag");
                //element.querySelector(".select-item-flag").classList.remove("select-active");
                element.querySelector(".select-item-flag").classList.remove("select-item-flag");        
                element.querySelectorAll(".connect-line")[1].classList.remove("select-active");
                if (!!obj.dataContent.querySelector(".select-active")) {
                    obj.dataContent.querySelector(".select-active").classList.remove("check-blue");
                    obj.dataContent.querySelector(".select-active").classList.remove("select-active");
                }
            } else {
                element.querySelector("[data-id='name']").innerHTML = "请选择";
                element.querySelector("[data-id='name']").setAttribute("hidden", "hidden");
                element.querySelector(".select-item-flag").classList.add("unselect-item-flag");
                element.querySelector(".select-item-flag").classList.remove("select-active");
                element.querySelector(".select-item-flag").classList.remove("select-item-flag");
                element.querySelectorAll(".connect-line")[0].classList.remove("select-active");       
                element.querySelectorAll(".connect-line")[1].classList.remove("select-active");
            }
	    }
        for (var i = obj.body.querySelector(".select-list").querySelectorAll("li").length; i > 0; i--) {
            var element = _getElement(obj, i);
            var data = element.data;
            if (!!!element.data) {
                if (!!element.querySelector(".unselect-item-flag")) {
                    element.querySelector("[data-id='name']").innerHTML = "请选择";
                    element.querySelector("[data-id='name']").setAttribute("hidden", "hidden");
                    element.querySelector(".unselect-item-flag").classList.remove("select-active");
                    element.querySelectorAll(".connect-line")[0].classList.remove("select-active"); 
                }
                continue;
            }
            //当暂不选项传入数据为空时，则取当前最大已选择区域数据
            if (!!!target.data) {
                 obj.hide();
                 obj.callback(data);
                 return;
            }
            //从最大的区域级别开发计算
            if (Number(data.regionLevel) > Number(target.data.regionLevel) && options === "noselect"){
                selectProc(element, false);
            } else if (Number(data.regionLevel) === Number(target.data.regionLevel) && options === "noselect"){
                selectProc(element, true);
            } else  if (Number(data.regionLevel) < Number(target.data.regionLevel) && options === "noselect"){
                obj.hide();
                obj.callback(data);
                return;
            }
            //选中项时，同级，与下一级在选中事件处理数据，此处只负责删除多余项
            if (Number(data.regionLevel) > Number(target.data.regionLevel) + 1 && options === "select"){
                selectProc(element, false);
            } else if (Number(data.regionLevel) === Number(target.data.regionLevel) + 1 && options === "select"){
                selectProc(element, true);
            }
        }
	}
	
	var _noselectClick = function(obj, event) {
	    var data = event.currentTarget.data;
	    _checkOrDelSelectListChild(obj, event.currentTarget, "noselect");
	}

})(window.Neusoft || window, window, document);