

if(!window.patientAssessList){
    window.patientAssessList = {};
}

var patientAssessList = function() {

    var pageCount = 0;
    var pageParam;
    pageParam = _.clone(window.pagingParam);
    pageParam.patientId = "_"; 
    
    //声明viewmodel
    var ViewModelAssess = new(MVVM.ViewModel.extend({
        el: "#patientAssessListView",
        collection: new PatientAssessListCollection()
    
    }))();

    //加载数据
    var loadData = function(){
        pageCount++;
        pageParam.pageIndex = pageCount;
        commonService.request(pageParam, {
            url: window.ServerURL + "/getWaitEvaluateOrderXf",
            success: function(res) {
                if (pageCount === 1) {
                    ViewModelAssess.collection.set(res.waitEvaluateOrderVOList);
                } else {
                    ViewModelAssess.collection.add(res.waitEvaluateOrderVOList);
                }
            }
        });
        //ViewModelAssess.collection.fetch({selfViewModel: ViewModelAssess, param: pageParam});
    }
    
    //加载详细页
    var loadDetail = function(event){
        
        var orderId = $(event.currentTarget).find("#orderId").text().trim(); 
        var orderType = $(event.currentTarget).find("#orderType").text().trim();
        
        //上门服务、预约服务直接返回
        orderType = !!getCodeListValue(window.codeList.evaluateOrderType,orderType) ? getCodeListValue(window.codeList.evaluateOrderType,orderType) : $(event.currentTarget).find("#orderType").text().trim();

        if (!!orderId) {
            //appcan.locStorage.setVal("orderId",orderId);
            var param, pageName = "", detailUrl = "";
            if(orderType=="ZL"){
                //诊疗
                pageName = "diagnosisAssessPage";
                param = "taskId=" + orderId;
                detailUrl = "../diagnosis/diagnosis_assess.html?";
            }else if(orderType=="GY"){
                //购药
                pageName = "buymedicineAssessPage";
                param = "orderId=" + orderId
                detailUrl = "../buymedicine/buymedicine_assess.html?";
            }else if(orderType=="YYFW"){
                //预约服务    by sushu 2019-04-17
                var param = {"id": orderId};
			    commonService.request(param, {
		            url: window.ServerURL + "/getTForwardInfo",
		            success: function(res){
		            	pageName = "assayBillEvaluatePage";
			            param = "forwardId=" + res[0].id;
			        	param += "&forwardType=" + res[0].forwardType;
			        	detailUrl = "../assay/assay_bill_evaluate.html?";
						param += "&pageName=patientAssessListPage";
			            param += "&pageFrameName=patientAssessListcontentPage";
			            param += "&js=patientAssessList.refreshLoad"; 
			            commonJs.openWindow(pageName, detailUrl + param);
		            }
		        });
		        return;
            }else if(orderType=="SM"){
                //远程医疗、上门服务  by sushu 2019-04-17
	            var param = {"id": orderId};
			    commonService.request(param, {
		            url: window.ServerURL + "/getTUpdoorInfo",
		            success: function(res){
		            	pageName = "patientServiceEvaluatePage";
			            param = "serviceId=" + res[0].id;
			        	param += "&sourceType=" + res[0].forwardType;
			        	detailUrl = "../roomService/patient_service_evaluate.html?";
						param += "&pageName=patientAssessListPage";
			            param += "&pageFrameName=patientAssessListcontentPage";
			            param += "&js=patientAssessList.refreshLoad"; 
			            commonJs.openWindow(pageName, detailUrl + param);
		            }
		        });
		        return;
            }
            param += "&pageName=patientAssessListPage";
            param += "&pageFrameName=patientAssessListcontentPage";
            param += "&js=patientAssessList.refreshLoad"; 
            commonJs.openWindow(pageName, detailUrl + param);
            // appcan.window.open({
                // name : "assessDetail",
                // data : detailUrl,
                // aniId : "2"
            // }); 
        }
    }
    
    var _refreshLoad = function() {
        pageCount = 0;
        loadData();
    }
    
    //类型下拉
    var assessListTypeSelect = function(){
        
        var assessListTypeSelect = appcan.selectview({
            selector : "#assessItemTypeSelect"
        });
        var assessListType = [{id: "999999", value: "ALL", text: "全部"}];
        for (var i in window.codeList.evaluateItems) {
            assessListType.push(window.codeList.evaluateItemsForAssessList[i]);
        }
        assessListTypeSelect.set(assessListType);
        assessListTypeSelect.on("select:click", function(obj, data) {
            //console.log(data);
            
            pageParam.orderType =  data[0].value;
            if (data[0].value === "ALL") {
                 $("#assessItemType").find("span").text("类型");
            } else {
                $("#assessItemType").find("span").text(data[0].text);
            }            
            hidenSelector();
            setScollbar("enable");
            
            
            pageCount = 0;
            
            loadData();
            return;
        });
    }
    
    //隐藏下拉
    var hidenSelector = function(hidenFlag) {
        //使用延迟设置,避免连续点击问题
        setTimeout(function() {
            //全科职称
            $("#assessItemType").find(".list-caret-size").addClass("list-caret-down");
            $("#assessItemType").find(".list-caret-size").removeClass("list-caret-up-select");
            $("#assessItemType").removeClass("filter-select-color");
            $("#assessItemTypeSelect").removeClass("mask-show");
        }, 100);
    }
    
    var setScollbar = function(operate) {
        if (operate === "disable") {
            appcan.window.disableBounce();
            //禁止默认行为方法，防止滚动条滚动
            $(document).on("mousewheel", function(evt) {
                evt.preventDefault();
            }, false);
            $(document).on("touchmove", function(evt) {
                evt.preventDefault();
            });
        } else if (operate === "enable") {
            //检查默认行为方法是否禁用，禁用了则重新启用
            appcan.window.enableBounce();
            $(document).on("touchmove", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            });
            $(document).on("mousewheel", function(evt) {
                //console.log(evt);
                if (!!evt.isDefaultPrevented()) {
                    evt.returnValue = true;
                }
            }, false);
        }
    }
    
    var checkOpenFilter = function(target) {
        if ($(target.parentElement).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
            //组件自身选中时，返回true
            if ($(target).find("div[class='list-caret-size list-caret-up-select']").length > 0) {
                return true;
            } else {
                return false;
            }
        }
        return true;
    }
    
    
    //下拉点击事件
    $("#assessItemType").on("tap", function(event) {

        if (!!!checkOpenFilter(event.currentTarget))
            return;
        event.cancelBubble = true;
        if ($(event.currentTarget).find("div[class='list-caret-size list-caret-down']").length > 0) {
            var maskTop = Number($("#divFilterItem").offset().height) + Number($("#divFilterItem").offset().top) - 2;
            $("#assessItemTypeSelect").css("top", maskTop + "px");
            $("#assessItemTypeSelect").addClass("mask-show");
            $(event.currentTarget).find(".list-caret-size").removeClass("list-caret-down");
            $(event.currentTarget).find(".list-caret-size").addClass("list-caret-up-select");
            $(event.currentTarget).addClass("filter-select-color");
            setScollbar("disable");
        } else {
            hidenSelector();
            setScollbar("enable");
        }
    }); 
    
    //时间控件
    $("#assessItemDate").on("tap", function(event) {
        // if (!!!checkOpenFilter(event.currentTarget)) return;
        // var date = new Date();
        // uexControl.openDatePicker(date.getFullYear(), date.getMonth() + 1, date.getDate(), function(data) {
            // pageParam.createDate = data.year + "-" + data.month + "-" + data.day;
            // pageCount = 0;
            // loadData();
        // });
        hidenSelector();
        setScollbar("enable");
        var _self = this;
        var okCallback = function(date) {
            var selectData = date.text;
            $("#assessItemDate").find("span").text(selectData);
            pageParam.createDate = selectData;
            pageCount = 0;
            loadData();
            _self.picker.dispose();
            _self.picker = null;
        }
        var clearCallback = function() {
            $("#assessItemDate").find("span").text("日期");
            if (!!pageParam.createDate) {
                delete pageParam.createDate;
            }
            pageCount = 0;
            loadData();
            _self.picker.dispose();
            _self.picker = null;
        }
        
        if (!!_self.picker) {
            _self.picker.show(okCallback, clearCallback);
        } else {
            //var optionsJson = this.getAttribute('data-options') || '{}';
            var options = {
                "type" : "date",
                "beginYear" : 1901,
                "bounceState": 1
            };
            //var id = this.getAttribute('id');
            /*
             * 首次显示时实例化组件
             * 示例为了简洁，将 options 放在了按钮的 dom 上
             * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
             */
            _self.picker = new Neusoft.DtPicker(options);
            _self.picker.show(okCallback, clearCallback);
        }
    });
    
    var init = function() {
        pageParam.orderType = "ALL";
        pageParam.patientId = !!commonJs.getPatient() ? commonJs.getPatient().id : "_";
        
        //设置弹动事件
        commonJs.listWindowBounce(loadData);
        loadData();
        //ViewModelAssess.collection.fetch({selfViewModel: ViewModelAssess, param: pageParam});
        
        //加载下拉
        assessListTypeSelect();
        
    }
    
    return {
        loadData : loadData,
        loadDetail : loadDetail,
        init: init,
        refreshLoad: _refreshLoad
    }
    
    
}();

appcan.ready(function() {
    
   appcan.button("#nav-left", "btn-act",
      function() {
          appcan.window.close(-1);
          uexWindow.setSlidingWindowEnabled(1);
          uexWindow.setMultilPopoverFlippingEnbaled(1);
    });
    appcan.initBounce();
    patientAssessList.init();
});